/* This file is autogenerated by tracetool, do not edit. */

#ifndef TRACE__GENERATED_TRACERS_H
#define TRACE__GENERATED_TRACERS_H

#include "qemu-common.h"

#include "trace/generated-tracers-dtrace.h"

#include <stdio.h>
#include <sys/time.h>
#include <sys/types.h>
#include <unistd.h>
#include "trace/control.h"
#include "qemu/log.h"


static inline void trace_qemu_memalign(size_t alignment, size_t size, void * ptr)
{
    QEMU_QEMU_MEMALIGN(alignment, size, ptr);
    if (trace_event_get_state(TRACE_QEMU_MEMALIGN)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qemu_memalign " "alignment %zu size %zu ptr %p" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , alignment, size, ptr);
    }
}

static inline void trace_qemu_anon_ram_alloc(size_t size, void * ptr)
{
    QEMU_QEMU_ANON_RAM_ALLOC(size, ptr);
    if (trace_event_get_state(TRACE_QEMU_ANON_RAM_ALLOC)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qemu_anon_ram_alloc " "size %zu ptr %p" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , size, ptr);
    }
}

static inline void trace_qemu_vfree(void * ptr)
{
    QEMU_QEMU_VFREE(ptr);
    if (trace_event_get_state(TRACE_QEMU_VFREE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qemu_vfree " "ptr %p" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , ptr);
    }
}

static inline void trace_qemu_anon_ram_free(void * ptr, size_t size)
{
    QEMU_QEMU_ANON_RAM_FREE(ptr, size);
    if (trace_event_get_state(TRACE_QEMU_ANON_RAM_FREE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qemu_anon_ram_free " "ptr %p size %zu" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , ptr, size);
    }
}

static inline void trace_virtqueue_fill(void * vq, const void * elem, unsigned int len, unsigned int idx)
{
    QEMU_VIRTQUEUE_FILL(vq, elem, len, idx);
    if (trace_event_get_state(TRACE_VIRTQUEUE_FILL)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:virtqueue_fill " "vq %p elem %p len %u idx %u" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , vq, elem, len, idx);
    }
}

static inline void trace_virtqueue_flush(void * vq, unsigned int count)
{
    QEMU_VIRTQUEUE_FLUSH(vq, count);
    if (trace_event_get_state(TRACE_VIRTQUEUE_FLUSH)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:virtqueue_flush " "vq %p count %u" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , vq, count);
    }
}

static inline void trace_virtqueue_pop(void * vq, void * elem, unsigned int in_num, unsigned int out_num)
{
    QEMU_VIRTQUEUE_POP(vq, elem, in_num, out_num);
    if (trace_event_get_state(TRACE_VIRTQUEUE_POP)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:virtqueue_pop " "vq %p elem %p in_num %u out_num %u" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , vq, elem, in_num, out_num);
    }
}

static inline void trace_virtio_queue_notify(void * vdev, int n, void * vq)
{
    QEMU_VIRTIO_QUEUE_NOTIFY(vdev, n, vq);
    if (trace_event_get_state(TRACE_VIRTIO_QUEUE_NOTIFY)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:virtio_queue_notify " "vdev %p n %d vq %p" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , vdev, n, vq);
    }
}

static inline void trace_virtio_irq(void * vq)
{
    QEMU_VIRTIO_IRQ(vq);
    if (trace_event_get_state(TRACE_VIRTIO_IRQ)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:virtio_irq " "vq %p" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , vq);
    }
}

static inline void trace_virtio_notify(void * vdev, void * vq)
{
    QEMU_VIRTIO_NOTIFY(vdev, vq);
    if (trace_event_get_state(TRACE_VIRTIO_NOTIFY)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:virtio_notify " "vdev %p vq %p" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , vdev, vq);
    }
}

static inline void trace_virtio_set_status(void * vdev, uint8_t val)
{
    QEMU_VIRTIO_SET_STATUS(vdev, val);
    if (trace_event_get_state(TRACE_VIRTIO_SET_STATUS)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:virtio_set_status " "vdev %p val %u" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , vdev, val);
    }
}

static inline void trace_virtio_rng_guest_not_ready(void * rng)
{
    QEMU_VIRTIO_RNG_GUEST_NOT_READY(rng);
    if (trace_event_get_state(TRACE_VIRTIO_RNG_GUEST_NOT_READY)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:virtio_rng_guest_not_ready " "rng %p: guest not ready" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , rng);
    }
}

static inline void trace_virtio_rng_pushed(void * rng, size_t len)
{
    QEMU_VIRTIO_RNG_PUSHED(rng, len);
    if (trace_event_get_state(TRACE_VIRTIO_RNG_PUSHED)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:virtio_rng_pushed " "rng %p: %zd bytes pushed" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , rng, len);
    }
}

static inline void trace_virtio_rng_request(void * rng, size_t size, unsigned quota)
{
    QEMU_VIRTIO_RNG_REQUEST(rng, size, quota);
    if (trace_event_get_state(TRACE_VIRTIO_RNG_REQUEST)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:virtio_rng_request " "rng %p: %zd bytes requested, %u bytes quota left" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , rng, size, quota);
    }
}

static inline void trace_virtio_serial_send_control_event(unsigned int port, uint16_t event, uint16_t value)
{
    QEMU_VIRTIO_SERIAL_SEND_CONTROL_EVENT(port, event, value);
    if (trace_event_get_state(TRACE_VIRTIO_SERIAL_SEND_CONTROL_EVENT)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:virtio_serial_send_control_event " "port %u, event %u, value %u" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , port, event, value);
    }
}

static inline void trace_virtio_serial_throttle_port(unsigned int port, bool throttle)
{
    QEMU_VIRTIO_SERIAL_THROTTLE_PORT(port, throttle);
    if (trace_event_get_state(TRACE_VIRTIO_SERIAL_THROTTLE_PORT)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:virtio_serial_throttle_port " "port %u, throttle %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , port, throttle);
    }
}

static inline void trace_virtio_serial_handle_control_message(uint16_t event, uint16_t value)
{
    QEMU_VIRTIO_SERIAL_HANDLE_CONTROL_MESSAGE(event, value);
    if (trace_event_get_state(TRACE_VIRTIO_SERIAL_HANDLE_CONTROL_MESSAGE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:virtio_serial_handle_control_message " "event %u, value %u" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , event, value);
    }
}

static inline void trace_virtio_serial_handle_control_message_port(unsigned int port)
{
    QEMU_VIRTIO_SERIAL_HANDLE_CONTROL_MESSAGE_PORT(port);
    if (trace_event_get_state(TRACE_VIRTIO_SERIAL_HANDLE_CONTROL_MESSAGE_PORT)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:virtio_serial_handle_control_message_port " "port %u" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , port);
    }
}

static inline void trace_virtio_console_flush_buf(unsigned int port, size_t len, ssize_t ret)
{
    QEMU_VIRTIO_CONSOLE_FLUSH_BUF(port, len, ret);
    if (trace_event_get_state(TRACE_VIRTIO_CONSOLE_FLUSH_BUF)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:virtio_console_flush_buf " "port %u, in_len %zu, out_len %zd" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , port, len, ret);
    }
}

static inline void trace_virtio_console_chr_read(unsigned int port, int size)
{
    QEMU_VIRTIO_CONSOLE_CHR_READ(port, size);
    if (trace_event_get_state(TRACE_VIRTIO_CONSOLE_CHR_READ)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:virtio_console_chr_read " "port %u, size %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , port, size);
    }
}

static inline void trace_virtio_console_chr_event(unsigned int port, int event)
{
    QEMU_VIRTIO_CONSOLE_CHR_EVENT(port, event);
    if (trace_event_get_state(TRACE_VIRTIO_CONSOLE_CHR_EVENT)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:virtio_console_chr_event " "port %u, event %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , port, event);
    }
}

static inline void trace_bdrv_open_common(void * bs, const char * filename, int flags, const char * format_name)
{
    QEMU_BDRV_OPEN_COMMON(bs, filename, flags, format_name);
    if (trace_event_get_state(TRACE_BDRV_OPEN_COMMON)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:bdrv_open_common " "bs %p filename \"%s\" flags %#x format_name \"%s\"" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , bs, filename, flags, format_name);
    }
}

static inline void trace_multiwrite_cb(void * mcb, int ret)
{
    QEMU_MULTIWRITE_CB(mcb, ret);
    if (trace_event_get_state(TRACE_MULTIWRITE_CB)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:multiwrite_cb " "mcb %p ret %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , mcb, ret);
    }
}

static inline void trace_bdrv_aio_multiwrite(void * mcb, int num_callbacks, int num_reqs)
{
    QEMU_BDRV_AIO_MULTIWRITE(mcb, num_callbacks, num_reqs);
    if (trace_event_get_state(TRACE_BDRV_AIO_MULTIWRITE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:bdrv_aio_multiwrite " "mcb %p num_callbacks %d num_reqs %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , mcb, num_callbacks, num_reqs);
    }
}

static inline void trace_bdrv_aio_discard(void * bs, int64_t sector_num, int nb_sectors, void * opaque)
{
    QEMU_BDRV_AIO_DISCARD(bs, sector_num, nb_sectors, opaque);
    if (trace_event_get_state(TRACE_BDRV_AIO_DISCARD)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:bdrv_aio_discard " "bs %p sector_num %"PRId64" nb_sectors %d opaque %p" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , bs, sector_num, nb_sectors, opaque);
    }
}

static inline void trace_bdrv_aio_flush(void * bs, void * opaque)
{
    QEMU_BDRV_AIO_FLUSH(bs, opaque);
    if (trace_event_get_state(TRACE_BDRV_AIO_FLUSH)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:bdrv_aio_flush " "bs %p opaque %p" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , bs, opaque);
    }
}

static inline void trace_bdrv_aio_readv(void * bs, int64_t sector_num, int nb_sectors, void * opaque)
{
    QEMU_BDRV_AIO_READV(bs, sector_num, nb_sectors, opaque);
    if (trace_event_get_state(TRACE_BDRV_AIO_READV)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:bdrv_aio_readv " "bs %p sector_num %"PRId64" nb_sectors %d opaque %p" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , bs, sector_num, nb_sectors, opaque);
    }
}

static inline void trace_bdrv_aio_writev(void * bs, int64_t sector_num, int nb_sectors, void * opaque)
{
    QEMU_BDRV_AIO_WRITEV(bs, sector_num, nb_sectors, opaque);
    if (trace_event_get_state(TRACE_BDRV_AIO_WRITEV)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:bdrv_aio_writev " "bs %p sector_num %"PRId64" nb_sectors %d opaque %p" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , bs, sector_num, nb_sectors, opaque);
    }
}

static inline void trace_bdrv_aio_write_zeroes(void * bs, int64_t sector_num, int nb_sectors, int flags, void * opaque)
{
    QEMU_BDRV_AIO_WRITE_ZEROES(bs, sector_num, nb_sectors, flags, opaque);
    if (trace_event_get_state(TRACE_BDRV_AIO_WRITE_ZEROES)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:bdrv_aio_write_zeroes " "bs %p sector_num %"PRId64" nb_sectors %d flags %#x opaque %p" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , bs, sector_num, nb_sectors, flags, opaque);
    }
}

static inline void trace_bdrv_lock_medium(void * bs, bool locked)
{
    QEMU_BDRV_LOCK_MEDIUM(bs, locked);
    if (trace_event_get_state(TRACE_BDRV_LOCK_MEDIUM)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:bdrv_lock_medium " "bs %p locked %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , bs, locked);
    }
}

static inline void trace_bdrv_co_readv(void * bs, int64_t sector_num, int nb_sector)
{
    QEMU_BDRV_CO_READV(bs, sector_num, nb_sector);
    if (trace_event_get_state(TRACE_BDRV_CO_READV)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:bdrv_co_readv " "bs %p sector_num %"PRId64" nb_sectors %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , bs, sector_num, nb_sector);
    }
}

static inline void trace_bdrv_co_copy_on_readv(void * bs, int64_t sector_num, int nb_sector)
{
    QEMU_BDRV_CO_COPY_ON_READV(bs, sector_num, nb_sector);
    if (trace_event_get_state(TRACE_BDRV_CO_COPY_ON_READV)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:bdrv_co_copy_on_readv " "bs %p sector_num %"PRId64" nb_sectors %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , bs, sector_num, nb_sector);
    }
}

static inline void trace_bdrv_co_readv_no_serialising(void * bs, int64_t sector_num, int nb_sector)
{
    QEMU_BDRV_CO_READV_NO_SERIALISING(bs, sector_num, nb_sector);
    if (trace_event_get_state(TRACE_BDRV_CO_READV_NO_SERIALISING)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:bdrv_co_readv_no_serialising " "bs %p sector_num %"PRId64" nb_sectors %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , bs, sector_num, nb_sector);
    }
}

static inline void trace_bdrv_co_writev(void * bs, int64_t sector_num, int nb_sector)
{
    QEMU_BDRV_CO_WRITEV(bs, sector_num, nb_sector);
    if (trace_event_get_state(TRACE_BDRV_CO_WRITEV)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:bdrv_co_writev " "bs %p sector_num %"PRId64" nb_sectors %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , bs, sector_num, nb_sector);
    }
}

static inline void trace_bdrv_co_write_zeroes(void * bs, int64_t sector_num, int nb_sector, int flags)
{
    QEMU_BDRV_CO_WRITE_ZEROES(bs, sector_num, nb_sector, flags);
    if (trace_event_get_state(TRACE_BDRV_CO_WRITE_ZEROES)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:bdrv_co_write_zeroes " "bs %p sector_num %"PRId64" nb_sectors %d flags %#x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , bs, sector_num, nb_sector, flags);
    }
}

static inline void trace_bdrv_co_io_em(void * bs, int64_t sector_num, int nb_sectors, int is_write, void * acb)
{
    QEMU_BDRV_CO_IO_EM(bs, sector_num, nb_sectors, is_write, acb);
    if (trace_event_get_state(TRACE_BDRV_CO_IO_EM)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:bdrv_co_io_em " "bs %p sector_num %"PRId64" nb_sectors %d is_write %d acb %p" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , bs, sector_num, nb_sectors, is_write, acb);
    }
}

static inline void trace_bdrv_co_do_copy_on_readv(void * bs, int64_t sector_num, int nb_sectors, int64_t cluster_sector_num, int cluster_nb_sectors)
{
    QEMU_BDRV_CO_DO_COPY_ON_READV(bs, sector_num, nb_sectors, cluster_sector_num, cluster_nb_sectors);
    if (trace_event_get_state(TRACE_BDRV_CO_DO_COPY_ON_READV)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:bdrv_co_do_copy_on_readv " "bs %p sector_num %"PRId64" nb_sectors %d cluster_sector_num %"PRId64" cluster_nb_sectors %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , bs, sector_num, nb_sectors, cluster_sector_num, cluster_nb_sectors);
    }
}

static inline void trace_stream_one_iteration(void * s, int64_t sector_num, int nb_sectors, int is_allocated)
{
    QEMU_STREAM_ONE_ITERATION(s, sector_num, nb_sectors, is_allocated);
    if (trace_event_get_state(TRACE_STREAM_ONE_ITERATION)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:stream_one_iteration " "s %p sector_num %"PRId64" nb_sectors %d is_allocated %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , s, sector_num, nb_sectors, is_allocated);
    }
}

static inline void trace_stream_start(void * bs, void * base, void * s, void * co, void * opaque)
{
    QEMU_STREAM_START(bs, base, s, co, opaque);
    if (trace_event_get_state(TRACE_STREAM_START)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:stream_start " "bs %p base %p s %p co %p opaque %p" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , bs, base, s, co, opaque);
    }
}

static inline void trace_commit_one_iteration(void * s, int64_t sector_num, int nb_sectors, int is_allocated)
{
    QEMU_COMMIT_ONE_ITERATION(s, sector_num, nb_sectors, is_allocated);
    if (trace_event_get_state(TRACE_COMMIT_ONE_ITERATION)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:commit_one_iteration " "s %p sector_num %"PRId64" nb_sectors %d is_allocated %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , s, sector_num, nb_sectors, is_allocated);
    }
}

static inline void trace_commit_start(void * bs, void * base, void * top, void * s, void * co, void * opaque)
{
    QEMU_COMMIT_START(bs, base, top, s, co, opaque);
    if (trace_event_get_state(TRACE_COMMIT_START)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:commit_start " "bs %p base %p top %p s %p co %p opaque %p" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , bs, base, top, s, co, opaque);
    }
}

static inline void trace_mirror_start(void * bs, void * s, void * co, void * opaque)
{
    QEMU_MIRROR_START(bs, s, co, opaque);
    if (trace_event_get_state(TRACE_MIRROR_START)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:mirror_start " "bs %p s %p co %p opaque %p" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , bs, s, co, opaque);
    }
}

static inline void trace_mirror_restart_iter(void * s, int64_t cnt)
{
    QEMU_MIRROR_RESTART_ITER(s, cnt);
    if (trace_event_get_state(TRACE_MIRROR_RESTART_ITER)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:mirror_restart_iter " "s %p dirty count %"PRId64 "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , s, cnt);
    }
}

static inline void trace_mirror_before_flush(void * s)
{
    QEMU_MIRROR_BEFORE_FLUSH(s);
    if (trace_event_get_state(TRACE_MIRROR_BEFORE_FLUSH)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:mirror_before_flush " "s %p" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , s);
    }
}

static inline void trace_mirror_before_drain(void * s, int64_t cnt)
{
    QEMU_MIRROR_BEFORE_DRAIN(s, cnt);
    if (trace_event_get_state(TRACE_MIRROR_BEFORE_DRAIN)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:mirror_before_drain " "s %p dirty count %"PRId64 "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , s, cnt);
    }
}

static inline void trace_mirror_before_sleep(void * s, int64_t cnt, int synced, uint64_t delay_ns)
{
    QEMU_MIRROR_BEFORE_SLEEP(s, cnt, synced, delay_ns);
    if (trace_event_get_state(TRACE_MIRROR_BEFORE_SLEEP)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:mirror_before_sleep " "s %p dirty count %"PRId64" synced %d delay %"PRIu64"ns" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , s, cnt, synced, delay_ns);
    }
}

static inline void trace_mirror_one_iteration(void * s, int64_t sector_num, int nb_sectors)
{
    QEMU_MIRROR_ONE_ITERATION(s, sector_num, nb_sectors);
    if (trace_event_get_state(TRACE_MIRROR_ONE_ITERATION)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:mirror_one_iteration " "s %p sector_num %"PRId64" nb_sectors %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , s, sector_num, nb_sectors);
    }
}

static inline void trace_mirror_iteration_done(void * s, int64_t sector_num, int nb_sectors, int ret)
{
    QEMU_MIRROR_ITERATION_DONE(s, sector_num, nb_sectors, ret);
    if (trace_event_get_state(TRACE_MIRROR_ITERATION_DONE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:mirror_iteration_done " "s %p sector_num %"PRId64" nb_sectors %d ret %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , s, sector_num, nb_sectors, ret);
    }
}

static inline void trace_mirror_yield(void * s, int64_t cnt, int buf_free_count, int in_flight)
{
    QEMU_MIRROR_YIELD(s, cnt, buf_free_count, in_flight);
    if (trace_event_get_state(TRACE_MIRROR_YIELD)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:mirror_yield " "s %p dirty count %"PRId64" free buffers %d in_flight %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , s, cnt, buf_free_count, in_flight);
    }
}

static inline void trace_mirror_yield_in_flight(void * s, int64_t sector_num, int in_flight)
{
    QEMU_MIRROR_YIELD_IN_FLIGHT(s, sector_num, in_flight);
    if (trace_event_get_state(TRACE_MIRROR_YIELD_IN_FLIGHT)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:mirror_yield_in_flight " "s %p sector_num %"PRId64" in_flight %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , s, sector_num, in_flight);
    }
}

static inline void trace_mirror_yield_ext(void * s, int64_t cnt, int buf_free_count, int in_flight)
{
    QEMU_MIRROR_YIELD_EXT(s, cnt, buf_free_count, in_flight);
    if (trace_event_get_state(TRACE_MIRROR_YIELD_EXT)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:mirror_yield_ext " "s %p dirty count %"PRId64" free buffers %d in_flight %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , s, cnt, buf_free_count, in_flight);
    }
}

static inline void trace_mirror_yield_in_flight_ext(void * s, int64_t sector_num, int in_flight)
{
    QEMU_MIRROR_YIELD_IN_FLIGHT_EXT(s, sector_num, in_flight);
    if (trace_event_get_state(TRACE_MIRROR_YIELD_IN_FLIGHT_EXT)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:mirror_yield_in_flight_ext " "s %p sector_num %"PRId64" in_flight %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , s, sector_num, in_flight);
    }
}

static inline void trace_mirror_yield_buf_busy(void * s, int nb_chunks, int in_flight)
{
    QEMU_MIRROR_YIELD_BUF_BUSY(s, nb_chunks, in_flight);
    if (trace_event_get_state(TRACE_MIRROR_YIELD_BUF_BUSY)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:mirror_yield_buf_busy " "s %p requested chunks %d in_flight %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , s, nb_chunks, in_flight);
    }
}

static inline void trace_mirror_break_buf_busy(void * s, int nb_chunks, int in_flight)
{
    QEMU_MIRROR_BREAK_BUF_BUSY(s, nb_chunks, in_flight);
    if (trace_event_get_state(TRACE_MIRROR_BREAK_BUF_BUSY)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:mirror_break_buf_busy " "s %p requested chunks %d in_flight %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , s, nb_chunks, in_flight);
    }
}

static inline void trace_backup_copy_cluster_enter(void * job, int64_t cluster)
{
    QEMU_BACKUP_COPY_CLUSTER_ENTER(job, cluster);
    if (trace_event_get_state(TRACE_BACKUP_COPY_CLUSTER_ENTER)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:backup_copy_cluster_enter " "job %p cluster %"PRId64 "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , job, cluster);
    }
}

static inline void trace_backup_copy_cluster_return(void * job, int64_t cluster, int ret)
{
    QEMU_BACKUP_COPY_CLUSTER_RETURN(job, cluster, ret);
    if (trace_event_get_state(TRACE_BACKUP_COPY_CLUSTER_RETURN)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:backup_copy_cluster_return " "job %p cluster %"PRId64" ret %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , job, cluster, ret);
    }
}

static inline void trace_backup_do_read_fail(void * job, int64_t cluster, int ret)
{
    QEMU_BACKUP_DO_READ_FAIL(job, cluster, ret);
    if (trace_event_get_state(TRACE_BACKUP_DO_READ_FAIL)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:backup_do_read_fail " "job %p cluster %"PRId64" ret %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , job, cluster, ret);
    }
}

static inline void trace_backup_do_write_fail(void * job, int64_t cluster, int ret)
{
    QEMU_BACKUP_DO_WRITE_FAIL(job, cluster, ret);
    if (trace_event_get_state(TRACE_BACKUP_DO_WRITE_FAIL)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:backup_do_write_fail " "job %p cluster %"PRId64" ret %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , job, cluster, ret);
    }
}

static inline void trace_backup_before_write_notify_skip(void * job, int64_t offset, int64_t bytes)
{
    QEMU_BACKUP_BEFORE_WRITE_NOTIFY_SKIP(job, offset, bytes);
    if (trace_event_get_state(TRACE_BACKUP_BEFORE_WRITE_NOTIFY_SKIP)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:backup_before_write_notify_skip " "job %p offset %"PRId64" bytes %"PRId64 "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , job, offset, bytes);
    }
}

static inline void trace_backup_before_write_notify_start(void * job, int64_t offset, int64_t bytes, void * nr, int64_t start, int64_t end, int nb_wait)
{
    QEMU_BACKUP_BEFORE_WRITE_NOTIFY_START(job, offset, bytes, nr, start, end, nb_wait);
    if (trace_event_get_state(TRACE_BACKUP_BEFORE_WRITE_NOTIFY_START)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:backup_before_write_notify_start " "job %p offset %"PRId64" bytes %"PRId64" notif %p start %"PRId64" end %"PRId64" nb_wait %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , job, offset, bytes, nr, start, end, nb_wait);
    }
}

static inline void trace_backup_before_write_notify_timeout(void * job, void * nr, int64_t start, int64_t end, int nb_wait)
{
    QEMU_BACKUP_BEFORE_WRITE_NOTIFY_TIMEOUT(job, nr, start, end, nb_wait);
    if (trace_event_get_state(TRACE_BACKUP_BEFORE_WRITE_NOTIFY_TIMEOUT)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:backup_before_write_notify_timeout " "job %p notif %p start %"PRId64" end %"PRId64" nb_wait %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , job, nr, start, end, nb_wait);
    }
}

static inline void trace_backup_before_write_notify_success(void * job, void * nr, int64_t start, int64_t end, int nb_wait)
{
    QEMU_BACKUP_BEFORE_WRITE_NOTIFY_SUCCESS(job, nr, start, end, nb_wait);
    if (trace_event_get_state(TRACE_BACKUP_BEFORE_WRITE_NOTIFY_SUCCESS)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:backup_before_write_notify_success " "job %p notif %p start %"PRId64" end %"PRId64" nb_wait %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , job, nr, start, end, nb_wait);
    }
}

static inline void trace_backup_skip_cluster(void * job, int64_t cluster)
{
    QEMU_BACKUP_SKIP_CLUSTER(job, cluster);
    if (trace_event_get_state(TRACE_BACKUP_SKIP_CLUSTER)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:backup_skip_cluster " "job %p cluster %"PRId64 "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , job, cluster);
    }
}

static inline void trace_backup_finish_cluster_for_notif(void * job, int64_t cluster)
{
    QEMU_BACKUP_FINISH_CLUSTER_FOR_NOTIF(job, cluster);
    if (trace_event_get_state(TRACE_BACKUP_FINISH_CLUSTER_FOR_NOTIF)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:backup_finish_cluster_for_notif " "job %p cluster %"PRId64 "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , job, cluster);
    }
}

static inline void trace_backup_worker_co(void * job, int64_t cluster, bool is_write_notifier)
{
    QEMU_BACKUP_WORKER_CO(job, cluster, is_write_notifier);
    if (trace_event_get_state(TRACE_BACKUP_WORKER_CO)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:backup_worker_co " "job %p cluster %"PRId64" is_write_notifier %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , job, cluster, is_write_notifier);
    }
}

static inline void trace_qmp_block_job_cancel(void * job)
{
    QEMU_QMP_BLOCK_JOB_CANCEL(job);
    if (trace_event_get_state(TRACE_QMP_BLOCK_JOB_CANCEL)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qmp_block_job_cancel " "job %p" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , job);
    }
}

static inline void trace_qmp_block_job_pause(void * job)
{
    QEMU_QMP_BLOCK_JOB_PAUSE(job);
    if (trace_event_get_state(TRACE_QMP_BLOCK_JOB_PAUSE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qmp_block_job_pause " "job %p" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , job);
    }
}

static inline void trace_qmp_block_job_resume(void * job)
{
    QEMU_QMP_BLOCK_JOB_RESUME(job);
    if (trace_event_get_state(TRACE_QMP_BLOCK_JOB_RESUME)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qmp_block_job_resume " "job %p" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , job);
    }
}

static inline void trace_qmp_block_job_complete(void * job)
{
    QEMU_QMP_BLOCK_JOB_COMPLETE(job);
    if (trace_event_get_state(TRACE_QMP_BLOCK_JOB_COMPLETE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qmp_block_job_complete " "job %p" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , job);
    }
}

static inline void trace_block_job_cb(void * bs, void * job, int ret)
{
    QEMU_BLOCK_JOB_CB(bs, job, ret);
    if (trace_event_get_state(TRACE_BLOCK_JOB_CB)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:block_job_cb " "bs %p job %p ret %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , bs, job, ret);
    }
}

static inline void trace_qmp_block_stream(void * bs, void * job)
{
    QEMU_QMP_BLOCK_STREAM(bs, job);
    if (trace_event_get_state(TRACE_QMP_BLOCK_STREAM)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qmp_block_stream " "bs %p job %p" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , bs, job);
    }
}

static inline void trace_virtio_blk_req_complete(void * req, int status)
{
    QEMU_VIRTIO_BLK_REQ_COMPLETE(req, status);
    if (trace_event_get_state(TRACE_VIRTIO_BLK_REQ_COMPLETE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:virtio_blk_req_complete " "req %p status %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , req, status);
    }
}

static inline void trace_virtio_blk_rw_complete(void * req, int ret)
{
    QEMU_VIRTIO_BLK_RW_COMPLETE(req, ret);
    if (trace_event_get_state(TRACE_VIRTIO_BLK_RW_COMPLETE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:virtio_blk_rw_complete " "req %p ret %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , req, ret);
    }
}

static inline void trace_virtio_blk_handle_write(void * req, uint64_t sector, size_t nsectors)
{
    QEMU_VIRTIO_BLK_HANDLE_WRITE(req, sector, nsectors);
    if (trace_event_get_state(TRACE_VIRTIO_BLK_HANDLE_WRITE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:virtio_blk_handle_write " "req %p sector %"PRIu64" nsectors %zu" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , req, sector, nsectors);
    }
}

static inline void trace_virtio_blk_handle_read(void * req, uint64_t sector, size_t nsectors)
{
    QEMU_VIRTIO_BLK_HANDLE_READ(req, sector, nsectors);
    if (trace_event_get_state(TRACE_VIRTIO_BLK_HANDLE_READ)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:virtio_blk_handle_read " "req %p sector %"PRIu64" nsectors %zu" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , req, sector, nsectors);
    }
}

static inline void trace_virtio_blk_submit_multireq(void * mrb, int start, int num_reqs, uint64_t sector, size_t nsectors, bool is_write)
{
    QEMU_VIRTIO_BLK_SUBMIT_MULTIREQ(mrb, start, num_reqs, sector, nsectors, is_write);
    if (trace_event_get_state(TRACE_VIRTIO_BLK_SUBMIT_MULTIREQ)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:virtio_blk_submit_multireq " "mrb %p start %d num_reqs %d sector %"PRIu64" nsectors %zu is_write %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , mrb, start, num_reqs, sector, nsectors, is_write);
    }
}

static inline void trace_virtio_blk_data_plane_start(void * s)
{
    QEMU_VIRTIO_BLK_DATA_PLANE_START(s);
    if (trace_event_get_state(TRACE_VIRTIO_BLK_DATA_PLANE_START)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:virtio_blk_data_plane_start " "dataplane %p" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , s);
    }
}

static inline void trace_virtio_blk_data_plane_stop(void * s)
{
    QEMU_VIRTIO_BLK_DATA_PLANE_STOP(s);
    if (trace_event_get_state(TRACE_VIRTIO_BLK_DATA_PLANE_STOP)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:virtio_blk_data_plane_stop " "dataplane %p" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , s);
    }
}

static inline void trace_virtio_blk_data_plane_process_request(void * s, unsigned int out_num, unsigned int in_num, unsigned int head)
{
    QEMU_VIRTIO_BLK_DATA_PLANE_PROCESS_REQUEST(s, out_num, in_num, head);
    if (trace_event_get_state(TRACE_VIRTIO_BLK_DATA_PLANE_PROCESS_REQUEST)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:virtio_blk_data_plane_process_request " "dataplane %p out_num %u in_num %u head %u" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , s, out_num, in_num, head);
    }
}

static inline void trace_vring_setup(uint64_t physical, void * desc, void * avail, void * used)
{
    QEMU_VRING_SETUP(physical, desc, avail, used);
    if (trace_event_get_state(TRACE_VRING_SETUP)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:vring_setup " "vring physical %#"PRIx64" desc %p avail %p used %p" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , physical, desc, avail, used);
    }
}

static inline void trace_thread_pool_submit(void * pool, void * req, void * opaque)
{
    QEMU_THREAD_POOL_SUBMIT(pool, req, opaque);
    if (trace_event_get_state(TRACE_THREAD_POOL_SUBMIT)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:thread_pool_submit " "pool %p req %p opaque %p" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , pool, req, opaque);
    }
}

static inline void trace_thread_pool_complete(void * pool, void * req, void * opaque, int ret)
{
    QEMU_THREAD_POOL_COMPLETE(pool, req, opaque, ret);
    if (trace_event_get_state(TRACE_THREAD_POOL_COMPLETE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:thread_pool_complete " "pool %p req %p opaque %p ret %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , pool, req, opaque, ret);
    }
}

static inline void trace_thread_pool_cancel(void * req, void * opaque)
{
    QEMU_THREAD_POOL_CANCEL(req, opaque);
    if (trace_event_get_state(TRACE_THREAD_POOL_CANCEL)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:thread_pool_cancel " "req %p opaque %p" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , req, opaque);
    }
}

static inline void trace_paio_submit_co(int64_t sector_num, int nb_sectors, int type)
{
    QEMU_PAIO_SUBMIT_CO(sector_num, nb_sectors, type);
    if (trace_event_get_state(TRACE_PAIO_SUBMIT_CO)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:paio_submit_co " "sector_num %"PRId64" nb_sectors %d type %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , sector_num, nb_sectors, type);
    }
}

static inline void trace_paio_submit(void * acb, void * opaque, int64_t sector_num, int nb_sectors, int type)
{
    QEMU_PAIO_SUBMIT(acb, opaque, sector_num, nb_sectors, type);
    if (trace_event_get_state(TRACE_PAIO_SUBMIT)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:paio_submit " "acb %p opaque %p sector_num %"PRId64" nb_sectors %d type %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , acb, opaque, sector_num, nb_sectors, type);
    }
}

static inline void trace_cpu_in(unsigned int addr, unsigned int val)
{
    QEMU_CPU_IN(addr, val);
    if (trace_event_get_state(TRACE_CPU_IN)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:cpu_in " "addr %#x value %u" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , addr, val);
    }
}

static inline void trace_cpu_out(unsigned int addr, unsigned int val)
{
    QEMU_CPU_OUT(addr, val);
    if (trace_event_get_state(TRACE_CPU_OUT)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:cpu_out " "addr %#x value %u" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , addr, val);
    }
}

static inline void trace_balloon_event(void * opaque, unsigned long addr)
{
    QEMU_BALLOON_EVENT(opaque, addr);
    if (trace_event_get_state(TRACE_BALLOON_EVENT)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:balloon_event " "opaque %p addr %lu" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , opaque, addr);
    }
}

static inline void trace_virtio_balloon_handle_output(const char * name, uint64_t gpa)
{
    QEMU_VIRTIO_BALLOON_HANDLE_OUTPUT(name, gpa);
    if (trace_event_get_state(TRACE_VIRTIO_BALLOON_HANDLE_OUTPUT)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:virtio_balloon_handle_output " "setion name: %s gpa: %"PRIx64"" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , name, gpa);
    }
}

static inline void trace_virtio_balloon_get_config(uint32_t num_pages, uint32_t acutal)
{
    QEMU_VIRTIO_BALLOON_GET_CONFIG(num_pages, acutal);
    if (trace_event_get_state(TRACE_VIRTIO_BALLOON_GET_CONFIG)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:virtio_balloon_get_config " "num_pages: %d acutal: %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , num_pages, acutal);
    }
}

static inline void trace_virtio_balloon_set_config(uint32_t acutal, uint32_t oldacutal)
{
    QEMU_VIRTIO_BALLOON_SET_CONFIG(acutal, oldacutal);
    if (trace_event_get_state(TRACE_VIRTIO_BALLOON_SET_CONFIG)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:virtio_balloon_set_config " "acutal: %d oldacutal: %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , acutal, oldacutal);
    }
}

static inline void trace_virtio_balloon_to_target(uint64_t target, uint32_t num_pages)
{
    QEMU_VIRTIO_BALLOON_TO_TARGET(target, num_pages);
    if (trace_event_get_state(TRACE_VIRTIO_BALLOON_TO_TARGET)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:virtio_balloon_to_target " "balloon target: %"PRIx64" num_pages: %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , target, num_pages);
    }
}

static inline void trace_cpu_set_apic_base(uint64_t val)
{
    QEMU_CPU_SET_APIC_BASE(val);
    if (trace_event_get_state(TRACE_CPU_SET_APIC_BASE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:cpu_set_apic_base " "%016"PRIx64 "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , val);
    }
}

static inline void trace_cpu_get_apic_base(uint64_t val)
{
    QEMU_CPU_GET_APIC_BASE(val);
    if (trace_event_get_state(TRACE_CPU_GET_APIC_BASE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:cpu_get_apic_base " "%016"PRIx64 "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , val);
    }
}

static inline void trace_apic_report_irq_delivered(int apic_irq_delivered)
{
    QEMU_APIC_REPORT_IRQ_DELIVERED(apic_irq_delivered);
    if (trace_event_get_state(TRACE_APIC_REPORT_IRQ_DELIVERED)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:apic_report_irq_delivered " "coalescing %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , apic_irq_delivered);
    }
}

static inline void trace_apic_reset_irq_delivered(int apic_irq_delivered)
{
    QEMU_APIC_RESET_IRQ_DELIVERED(apic_irq_delivered);
    if (trace_event_get_state(TRACE_APIC_RESET_IRQ_DELIVERED)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:apic_reset_irq_delivered " "old coalescing %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , apic_irq_delivered);
    }
}

static inline void trace_apic_get_irq_delivered(int apic_irq_delivered)
{
    QEMU_APIC_GET_IRQ_DELIVERED(apic_irq_delivered);
    if (trace_event_get_state(TRACE_APIC_GET_IRQ_DELIVERED)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:apic_get_irq_delivered " "returning coalescing %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , apic_irq_delivered);
    }
}

static inline void trace_apic_local_deliver(int vector, uint32_t lvt)
{
    QEMU_APIC_LOCAL_DELIVER(vector, lvt);
    if (trace_event_get_state(TRACE_APIC_LOCAL_DELIVER)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:apic_local_deliver " "vector %d delivery mode %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , vector, lvt);
    }
}

static inline void trace_apic_deliver_irq(uint8_t dest, uint8_t dest_mode, uint8_t delivery_mode, uint8_t vector_num, uint8_t trigger_mode)
{
    QEMU_APIC_DELIVER_IRQ(dest, dest_mode, delivery_mode, vector_num, trigger_mode);
    if (trace_event_get_state(TRACE_APIC_DELIVER_IRQ)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:apic_deliver_irq " "dest %d dest_mode %d delivery_mode %d vector %d trigger_mode %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , dest, dest_mode, delivery_mode, vector_num, trigger_mode);
    }
}

static inline void trace_apic_mem_readl(uint64_t addr, uint32_t val)
{
    QEMU_APIC_MEM_READL(addr, val);
    if (trace_event_get_state(TRACE_APIC_MEM_READL)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:apic_mem_readl " "%"PRIx64" = %08x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , addr, val);
    }
}

static inline void trace_apic_mem_writel(uint64_t addr, uint32_t val)
{
    QEMU_APIC_MEM_WRITEL(addr, val);
    if (trace_event_get_state(TRACE_APIC_MEM_WRITEL)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:apic_mem_writel " "%"PRIx64" = %08x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , addr, val);
    }
}

static inline void trace_cs4231_mem_readl_dreg(uint32_t reg, uint32_t ret)
{
    QEMU_CS4231_MEM_READL_DREG(reg, ret);
    if (trace_event_get_state(TRACE_CS4231_MEM_READL_DREG)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:cs4231_mem_readl_dreg " "read dreg %d: 0x%02x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , reg, ret);
    }
}

static inline void trace_cs4231_mem_readl_reg(uint32_t reg, uint32_t ret)
{
    QEMU_CS4231_MEM_READL_REG(reg, ret);
    if (trace_event_get_state(TRACE_CS4231_MEM_READL_REG)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:cs4231_mem_readl_reg " "read reg %d: 0x%08x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , reg, ret);
    }
}

static inline void trace_cs4231_mem_writel_reg(uint32_t reg, uint32_t old, uint32_t val)
{
    QEMU_CS4231_MEM_WRITEL_REG(reg, old, val);
    if (trace_event_get_state(TRACE_CS4231_MEM_WRITEL_REG)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:cs4231_mem_writel_reg " "write reg %d: 0x%08x -> 0x%08x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , reg, old, val);
    }
}

static inline void trace_cs4231_mem_writel_dreg(uint32_t reg, uint32_t old, uint32_t val)
{
    QEMU_CS4231_MEM_WRITEL_DREG(reg, old, val);
    if (trace_event_get_state(TRACE_CS4231_MEM_WRITEL_DREG)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:cs4231_mem_writel_dreg " "write dreg %d: 0x%02x -> 0x%02x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , reg, old, val);
    }
}

static inline void trace_nvram_read(uint32_t addr, uint32_t ret)
{
    QEMU_NVRAM_READ(addr, ret);
    if (trace_event_get_state(TRACE_NVRAM_READ)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:nvram_read " "read addr %d: 0x%02x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , addr, ret);
    }
}

static inline void trace_nvram_write(uint32_t addr, uint32_t old, uint32_t val)
{
    QEMU_NVRAM_WRITE(addr, old, val);
    if (trace_event_get_state(TRACE_NVRAM_WRITE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:nvram_write " "write addr %d: 0x%02x -> 0x%02x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , addr, old, val);
    }
}

static inline void trace_ecc_mem_writel_mer(uint32_t val)
{
    QEMU_ECC_MEM_WRITEL_MER(val);
    if (trace_event_get_state(TRACE_ECC_MEM_WRITEL_MER)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:ecc_mem_writel_mer " "Write memory enable %08x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , val);
    }
}

static inline void trace_ecc_mem_writel_mdr(uint32_t val)
{
    QEMU_ECC_MEM_WRITEL_MDR(val);
    if (trace_event_get_state(TRACE_ECC_MEM_WRITEL_MDR)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:ecc_mem_writel_mdr " "Write memory delay %08x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , val);
    }
}

static inline void trace_ecc_mem_writel_mfsr(uint32_t val)
{
    QEMU_ECC_MEM_WRITEL_MFSR(val);
    if (trace_event_get_state(TRACE_ECC_MEM_WRITEL_MFSR)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:ecc_mem_writel_mfsr " "Write memory fault status %08x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , val);
    }
}

static inline void trace_ecc_mem_writel_vcr(uint32_t val)
{
    QEMU_ECC_MEM_WRITEL_VCR(val);
    if (trace_event_get_state(TRACE_ECC_MEM_WRITEL_VCR)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:ecc_mem_writel_vcr " "Write slot configuration %08x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , val);
    }
}

static inline void trace_ecc_mem_writel_dr(uint32_t val)
{
    QEMU_ECC_MEM_WRITEL_DR(val);
    if (trace_event_get_state(TRACE_ECC_MEM_WRITEL_DR)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:ecc_mem_writel_dr " "Write diagnostic %08x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , val);
    }
}

static inline void trace_ecc_mem_writel_ecr0(uint32_t val)
{
    QEMU_ECC_MEM_WRITEL_ECR0(val);
    if (trace_event_get_state(TRACE_ECC_MEM_WRITEL_ECR0)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:ecc_mem_writel_ecr0 " "Write event count 1 %08x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , val);
    }
}

static inline void trace_ecc_mem_writel_ecr1(uint32_t val)
{
    QEMU_ECC_MEM_WRITEL_ECR1(val);
    if (trace_event_get_state(TRACE_ECC_MEM_WRITEL_ECR1)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:ecc_mem_writel_ecr1 " "Write event count 2 %08x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , val);
    }
}

static inline void trace_ecc_mem_readl_mer(uint32_t ret)
{
    QEMU_ECC_MEM_READL_MER(ret);
    if (trace_event_get_state(TRACE_ECC_MEM_READL_MER)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:ecc_mem_readl_mer " "Read memory enable %08x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , ret);
    }
}

static inline void trace_ecc_mem_readl_mdr(uint32_t ret)
{
    QEMU_ECC_MEM_READL_MDR(ret);
    if (trace_event_get_state(TRACE_ECC_MEM_READL_MDR)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:ecc_mem_readl_mdr " "Read memory delay %08x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , ret);
    }
}

static inline void trace_ecc_mem_readl_mfsr(uint32_t ret)
{
    QEMU_ECC_MEM_READL_MFSR(ret);
    if (trace_event_get_state(TRACE_ECC_MEM_READL_MFSR)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:ecc_mem_readl_mfsr " "Read memory fault status %08x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , ret);
    }
}

static inline void trace_ecc_mem_readl_vcr(uint32_t ret)
{
    QEMU_ECC_MEM_READL_VCR(ret);
    if (trace_event_get_state(TRACE_ECC_MEM_READL_VCR)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:ecc_mem_readl_vcr " "Read slot configuration %08x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , ret);
    }
}

static inline void trace_ecc_mem_readl_mfar0(uint32_t ret)
{
    QEMU_ECC_MEM_READL_MFAR0(ret);
    if (trace_event_get_state(TRACE_ECC_MEM_READL_MFAR0)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:ecc_mem_readl_mfar0 " "Read memory fault address 0 %08x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , ret);
    }
}

static inline void trace_ecc_mem_readl_mfar1(uint32_t ret)
{
    QEMU_ECC_MEM_READL_MFAR1(ret);
    if (trace_event_get_state(TRACE_ECC_MEM_READL_MFAR1)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:ecc_mem_readl_mfar1 " "Read memory fault address 1 %08x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , ret);
    }
}

static inline void trace_ecc_mem_readl_dr(uint32_t ret)
{
    QEMU_ECC_MEM_READL_DR(ret);
    if (trace_event_get_state(TRACE_ECC_MEM_READL_DR)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:ecc_mem_readl_dr " "Read diagnostic %08x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , ret);
    }
}

static inline void trace_ecc_mem_readl_ecr0(uint32_t ret)
{
    QEMU_ECC_MEM_READL_ECR0(ret);
    if (trace_event_get_state(TRACE_ECC_MEM_READL_ECR0)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:ecc_mem_readl_ecr0 " "Read event count 1 %08x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , ret);
    }
}

static inline void trace_ecc_mem_readl_ecr1(uint32_t ret)
{
    QEMU_ECC_MEM_READL_ECR1(ret);
    if (trace_event_get_state(TRACE_ECC_MEM_READL_ECR1)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:ecc_mem_readl_ecr1 " "Read event count 2 %08x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , ret);
    }
}

static inline void trace_ecc_diag_mem_writeb(uint64_t addr, uint32_t val)
{
    QEMU_ECC_DIAG_MEM_WRITEB(addr, val);
    if (trace_event_get_state(TRACE_ECC_DIAG_MEM_WRITEB)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:ecc_diag_mem_writeb " "Write diagnostic %"PRId64" = %02x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , addr, val);
    }
}

static inline void trace_ecc_diag_mem_readb(uint64_t addr, uint32_t ret)
{
    QEMU_ECC_DIAG_MEM_READB(addr, ret);
    if (trace_event_get_state(TRACE_ECC_DIAG_MEM_READB)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:ecc_diag_mem_readb " "Read diagnostic %"PRId64"= %02x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , addr, ret);
    }
}

static inline void trace_fw_cfg_write(void * s, uint8_t value)
{
    QEMU_FW_CFG_WRITE(s, value);
    if (trace_event_get_state(TRACE_FW_CFG_WRITE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:fw_cfg_write " "%p %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , s, value);
    }
}

static inline void trace_fw_cfg_select(void * s, uint16_t key, int ret)
{
    QEMU_FW_CFG_SELECT(s, key, ret);
    if (trace_event_get_state(TRACE_FW_CFG_SELECT)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:fw_cfg_select " "%p key %d = %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , s, key, ret);
    }
}

static inline void trace_fw_cfg_read(void * s, uint8_t ret)
{
    QEMU_FW_CFG_READ(s, ret);
    if (trace_event_get_state(TRACE_FW_CFG_READ)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:fw_cfg_read " "%p = %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , s, ret);
    }
}

static inline void trace_fw_cfg_add_file_dupe(void * s, char * name)
{
    QEMU_FW_CFG_ADD_FILE_DUPE(s, name);
    if (trace_event_get_state(TRACE_FW_CFG_ADD_FILE_DUPE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:fw_cfg_add_file_dupe " "%p %s" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , s, name);
    }
}

static inline void trace_fw_cfg_add_file(void * s, int index, char * name, size_t len)
{
    QEMU_FW_CFG_ADD_FILE(s, index, name, len);
    if (trace_event_get_state(TRACE_FW_CFG_ADD_FILE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:fw_cfg_add_file " "%p #%d: %s (%zd bytes)" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , s, index, name, len);
    }
}

static inline void trace_hd_geometry_lchs_guess(void * blk, int cyls, int heads, int secs)
{
    QEMU_HD_GEOMETRY_LCHS_GUESS(blk, cyls, heads, secs);
    if (trace_event_get_state(TRACE_HD_GEOMETRY_LCHS_GUESS)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:hd_geometry_lchs_guess " "blk %p LCHS %d %d %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , blk, cyls, heads, secs);
    }
}

static inline void trace_hd_geometry_guess(void * blk, uint32_t cyls, uint32_t heads, uint32_t secs, int trans)
{
    QEMU_HD_GEOMETRY_GUESS(blk, cyls, heads, secs, trans);
    if (trace_event_get_state(TRACE_HD_GEOMETRY_GUESS)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:hd_geometry_guess " "blk %p CHS %u %u %u trans %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , blk, cyls, heads, secs, trans);
    }
}

static inline void trace_jazz_led_read(uint64_t addr, uint8_t val)
{
    QEMU_JAZZ_LED_READ(addr, val);
    if (trace_event_get_state(TRACE_JAZZ_LED_READ)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:jazz_led_read " "read addr=0x%"PRIx64": 0x%x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , addr, val);
    }
}

static inline void trace_jazz_led_write(uint64_t addr, uint8_t new)
{
    QEMU_JAZZ_LED_WRITE(addr, new);
    if (trace_event_get_state(TRACE_JAZZ_LED_WRITE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:jazz_led_write " "write addr=0x%"PRIx64": 0x%x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , addr, new);
    }
}

static inline void trace_xenfb_mouse_event(void * opaque, int dx, int dy, int dz, int button_state, int abs_pointer_wanted)
{
    QEMU_XENFB_MOUSE_EVENT(opaque, dx, dy, dz, button_state, abs_pointer_wanted);
    if (trace_event_get_state(TRACE_XENFB_MOUSE_EVENT)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:xenfb_mouse_event " "%p x %d y %d z %d bs %#x abs %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , opaque, dx, dy, dz, button_state, abs_pointer_wanted);
    }
}

static inline void trace_xenfb_input_connected(void * xendev, int abs_pointer_wanted)
{
    QEMU_XENFB_INPUT_CONNECTED(xendev, abs_pointer_wanted);
    if (trace_event_get_state(TRACE_XENFB_INPUT_CONNECTED)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:xenfb_input_connected " "%p abs %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , xendev, abs_pointer_wanted);
    }
}

static inline void trace_lance_mem_readw(uint64_t addr, uint32_t ret)
{
    QEMU_LANCE_MEM_READW(addr, ret);
    if (trace_event_get_state(TRACE_LANCE_MEM_READW)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:lance_mem_readw " "addr=%"PRIx64"val=0x%04x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , addr, ret);
    }
}

static inline void trace_lance_mem_writew(uint64_t addr, uint32_t val)
{
    QEMU_LANCE_MEM_WRITEW(addr, val);
    if (trace_event_get_state(TRACE_LANCE_MEM_WRITEW)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:lance_mem_writew " "addr=%"PRIx64"val=0x%04x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , addr, val);
    }
}

static inline void trace_slavio_intctl_mem_readl(uint32_t cpu, uint64_t addr, uint32_t ret)
{
    QEMU_SLAVIO_INTCTL_MEM_READL(cpu, addr, ret);
    if (trace_event_get_state(TRACE_SLAVIO_INTCTL_MEM_READL)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:slavio_intctl_mem_readl " "read cpu %d reg 0x%"PRIx64" = %x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , cpu, addr, ret);
    }
}

static inline void trace_slavio_intctl_mem_writel(uint32_t cpu, uint64_t addr, uint32_t val)
{
    QEMU_SLAVIO_INTCTL_MEM_WRITEL(cpu, addr, val);
    if (trace_event_get_state(TRACE_SLAVIO_INTCTL_MEM_WRITEL)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:slavio_intctl_mem_writel " "write cpu %d reg 0x%"PRIx64" = %x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , cpu, addr, val);
    }
}

static inline void trace_slavio_intctl_mem_writel_clear(uint32_t cpu, uint32_t val, uint32_t intreg_pending)
{
    QEMU_SLAVIO_INTCTL_MEM_WRITEL_CLEAR(cpu, val, intreg_pending);
    if (trace_event_get_state(TRACE_SLAVIO_INTCTL_MEM_WRITEL_CLEAR)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:slavio_intctl_mem_writel_clear " "Cleared cpu %d irq mask %x, curmask %x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , cpu, val, intreg_pending);
    }
}

static inline void trace_slavio_intctl_mem_writel_set(uint32_t cpu, uint32_t val, uint32_t intreg_pending)
{
    QEMU_SLAVIO_INTCTL_MEM_WRITEL_SET(cpu, val, intreg_pending);
    if (trace_event_get_state(TRACE_SLAVIO_INTCTL_MEM_WRITEL_SET)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:slavio_intctl_mem_writel_set " "Set cpu %d irq mask %x, curmask %x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , cpu, val, intreg_pending);
    }
}

static inline void trace_slavio_intctlm_mem_readl(uint64_t addr, uint32_t ret)
{
    QEMU_SLAVIO_INTCTLM_MEM_READL(addr, ret);
    if (trace_event_get_state(TRACE_SLAVIO_INTCTLM_MEM_READL)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:slavio_intctlm_mem_readl " "read system reg 0x%"PRIx64" = %x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , addr, ret);
    }
}

static inline void trace_slavio_intctlm_mem_writel(uint64_t addr, uint32_t val)
{
    QEMU_SLAVIO_INTCTLM_MEM_WRITEL(addr, val);
    if (trace_event_get_state(TRACE_SLAVIO_INTCTLM_MEM_WRITEL)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:slavio_intctlm_mem_writel " "write system reg 0x%"PRIx64" = %x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , addr, val);
    }
}

static inline void trace_slavio_intctlm_mem_writel_enable(uint32_t val, uint32_t intregm_disabled)
{
    QEMU_SLAVIO_INTCTLM_MEM_WRITEL_ENABLE(val, intregm_disabled);
    if (trace_event_get_state(TRACE_SLAVIO_INTCTLM_MEM_WRITEL_ENABLE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:slavio_intctlm_mem_writel_enable " "Enabled master irq mask %x, curmask %x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , val, intregm_disabled);
    }
}

static inline void trace_slavio_intctlm_mem_writel_disable(uint32_t val, uint32_t intregm_disabled)
{
    QEMU_SLAVIO_INTCTLM_MEM_WRITEL_DISABLE(val, intregm_disabled);
    if (trace_event_get_state(TRACE_SLAVIO_INTCTLM_MEM_WRITEL_DISABLE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:slavio_intctlm_mem_writel_disable " "Disabled master irq mask %x, curmask %x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , val, intregm_disabled);
    }
}

static inline void trace_slavio_intctlm_mem_writel_target(uint32_t cpu)
{
    QEMU_SLAVIO_INTCTLM_MEM_WRITEL_TARGET(cpu);
    if (trace_event_get_state(TRACE_SLAVIO_INTCTLM_MEM_WRITEL_TARGET)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:slavio_intctlm_mem_writel_target " "Set master irq cpu %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , cpu);
    }
}

static inline void trace_slavio_check_interrupts(uint32_t pending, uint32_t intregm_disabled)
{
    QEMU_SLAVIO_CHECK_INTERRUPTS(pending, intregm_disabled);
    if (trace_event_get_state(TRACE_SLAVIO_CHECK_INTERRUPTS)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:slavio_check_interrupts " "pending %x disabled %x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , pending, intregm_disabled);
    }
}

static inline void trace_slavio_set_irq(uint32_t target_cpu, int irq, uint32_t pil, int level)
{
    QEMU_SLAVIO_SET_IRQ(target_cpu, irq, pil, level);
    if (trace_event_get_state(TRACE_SLAVIO_SET_IRQ)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:slavio_set_irq " "Set cpu %d irq %d -> pil %d level %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , target_cpu, irq, pil, level);
    }
}

static inline void trace_slavio_set_timer_irq_cpu(int cpu, int level)
{
    QEMU_SLAVIO_SET_TIMER_IRQ_CPU(cpu, level);
    if (trace_event_get_state(TRACE_SLAVIO_SET_TIMER_IRQ_CPU)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:slavio_set_timer_irq_cpu " "Set cpu %d local timer level %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , cpu, level);
    }
}

static inline void trace_ps2_put_keycode(void * opaque, int keycode)
{
    QEMU_PS2_PUT_KEYCODE(opaque, keycode);
    if (trace_event_get_state(TRACE_PS2_PUT_KEYCODE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:ps2_put_keycode " "%p keycode %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , opaque, keycode);
    }
}

static inline void trace_ps2_read_data(void * opaque)
{
    QEMU_PS2_READ_DATA(opaque);
    if (trace_event_get_state(TRACE_PS2_READ_DATA)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:ps2_read_data " "%p" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , opaque);
    }
}

static inline void trace_ps2_set_ledstate(void * s, int ledstate)
{
    QEMU_PS2_SET_LEDSTATE(s, ledstate);
    if (trace_event_get_state(TRACE_PS2_SET_LEDSTATE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:ps2_set_ledstate " "%p ledstate %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , s, ledstate);
    }
}

static inline void trace_ps2_reset_keyboard(void * s)
{
    QEMU_PS2_RESET_KEYBOARD(s);
    if (trace_event_get_state(TRACE_PS2_RESET_KEYBOARD)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:ps2_reset_keyboard " "%p" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , s);
    }
}

static inline void trace_ps2_write_keyboard(void * opaque, int val)
{
    QEMU_PS2_WRITE_KEYBOARD(opaque, val);
    if (trace_event_get_state(TRACE_PS2_WRITE_KEYBOARD)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:ps2_write_keyboard " "%p val %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , opaque, val);
    }
}

static inline void trace_ps2_keyboard_set_translation(void * opaque, int mode)
{
    QEMU_PS2_KEYBOARD_SET_TRANSLATION(opaque, mode);
    if (trace_event_get_state(TRACE_PS2_KEYBOARD_SET_TRANSLATION)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:ps2_keyboard_set_translation " "%p mode %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , opaque, mode);
    }
}

static inline void trace_ps2_mouse_send_packet(void * s, int dx1, int dy1, int dz1, int b)
{
    QEMU_PS2_MOUSE_SEND_PACKET(s, dx1, dy1, dz1, b);
    if (trace_event_get_state(TRACE_PS2_MOUSE_SEND_PACKET)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:ps2_mouse_send_packet " "%p x %d y %d z %d bs %#x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , s, dx1, dy1, dz1, b);
    }
}

static inline void trace_ps2_mouse_event_disabled(void * opaque, int dx, int dy, int dz, int buttons_state, int mouse_dx, int mouse_dy, int mouse_dz)
{
    QEMU_PS2_MOUSE_EVENT_DISABLED(opaque, dx, dy, dz, buttons_state, mouse_dx, mouse_dy, mouse_dz);
    if (trace_event_get_state(TRACE_PS2_MOUSE_EVENT_DISABLED)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:ps2_mouse_event_disabled " "%p x %d y %d z %d bs %#x mx %d my %d mz %d " "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , opaque, dx, dy, dz, buttons_state, mouse_dx, mouse_dy, mouse_dz);
    }
}

static inline void trace_ps2_mouse_event(void * opaque, int dx, int dy, int dz, int buttons_state, int mouse_dx, int mouse_dy, int mouse_dz)
{
    QEMU_PS2_MOUSE_EVENT(opaque, dx, dy, dz, buttons_state, mouse_dx, mouse_dy, mouse_dz);
    if (trace_event_get_state(TRACE_PS2_MOUSE_EVENT)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:ps2_mouse_event " "%p x %d y %d z %d bs %#x mx %d my %d mz %d " "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , opaque, dx, dy, dz, buttons_state, mouse_dx, mouse_dy, mouse_dz);
    }
}

static inline void trace_ps2_mouse_fake_event(void * opaque)
{
    QEMU_PS2_MOUSE_FAKE_EVENT(opaque);
    if (trace_event_get_state(TRACE_PS2_MOUSE_FAKE_EVENT)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:ps2_mouse_fake_event " "%p" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , opaque);
    }
}

static inline void trace_ps2_write_mouse(void * opaque, int val)
{
    QEMU_PS2_WRITE_MOUSE(opaque, val);
    if (trace_event_get_state(TRACE_PS2_WRITE_MOUSE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:ps2_write_mouse " "%p val %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , opaque, val);
    }
}

static inline void trace_ps2_kbd_reset(void * opaque)
{
    QEMU_PS2_KBD_RESET(opaque);
    if (trace_event_get_state(TRACE_PS2_KBD_RESET)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:ps2_kbd_reset " "%p" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , opaque);
    }
}

static inline void trace_ps2_mouse_reset(void * opaque)
{
    QEMU_PS2_MOUSE_RESET(opaque);
    if (trace_event_get_state(TRACE_PS2_MOUSE_RESET)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:ps2_mouse_reset " "%p" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , opaque);
    }
}

static inline void trace_ps2_kbd_init(void * s)
{
    QEMU_PS2_KBD_INIT(s);
    if (trace_event_get_state(TRACE_PS2_KBD_INIT)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:ps2_kbd_init " "%p" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , s);
    }
}

static inline void trace_ps2_mouse_init(void * s)
{
    QEMU_PS2_MOUSE_INIT(s);
    if (trace_event_get_state(TRACE_PS2_MOUSE_INIT)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:ps2_mouse_init " "%p" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , s);
    }
}

static inline void trace_slavio_misc_update_irq_raise(void)
{
    QEMU_SLAVIO_MISC_UPDATE_IRQ_RAISE();
    if (trace_event_get_state(TRACE_SLAVIO_MISC_UPDATE_IRQ_RAISE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:slavio_misc_update_irq_raise " "Raise IRQ" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      );
    }
}

static inline void trace_slavio_misc_update_irq_lower(void)
{
    QEMU_SLAVIO_MISC_UPDATE_IRQ_LOWER();
    if (trace_event_get_state(TRACE_SLAVIO_MISC_UPDATE_IRQ_LOWER)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:slavio_misc_update_irq_lower " "Lower IRQ" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      );
    }
}

static inline void trace_slavio_set_power_fail(int power_failing, uint8_t config)
{
    QEMU_SLAVIO_SET_POWER_FAIL(power_failing, config);
    if (trace_event_get_state(TRACE_SLAVIO_SET_POWER_FAIL)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:slavio_set_power_fail " "Power fail: %d, config: %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , power_failing, config);
    }
}

static inline void trace_slavio_cfg_mem_writeb(uint32_t val)
{
    QEMU_SLAVIO_CFG_MEM_WRITEB(val);
    if (trace_event_get_state(TRACE_SLAVIO_CFG_MEM_WRITEB)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:slavio_cfg_mem_writeb " "Write config %02x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , val);
    }
}

static inline void trace_slavio_cfg_mem_readb(uint32_t ret)
{
    QEMU_SLAVIO_CFG_MEM_READB(ret);
    if (trace_event_get_state(TRACE_SLAVIO_CFG_MEM_READB)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:slavio_cfg_mem_readb " "Read config %02x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , ret);
    }
}

static inline void trace_slavio_diag_mem_writeb(uint32_t val)
{
    QEMU_SLAVIO_DIAG_MEM_WRITEB(val);
    if (trace_event_get_state(TRACE_SLAVIO_DIAG_MEM_WRITEB)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:slavio_diag_mem_writeb " "Write diag %02x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , val);
    }
}

static inline void trace_slavio_diag_mem_readb(uint32_t ret)
{
    QEMU_SLAVIO_DIAG_MEM_READB(ret);
    if (trace_event_get_state(TRACE_SLAVIO_DIAG_MEM_READB)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:slavio_diag_mem_readb " "Read diag %02x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , ret);
    }
}

static inline void trace_slavio_mdm_mem_writeb(uint32_t val)
{
    QEMU_SLAVIO_MDM_MEM_WRITEB(val);
    if (trace_event_get_state(TRACE_SLAVIO_MDM_MEM_WRITEB)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:slavio_mdm_mem_writeb " "Write modem control %02x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , val);
    }
}

static inline void trace_slavio_mdm_mem_readb(uint32_t ret)
{
    QEMU_SLAVIO_MDM_MEM_READB(ret);
    if (trace_event_get_state(TRACE_SLAVIO_MDM_MEM_READB)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:slavio_mdm_mem_readb " "Read modem control %02x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , ret);
    }
}

static inline void trace_slavio_aux1_mem_writeb(uint32_t val)
{
    QEMU_SLAVIO_AUX1_MEM_WRITEB(val);
    if (trace_event_get_state(TRACE_SLAVIO_AUX1_MEM_WRITEB)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:slavio_aux1_mem_writeb " "Write aux1 %02x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , val);
    }
}

static inline void trace_slavio_aux1_mem_readb(uint32_t ret)
{
    QEMU_SLAVIO_AUX1_MEM_READB(ret);
    if (trace_event_get_state(TRACE_SLAVIO_AUX1_MEM_READB)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:slavio_aux1_mem_readb " "Read aux1 %02x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , ret);
    }
}

static inline void trace_slavio_aux2_mem_writeb(uint32_t val)
{
    QEMU_SLAVIO_AUX2_MEM_WRITEB(val);
    if (trace_event_get_state(TRACE_SLAVIO_AUX2_MEM_WRITEB)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:slavio_aux2_mem_writeb " "Write aux2 %02x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , val);
    }
}

static inline void trace_slavio_aux2_mem_readb(uint32_t ret)
{
    QEMU_SLAVIO_AUX2_MEM_READB(ret);
    if (trace_event_get_state(TRACE_SLAVIO_AUX2_MEM_READB)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:slavio_aux2_mem_readb " "Read aux2 %02x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , ret);
    }
}

static inline void trace_apc_mem_writeb(uint32_t val)
{
    QEMU_APC_MEM_WRITEB(val);
    if (trace_event_get_state(TRACE_APC_MEM_WRITEB)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:apc_mem_writeb " "Write power management %02x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , val);
    }
}

static inline void trace_apc_mem_readb(uint32_t ret)
{
    QEMU_APC_MEM_READB(ret);
    if (trace_event_get_state(TRACE_APC_MEM_READB)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:apc_mem_readb " "Read power management %02x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , ret);
    }
}

static inline void trace_slavio_sysctrl_mem_writel(uint32_t val)
{
    QEMU_SLAVIO_SYSCTRL_MEM_WRITEL(val);
    if (trace_event_get_state(TRACE_SLAVIO_SYSCTRL_MEM_WRITEL)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:slavio_sysctrl_mem_writel " "Write system control %08x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , val);
    }
}

static inline void trace_slavio_sysctrl_mem_readl(uint32_t ret)
{
    QEMU_SLAVIO_SYSCTRL_MEM_READL(ret);
    if (trace_event_get_state(TRACE_SLAVIO_SYSCTRL_MEM_READL)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:slavio_sysctrl_mem_readl " "Read system control %08x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , ret);
    }
}

static inline void trace_slavio_led_mem_writew(uint32_t val)
{
    QEMU_SLAVIO_LED_MEM_WRITEW(val);
    if (trace_event_get_state(TRACE_SLAVIO_LED_MEM_WRITEW)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:slavio_led_mem_writew " "Write diagnostic LED %04x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , val);
    }
}

static inline void trace_slavio_led_mem_readw(uint32_t ret)
{
    QEMU_SLAVIO_LED_MEM_READW(ret);
    if (trace_event_get_state(TRACE_SLAVIO_LED_MEM_READW)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:slavio_led_mem_readw " "Read diagnostic LED %04x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , ret);
    }
}

static inline void trace_slavio_timer_get_out(uint64_t limit, uint32_t counthigh, uint32_t count)
{
    QEMU_SLAVIO_TIMER_GET_OUT(limit, counthigh, count);
    if (trace_event_get_state(TRACE_SLAVIO_TIMER_GET_OUT)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:slavio_timer_get_out " "limit %"PRIx64" count %x%08x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , limit, counthigh, count);
    }
}

static inline void trace_slavio_timer_irq(uint32_t counthigh, uint32_t count)
{
    QEMU_SLAVIO_TIMER_IRQ(counthigh, count);
    if (trace_event_get_state(TRACE_SLAVIO_TIMER_IRQ)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:slavio_timer_irq " "callback: count %x%08x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , counthigh, count);
    }
}

static inline void trace_slavio_timer_mem_readl_invalid(uint64_t addr)
{
    QEMU_SLAVIO_TIMER_MEM_READL_INVALID(addr);
    if (trace_event_get_state(TRACE_SLAVIO_TIMER_MEM_READL_INVALID)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:slavio_timer_mem_readl_invalid " "invalid read address %"PRIx64 "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , addr);
    }
}

static inline void trace_slavio_timer_mem_readl(uint64_t addr, uint32_t ret)
{
    QEMU_SLAVIO_TIMER_MEM_READL(addr, ret);
    if (trace_event_get_state(TRACE_SLAVIO_TIMER_MEM_READL)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:slavio_timer_mem_readl " "read %"PRIx64" = %08x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , addr, ret);
    }
}

static inline void trace_slavio_timer_mem_writel(uint64_t addr, uint32_t val)
{
    QEMU_SLAVIO_TIMER_MEM_WRITEL(addr, val);
    if (trace_event_get_state(TRACE_SLAVIO_TIMER_MEM_WRITEL)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:slavio_timer_mem_writel " "write %"PRIx64" = %08x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , addr, val);
    }
}

static inline void trace_slavio_timer_mem_writel_limit(unsigned int timer_index, uint64_t count)
{
    QEMU_SLAVIO_TIMER_MEM_WRITEL_LIMIT(timer_index, count);
    if (trace_event_get_state(TRACE_SLAVIO_TIMER_MEM_WRITEL_LIMIT)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:slavio_timer_mem_writel_limit " "processor %d user timer set to %016"PRIx64 "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , timer_index, count);
    }
}

static inline void trace_slavio_timer_mem_writel_counter_invalid(void)
{
    QEMU_SLAVIO_TIMER_MEM_WRITEL_COUNTER_INVALID();
    if (trace_event_get_state(TRACE_SLAVIO_TIMER_MEM_WRITEL_COUNTER_INVALID)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:slavio_timer_mem_writel_counter_invalid " "not user timer" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      );
    }
}

static inline void trace_slavio_timer_mem_writel_status_start(unsigned int timer_index)
{
    QEMU_SLAVIO_TIMER_MEM_WRITEL_STATUS_START(timer_index);
    if (trace_event_get_state(TRACE_SLAVIO_TIMER_MEM_WRITEL_STATUS_START)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:slavio_timer_mem_writel_status_start " "processor %d user timer started" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , timer_index);
    }
}

static inline void trace_slavio_timer_mem_writel_status_stop(unsigned int timer_index)
{
    QEMU_SLAVIO_TIMER_MEM_WRITEL_STATUS_STOP(timer_index);
    if (trace_event_get_state(TRACE_SLAVIO_TIMER_MEM_WRITEL_STATUS_STOP)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:slavio_timer_mem_writel_status_stop " "processor %d user timer stopped" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , timer_index);
    }
}

static inline void trace_slavio_timer_mem_writel_mode_user(unsigned int timer_index)
{
    QEMU_SLAVIO_TIMER_MEM_WRITEL_MODE_USER(timer_index);
    if (trace_event_get_state(TRACE_SLAVIO_TIMER_MEM_WRITEL_MODE_USER)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:slavio_timer_mem_writel_mode_user " "processor %d changed from counter to user timer" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , timer_index);
    }
}

static inline void trace_slavio_timer_mem_writel_mode_counter(unsigned int timer_index)
{
    QEMU_SLAVIO_TIMER_MEM_WRITEL_MODE_COUNTER(timer_index);
    if (trace_event_get_state(TRACE_SLAVIO_TIMER_MEM_WRITEL_MODE_COUNTER)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:slavio_timer_mem_writel_mode_counter " "processor %d changed from user timer to counter" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , timer_index);
    }
}

static inline void trace_slavio_timer_mem_writel_mode_invalid(void)
{
    QEMU_SLAVIO_TIMER_MEM_WRITEL_MODE_INVALID();
    if (trace_event_get_state(TRACE_SLAVIO_TIMER_MEM_WRITEL_MODE_INVALID)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:slavio_timer_mem_writel_mode_invalid " "not system timer" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      );
    }
}

static inline void trace_slavio_timer_mem_writel_invalid(uint64_t addr)
{
    QEMU_SLAVIO_TIMER_MEM_WRITEL_INVALID(addr);
    if (trace_event_get_state(TRACE_SLAVIO_TIMER_MEM_WRITEL_INVALID)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:slavio_timer_mem_writel_invalid " "invalid write address %"PRIx64 "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , addr);
    }
}

static inline void trace_ledma_memory_read(uint64_t addr)
{
    QEMU_LEDMA_MEMORY_READ(addr);
    if (trace_event_get_state(TRACE_LEDMA_MEMORY_READ)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:ledma_memory_read " "DMA read addr 0x%"PRIx64 "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , addr);
    }
}

static inline void trace_ledma_memory_write(uint64_t addr)
{
    QEMU_LEDMA_MEMORY_WRITE(addr);
    if (trace_event_get_state(TRACE_LEDMA_MEMORY_WRITE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:ledma_memory_write " "DMA write addr 0x%"PRIx64 "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , addr);
    }
}

static inline void trace_sparc32_dma_set_irq_raise(void)
{
    QEMU_SPARC32_DMA_SET_IRQ_RAISE();
    if (trace_event_get_state(TRACE_SPARC32_DMA_SET_IRQ_RAISE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:sparc32_dma_set_irq_raise " "Raise IRQ" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      );
    }
}

static inline void trace_sparc32_dma_set_irq_lower(void)
{
    QEMU_SPARC32_DMA_SET_IRQ_LOWER();
    if (trace_event_get_state(TRACE_SPARC32_DMA_SET_IRQ_LOWER)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:sparc32_dma_set_irq_lower " "Lower IRQ" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      );
    }
}

static inline void trace_espdma_memory_read(uint32_t addr)
{
    QEMU_ESPDMA_MEMORY_READ(addr);
    if (trace_event_get_state(TRACE_ESPDMA_MEMORY_READ)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:espdma_memory_read " "DMA read addr 0x%08x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , addr);
    }
}

static inline void trace_espdma_memory_write(uint32_t addr)
{
    QEMU_ESPDMA_MEMORY_WRITE(addr);
    if (trace_event_get_state(TRACE_ESPDMA_MEMORY_WRITE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:espdma_memory_write " "DMA write addr 0x%08x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , addr);
    }
}

static inline void trace_sparc32_dma_mem_readl(uint64_t addr, uint32_t ret)
{
    QEMU_SPARC32_DMA_MEM_READL(addr, ret);
    if (trace_event_get_state(TRACE_SPARC32_DMA_MEM_READL)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:sparc32_dma_mem_readl " "read dmareg %"PRIx64": 0x%08x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , addr, ret);
    }
}

static inline void trace_sparc32_dma_mem_writel(uint64_t addr, uint32_t old, uint32_t val)
{
    QEMU_SPARC32_DMA_MEM_WRITEL(addr, old, val);
    if (trace_event_get_state(TRACE_SPARC32_DMA_MEM_WRITEL)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:sparc32_dma_mem_writel " "write dmareg %"PRIx64": 0x%08x -> 0x%08x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , addr, old, val);
    }
}

static inline void trace_sparc32_dma_enable_raise(void)
{
    QEMU_SPARC32_DMA_ENABLE_RAISE();
    if (trace_event_get_state(TRACE_SPARC32_DMA_ENABLE_RAISE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:sparc32_dma_enable_raise " "Raise DMA enable" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      );
    }
}

static inline void trace_sparc32_dma_enable_lower(void)
{
    QEMU_SPARC32_DMA_ENABLE_LOWER();
    if (trace_event_get_state(TRACE_SPARC32_DMA_ENABLE_LOWER)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:sparc32_dma_enable_lower " "Lower DMA enable" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      );
    }
}

static inline void trace_sun4m_cpu_interrupt(unsigned int level)
{
    QEMU_SUN4M_CPU_INTERRUPT(level);
    if (trace_event_get_state(TRACE_SUN4M_CPU_INTERRUPT)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:sun4m_cpu_interrupt " "Set CPU IRQ %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , level);
    }
}

static inline void trace_sun4m_cpu_reset_interrupt(unsigned int level)
{
    QEMU_SUN4M_CPU_RESET_INTERRUPT(level);
    if (trace_event_get_state(TRACE_SUN4M_CPU_RESET_INTERRUPT)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:sun4m_cpu_reset_interrupt " "Reset CPU IRQ %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , level);
    }
}

static inline void trace_sun4m_cpu_set_irq_raise(int level)
{
    QEMU_SUN4M_CPU_SET_IRQ_RAISE(level);
    if (trace_event_get_state(TRACE_SUN4M_CPU_SET_IRQ_RAISE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:sun4m_cpu_set_irq_raise " "Raise CPU IRQ %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , level);
    }
}

static inline void trace_sun4m_cpu_set_irq_lower(int level)
{
    QEMU_SUN4M_CPU_SET_IRQ_LOWER(level);
    if (trace_event_get_state(TRACE_SUN4M_CPU_SET_IRQ_LOWER)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:sun4m_cpu_set_irq_lower " "Lower CPU IRQ %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , level);
    }
}

static inline void trace_sun4m_iommu_mem_readl(uint64_t addr, uint32_t ret)
{
    QEMU_SUN4M_IOMMU_MEM_READL(addr, ret);
    if (trace_event_get_state(TRACE_SUN4M_IOMMU_MEM_READL)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:sun4m_iommu_mem_readl " "read reg[%"PRIx64"] = %x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , addr, ret);
    }
}

static inline void trace_sun4m_iommu_mem_writel(uint64_t addr, uint32_t val)
{
    QEMU_SUN4M_IOMMU_MEM_WRITEL(addr, val);
    if (trace_event_get_state(TRACE_SUN4M_IOMMU_MEM_WRITEL)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:sun4m_iommu_mem_writel " "write reg[%"PRIx64"] = %x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , addr, val);
    }
}

static inline void trace_sun4m_iommu_mem_writel_ctrl(uint64_t iostart)
{
    QEMU_SUN4M_IOMMU_MEM_WRITEL_CTRL(iostart);
    if (trace_event_get_state(TRACE_SUN4M_IOMMU_MEM_WRITEL_CTRL)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:sun4m_iommu_mem_writel_ctrl " "iostart = %"PRIx64 "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , iostart);
    }
}

static inline void trace_sun4m_iommu_mem_writel_tlbflush(uint32_t val)
{
    QEMU_SUN4M_IOMMU_MEM_WRITEL_TLBFLUSH(val);
    if (trace_event_get_state(TRACE_SUN4M_IOMMU_MEM_WRITEL_TLBFLUSH)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:sun4m_iommu_mem_writel_tlbflush " "tlb flush %x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , val);
    }
}

static inline void trace_sun4m_iommu_mem_writel_pgflush(uint32_t val)
{
    QEMU_SUN4M_IOMMU_MEM_WRITEL_PGFLUSH(val);
    if (trace_event_get_state(TRACE_SUN4M_IOMMU_MEM_WRITEL_PGFLUSH)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:sun4m_iommu_mem_writel_pgflush " "page flush %x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , val);
    }
}

static inline void trace_sun4m_iommu_page_get_flags(uint64_t pa, uint64_t iopte, uint32_t ret)
{
    QEMU_SUN4M_IOMMU_PAGE_GET_FLAGS(pa, iopte, ret);
    if (trace_event_get_state(TRACE_SUN4M_IOMMU_PAGE_GET_FLAGS)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:sun4m_iommu_page_get_flags " "get flags addr %"PRIx64" => pte %"PRIx64", *pte = %x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , pa, iopte, ret);
    }
}

static inline void trace_sun4m_iommu_translate_pa(uint64_t addr, uint64_t pa, uint32_t iopte)
{
    QEMU_SUN4M_IOMMU_TRANSLATE_PA(addr, pa, iopte);
    if (trace_event_get_state(TRACE_SUN4M_IOMMU_TRANSLATE_PA)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:sun4m_iommu_translate_pa " "xlate dva %"PRIx64" => pa %"PRIx64" iopte = %x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , addr, pa, iopte);
    }
}

static inline void trace_sun4m_iommu_bad_addr(uint64_t addr)
{
    QEMU_SUN4M_IOMMU_BAD_ADDR(addr);
    if (trace_event_get_state(TRACE_SUN4M_IOMMU_BAD_ADDR)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:sun4m_iommu_bad_addr " "bad addr %"PRIx64 "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , addr);
    }
}

static inline void trace_usb_packet_state_change(int bus, const char * port, int ep, void * p, const char * o, const char * n)
{
    QEMU_USB_PACKET_STATE_CHANGE(bus, port, ep, p, o, n);
    if (trace_event_get_state(TRACE_USB_PACKET_STATE_CHANGE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_packet_state_change " "bus %d, port %s, ep %d, packet %p, state %s -> %s" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , bus, port, ep, p, o, n);
    }
}

static inline void trace_usb_packet_state_fault(int bus, const char * port, int ep, void * p, const char * o, const char * n)
{
    QEMU_USB_PACKET_STATE_FAULT(bus, port, ep, p, o, n);
    if (trace_event_get_state(TRACE_USB_PACKET_STATE_FAULT)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_packet_state_fault " "bus %d, port %s, ep %d, packet %p, state %s, expected %s" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , bus, port, ep, p, o, n);
    }
}

static inline void trace_usb_port_claim(int bus, const char * port)
{
    QEMU_USB_PORT_CLAIM(bus, port);
    if (trace_event_get_state(TRACE_USB_PORT_CLAIM)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_port_claim " "bus %d, port %s" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , bus, port);
    }
}

static inline void trace_usb_port_attach(int bus, const char * port, const char * devspeed, const char * portspeed)
{
    QEMU_USB_PORT_ATTACH(bus, port, devspeed, portspeed);
    if (trace_event_get_state(TRACE_USB_PORT_ATTACH)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_port_attach " "bus %d, port %s, devspeed %s, portspeed %s" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , bus, port, devspeed, portspeed);
    }
}

static inline void trace_usb_port_detach(int bus, const char * port)
{
    QEMU_USB_PORT_DETACH(bus, port);
    if (trace_event_get_state(TRACE_USB_PORT_DETACH)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_port_detach " "bus %d, port %s" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , bus, port);
    }
}

static inline void trace_usb_port_release(int bus, const char * port)
{
    QEMU_USB_PORT_RELEASE(bus, port);
    if (trace_event_get_state(TRACE_USB_PORT_RELEASE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_port_release " "bus %d, port %s" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , bus, port);
    }
}

static inline void trace_usb_ohci_iso_td_read_failed(uint32_t addr)
{
    QEMU_USB_OHCI_ISO_TD_READ_FAILED(addr);
    if (trace_event_get_state(TRACE_USB_OHCI_ISO_TD_READ_FAILED)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_ohci_iso_td_read_failed " "ISO_TD read error at %x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , addr);
    }
}

static inline void trace_usb_ohci_iso_td_head(uint32_t head, uint32_t tail, uint32_t flags, uint32_t bp, uint32_t next, uint32_t be, uint32_t framenum, uint32_t startframe, uint32_t framecount, int rel_frame_num)
{
    QEMU_USB_OHCI_ISO_TD_HEAD(head, tail, flags, bp, next, be, framenum, startframe, framecount, rel_frame_num);
    if (trace_event_get_state(TRACE_USB_OHCI_ISO_TD_HEAD)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_ohci_iso_td_head " "ISO_TD ED head 0x%.8x tailp 0x%.8x\n0x%.8x 0x%.8x 0x%.8x 0x%.8x\nframe_number 0x%.8x starting_frame 0x%.8x\nframe_count  0x%.8x relative %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , head, tail, flags, bp, next, be, framenum, startframe, framecount, rel_frame_num);
    }
}

static inline void trace_usb_ohci_iso_td_head_offset(uint32_t o0, uint32_t o1, uint32_t o2, uint32_t o3, uint32_t o4, uint32_t o5, uint32_t o6, uint32_t o7)
{
    QEMU_USB_OHCI_ISO_TD_HEAD_OFFSET(o0, o1, o2, o3, o4, o5, o6, o7);
    if (trace_event_get_state(TRACE_USB_OHCI_ISO_TD_HEAD_OFFSET)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_ohci_iso_td_head_offset " "0x%.8x 0x%.8x 0x%.8x 0x%.8x 0x%.8x 0x%.8x 0x%.8x 0x%.8x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , o0, o1, o2, o3, o4, o5, o6, o7);
    }
}

static inline void trace_usb_ohci_iso_td_relative_frame_number_neg(int rel)
{
    QEMU_USB_OHCI_ISO_TD_RELATIVE_FRAME_NUMBER_NEG(rel);
    if (trace_event_get_state(TRACE_USB_OHCI_ISO_TD_RELATIVE_FRAME_NUMBER_NEG)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_ohci_iso_td_relative_frame_number_neg " "ISO_TD R=%d < 0" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , rel);
    }
}

static inline void trace_usb_ohci_iso_td_relative_frame_number_big(int rel, int count)
{
    QEMU_USB_OHCI_ISO_TD_RELATIVE_FRAME_NUMBER_BIG(rel, count);
    if (trace_event_get_state(TRACE_USB_OHCI_ISO_TD_RELATIVE_FRAME_NUMBER_BIG)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_ohci_iso_td_relative_frame_number_big " "ISO_TD R=%d > FC=%d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , rel, count);
    }
}

static inline void trace_usb_ohci_iso_td_bad_direction(int dir)
{
    QEMU_USB_OHCI_ISO_TD_BAD_DIRECTION(dir);
    if (trace_event_get_state(TRACE_USB_OHCI_ISO_TD_BAD_DIRECTION)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_ohci_iso_td_bad_direction " "Bad direction %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , dir);
    }
}

static inline void trace_usb_ohci_iso_td_bad_bp_be(uint32_t bp, uint32_t be)
{
    QEMU_USB_OHCI_ISO_TD_BAD_BP_BE(bp, be);
    if (trace_event_get_state(TRACE_USB_OHCI_ISO_TD_BAD_BP_BE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_ohci_iso_td_bad_bp_be " "ISO_TD bp 0x%.8x be 0x%.8x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , bp, be);
    }
}

static inline void trace_usb_ohci_iso_td_bad_cc_not_accessed(uint32_t start, uint32_t next)
{
    QEMU_USB_OHCI_ISO_TD_BAD_CC_NOT_ACCESSED(start, next);
    if (trace_event_get_state(TRACE_USB_OHCI_ISO_TD_BAD_CC_NOT_ACCESSED)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_ohci_iso_td_bad_cc_not_accessed " "ISO_TD cc != not accessed 0x%.8x 0x%.8x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , start, next);
    }
}

static inline void trace_usb_ohci_iso_td_bad_cc_overrun(uint32_t start, uint32_t next)
{
    QEMU_USB_OHCI_ISO_TD_BAD_CC_OVERRUN(start, next);
    if (trace_event_get_state(TRACE_USB_OHCI_ISO_TD_BAD_CC_OVERRUN)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_ohci_iso_td_bad_cc_overrun " "ISO_TD start_offset=0x%.8x > next_offset=0x%.8x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , start, next);
    }
}

static inline void trace_usb_ohci_iso_td_so(uint32_t so, uint32_t eo, uint32_t s, uint32_t e, const char * str, ssize_t len, int ret)
{
    QEMU_USB_OHCI_ISO_TD_SO(so, eo, s, e, str, len, ret);
    if (trace_event_get_state(TRACE_USB_OHCI_ISO_TD_SO)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_ohci_iso_td_so " "0x%.8x eo 0x%.8x\nsa 0x%.8x ea 0x%.8x\ndir %s len %zu ret %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , so, eo, s, e, str, len, ret);
    }
}

static inline void trace_usb_ohci_iso_td_data_overrun(int ret, ssize_t len)
{
    QEMU_USB_OHCI_ISO_TD_DATA_OVERRUN(ret, len);
    if (trace_event_get_state(TRACE_USB_OHCI_ISO_TD_DATA_OVERRUN)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_ohci_iso_td_data_overrun " "DataOverrun %d > %zu" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , ret, len);
    }
}

static inline void trace_usb_ohci_iso_td_data_underrun(int ret)
{
    QEMU_USB_OHCI_ISO_TD_DATA_UNDERRUN(ret);
    if (trace_event_get_state(TRACE_USB_OHCI_ISO_TD_DATA_UNDERRUN)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_ohci_iso_td_data_underrun " "DataUnderrun %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , ret);
    }
}

static inline void trace_usb_ohci_iso_td_nak(int ret)
{
    QEMU_USB_OHCI_ISO_TD_NAK(ret);
    if (trace_event_get_state(TRACE_USB_OHCI_ISO_TD_NAK)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_ohci_iso_td_nak " "got NAK/STALL %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , ret);
    }
}

static inline void trace_usb_ohci_iso_td_bad_response(int ret)
{
    QEMU_USB_OHCI_ISO_TD_BAD_RESPONSE(ret);
    if (trace_event_get_state(TRACE_USB_OHCI_ISO_TD_BAD_RESPONSE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_ohci_iso_td_bad_response " "Bad device response %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , ret);
    }
}

static inline void trace_usb_ohci_port_attach(int index)
{
    QEMU_USB_OHCI_PORT_ATTACH(index);
    if (trace_event_get_state(TRACE_USB_OHCI_PORT_ATTACH)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_ohci_port_attach " "port #%d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , index);
    }
}

static inline void trace_usb_ohci_port_detach(int index)
{
    QEMU_USB_OHCI_PORT_DETACH(index);
    if (trace_event_get_state(TRACE_USB_OHCI_PORT_DETACH)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_ohci_port_detach " "port #%d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , index);
    }
}

static inline void trace_usb_ohci_port_wakeup(int index)
{
    QEMU_USB_OHCI_PORT_WAKEUP(index);
    if (trace_event_get_state(TRACE_USB_OHCI_PORT_WAKEUP)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_ohci_port_wakeup " "port #%d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , index);
    }
}

static inline void trace_usb_ohci_port_suspend(int index)
{
    QEMU_USB_OHCI_PORT_SUSPEND(index);
    if (trace_event_get_state(TRACE_USB_OHCI_PORT_SUSPEND)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_ohci_port_suspend " "port #%d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , index);
    }
}

static inline void trace_usb_ohci_port_reset(int index)
{
    QEMU_USB_OHCI_PORT_RESET(index);
    if (trace_event_get_state(TRACE_USB_OHCI_PORT_RESET)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_ohci_port_reset " "port #%d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , index);
    }
}

static inline void trace_usb_ohci_remote_wakeup(const char * s)
{
    QEMU_USB_OHCI_REMOTE_WAKEUP(s);
    if (trace_event_get_state(TRACE_USB_OHCI_REMOTE_WAKEUP)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_ohci_remote_wakeup " "%s: SUSPEND->RESUME" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , s);
    }
}

static inline void trace_usb_ohci_reset(const char * s)
{
    QEMU_USB_OHCI_RESET(s);
    if (trace_event_get_state(TRACE_USB_OHCI_RESET)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_ohci_reset " "%s" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , s);
    }
}

static inline void trace_usb_ohci_start(const char * s)
{
    QEMU_USB_OHCI_START(s);
    if (trace_event_get_state(TRACE_USB_OHCI_START)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_ohci_start " "%s: USB Operational" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , s);
    }
}

static inline void trace_usb_ohci_resume(const char * s)
{
    QEMU_USB_OHCI_RESUME(s);
    if (trace_event_get_state(TRACE_USB_OHCI_RESUME)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_ohci_resume " "%s: USB Resume" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , s);
    }
}

static inline void trace_usb_ohci_stop(const char * s)
{
    QEMU_USB_OHCI_STOP(s);
    if (trace_event_get_state(TRACE_USB_OHCI_STOP)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_ohci_stop " "%s: USB Suspended" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , s);
    }
}

static inline void trace_usb_ohci_exit(const char * s)
{
    QEMU_USB_OHCI_EXIT(s);
    if (trace_event_get_state(TRACE_USB_OHCI_EXIT)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_ohci_exit " "%s" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , s);
    }
}

static inline void trace_usb_ohci_set_ctl(const char * s, uint32_t new_state)
{
    QEMU_USB_OHCI_SET_CTL(s, new_state);
    if (trace_event_get_state(TRACE_USB_OHCI_SET_CTL)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_ohci_set_ctl " "%s: new state 0x%x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , s, new_state);
    }
}

static inline void trace_usb_ohci_td_underrun(void)
{
    QEMU_USB_OHCI_TD_UNDERRUN();
    if (trace_event_get_state(TRACE_USB_OHCI_TD_UNDERRUN)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_ohci_td_underrun " "" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      );
    }
}

static inline void trace_usb_ohci_td_dev_error(void)
{
    QEMU_USB_OHCI_TD_DEV_ERROR();
    if (trace_event_get_state(TRACE_USB_OHCI_TD_DEV_ERROR)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_ohci_td_dev_error " "" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      );
    }
}

static inline void trace_usb_ohci_td_nak(void)
{
    QEMU_USB_OHCI_TD_NAK();
    if (trace_event_get_state(TRACE_USB_OHCI_TD_NAK)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_ohci_td_nak " "" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      );
    }
}

static inline void trace_usb_ohci_td_stall(void)
{
    QEMU_USB_OHCI_TD_STALL();
    if (trace_event_get_state(TRACE_USB_OHCI_TD_STALL)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_ohci_td_stall " "" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      );
    }
}

static inline void trace_usb_ohci_td_babble(void)
{
    QEMU_USB_OHCI_TD_BABBLE();
    if (trace_event_get_state(TRACE_USB_OHCI_TD_BABBLE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_ohci_td_babble " "" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      );
    }
}

static inline void trace_usb_ohci_td_bad_device_response(int rc)
{
    QEMU_USB_OHCI_TD_BAD_DEVICE_RESPONSE(rc);
    if (trace_event_get_state(TRACE_USB_OHCI_TD_BAD_DEVICE_RESPONSE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_ohci_td_bad_device_response " "%d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , rc);
    }
}

static inline void trace_usb_ohci_td_read_error(uint32_t addr)
{
    QEMU_USB_OHCI_TD_READ_ERROR(addr);
    if (trace_event_get_state(TRACE_USB_OHCI_TD_READ_ERROR)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_ohci_td_read_error " "TD read error at %x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , addr);
    }
}

static inline void trace_usb_ohci_td_bad_direction(int dir)
{
    QEMU_USB_OHCI_TD_BAD_DIRECTION(dir);
    if (trace_event_get_state(TRACE_USB_OHCI_TD_BAD_DIRECTION)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_ohci_td_bad_direction " "Bad direction %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , dir);
    }
}

static inline void trace_usb_ohci_td_skip_async(void)
{
    QEMU_USB_OHCI_TD_SKIP_ASYNC();
    if (trace_event_get_state(TRACE_USB_OHCI_TD_SKIP_ASYNC)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_ohci_td_skip_async " "" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      );
    }
}

static inline void trace_usb_ohci_td_pkt_hdr(uint32_t addr, int64_t pktlen, int64_t len, const char * s, int flag_r, uint32_t cbp, uint32_t be)
{
    QEMU_USB_OHCI_TD_PKT_HDR(addr, pktlen, len, s, flag_r, cbp, be);
    if (trace_event_get_state(TRACE_USB_OHCI_TD_PKT_HDR)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_ohci_td_pkt_hdr " " TD @ 0x%.8x %" PRId64 " of %" PRId64 " bytes %s r=%d cbp=0x%.8x be=0x%.8x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , addr, pktlen, len, s, flag_r, cbp, be);
    }
}

static inline void trace_usb_ohci_td_pkt_short(const char * dir, const char * buf)
{
    QEMU_USB_OHCI_TD_PKT_SHORT(dir, buf);
    if (trace_event_get_state(TRACE_USB_OHCI_TD_PKT_SHORT)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_ohci_td_pkt_short " "%s data: %s" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , dir, buf);
    }
}

static inline void trace_usb_ohci_td_pkt_full(const char * dir, const char * buf)
{
    QEMU_USB_OHCI_TD_PKT_FULL(dir, buf);
    if (trace_event_get_state(TRACE_USB_OHCI_TD_PKT_FULL)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_ohci_td_pkt_full " "%s data: %s" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , dir, buf);
    }
}

static inline void trace_usb_ohci_td_too_many_pending(void)
{
    QEMU_USB_OHCI_TD_TOO_MANY_PENDING();
    if (trace_event_get_state(TRACE_USB_OHCI_TD_TOO_MANY_PENDING)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_ohci_td_too_many_pending " "" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      );
    }
}

static inline void trace_usb_ohci_td_packet_status(int status)
{
    QEMU_USB_OHCI_TD_PACKET_STATUS(status);
    if (trace_event_get_state(TRACE_USB_OHCI_TD_PACKET_STATUS)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_ohci_td_packet_status " "status=%d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , status);
    }
}

static inline void trace_usb_ohci_ed_read_error(uint32_t addr)
{
    QEMU_USB_OHCI_ED_READ_ERROR(addr);
    if (trace_event_get_state(TRACE_USB_OHCI_ED_READ_ERROR)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_ohci_ed_read_error " "ED read error at %x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , addr);
    }
}

static inline void trace_usb_ohci_ed_pkt(uint32_t cur, int h, int c, uint32_t head, uint32_t tail, uint32_t next)
{
    QEMU_USB_OHCI_ED_PKT(cur, h, c, head, tail, next);
    if (trace_event_get_state(TRACE_USB_OHCI_ED_PKT)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_ohci_ed_pkt " "ED @ 0x%.8x h=%u c=%u\n  head=0x%.8x tailp=0x%.8x next=0x%.8x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , cur, h, c, head, tail, next);
    }
}

static inline void trace_usb_ohci_ed_pkt_flags(uint32_t fa, uint32_t en, uint32_t d, int s, int k, int f, uint32_t mps)
{
    QEMU_USB_OHCI_ED_PKT_FLAGS(fa, en, d, s, k, f, mps);
    if (trace_event_get_state(TRACE_USB_OHCI_ED_PKT_FLAGS)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_ohci_ed_pkt_flags " "fa=%u en=%u d=%u s=%u k=%u f=%u mps=%u" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , fa, en, d, s, k, f, mps);
    }
}

static inline void trace_usb_ohci_hcca_read_error(uint32_t addr)
{
    QEMU_USB_OHCI_HCCA_READ_ERROR(addr);
    if (trace_event_get_state(TRACE_USB_OHCI_HCCA_READ_ERROR)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_ohci_hcca_read_error " "HCCA read error at %x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , addr);
    }
}

static inline void trace_usb_ohci_mem_read_unaligned(uint32_t addr)
{
    QEMU_USB_OHCI_MEM_READ_UNALIGNED(addr);
    if (trace_event_get_state(TRACE_USB_OHCI_MEM_READ_UNALIGNED)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_ohci_mem_read_unaligned " "at %x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , addr);
    }
}

static inline void trace_usb_ohci_mem_read_bad_offset(uint32_t addr)
{
    QEMU_USB_OHCI_MEM_READ_BAD_OFFSET(addr);
    if (trace_event_get_state(TRACE_USB_OHCI_MEM_READ_BAD_OFFSET)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_ohci_mem_read_bad_offset " "%x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , addr);
    }
}

static inline void trace_usb_ohci_mem_write_unaligned(uint32_t addr)
{
    QEMU_USB_OHCI_MEM_WRITE_UNALIGNED(addr);
    if (trace_event_get_state(TRACE_USB_OHCI_MEM_WRITE_UNALIGNED)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_ohci_mem_write_unaligned " "at %x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , addr);
    }
}

static inline void trace_usb_ohci_mem_write_bad_offset(uint32_t addr)
{
    QEMU_USB_OHCI_MEM_WRITE_BAD_OFFSET(addr);
    if (trace_event_get_state(TRACE_USB_OHCI_MEM_WRITE_BAD_OFFSET)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_ohci_mem_write_bad_offset " "%x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , addr);
    }
}

static inline void trace_usb_ohci_process_lists(uint32_t head, uint32_t cur)
{
    QEMU_USB_OHCI_PROCESS_LISTS(head, cur);
    if (trace_event_get_state(TRACE_USB_OHCI_PROCESS_LISTS)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_ohci_process_lists " "head %x, cur %x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , head, cur);
    }
}

static inline void trace_usb_ohci_bus_eof_timer_failed(const char * name)
{
    QEMU_USB_OHCI_BUS_EOF_TIMER_FAILED(name);
    if (trace_event_get_state(TRACE_USB_OHCI_BUS_EOF_TIMER_FAILED)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_ohci_bus_eof_timer_failed " "%s: timer_new_ns failed" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , name);
    }
}

static inline void trace_usb_ohci_set_frame_interval(const char * name, uint16_t fi_x, uint16_t fi_u)
{
    QEMU_USB_OHCI_SET_FRAME_INTERVAL(name, fi_x, fi_u);
    if (trace_event_get_state(TRACE_USB_OHCI_SET_FRAME_INTERVAL)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_ohci_set_frame_interval " "%s: FrameInterval = 0x%x (%u)" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , name, fi_x, fi_u);
    }
}

static inline void trace_usb_ohci_hub_power_up(void)
{
    QEMU_USB_OHCI_HUB_POWER_UP();
    if (trace_event_get_state(TRACE_USB_OHCI_HUB_POWER_UP)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_ohci_hub_power_up " "powered up all ports" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      );
    }
}

static inline void trace_usb_ohci_hub_power_down(void)
{
    QEMU_USB_OHCI_HUB_POWER_DOWN();
    if (trace_event_get_state(TRACE_USB_OHCI_HUB_POWER_DOWN)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_ohci_hub_power_down " "powered down all ports" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      );
    }
}

static inline void trace_usb_ohci_init_time(int64_t frametime, int64_t bittime)
{
    QEMU_USB_OHCI_INIT_TIME(frametime, bittime);
    if (trace_event_get_state(TRACE_USB_OHCI_INIT_TIME)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_ohci_init_time " "usb_bit_time=%" PRId64 " usb_frame_time=%" PRId64 "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , frametime, bittime);
    }
}

static inline void trace_usb_ohci_die(void)
{
    QEMU_USB_OHCI_DIE();
    if (trace_event_get_state(TRACE_USB_OHCI_DIE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_ohci_die " "" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      );
    }
}

static inline void trace_usb_ohci_async_complete(void)
{
    QEMU_USB_OHCI_ASYNC_COMPLETE();
    if (trace_event_get_state(TRACE_USB_OHCI_ASYNC_COMPLETE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_ohci_async_complete " "" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      );
    }
}

static inline void trace_usb_ehci_reset(void)
{
    QEMU_USB_EHCI_RESET();
    if (trace_event_get_state(TRACE_USB_EHCI_RESET)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_ehci_reset " "=== RESET ===" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      );
    }
}

static inline void trace_usb_ehci_unrealize(void)
{
    QEMU_USB_EHCI_UNREALIZE();
    if (trace_event_get_state(TRACE_USB_EHCI_UNREALIZE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_ehci_unrealize " "=== UNREALIZE ===" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      );
    }
}

static inline void trace_usb_ehci_opreg_read(uint32_t addr, const char * str, uint32_t val)
{
    QEMU_USB_EHCI_OPREG_READ(addr, str, val);
    if (trace_event_get_state(TRACE_USB_EHCI_OPREG_READ)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_ehci_opreg_read " "rd mmio %04x [%s] = %x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , addr, str, val);
    }
}

static inline void trace_usb_ehci_opreg_write(uint32_t addr, const char * str, uint32_t val)
{
    QEMU_USB_EHCI_OPREG_WRITE(addr, str, val);
    if (trace_event_get_state(TRACE_USB_EHCI_OPREG_WRITE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_ehci_opreg_write " "wr mmio %04x [%s] = %x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , addr, str, val);
    }
}

static inline void trace_usb_ehci_opreg_change(uint32_t addr, const char * str, uint32_t new, uint32_t old)
{
    QEMU_USB_EHCI_OPREG_CHANGE(addr, str, new, old);
    if (trace_event_get_state(TRACE_USB_EHCI_OPREG_CHANGE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_ehci_opreg_change " "ch mmio %04x [%s] = %x (old: %x)" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , addr, str, new, old);
    }
}

static inline void trace_usb_ehci_portsc_read(uint32_t addr, uint32_t port, uint32_t val)
{
    QEMU_USB_EHCI_PORTSC_READ(addr, port, val);
    if (trace_event_get_state(TRACE_USB_EHCI_PORTSC_READ)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_ehci_portsc_read " "rd mmio %04x [port %d] = %x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , addr, port, val);
    }
}

static inline void trace_usb_ehci_portsc_write(uint32_t addr, uint32_t port, uint32_t val)
{
    QEMU_USB_EHCI_PORTSC_WRITE(addr, port, val);
    if (trace_event_get_state(TRACE_USB_EHCI_PORTSC_WRITE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_ehci_portsc_write " "wr mmio %04x [port %d] = %x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , addr, port, val);
    }
}

static inline void trace_usb_ehci_portsc_change(uint32_t addr, uint32_t port, uint32_t new, uint32_t old)
{
    QEMU_USB_EHCI_PORTSC_CHANGE(addr, port, new, old);
    if (trace_event_get_state(TRACE_USB_EHCI_PORTSC_CHANGE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_ehci_portsc_change " "ch mmio %04x [port %d] = %x (old: %x)" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , addr, port, new, old);
    }
}

static inline void trace_usb_ehci_usbsts(const char * sts, int state)
{
    QEMU_USB_EHCI_USBSTS(sts, state);
    if (trace_event_get_state(TRACE_USB_EHCI_USBSTS)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_ehci_usbsts " "usbsts %s %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , sts, state);
    }
}

static inline void trace_usb_ehci_state(const char * schedule, const char * state)
{
    QEMU_USB_EHCI_STATE(schedule, state);
    if (trace_event_get_state(TRACE_USB_EHCI_STATE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_ehci_state " "%s schedule %s" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , schedule, state);
    }
}

static inline void trace_usb_ehci_qh_ptrs(void * q, uint32_t addr, uint32_t nxt, uint32_t c_qtd, uint32_t n_qtd, uint32_t a_qtd)
{
    QEMU_USB_EHCI_QH_PTRS(q, addr, nxt, c_qtd, n_qtd, a_qtd);
    if (trace_event_get_state(TRACE_USB_EHCI_QH_PTRS)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_ehci_qh_ptrs " "q %p - QH @ %08x: next %08x qtds %08x,%08x,%08x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , q, addr, nxt, c_qtd, n_qtd, a_qtd);
    }
}

static inline void trace_usb_ehci_qh_fields(uint32_t addr, int rl, int mplen, int eps, int ep, int devaddr)
{
    QEMU_USB_EHCI_QH_FIELDS(addr, rl, mplen, eps, ep, devaddr);
    if (trace_event_get_state(TRACE_USB_EHCI_QH_FIELDS)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_ehci_qh_fields " "QH @ %08x - rl %d, mplen %d, eps %d, ep %d, dev %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , addr, rl, mplen, eps, ep, devaddr);
    }
}

static inline void trace_usb_ehci_qh_bits(uint32_t addr, int c, int h, int dtc, int i)
{
    QEMU_USB_EHCI_QH_BITS(addr, c, h, dtc, i);
    if (trace_event_get_state(TRACE_USB_EHCI_QH_BITS)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_ehci_qh_bits " "QH @ %08x - c %d, h %d, dtc %d, i %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , addr, c, h, dtc, i);
    }
}

static inline void trace_usb_ehci_qtd_ptrs(void * q, uint32_t addr, uint32_t nxt, uint32_t altnext)
{
    QEMU_USB_EHCI_QTD_PTRS(q, addr, nxt, altnext);
    if (trace_event_get_state(TRACE_USB_EHCI_QTD_PTRS)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_ehci_qtd_ptrs " "q %p - QTD @ %08x: next %08x altnext %08x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , q, addr, nxt, altnext);
    }
}

static inline void trace_usb_ehci_qtd_fields(uint32_t addr, int tbytes, int cpage, int cerr, int pid)
{
    QEMU_USB_EHCI_QTD_FIELDS(addr, tbytes, cpage, cerr, pid);
    if (trace_event_get_state(TRACE_USB_EHCI_QTD_FIELDS)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_ehci_qtd_fields " "QTD @ %08x - tbytes %d, cpage %d, cerr %d, pid %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , addr, tbytes, cpage, cerr, pid);
    }
}

static inline void trace_usb_ehci_qtd_bits(uint32_t addr, int ioc, int active, int halt, int babble, int xacterr)
{
    QEMU_USB_EHCI_QTD_BITS(addr, ioc, active, halt, babble, xacterr);
    if (trace_event_get_state(TRACE_USB_EHCI_QTD_BITS)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_ehci_qtd_bits " "QTD @ %08x - ioc %d, active %d, halt %d, babble %d, xacterr %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , addr, ioc, active, halt, babble, xacterr);
    }
}

static inline void trace_usb_ehci_itd(uint32_t addr, uint32_t nxt, uint32_t mplen, uint32_t mult, uint32_t ep, uint32_t devaddr)
{
    QEMU_USB_EHCI_ITD(addr, nxt, mplen, mult, ep, devaddr);
    if (trace_event_get_state(TRACE_USB_EHCI_ITD)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_ehci_itd " "ITD @ %08x: next %08x - mplen %d, mult %d, ep %d, dev %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , addr, nxt, mplen, mult, ep, devaddr);
    }
}

static inline void trace_usb_ehci_sitd(uint32_t addr, uint32_t nxt, uint32_t active)
{
    QEMU_USB_EHCI_SITD(addr, nxt, active);
    if (trace_event_get_state(TRACE_USB_EHCI_SITD)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_ehci_sitd " "ITD @ %08x: next %08x - active %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , addr, nxt, active);
    }
}

static inline void trace_usb_ehci_port_attach(uint32_t port, const char * owner, const char * device)
{
    QEMU_USB_EHCI_PORT_ATTACH(port, owner, device);
    if (trace_event_get_state(TRACE_USB_EHCI_PORT_ATTACH)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_ehci_port_attach " "attach port #%d, owner %s, device %s" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , port, owner, device);
    }
}

static inline void trace_usb_ehci_port_detach(uint32_t port, const char * owner)
{
    QEMU_USB_EHCI_PORT_DETACH(port, owner);
    if (trace_event_get_state(TRACE_USB_EHCI_PORT_DETACH)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_ehci_port_detach " "detach port #%d, owner %s" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , port, owner);
    }
}

static inline void trace_usb_ehci_port_reset(uint32_t port, int enable)
{
    QEMU_USB_EHCI_PORT_RESET(port, enable);
    if (trace_event_get_state(TRACE_USB_EHCI_PORT_RESET)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_ehci_port_reset " "reset port #%d - %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , port, enable);
    }
}

static inline void trace_usb_ehci_port_suspend(uint32_t port)
{
    QEMU_USB_EHCI_PORT_SUSPEND(port);
    if (trace_event_get_state(TRACE_USB_EHCI_PORT_SUSPEND)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_ehci_port_suspend " "port #%d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , port);
    }
}

static inline void trace_usb_ehci_port_wakeup(uint32_t port)
{
    QEMU_USB_EHCI_PORT_WAKEUP(port);
    if (trace_event_get_state(TRACE_USB_EHCI_PORT_WAKEUP)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_ehci_port_wakeup " "port #%d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , port);
    }
}

static inline void trace_usb_ehci_port_resume(uint32_t port)
{
    QEMU_USB_EHCI_PORT_RESUME(port);
    if (trace_event_get_state(TRACE_USB_EHCI_PORT_RESUME)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_ehci_port_resume " "port #%d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , port);
    }
}

static inline void trace_usb_ehci_queue_action(void * q, const char * action)
{
    QEMU_USB_EHCI_QUEUE_ACTION(q, action);
    if (trace_event_get_state(TRACE_USB_EHCI_QUEUE_ACTION)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_ehci_queue_action " "q %p: %s" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , q, action);
    }
}

static inline void trace_usb_ehci_packet_action(void * q, void * p, const char * action)
{
    QEMU_USB_EHCI_PACKET_ACTION(q, p, action);
    if (trace_event_get_state(TRACE_USB_EHCI_PACKET_ACTION)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_ehci_packet_action " "q %p p %p: %s" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , q, p, action);
    }
}

static inline void trace_usb_ehci_irq(uint32_t level, uint32_t frindex, uint32_t sts, uint32_t mask)
{
    QEMU_USB_EHCI_IRQ(level, frindex, sts, mask);
    if (trace_event_get_state(TRACE_USB_EHCI_IRQ)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_ehci_irq " "level %d, frindex 0x%04x, sts 0x%x, mask 0x%x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , level, frindex, sts, mask);
    }
}

static inline void trace_usb_ehci_guest_bug(const char * reason)
{
    QEMU_USB_EHCI_GUEST_BUG(reason);
    if (trace_event_get_state(TRACE_USB_EHCI_GUEST_BUG)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_ehci_guest_bug " "%s" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , reason);
    }
}

static inline void trace_usb_ehci_doorbell_ring(void)
{
    QEMU_USB_EHCI_DOORBELL_RING();
    if (trace_event_get_state(TRACE_USB_EHCI_DOORBELL_RING)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_ehci_doorbell_ring " "" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      );
    }
}

static inline void trace_usb_ehci_doorbell_ack(void)
{
    QEMU_USB_EHCI_DOORBELL_ACK();
    if (trace_event_get_state(TRACE_USB_EHCI_DOORBELL_ACK)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_ehci_doorbell_ack " "" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      );
    }
}

static inline void trace_usb_ehci_dma_error(void)
{
    QEMU_USB_EHCI_DMA_ERROR();
    if (trace_event_get_state(TRACE_USB_EHCI_DMA_ERROR)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_ehci_dma_error " "" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      );
    }
}

static inline void trace_usb_uhci_reset(void)
{
    QEMU_USB_UHCI_RESET();
    if (trace_event_get_state(TRACE_USB_UHCI_RESET)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_uhci_reset " "=== RESET ===" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      );
    }
}

static inline void trace_usb_uhci_exit(void)
{
    QEMU_USB_UHCI_EXIT();
    if (trace_event_get_state(TRACE_USB_UHCI_EXIT)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_uhci_exit " "=== EXIT ===" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      );
    }
}

static inline void trace_usb_uhci_schedule_start(void)
{
    QEMU_USB_UHCI_SCHEDULE_START();
    if (trace_event_get_state(TRACE_USB_UHCI_SCHEDULE_START)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_uhci_schedule_start " "" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      );
    }
}

static inline void trace_usb_uhci_schedule_stop(void)
{
    QEMU_USB_UHCI_SCHEDULE_STOP();
    if (trace_event_get_state(TRACE_USB_UHCI_SCHEDULE_STOP)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_uhci_schedule_stop " "" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      );
    }
}

static inline void trace_usb_uhci_frame_start(uint32_t num)
{
    QEMU_USB_UHCI_FRAME_START(num);
    if (trace_event_get_state(TRACE_USB_UHCI_FRAME_START)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_uhci_frame_start " "nr %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , num);
    }
}

static inline void trace_usb_uhci_frame_stop_bandwidth(void)
{
    QEMU_USB_UHCI_FRAME_STOP_BANDWIDTH();
    if (trace_event_get_state(TRACE_USB_UHCI_FRAME_STOP_BANDWIDTH)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_uhci_frame_stop_bandwidth " "" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      );
    }
}

static inline void trace_usb_uhci_frame_loop_stop_idle(void)
{
    QEMU_USB_UHCI_FRAME_LOOP_STOP_IDLE();
    if (trace_event_get_state(TRACE_USB_UHCI_FRAME_LOOP_STOP_IDLE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_uhci_frame_loop_stop_idle " "" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      );
    }
}

static inline void trace_usb_uhci_frame_loop_continue(void)
{
    QEMU_USB_UHCI_FRAME_LOOP_CONTINUE();
    if (trace_event_get_state(TRACE_USB_UHCI_FRAME_LOOP_CONTINUE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_uhci_frame_loop_continue " "" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      );
    }
}

static inline void trace_usb_uhci_mmio_readw(uint32_t addr, uint32_t val)
{
    QEMU_USB_UHCI_MMIO_READW(addr, val);
    if (trace_event_get_state(TRACE_USB_UHCI_MMIO_READW)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_uhci_mmio_readw " "addr 0x%04x, ret 0x%04x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , addr, val);
    }
}

static inline void trace_usb_uhci_mmio_writew(uint32_t addr, uint32_t val)
{
    QEMU_USB_UHCI_MMIO_WRITEW(addr, val);
    if (trace_event_get_state(TRACE_USB_UHCI_MMIO_WRITEW)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_uhci_mmio_writew " "addr 0x%04x, val 0x%04x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , addr, val);
    }
}

static inline void trace_usb_uhci_queue_add(uint32_t token)
{
    QEMU_USB_UHCI_QUEUE_ADD(token);
    if (trace_event_get_state(TRACE_USB_UHCI_QUEUE_ADD)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_uhci_queue_add " "token 0x%x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , token);
    }
}

static inline void trace_usb_uhci_queue_del(uint32_t token, const char * reason)
{
    QEMU_USB_UHCI_QUEUE_DEL(token, reason);
    if (trace_event_get_state(TRACE_USB_UHCI_QUEUE_DEL)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_uhci_queue_del " "token 0x%x: %s" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , token, reason);
    }
}

static inline void trace_usb_uhci_packet_add(uint32_t token, uint32_t addr)
{
    QEMU_USB_UHCI_PACKET_ADD(token, addr);
    if (trace_event_get_state(TRACE_USB_UHCI_PACKET_ADD)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_uhci_packet_add " "token 0x%x, td 0x%x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , token, addr);
    }
}

static inline void trace_usb_uhci_packet_link_async(uint32_t token, uint32_t addr)
{
    QEMU_USB_UHCI_PACKET_LINK_ASYNC(token, addr);
    if (trace_event_get_state(TRACE_USB_UHCI_PACKET_LINK_ASYNC)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_uhci_packet_link_async " "token 0x%x, td 0x%x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , token, addr);
    }
}

static inline void trace_usb_uhci_packet_unlink_async(uint32_t token, uint32_t addr)
{
    QEMU_USB_UHCI_PACKET_UNLINK_ASYNC(token, addr);
    if (trace_event_get_state(TRACE_USB_UHCI_PACKET_UNLINK_ASYNC)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_uhci_packet_unlink_async " "token 0x%x, td 0x%x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , token, addr);
    }
}

static inline void trace_usb_uhci_packet_cancel(uint32_t token, uint32_t addr, int done)
{
    QEMU_USB_UHCI_PACKET_CANCEL(token, addr, done);
    if (trace_event_get_state(TRACE_USB_UHCI_PACKET_CANCEL)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_uhci_packet_cancel " "token 0x%x, td 0x%x, done %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , token, addr, done);
    }
}

static inline void trace_usb_uhci_packet_complete_success(uint32_t token, uint32_t addr)
{
    QEMU_USB_UHCI_PACKET_COMPLETE_SUCCESS(token, addr);
    if (trace_event_get_state(TRACE_USB_UHCI_PACKET_COMPLETE_SUCCESS)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_uhci_packet_complete_success " "token 0x%x, td 0x%x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , token, addr);
    }
}

static inline void trace_usb_uhci_packet_complete_shortxfer(uint32_t token, uint32_t addr)
{
    QEMU_USB_UHCI_PACKET_COMPLETE_SHORTXFER(token, addr);
    if (trace_event_get_state(TRACE_USB_UHCI_PACKET_COMPLETE_SHORTXFER)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_uhci_packet_complete_shortxfer " "token 0x%x, td 0x%x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , token, addr);
    }
}

static inline void trace_usb_uhci_packet_complete_stall(uint32_t token, uint32_t addr)
{
    QEMU_USB_UHCI_PACKET_COMPLETE_STALL(token, addr);
    if (trace_event_get_state(TRACE_USB_UHCI_PACKET_COMPLETE_STALL)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_uhci_packet_complete_stall " "token 0x%x, td 0x%x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , token, addr);
    }
}

static inline void trace_usb_uhci_packet_complete_babble(uint32_t token, uint32_t addr)
{
    QEMU_USB_UHCI_PACKET_COMPLETE_BABBLE(token, addr);
    if (trace_event_get_state(TRACE_USB_UHCI_PACKET_COMPLETE_BABBLE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_uhci_packet_complete_babble " "token 0x%x, td 0x%x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , token, addr);
    }
}

static inline void trace_usb_uhci_packet_complete_error(uint32_t token, uint32_t addr)
{
    QEMU_USB_UHCI_PACKET_COMPLETE_ERROR(token, addr);
    if (trace_event_get_state(TRACE_USB_UHCI_PACKET_COMPLETE_ERROR)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_uhci_packet_complete_error " "token 0x%x, td 0x%x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , token, addr);
    }
}

static inline void trace_usb_uhci_packet_del(uint32_t token, uint32_t addr)
{
    QEMU_USB_UHCI_PACKET_DEL(token, addr);
    if (trace_event_get_state(TRACE_USB_UHCI_PACKET_DEL)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_uhci_packet_del " "token 0x%x, td 0x%x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , token, addr);
    }
}

static inline void trace_usb_uhci_qh_load(uint32_t qh)
{
    QEMU_USB_UHCI_QH_LOAD(qh);
    if (trace_event_get_state(TRACE_USB_UHCI_QH_LOAD)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_uhci_qh_load " "qh 0x%x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , qh);
    }
}

static inline void trace_usb_uhci_td_load(uint32_t qh, uint32_t td, uint32_t ctrl, uint32_t token)
{
    QEMU_USB_UHCI_TD_LOAD(qh, td, ctrl, token);
    if (trace_event_get_state(TRACE_USB_UHCI_TD_LOAD)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_uhci_td_load " "qh 0x%x, td 0x%x, ctrl 0x%x, token 0x%x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , qh, td, ctrl, token);
    }
}

static inline void trace_usb_uhci_td_queue(uint32_t td, uint32_t ctrl, uint32_t token)
{
    QEMU_USB_UHCI_TD_QUEUE(td, ctrl, token);
    if (trace_event_get_state(TRACE_USB_UHCI_TD_QUEUE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_uhci_td_queue " "td 0x%x, ctrl 0x%x, token 0x%x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , td, ctrl, token);
    }
}

static inline void trace_usb_uhci_td_nextqh(uint32_t qh, uint32_t td)
{
    QEMU_USB_UHCI_TD_NEXTQH(qh, td);
    if (trace_event_get_state(TRACE_USB_UHCI_TD_NEXTQH)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_uhci_td_nextqh " "qh 0x%x, td 0x%x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , qh, td);
    }
}

static inline void trace_usb_uhci_td_async(uint32_t qh, uint32_t td)
{
    QEMU_USB_UHCI_TD_ASYNC(qh, td);
    if (trace_event_get_state(TRACE_USB_UHCI_TD_ASYNC)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_uhci_td_async " "qh 0x%x, td 0x%x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , qh, td);
    }
}

static inline void trace_usb_uhci_td_complete(uint32_t qh, uint32_t td)
{
    QEMU_USB_UHCI_TD_COMPLETE(qh, td);
    if (trace_event_get_state(TRACE_USB_UHCI_TD_COMPLETE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_uhci_td_complete " "qh 0x%x, td 0x%x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , qh, td);
    }
}

static inline void trace_usb_xhci_reset(void)
{
    QEMU_USB_XHCI_RESET();
    if (trace_event_get_state(TRACE_USB_XHCI_RESET)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_xhci_reset " "=== RESET ===" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      );
    }
}

static inline void trace_usb_xhci_exit(void)
{
    QEMU_USB_XHCI_EXIT();
    if (trace_event_get_state(TRACE_USB_XHCI_EXIT)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_xhci_exit " "=== EXIT ===" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      );
    }
}

static inline void trace_usb_xhci_run(void)
{
    QEMU_USB_XHCI_RUN();
    if (trace_event_get_state(TRACE_USB_XHCI_RUN)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_xhci_run " "" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      );
    }
}

static inline void trace_usb_xhci_stop(void)
{
    QEMU_USB_XHCI_STOP();
    if (trace_event_get_state(TRACE_USB_XHCI_STOP)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_xhci_stop " "" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      );
    }
}

static inline void trace_usb_xhci_cap_read(uint32_t off, uint32_t val)
{
    QEMU_USB_XHCI_CAP_READ(off, val);
    if (trace_event_get_state(TRACE_USB_XHCI_CAP_READ)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_xhci_cap_read " "off 0x%04x, ret 0x%08x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , off, val);
    }
}

static inline void trace_usb_xhci_oper_read(uint32_t off, uint32_t val)
{
    QEMU_USB_XHCI_OPER_READ(off, val);
    if (trace_event_get_state(TRACE_USB_XHCI_OPER_READ)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_xhci_oper_read " "off 0x%04x, ret 0x%08x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , off, val);
    }
}

static inline void trace_usb_xhci_port_read(uint32_t port, uint32_t off, uint32_t val)
{
    QEMU_USB_XHCI_PORT_READ(port, off, val);
    if (trace_event_get_state(TRACE_USB_XHCI_PORT_READ)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_xhci_port_read " "port %d, off 0x%04x, ret 0x%08x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , port, off, val);
    }
}

static inline void trace_usb_xhci_runtime_read(uint32_t off, uint32_t val)
{
    QEMU_USB_XHCI_RUNTIME_READ(off, val);
    if (trace_event_get_state(TRACE_USB_XHCI_RUNTIME_READ)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_xhci_runtime_read " "off 0x%04x, ret 0x%08x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , off, val);
    }
}

static inline void trace_usb_xhci_doorbell_read(uint32_t off, uint32_t val)
{
    QEMU_USB_XHCI_DOORBELL_READ(off, val);
    if (trace_event_get_state(TRACE_USB_XHCI_DOORBELL_READ)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_xhci_doorbell_read " "off 0x%04x, ret 0x%08x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , off, val);
    }
}

static inline void trace_usb_xhci_oper_write(uint32_t off, uint32_t val)
{
    QEMU_USB_XHCI_OPER_WRITE(off, val);
    if (trace_event_get_state(TRACE_USB_XHCI_OPER_WRITE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_xhci_oper_write " "off 0x%04x, val 0x%08x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , off, val);
    }
}

static inline void trace_usb_xhci_port_write(uint32_t port, uint32_t off, uint32_t val)
{
    QEMU_USB_XHCI_PORT_WRITE(port, off, val);
    if (trace_event_get_state(TRACE_USB_XHCI_PORT_WRITE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_xhci_port_write " "port %d, off 0x%04x, val 0x%08x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , port, off, val);
    }
}

static inline void trace_usb_xhci_runtime_write(uint32_t off, uint32_t val)
{
    QEMU_USB_XHCI_RUNTIME_WRITE(off, val);
    if (trace_event_get_state(TRACE_USB_XHCI_RUNTIME_WRITE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_xhci_runtime_write " "off 0x%04x, val 0x%08x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , off, val);
    }
}

static inline void trace_usb_xhci_doorbell_write(uint32_t off, uint32_t val)
{
    QEMU_USB_XHCI_DOORBELL_WRITE(off, val);
    if (trace_event_get_state(TRACE_USB_XHCI_DOORBELL_WRITE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_xhci_doorbell_write " "off 0x%04x, val 0x%08x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , off, val);
    }
}

static inline void trace_usb_xhci_irq_intx(uint32_t level)
{
    QEMU_USB_XHCI_IRQ_INTX(level);
    if (trace_event_get_state(TRACE_USB_XHCI_IRQ_INTX)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_xhci_irq_intx " "level %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , level);
    }
}

static inline void trace_usb_xhci_irq_msi(uint32_t nr)
{
    QEMU_USB_XHCI_IRQ_MSI(nr);
    if (trace_event_get_state(TRACE_USB_XHCI_IRQ_MSI)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_xhci_irq_msi " "nr %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , nr);
    }
}

static inline void trace_usb_xhci_irq_msix(uint32_t nr)
{
    QEMU_USB_XHCI_IRQ_MSIX(nr);
    if (trace_event_get_state(TRACE_USB_XHCI_IRQ_MSIX)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_xhci_irq_msix " "nr %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , nr);
    }
}

static inline void trace_usb_xhci_irq_msix_use(uint32_t nr)
{
    QEMU_USB_XHCI_IRQ_MSIX_USE(nr);
    if (trace_event_get_state(TRACE_USB_XHCI_IRQ_MSIX_USE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_xhci_irq_msix_use " "nr %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , nr);
    }
}

static inline void trace_usb_xhci_irq_msix_unuse(uint32_t nr)
{
    QEMU_USB_XHCI_IRQ_MSIX_UNUSE(nr);
    if (trace_event_get_state(TRACE_USB_XHCI_IRQ_MSIX_UNUSE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_xhci_irq_msix_unuse " "nr %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , nr);
    }
}

static inline void trace_usb_xhci_queue_event(uint32_t vector, uint32_t idx, const char * trb, const char * evt, uint64_t param, uint32_t status, uint32_t control)
{
    QEMU_USB_XHCI_QUEUE_EVENT(vector, idx, trb, evt, param, status, control);
    if (trace_event_get_state(TRACE_USB_XHCI_QUEUE_EVENT)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_xhci_queue_event " "v %d, idx %d, %s, %s, p %016" PRIx64 ", s %08x, c 0x%08x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , vector, idx, trb, evt, param, status, control);
    }
}

static inline void trace_usb_xhci_fetch_trb(uint64_t addr, const char * name, uint64_t param, uint32_t status, uint32_t control)
{
    QEMU_USB_XHCI_FETCH_TRB(addr, name, param, status, control);
    if (trace_event_get_state(TRACE_USB_XHCI_FETCH_TRB)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_xhci_fetch_trb " "addr %016" PRIx64 ", %s, p %016" PRIx64 ", s %08x, c 0x%08x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , addr, name, param, status, control);
    }
}

static inline void trace_usb_xhci_port_reset(uint32_t port, bool warm)
{
    QEMU_USB_XHCI_PORT_RESET(port, warm);
    if (trace_event_get_state(TRACE_USB_XHCI_PORT_RESET)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_xhci_port_reset " "port %d, warm %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , port, warm);
    }
}

static inline void trace_usb_xhci_port_link(uint32_t port, uint32_t pls)
{
    QEMU_USB_XHCI_PORT_LINK(port, pls);
    if (trace_event_get_state(TRACE_USB_XHCI_PORT_LINK)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_xhci_port_link " "port %d, pls %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , port, pls);
    }
}

static inline void trace_usb_xhci_port_notify(uint32_t port, uint32_t pls)
{
    QEMU_USB_XHCI_PORT_NOTIFY(port, pls);
    if (trace_event_get_state(TRACE_USB_XHCI_PORT_NOTIFY)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_xhci_port_notify " "port %d, bits %x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , port, pls);
    }
}

static inline void trace_usb_xhci_slot_enable(uint32_t slotid)
{
    QEMU_USB_XHCI_SLOT_ENABLE(slotid);
    if (trace_event_get_state(TRACE_USB_XHCI_SLOT_ENABLE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_xhci_slot_enable " "slotid %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , slotid);
    }
}

static inline void trace_usb_xhci_slot_disable(uint32_t slotid)
{
    QEMU_USB_XHCI_SLOT_DISABLE(slotid);
    if (trace_event_get_state(TRACE_USB_XHCI_SLOT_DISABLE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_xhci_slot_disable " "slotid %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , slotid);
    }
}

static inline void trace_usb_xhci_slot_address(uint32_t slotid, const char * port)
{
    QEMU_USB_XHCI_SLOT_ADDRESS(slotid, port);
    if (trace_event_get_state(TRACE_USB_XHCI_SLOT_ADDRESS)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_xhci_slot_address " "slotid %d, port %s" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , slotid, port);
    }
}

static inline void trace_usb_xhci_slot_configure(uint32_t slotid)
{
    QEMU_USB_XHCI_SLOT_CONFIGURE(slotid);
    if (trace_event_get_state(TRACE_USB_XHCI_SLOT_CONFIGURE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_xhci_slot_configure " "slotid %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , slotid);
    }
}

static inline void trace_usb_xhci_slot_evaluate(uint32_t slotid)
{
    QEMU_USB_XHCI_SLOT_EVALUATE(slotid);
    if (trace_event_get_state(TRACE_USB_XHCI_SLOT_EVALUATE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_xhci_slot_evaluate " "slotid %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , slotid);
    }
}

static inline void trace_usb_xhci_slot_reset(uint32_t slotid)
{
    QEMU_USB_XHCI_SLOT_RESET(slotid);
    if (trace_event_get_state(TRACE_USB_XHCI_SLOT_RESET)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_xhci_slot_reset " "slotid %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , slotid);
    }
}

static inline void trace_usb_xhci_ep_enable(uint32_t slotid, uint32_t epid)
{
    QEMU_USB_XHCI_EP_ENABLE(slotid, epid);
    if (trace_event_get_state(TRACE_USB_XHCI_EP_ENABLE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_xhci_ep_enable " "slotid %d, epid %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , slotid, epid);
    }
}

static inline void trace_usb_xhci_ep_disable(uint32_t slotid, uint32_t epid)
{
    QEMU_USB_XHCI_EP_DISABLE(slotid, epid);
    if (trace_event_get_state(TRACE_USB_XHCI_EP_DISABLE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_xhci_ep_disable " "slotid %d, epid %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , slotid, epid);
    }
}

static inline void trace_usb_xhci_ep_set_dequeue(uint32_t slotid, uint32_t epid, uint32_t streamid, uint64_t param)
{
    QEMU_USB_XHCI_EP_SET_DEQUEUE(slotid, epid, streamid, param);
    if (trace_event_get_state(TRACE_USB_XHCI_EP_SET_DEQUEUE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_xhci_ep_set_dequeue " "slotid %d, epid %d, streamid %d, ptr %016" PRIx64 "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , slotid, epid, streamid, param);
    }
}

static inline void trace_usb_xhci_ep_kick(uint32_t slotid, uint32_t epid, uint32_t streamid)
{
    QEMU_USB_XHCI_EP_KICK(slotid, epid, streamid);
    if (trace_event_get_state(TRACE_USB_XHCI_EP_KICK)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_xhci_ep_kick " "slotid %d, epid %d, streamid %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , slotid, epid, streamid);
    }
}

static inline void trace_usb_xhci_ep_stop(uint32_t slotid, uint32_t epid)
{
    QEMU_USB_XHCI_EP_STOP(slotid, epid);
    if (trace_event_get_state(TRACE_USB_XHCI_EP_STOP)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_xhci_ep_stop " "slotid %d, epid %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , slotid, epid);
    }
}

static inline void trace_usb_xhci_ep_reset(uint32_t slotid, uint32_t epid)
{
    QEMU_USB_XHCI_EP_RESET(slotid, epid);
    if (trace_event_get_state(TRACE_USB_XHCI_EP_RESET)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_xhci_ep_reset " "slotid %d, epid %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , slotid, epid);
    }
}

static inline void trace_usb_xhci_ep_state(uint32_t slotid, uint32_t epid, const char * os, const char * ns)
{
    QEMU_USB_XHCI_EP_STATE(slotid, epid, os, ns);
    if (trace_event_get_state(TRACE_USB_XHCI_EP_STATE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_xhci_ep_state " "slotid %d, epid %d, %s -> %s" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , slotid, epid, os, ns);
    }
}

static inline void trace_usb_xhci_xfer_start(void * xfer, uint32_t slotid, uint32_t epid, uint32_t streamid)
{
    QEMU_USB_XHCI_XFER_START(xfer, slotid, epid, streamid);
    if (trace_event_get_state(TRACE_USB_XHCI_XFER_START)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_xhci_xfer_start " "%p: slotid %d, epid %d, streamid %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , xfer, slotid, epid, streamid);
    }
}

static inline void trace_usb_xhci_xfer_async(void * xfer)
{
    QEMU_USB_XHCI_XFER_ASYNC(xfer);
    if (trace_event_get_state(TRACE_USB_XHCI_XFER_ASYNC)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_xhci_xfer_async " "%p" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , xfer);
    }
}

static inline void trace_usb_xhci_xfer_nak(void * xfer)
{
    QEMU_USB_XHCI_XFER_NAK(xfer);
    if (trace_event_get_state(TRACE_USB_XHCI_XFER_NAK)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_xhci_xfer_nak " "%p" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , xfer);
    }
}

static inline void trace_usb_xhci_xfer_retry(void * xfer)
{
    QEMU_USB_XHCI_XFER_RETRY(xfer);
    if (trace_event_get_state(TRACE_USB_XHCI_XFER_RETRY)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_xhci_xfer_retry " "%p" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , xfer);
    }
}

static inline void trace_usb_xhci_xfer_success(void * xfer, uint32_t bytes)
{
    QEMU_USB_XHCI_XFER_SUCCESS(xfer, bytes);
    if (trace_event_get_state(TRACE_USB_XHCI_XFER_SUCCESS)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_xhci_xfer_success " "%p: len %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , xfer, bytes);
    }
}

static inline void trace_usb_xhci_xfer_error(void * xfer, uint32_t ret)
{
    QEMU_USB_XHCI_XFER_ERROR(xfer, ret);
    if (trace_event_get_state(TRACE_USB_XHCI_XFER_ERROR)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_xhci_xfer_error " "%p: ret %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , xfer, ret);
    }
}

static inline void trace_usb_xhci_unimplemented(const char * item, int nr)
{
    QEMU_USB_XHCI_UNIMPLEMENTED(item, nr);
    if (trace_event_get_state(TRACE_USB_XHCI_UNIMPLEMENTED)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_xhci_unimplemented " "%s (0x%x)" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , item, nr);
    }
}

static inline void trace_usb_desc_device(int addr, int len, int ret)
{
    QEMU_USB_DESC_DEVICE(addr, len, ret);
    if (trace_event_get_state(TRACE_USB_DESC_DEVICE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_desc_device " "dev %d query device, len %d, ret %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , addr, len, ret);
    }
}

static inline void trace_usb_desc_device_qualifier(int addr, int len, int ret)
{
    QEMU_USB_DESC_DEVICE_QUALIFIER(addr, len, ret);
    if (trace_event_get_state(TRACE_USB_DESC_DEVICE_QUALIFIER)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_desc_device_qualifier " "dev %d query device qualifier, len %d, ret %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , addr, len, ret);
    }
}

static inline void trace_usb_desc_config(int addr, int index, int len, int ret)
{
    QEMU_USB_DESC_CONFIG(addr, index, len, ret);
    if (trace_event_get_state(TRACE_USB_DESC_CONFIG)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_desc_config " "dev %d query config %d, len %d, ret %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , addr, index, len, ret);
    }
}

static inline void trace_usb_desc_other_speed_config(int addr, int index, int len, int ret)
{
    QEMU_USB_DESC_OTHER_SPEED_CONFIG(addr, index, len, ret);
    if (trace_event_get_state(TRACE_USB_DESC_OTHER_SPEED_CONFIG)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_desc_other_speed_config " "dev %d query config %d, len %d, ret %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , addr, index, len, ret);
    }
}

static inline void trace_usb_desc_string(int addr, int index, int len, int ret)
{
    QEMU_USB_DESC_STRING(addr, index, len, ret);
    if (trace_event_get_state(TRACE_USB_DESC_STRING)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_desc_string " "dev %d query string %d, len %d, ret %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , addr, index, len, ret);
    }
}

static inline void trace_usb_desc_bos(int addr, int len, int ret)
{
    QEMU_USB_DESC_BOS(addr, len, ret);
    if (trace_event_get_state(TRACE_USB_DESC_BOS)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_desc_bos " "dev %d bos, len %d, ret %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , addr, len, ret);
    }
}

static inline void trace_usb_desc_msos(int addr, int index, int len, int ret)
{
    QEMU_USB_DESC_MSOS(addr, index, len, ret);
    if (trace_event_get_state(TRACE_USB_DESC_MSOS)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_desc_msos " "dev %d msos, index 0x%x, len %d, ret %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , addr, index, len, ret);
    }
}

static inline void trace_usb_set_addr(int addr)
{
    QEMU_USB_SET_ADDR(addr);
    if (trace_event_get_state(TRACE_USB_SET_ADDR)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_set_addr " "dev %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , addr);
    }
}

static inline void trace_usb_set_config(int addr, int config, int ret)
{
    QEMU_USB_SET_CONFIG(addr, config, ret);
    if (trace_event_get_state(TRACE_USB_SET_CONFIG)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_set_config " "dev %d, config %d, ret %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , addr, config, ret);
    }
}

static inline void trace_usb_set_interface(int addr, int iface, int alt, int ret)
{
    QEMU_USB_SET_INTERFACE(addr, iface, alt, ret);
    if (trace_event_get_state(TRACE_USB_SET_INTERFACE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_set_interface " "dev %d, interface %d, altsetting %d, ret %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , addr, iface, alt, ret);
    }
}

static inline void trace_usb_clear_device_feature(int addr, int feature, int ret)
{
    QEMU_USB_CLEAR_DEVICE_FEATURE(addr, feature, ret);
    if (trace_event_get_state(TRACE_USB_CLEAR_DEVICE_FEATURE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_clear_device_feature " "dev %d, feature %d, ret %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , addr, feature, ret);
    }
}

static inline void trace_usb_set_device_feature(int addr, int feature, int ret)
{
    QEMU_USB_SET_DEVICE_FEATURE(addr, feature, ret);
    if (trace_event_get_state(TRACE_USB_SET_DEVICE_FEATURE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_set_device_feature " "dev %d, feature %d, ret %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , addr, feature, ret);
    }
}

static inline void trace_usb_hub_reset(int addr)
{
    QEMU_USB_HUB_RESET(addr);
    if (trace_event_get_state(TRACE_USB_HUB_RESET)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_hub_reset " "dev %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , addr);
    }
}

static inline void trace_usb_hub_control(int addr, int request, int value, int index, int length)
{
    QEMU_USB_HUB_CONTROL(addr, request, value, index, length);
    if (trace_event_get_state(TRACE_USB_HUB_CONTROL)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_hub_control " "dev %d, req 0x%x, value %d, index %d, langth %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , addr, request, value, index, length);
    }
}

static inline void trace_usb_hub_get_port_status(int addr, int nr, int status, int changed)
{
    QEMU_USB_HUB_GET_PORT_STATUS(addr, nr, status, changed);
    if (trace_event_get_state(TRACE_USB_HUB_GET_PORT_STATUS)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_hub_get_port_status " "dev %d, port %d, status 0x%x, changed 0x%x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , addr, nr, status, changed);
    }
}

static inline void trace_usb_hub_set_port_feature(int addr, int nr, const char * f)
{
    QEMU_USB_HUB_SET_PORT_FEATURE(addr, nr, f);
    if (trace_event_get_state(TRACE_USB_HUB_SET_PORT_FEATURE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_hub_set_port_feature " "dev %d, port %d, feature %s" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , addr, nr, f);
    }
}

static inline void trace_usb_hub_clear_port_feature(int addr, int nr, const char * f)
{
    QEMU_USB_HUB_CLEAR_PORT_FEATURE(addr, nr, f);
    if (trace_event_get_state(TRACE_USB_HUB_CLEAR_PORT_FEATURE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_hub_clear_port_feature " "dev %d, port %d, feature %s" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , addr, nr, f);
    }
}

static inline void trace_usb_hub_attach(int addr, int nr)
{
    QEMU_USB_HUB_ATTACH(addr, nr);
    if (trace_event_get_state(TRACE_USB_HUB_ATTACH)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_hub_attach " "dev %d, port %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , addr, nr);
    }
}

static inline void trace_usb_hub_detach(int addr, int nr)
{
    QEMU_USB_HUB_DETACH(addr, nr);
    if (trace_event_get_state(TRACE_USB_HUB_DETACH)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_hub_detach " "dev %d, port %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , addr, nr);
    }
}

static inline void trace_usb_hub_status_report(int addr, int status)
{
    QEMU_USB_HUB_STATUS_REPORT(addr, status);
    if (trace_event_get_state(TRACE_USB_HUB_STATUS_REPORT)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_hub_status_report " "dev %d, status 0x%x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , addr, status);
    }
}

static inline void trace_usb_uas_reset(int addr)
{
    QEMU_USB_UAS_RESET(addr);
    if (trace_event_get_state(TRACE_USB_UAS_RESET)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_uas_reset " "dev %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , addr);
    }
}

static inline void trace_usb_uas_command(int addr, uint16_t tag, int lun, uint32_t lun64_1, uint32_t lun64_2)
{
    QEMU_USB_UAS_COMMAND(addr, tag, lun, lun64_1, lun64_2);
    if (trace_event_get_state(TRACE_USB_UAS_COMMAND)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_uas_command " "dev %d, tag 0x%x, lun %d, lun64 %08x-%08x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , addr, tag, lun, lun64_1, lun64_2);
    }
}

static inline void trace_usb_uas_response(int addr, uint16_t tag, uint8_t code)
{
    QEMU_USB_UAS_RESPONSE(addr, tag, code);
    if (trace_event_get_state(TRACE_USB_UAS_RESPONSE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_uas_response " "dev %d, tag 0x%x, code 0x%x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , addr, tag, code);
    }
}

static inline void trace_usb_uas_sense(int addr, uint16_t tag, uint8_t status)
{
    QEMU_USB_UAS_SENSE(addr, tag, status);
    if (trace_event_get_state(TRACE_USB_UAS_SENSE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_uas_sense " "dev %d, tag 0x%x, status 0x%x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , addr, tag, status);
    }
}

static inline void trace_usb_uas_read_ready(int addr, uint16_t tag)
{
    QEMU_USB_UAS_READ_READY(addr, tag);
    if (trace_event_get_state(TRACE_USB_UAS_READ_READY)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_uas_read_ready " "dev %d, tag 0x%x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , addr, tag);
    }
}

static inline void trace_usb_uas_write_ready(int addr, uint16_t tag)
{
    QEMU_USB_UAS_WRITE_READY(addr, tag);
    if (trace_event_get_state(TRACE_USB_UAS_WRITE_READY)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_uas_write_ready " "dev %d, tag 0x%x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , addr, tag);
    }
}

static inline void trace_usb_uas_xfer_data(int addr, uint16_t tag, uint32_t copy, uint32_t uoff, uint32_t usize, uint32_t soff, uint32_t ssize)
{
    QEMU_USB_UAS_XFER_DATA(addr, tag, copy, uoff, usize, soff, ssize);
    if (trace_event_get_state(TRACE_USB_UAS_XFER_DATA)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_uas_xfer_data " "dev %d, tag 0x%x, copy %d, usb-pkt %d/%d, scsi-buf %d/%d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , addr, tag, copy, uoff, usize, soff, ssize);
    }
}

static inline void trace_usb_uas_scsi_data(int addr, uint16_t tag, uint32_t bytes)
{
    QEMU_USB_UAS_SCSI_DATA(addr, tag, bytes);
    if (trace_event_get_state(TRACE_USB_UAS_SCSI_DATA)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_uas_scsi_data " "dev %d, tag 0x%x, bytes %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , addr, tag, bytes);
    }
}

static inline void trace_usb_uas_scsi_complete(int addr, uint16_t tag, uint32_t status, uint32_t resid)
{
    QEMU_USB_UAS_SCSI_COMPLETE(addr, tag, status, resid);
    if (trace_event_get_state(TRACE_USB_UAS_SCSI_COMPLETE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_uas_scsi_complete " "dev %d, tag 0x%x, status 0x%x, residue %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , addr, tag, status, resid);
    }
}

static inline void trace_usb_uas_tmf_abort_task(int addr, uint16_t tag, uint16_t task_tag)
{
    QEMU_USB_UAS_TMF_ABORT_TASK(addr, tag, task_tag);
    if (trace_event_get_state(TRACE_USB_UAS_TMF_ABORT_TASK)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_uas_tmf_abort_task " "dev %d, tag 0x%x, task-tag 0x%x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , addr, tag, task_tag);
    }
}

static inline void trace_usb_uas_tmf_logical_unit_reset(int addr, uint16_t tag, int lun)
{
    QEMU_USB_UAS_TMF_LOGICAL_UNIT_RESET(addr, tag, lun);
    if (trace_event_get_state(TRACE_USB_UAS_TMF_LOGICAL_UNIT_RESET)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_uas_tmf_logical_unit_reset " "dev %d, tag 0x%x, lun %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , addr, tag, lun);
    }
}

static inline void trace_usb_uas_tmf_unsupported(int addr, uint16_t tag, uint32_t function)
{
    QEMU_USB_UAS_TMF_UNSUPPORTED(addr, tag, function);
    if (trace_event_get_state(TRACE_USB_UAS_TMF_UNSUPPORTED)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_uas_tmf_unsupported " "dev %d, tag 0x%x, function 0x%x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , addr, tag, function);
    }
}

static inline void trace_usb_mtp_reset(int addr)
{
    QEMU_USB_MTP_RESET(addr);
    if (trace_event_get_state(TRACE_USB_MTP_RESET)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_mtp_reset " "dev %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , addr);
    }
}

static inline void trace_usb_mtp_command(int dev, uint16_t code, uint32_t trans, uint32_t arg0, uint32_t arg1, uint32_t arg2, uint32_t arg3, uint32_t arg4)
{
    QEMU_USB_MTP_COMMAND(dev, code, trans, arg0, arg1, arg2, arg3, arg4);
    if (trace_event_get_state(TRACE_USB_MTP_COMMAND)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_mtp_command " "dev %d, code 0x%x, trans 0x%x, args 0x%x, 0x%x, 0x%x, 0x%x, 0x%x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , dev, code, trans, arg0, arg1, arg2, arg3, arg4);
    }
}

static inline void trace_usb_mtp_success(int dev, uint32_t trans, uint32_t arg0, uint32_t arg1)
{
    QEMU_USB_MTP_SUCCESS(dev, trans, arg0, arg1);
    if (trace_event_get_state(TRACE_USB_MTP_SUCCESS)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_mtp_success " "dev %d, trans 0x%x, args 0x%x, 0x%x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , dev, trans, arg0, arg1);
    }
}

static inline void trace_usb_mtp_error(int dev, uint16_t code, uint32_t trans, uint32_t arg0, uint32_t arg1)
{
    QEMU_USB_MTP_ERROR(dev, code, trans, arg0, arg1);
    if (trace_event_get_state(TRACE_USB_MTP_ERROR)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_mtp_error " "dev %d, code 0x%x, trans 0x%x, args 0x%x, 0x%x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , dev, code, trans, arg0, arg1);
    }
}

static inline void trace_usb_mtp_data_in(int dev, uint32_t trans, uint32_t len)
{
    QEMU_USB_MTP_DATA_IN(dev, trans, len);
    if (trace_event_get_state(TRACE_USB_MTP_DATA_IN)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_mtp_data_in " "dev %d, trans 0x%x, len %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , dev, trans, len);
    }
}

static inline void trace_usb_mtp_xfer(int dev, uint32_t ep, uint32_t dlen, uint32_t plen)
{
    QEMU_USB_MTP_XFER(dev, ep, dlen, plen);
    if (trace_event_get_state(TRACE_USB_MTP_XFER)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_mtp_xfer " "dev %d, ep %d, %d/%d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , dev, ep, dlen, plen);
    }
}

static inline void trace_usb_mtp_nak(int dev, uint32_t ep)
{
    QEMU_USB_MTP_NAK(dev, ep);
    if (trace_event_get_state(TRACE_USB_MTP_NAK)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_mtp_nak " "dev %d, ep %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , dev, ep);
    }
}

static inline void trace_usb_mtp_stall(int dev, const char * reason)
{
    QEMU_USB_MTP_STALL(dev, reason);
    if (trace_event_get_state(TRACE_USB_MTP_STALL)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_mtp_stall " "dev %d, reason: %s" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , dev, reason);
    }
}

static inline void trace_usb_mtp_op_get_device_info(int dev)
{
    QEMU_USB_MTP_OP_GET_DEVICE_INFO(dev);
    if (trace_event_get_state(TRACE_USB_MTP_OP_GET_DEVICE_INFO)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_mtp_op_get_device_info " "dev %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , dev);
    }
}

static inline void trace_usb_mtp_op_open_session(int dev)
{
    QEMU_USB_MTP_OP_OPEN_SESSION(dev);
    if (trace_event_get_state(TRACE_USB_MTP_OP_OPEN_SESSION)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_mtp_op_open_session " "dev %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , dev);
    }
}

static inline void trace_usb_mtp_op_close_session(int dev)
{
    QEMU_USB_MTP_OP_CLOSE_SESSION(dev);
    if (trace_event_get_state(TRACE_USB_MTP_OP_CLOSE_SESSION)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_mtp_op_close_session " "dev %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , dev);
    }
}

static inline void trace_usb_mtp_op_get_storage_ids(int dev)
{
    QEMU_USB_MTP_OP_GET_STORAGE_IDS(dev);
    if (trace_event_get_state(TRACE_USB_MTP_OP_GET_STORAGE_IDS)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_mtp_op_get_storage_ids " "dev %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , dev);
    }
}

static inline void trace_usb_mtp_op_get_storage_info(int dev)
{
    QEMU_USB_MTP_OP_GET_STORAGE_INFO(dev);
    if (trace_event_get_state(TRACE_USB_MTP_OP_GET_STORAGE_INFO)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_mtp_op_get_storage_info " "dev %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , dev);
    }
}

static inline void trace_usb_mtp_op_get_num_objects(int dev, uint32_t handle, const char * path)
{
    QEMU_USB_MTP_OP_GET_NUM_OBJECTS(dev, handle, path);
    if (trace_event_get_state(TRACE_USB_MTP_OP_GET_NUM_OBJECTS)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_mtp_op_get_num_objects " "dev %d, handle 0x%x, path %s" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , dev, handle, path);
    }
}

static inline void trace_usb_mtp_op_get_object_handles(int dev, uint32_t handle, const char * path)
{
    QEMU_USB_MTP_OP_GET_OBJECT_HANDLES(dev, handle, path);
    if (trace_event_get_state(TRACE_USB_MTP_OP_GET_OBJECT_HANDLES)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_mtp_op_get_object_handles " "dev %d, handle 0x%x, path %s" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , dev, handle, path);
    }
}

static inline void trace_usb_mtp_op_get_object_info(int dev, uint32_t handle, const char * path)
{
    QEMU_USB_MTP_OP_GET_OBJECT_INFO(dev, handle, path);
    if (trace_event_get_state(TRACE_USB_MTP_OP_GET_OBJECT_INFO)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_mtp_op_get_object_info " "dev %d, handle 0x%x, path %s" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , dev, handle, path);
    }
}

static inline void trace_usb_mtp_op_get_object(int dev, uint32_t handle, const char * path)
{
    QEMU_USB_MTP_OP_GET_OBJECT(dev, handle, path);
    if (trace_event_get_state(TRACE_USB_MTP_OP_GET_OBJECT)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_mtp_op_get_object " "dev %d, handle 0x%x, path %s" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , dev, handle, path);
    }
}

static inline void trace_usb_mtp_op_get_partial_object(int dev, uint32_t handle, const char * path, uint32_t offset, uint32_t length)
{
    QEMU_USB_MTP_OP_GET_PARTIAL_OBJECT(dev, handle, path, offset, length);
    if (trace_event_get_state(TRACE_USB_MTP_OP_GET_PARTIAL_OBJECT)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_mtp_op_get_partial_object " "dev %d, handle 0x%x, path %s, off %d, len %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , dev, handle, path, offset, length);
    }
}

static inline void trace_usb_mtp_op_unknown(int dev, uint32_t code)
{
    QEMU_USB_MTP_OP_UNKNOWN(dev, code);
    if (trace_event_get_state(TRACE_USB_MTP_OP_UNKNOWN)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_mtp_op_unknown " "dev %d, command code 0x%x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , dev, code);
    }
}

static inline void trace_usb_mtp_object_alloc(int dev, uint32_t handle, const char * path)
{
    QEMU_USB_MTP_OBJECT_ALLOC(dev, handle, path);
    if (trace_event_get_state(TRACE_USB_MTP_OBJECT_ALLOC)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_mtp_object_alloc " "dev %d, handle 0x%x, path %s" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , dev, handle, path);
    }
}

static inline void trace_usb_mtp_object_free(int dev, uint32_t handle, const char * path)
{
    QEMU_USB_MTP_OBJECT_FREE(dev, handle, path);
    if (trace_event_get_state(TRACE_USB_MTP_OBJECT_FREE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_mtp_object_free " "dev %d, handle 0x%x, path %s" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , dev, handle, path);
    }
}

static inline void trace_usb_host_open_started(int bus, int addr)
{
    QEMU_USB_HOST_OPEN_STARTED(bus, addr);
    if (trace_event_get_state(TRACE_USB_HOST_OPEN_STARTED)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_host_open_started " "dev %d:%d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , bus, addr);
    }
}

static inline void trace_usb_host_open_success(int bus, int addr)
{
    QEMU_USB_HOST_OPEN_SUCCESS(bus, addr);
    if (trace_event_get_state(TRACE_USB_HOST_OPEN_SUCCESS)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_host_open_success " "dev %d:%d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , bus, addr);
    }
}

static inline void trace_usb_host_open_failure(int bus, int addr)
{
    QEMU_USB_HOST_OPEN_FAILURE(bus, addr);
    if (trace_event_get_state(TRACE_USB_HOST_OPEN_FAILURE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_host_open_failure " "dev %d:%d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , bus, addr);
    }
}

static inline void trace_usb_host_close(int bus, int addr)
{
    QEMU_USB_HOST_CLOSE(bus, addr);
    if (trace_event_get_state(TRACE_USB_HOST_CLOSE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_host_close " "dev %d:%d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , bus, addr);
    }
}

static inline void trace_usb_host_attach_kernel(int bus, int addr, int interface)
{
    QEMU_USB_HOST_ATTACH_KERNEL(bus, addr, interface);
    if (trace_event_get_state(TRACE_USB_HOST_ATTACH_KERNEL)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_host_attach_kernel " "dev %d:%d, if %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , bus, addr, interface);
    }
}

static inline void trace_usb_host_detach_kernel(int bus, int addr, int interface)
{
    QEMU_USB_HOST_DETACH_KERNEL(bus, addr, interface);
    if (trace_event_get_state(TRACE_USB_HOST_DETACH_KERNEL)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_host_detach_kernel " "dev %d:%d, if %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , bus, addr, interface);
    }
}

static inline void trace_usb_host_set_address(int bus, int addr, int config)
{
    QEMU_USB_HOST_SET_ADDRESS(bus, addr, config);
    if (trace_event_get_state(TRACE_USB_HOST_SET_ADDRESS)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_host_set_address " "dev %d:%d, address %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , bus, addr, config);
    }
}

static inline void trace_usb_host_set_config(int bus, int addr, int config)
{
    QEMU_USB_HOST_SET_CONFIG(bus, addr, config);
    if (trace_event_get_state(TRACE_USB_HOST_SET_CONFIG)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_host_set_config " "dev %d:%d, config %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , bus, addr, config);
    }
}

static inline void trace_usb_host_set_interface(int bus, int addr, int interface, int alt)
{
    QEMU_USB_HOST_SET_INTERFACE(bus, addr, interface, alt);
    if (trace_event_get_state(TRACE_USB_HOST_SET_INTERFACE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_host_set_interface " "dev %d:%d, interface %d, alt %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , bus, addr, interface, alt);
    }
}

static inline void trace_usb_host_claim_interface(int bus, int addr, int config, int interface)
{
    QEMU_USB_HOST_CLAIM_INTERFACE(bus, addr, config, interface);
    if (trace_event_get_state(TRACE_USB_HOST_CLAIM_INTERFACE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_host_claim_interface " "dev %d:%d, config %d, if %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , bus, addr, config, interface);
    }
}

static inline void trace_usb_host_release_interface(int bus, int addr, int interface)
{
    QEMU_USB_HOST_RELEASE_INTERFACE(bus, addr, interface);
    if (trace_event_get_state(TRACE_USB_HOST_RELEASE_INTERFACE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_host_release_interface " "dev %d:%d, if %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , bus, addr, interface);
    }
}

static inline void trace_usb_host_req_control(int bus, int addr, void * p, int req, int value, int index)
{
    QEMU_USB_HOST_REQ_CONTROL(bus, addr, p, req, value, index);
    if (trace_event_get_state(TRACE_USB_HOST_REQ_CONTROL)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_host_req_control " "dev %d:%d, packet %p, req 0x%x, value %d, index %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , bus, addr, p, req, value, index);
    }
}

static inline void trace_usb_host_req_data(int bus, int addr, void * p, int in, int ep, int size)
{
    QEMU_USB_HOST_REQ_DATA(bus, addr, p, in, ep, size);
    if (trace_event_get_state(TRACE_USB_HOST_REQ_DATA)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_host_req_data " "dev %d:%d, packet %p, in %d, ep %d, size %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , bus, addr, p, in, ep, size);
    }
}

static inline void trace_usb_host_req_complete(int bus, int addr, void * p, int status, int length)
{
    QEMU_USB_HOST_REQ_COMPLETE(bus, addr, p, status, length);
    if (trace_event_get_state(TRACE_USB_HOST_REQ_COMPLETE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_host_req_complete " "dev %d:%d, packet %p, status %d, length %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , bus, addr, p, status, length);
    }
}

static inline void trace_usb_host_req_emulated(int bus, int addr, void * p, int status)
{
    QEMU_USB_HOST_REQ_EMULATED(bus, addr, p, status);
    if (trace_event_get_state(TRACE_USB_HOST_REQ_EMULATED)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_host_req_emulated " "dev %d:%d, packet %p, status %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , bus, addr, p, status);
    }
}

static inline void trace_usb_host_req_canceled(int bus, int addr, void * p)
{
    QEMU_USB_HOST_REQ_CANCELED(bus, addr, p);
    if (trace_event_get_state(TRACE_USB_HOST_REQ_CANCELED)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_host_req_canceled " "dev %d:%d, packet %p" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , bus, addr, p);
    }
}

static inline void trace_usb_host_iso_start(int bus, int addr, int ep)
{
    QEMU_USB_HOST_ISO_START(bus, addr, ep);
    if (trace_event_get_state(TRACE_USB_HOST_ISO_START)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_host_iso_start " "dev %d:%d, ep %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , bus, addr, ep);
    }
}

static inline void trace_usb_host_iso_stop(int bus, int addr, int ep)
{
    QEMU_USB_HOST_ISO_STOP(bus, addr, ep);
    if (trace_event_get_state(TRACE_USB_HOST_ISO_STOP)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_host_iso_stop " "dev %d:%d, ep %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , bus, addr, ep);
    }
}

static inline void trace_usb_host_iso_out_of_bufs(int bus, int addr, int ep)
{
    QEMU_USB_HOST_ISO_OUT_OF_BUFS(bus, addr, ep);
    if (trace_event_get_state(TRACE_USB_HOST_ISO_OUT_OF_BUFS)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_host_iso_out_of_bufs " "dev %d:%d, ep %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , bus, addr, ep);
    }
}

static inline void trace_usb_host_reset(int bus, int addr)
{
    QEMU_USB_HOST_RESET(bus, addr);
    if (trace_event_get_state(TRACE_USB_HOST_RESET)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_host_reset " "dev %d:%d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , bus, addr);
    }
}

static inline void trace_usb_host_auto_scan_enabled(void)
{
    QEMU_USB_HOST_AUTO_SCAN_ENABLED();
    if (trace_event_get_state(TRACE_USB_HOST_AUTO_SCAN_ENABLED)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_host_auto_scan_enabled "  "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      );
    }
}

static inline void trace_usb_host_auto_scan_disabled(void)
{
    QEMU_USB_HOST_AUTO_SCAN_DISABLED();
    if (trace_event_get_state(TRACE_USB_HOST_AUTO_SCAN_DISABLED)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_host_auto_scan_disabled "  "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      );
    }
}

static inline void trace_usb_host_parse_config(int bus, int addr, int value, int active)
{
    QEMU_USB_HOST_PARSE_CONFIG(bus, addr, value, active);
    if (trace_event_get_state(TRACE_USB_HOST_PARSE_CONFIG)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_host_parse_config " "dev %d:%d, value %d, active %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , bus, addr, value, active);
    }
}

static inline void trace_usb_host_parse_interface(int bus, int addr, int num, int alt, int active)
{
    QEMU_USB_HOST_PARSE_INTERFACE(bus, addr, num, alt, active);
    if (trace_event_get_state(TRACE_USB_HOST_PARSE_INTERFACE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_host_parse_interface " "dev %d:%d, num %d, alt %d, active %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , bus, addr, num, alt, active);
    }
}

static inline void trace_usb_host_parse_endpoint(int bus, int addr, int ep, const char * dir, const char * type, int active)
{
    QEMU_USB_HOST_PARSE_ENDPOINT(bus, addr, ep, dir, type, active);
    if (trace_event_get_state(TRACE_USB_HOST_PARSE_ENDPOINT)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_host_parse_endpoint " "dev %d:%d, ep %d, %s, %s, active %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , bus, addr, ep, dir, type, active);
    }
}

static inline void trace_usb_host_parse_error(int bus, int addr, const char * errmsg)
{
    QEMU_USB_HOST_PARSE_ERROR(bus, addr, errmsg);
    if (trace_event_get_state(TRACE_USB_HOST_PARSE_ERROR)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:usb_host_parse_error " "dev %d:%d, msg %s" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , bus, addr, errmsg);
    }
}

static inline void trace_scsi_req_alloc(int target, int lun, int tag)
{
    QEMU_SCSI_REQ_ALLOC(target, lun, tag);
    if (trace_event_get_state(TRACE_SCSI_REQ_ALLOC)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:scsi_req_alloc " "target %d lun %d tag %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , target, lun, tag);
    }
}

static inline void trace_scsi_req_cancel(int target, int lun, int tag)
{
    QEMU_SCSI_REQ_CANCEL(target, lun, tag);
    if (trace_event_get_state(TRACE_SCSI_REQ_CANCEL)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:scsi_req_cancel " "target %d lun %d tag %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , target, lun, tag);
    }
}

static inline void trace_scsi_req_data(int target, int lun, int tag, int len)
{
    QEMU_SCSI_REQ_DATA(target, lun, tag, len);
    if (trace_event_get_state(TRACE_SCSI_REQ_DATA)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:scsi_req_data " "target %d lun %d tag %d len %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , target, lun, tag, len);
    }
}

static inline void trace_scsi_req_data_canceled(int target, int lun, int tag, int len)
{
    QEMU_SCSI_REQ_DATA_CANCELED(target, lun, tag, len);
    if (trace_event_get_state(TRACE_SCSI_REQ_DATA_CANCELED)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:scsi_req_data_canceled " "target %d lun %d tag %d len %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , target, lun, tag, len);
    }
}

static inline void trace_scsi_req_dequeue(int target, int lun, int tag)
{
    QEMU_SCSI_REQ_DEQUEUE(target, lun, tag);
    if (trace_event_get_state(TRACE_SCSI_REQ_DEQUEUE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:scsi_req_dequeue " "target %d lun %d tag %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , target, lun, tag);
    }
}

static inline void trace_scsi_req_continue(int target, int lun, int tag)
{
    QEMU_SCSI_REQ_CONTINUE(target, lun, tag);
    if (trace_event_get_state(TRACE_SCSI_REQ_CONTINUE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:scsi_req_continue " "target %d lun %d tag %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , target, lun, tag);
    }
}

static inline void trace_scsi_req_continue_canceled(int target, int lun, int tag)
{
    QEMU_SCSI_REQ_CONTINUE_CANCELED(target, lun, tag);
    if (trace_event_get_state(TRACE_SCSI_REQ_CONTINUE_CANCELED)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:scsi_req_continue_canceled " "target %d lun %d tag %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , target, lun, tag);
    }
}

static inline void trace_scsi_req_parsed(int target, int lun, int tag, int cmd, int mode, int xfer)
{
    QEMU_SCSI_REQ_PARSED(target, lun, tag, cmd, mode, xfer);
    if (trace_event_get_state(TRACE_SCSI_REQ_PARSED)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:scsi_req_parsed " "target %d lun %d tag %d command %d dir %d length %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , target, lun, tag, cmd, mode, xfer);
    }
}

static inline void trace_scsi_req_parsed_lba(int target, int lun, int tag, int cmd, uint64_t lba)
{
    QEMU_SCSI_REQ_PARSED_LBA(target, lun, tag, cmd, lba);
    if (trace_event_get_state(TRACE_SCSI_REQ_PARSED_LBA)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:scsi_req_parsed_lba " "target %d lun %d tag %d command %d lba %"PRIu64 "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , target, lun, tag, cmd, lba);
    }
}

static inline void trace_scsi_req_parse_bad(int target, int lun, int tag, int cmd)
{
    QEMU_SCSI_REQ_PARSE_BAD(target, lun, tag, cmd);
    if (trace_event_get_state(TRACE_SCSI_REQ_PARSE_BAD)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:scsi_req_parse_bad " "target %d lun %d tag %d command %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , target, lun, tag, cmd);
    }
}

static inline void trace_scsi_req_build_sense(int target, int lun, int tag, int key, int asc, int ascq)
{
    QEMU_SCSI_REQ_BUILD_SENSE(target, lun, tag, key, asc, ascq);
    if (trace_event_get_state(TRACE_SCSI_REQ_BUILD_SENSE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:scsi_req_build_sense " "target %d lun %d tag %d key %#02x asc %#02x ascq %#02x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , target, lun, tag, key, asc, ascq);
    }
}

static inline void trace_scsi_device_set_ua(int target, int lun, int key, int asc, int ascq)
{
    QEMU_SCSI_DEVICE_SET_UA(target, lun, key, asc, ascq);
    if (trace_event_get_state(TRACE_SCSI_DEVICE_SET_UA)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:scsi_device_set_ua " "target %d lun %d key %#02x asc %#02x ascq %#02x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , target, lun, key, asc, ascq);
    }
}

static inline void trace_scsi_report_luns(int target, int lun, int tag)
{
    QEMU_SCSI_REPORT_LUNS(target, lun, tag);
    if (trace_event_get_state(TRACE_SCSI_REPORT_LUNS)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:scsi_report_luns " "target %d lun %d tag %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , target, lun, tag);
    }
}

static inline void trace_scsi_inquiry(int target, int lun, int tag, int cdb1, int cdb2)
{
    QEMU_SCSI_INQUIRY(target, lun, tag, cdb1, cdb2);
    if (trace_event_get_state(TRACE_SCSI_INQUIRY)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:scsi_inquiry " "target %d lun %d tag %d page %#02x/%#02x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , target, lun, tag, cdb1, cdb2);
    }
}

static inline void trace_scsi_test_unit_ready(int target, int lun, int tag)
{
    QEMU_SCSI_TEST_UNIT_READY(target, lun, tag);
    if (trace_event_get_state(TRACE_SCSI_TEST_UNIT_READY)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:scsi_test_unit_ready " "target %d lun %d tag %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , target, lun, tag);
    }
}

static inline void trace_scsi_request_sense(int target, int lun, int tag)
{
    QEMU_SCSI_REQUEST_SENSE(target, lun, tag);
    if (trace_event_get_state(TRACE_SCSI_REQUEST_SENSE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:scsi_request_sense " "target %d lun %d tag %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , target, lun, tag);
    }
}

static inline void trace_vm_state_notify(int running, int reason)
{
    QEMU_VM_STATE_NOTIFY(running, reason);
    if (trace_event_get_state(TRACE_VM_STATE_NOTIFY)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:vm_state_notify " "running %d reason %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , running, reason);
    }
}

static inline void trace_load_file(const char * name, const char * path)
{
    QEMU_LOAD_FILE(name, path);
    if (trace_event_get_state(TRACE_LOAD_FILE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:load_file " "name %s location %s" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , name, path);
    }
}

static inline void trace_runstate_set(int new_state)
{
    QEMU_RUNSTATE_SET(new_state);
    if (trace_event_get_state(TRACE_RUNSTATE_SET)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:runstate_set " "new state %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , new_state);
    }
}

static inline void trace_system_wakeup_request(int reason)
{
    QEMU_SYSTEM_WAKEUP_REQUEST(reason);
    if (trace_event_get_state(TRACE_SYSTEM_WAKEUP_REQUEST)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:system_wakeup_request " "reason=%d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , reason);
    }
}

static inline void trace_qemu_system_shutdown_request(void)
{
    QEMU_QEMU_SYSTEM_SHUTDOWN_REQUEST();
    if (trace_event_get_state(TRACE_QEMU_SYSTEM_SHUTDOWN_REQUEST)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qemu_system_shutdown_request " "" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      );
    }
}

static inline void trace_qemu_system_powerdown_request(void)
{
    QEMU_QEMU_SYSTEM_POWERDOWN_REQUEST();
    if (trace_event_get_state(TRACE_QEMU_SYSTEM_POWERDOWN_REQUEST)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qemu_system_powerdown_request " "" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      );
    }
}

static inline void trace_qcow2_writev_start_req(void * co, int64_t sector, int nb_sectors)
{
    QEMU_QCOW2_WRITEV_START_REQ(co, sector, nb_sectors);
    if (trace_event_get_state(TRACE_QCOW2_WRITEV_START_REQ)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qcow2_writev_start_req " "co %p sector %" PRIx64 " nb_sectors %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , co, sector, nb_sectors);
    }
}

static inline void trace_qcow2_writev_done_req(void * co, int ret)
{
    QEMU_QCOW2_WRITEV_DONE_REQ(co, ret);
    if (trace_event_get_state(TRACE_QCOW2_WRITEV_DONE_REQ)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qcow2_writev_done_req " "co %p ret %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , co, ret);
    }
}

static inline void trace_qcow2_writev_start_part(void * co)
{
    QEMU_QCOW2_WRITEV_START_PART(co);
    if (trace_event_get_state(TRACE_QCOW2_WRITEV_START_PART)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qcow2_writev_start_part " "co %p" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , co);
    }
}

static inline void trace_qcow2_writev_done_part(void * co, int cur_nr_sectors)
{
    QEMU_QCOW2_WRITEV_DONE_PART(co, cur_nr_sectors);
    if (trace_event_get_state(TRACE_QCOW2_WRITEV_DONE_PART)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qcow2_writev_done_part " "co %p cur_nr_sectors %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , co, cur_nr_sectors);
    }
}

static inline void trace_qcow2_writev_data(void * co, uint64_t offset)
{
    QEMU_QCOW2_WRITEV_DATA(co, offset);
    if (trace_event_get_state(TRACE_QCOW2_WRITEV_DATA)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qcow2_writev_data " "co %p offset %" PRIx64 "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , co, offset);
    }
}

static inline void trace_qcow2_write_zeroes_start_req(void * co, int64_t sector, int nb_sectors)
{
    QEMU_QCOW2_WRITE_ZEROES_START_REQ(co, sector, nb_sectors);
    if (trace_event_get_state(TRACE_QCOW2_WRITE_ZEROES_START_REQ)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qcow2_write_zeroes_start_req " "co %p sector %" PRIx64 " nb_sectors %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , co, sector, nb_sectors);
    }
}

static inline void trace_qcow2_write_zeroes(void * co, int64_t sector, int nb_sectors)
{
    QEMU_QCOW2_WRITE_ZEROES(co, sector, nb_sectors);
    if (trace_event_get_state(TRACE_QCOW2_WRITE_ZEROES)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qcow2_write_zeroes " "co %p sector %" PRIx64 " nb_sectors %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , co, sector, nb_sectors);
    }
}

static inline void trace_qcow2_alloc_clusters_offset(void * co, uint64_t offset, int num)
{
    QEMU_QCOW2_ALLOC_CLUSTERS_OFFSET(co, offset, num);
    if (trace_event_get_state(TRACE_QCOW2_ALLOC_CLUSTERS_OFFSET)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qcow2_alloc_clusters_offset " "co %p offset %" PRIx64 " num %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , co, offset, num);
    }
}

static inline void trace_qcow2_handle_copied(void * co, uint64_t guest_offset, uint64_t host_offset, uint64_t bytes)
{
    QEMU_QCOW2_HANDLE_COPIED(co, guest_offset, host_offset, bytes);
    if (trace_event_get_state(TRACE_QCOW2_HANDLE_COPIED)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qcow2_handle_copied " "co %p guest_offset %" PRIx64 " host_offset %" PRIx64 " bytes %" PRIx64 "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , co, guest_offset, host_offset, bytes);
    }
}

static inline void trace_qcow2_handle_alloc(void * co, uint64_t guest_offset, uint64_t host_offset, uint64_t bytes)
{
    QEMU_QCOW2_HANDLE_ALLOC(co, guest_offset, host_offset, bytes);
    if (trace_event_get_state(TRACE_QCOW2_HANDLE_ALLOC)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qcow2_handle_alloc " "co %p guest_offset %" PRIx64 " host_offset %" PRIx64 " bytes %" PRIx64 "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , co, guest_offset, host_offset, bytes);
    }
}

static inline void trace_qcow2_do_alloc_clusters_offset(void * co, uint64_t guest_offset, uint64_t host_offset, int nb_clusters)
{
    QEMU_QCOW2_DO_ALLOC_CLUSTERS_OFFSET(co, guest_offset, host_offset, nb_clusters);
    if (trace_event_get_state(TRACE_QCOW2_DO_ALLOC_CLUSTERS_OFFSET)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qcow2_do_alloc_clusters_offset " "co %p guest_offset %" PRIx64 " host_offset %" PRIx64 " nb_clusters %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , co, guest_offset, host_offset, nb_clusters);
    }
}

static inline void trace_qcow2_cluster_alloc_phys(void * co)
{
    QEMU_QCOW2_CLUSTER_ALLOC_PHYS(co);
    if (trace_event_get_state(TRACE_QCOW2_CLUSTER_ALLOC_PHYS)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qcow2_cluster_alloc_phys " "co %p" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , co);
    }
}

static inline void trace_qcow2_cluster_link_l2(void * co, int nb_clusters)
{
    QEMU_QCOW2_CLUSTER_LINK_L2(co, nb_clusters);
    if (trace_event_get_state(TRACE_QCOW2_CLUSTER_LINK_L2)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qcow2_cluster_link_l2 " "co %p nb_clusters %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , co, nb_clusters);
    }
}

static inline void trace_qcow2_l2_allocate(void * bs, int l1_index)
{
    QEMU_QCOW2_L2_ALLOCATE(bs, l1_index);
    if (trace_event_get_state(TRACE_QCOW2_L2_ALLOCATE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qcow2_l2_allocate " "bs %p l1_index %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , bs, l1_index);
    }
}

static inline void trace_qcow2_l2_allocate_get_empty(void * bs, int l1_index)
{
    QEMU_QCOW2_L2_ALLOCATE_GET_EMPTY(bs, l1_index);
    if (trace_event_get_state(TRACE_QCOW2_L2_ALLOCATE_GET_EMPTY)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qcow2_l2_allocate_get_empty " "bs %p l1_index %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , bs, l1_index);
    }
}

static inline void trace_qcow2_l2_allocate_write_l2(void * bs, int l1_index)
{
    QEMU_QCOW2_L2_ALLOCATE_WRITE_L2(bs, l1_index);
    if (trace_event_get_state(TRACE_QCOW2_L2_ALLOCATE_WRITE_L2)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qcow2_l2_allocate_write_l2 " "bs %p l1_index %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , bs, l1_index);
    }
}

static inline void trace_qcow2_l2_allocate_write_l1(void * bs, int l1_index)
{
    QEMU_QCOW2_L2_ALLOCATE_WRITE_L1(bs, l1_index);
    if (trace_event_get_state(TRACE_QCOW2_L2_ALLOCATE_WRITE_L1)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qcow2_l2_allocate_write_l1 " "bs %p l1_index %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , bs, l1_index);
    }
}

static inline void trace_qcow2_l2_allocate_done(void * bs, int l1_index, int ret)
{
    QEMU_QCOW2_L2_ALLOCATE_DONE(bs, l1_index, ret);
    if (trace_event_get_state(TRACE_QCOW2_L2_ALLOCATE_DONE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qcow2_l2_allocate_done " "bs %p l1_index %d ret %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , bs, l1_index, ret);
    }
}

static inline void trace_qcow2_cache_get(void * co, int c, uint64_t offset, bool read_from_disk)
{
    QEMU_QCOW2_CACHE_GET(co, c, offset, read_from_disk);
    if (trace_event_get_state(TRACE_QCOW2_CACHE_GET)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qcow2_cache_get " "co %p is_l2_cache %d offset %" PRIx64 " read_from_disk %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , co, c, offset, read_from_disk);
    }
}

static inline void trace_qcow2_cache_get_replace_entry(void * co, int c, int i)
{
    QEMU_QCOW2_CACHE_GET_REPLACE_ENTRY(co, c, i);
    if (trace_event_get_state(TRACE_QCOW2_CACHE_GET_REPLACE_ENTRY)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qcow2_cache_get_replace_entry " "co %p is_l2_cache %d index %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , co, c, i);
    }
}

static inline void trace_qcow2_cache_get_read(void * co, int c, int i)
{
    QEMU_QCOW2_CACHE_GET_READ(co, c, i);
    if (trace_event_get_state(TRACE_QCOW2_CACHE_GET_READ)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qcow2_cache_get_read " "co %p is_l2_cache %d index %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , co, c, i);
    }
}

static inline void trace_qcow2_cache_get_done(void * co, int c, int i)
{
    QEMU_QCOW2_CACHE_GET_DONE(co, c, i);
    if (trace_event_get_state(TRACE_QCOW2_CACHE_GET_DONE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qcow2_cache_get_done " "co %p is_l2_cache %d index %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , co, c, i);
    }
}

static inline void trace_qcow2_cache_flush(void * co, int c)
{
    QEMU_QCOW2_CACHE_FLUSH(co, c);
    if (trace_event_get_state(TRACE_QCOW2_CACHE_FLUSH)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qcow2_cache_flush " "co %p is_l2_cache %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , co, c);
    }
}

static inline void trace_qcow2_cache_entry_flush(void * co, int c, int i)
{
    QEMU_QCOW2_CACHE_ENTRY_FLUSH(co, c, i);
    if (trace_event_get_state(TRACE_QCOW2_CACHE_ENTRY_FLUSH)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qcow2_cache_entry_flush " "co %p is_l2_cache %d index %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , co, c, i);
    }
}

static inline void trace_qed_alloc_l2_cache_entry(void * l2_cache, void * entry)
{
    QEMU_QED_ALLOC_L2_CACHE_ENTRY(l2_cache, entry);
    if (trace_event_get_state(TRACE_QED_ALLOC_L2_CACHE_ENTRY)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qed_alloc_l2_cache_entry " "l2_cache %p entry %p" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , l2_cache, entry);
    }
}

static inline void trace_qed_unref_l2_cache_entry(void * entry, int ref)
{
    QEMU_QED_UNREF_L2_CACHE_ENTRY(entry, ref);
    if (trace_event_get_state(TRACE_QED_UNREF_L2_CACHE_ENTRY)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qed_unref_l2_cache_entry " "entry %p ref %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , entry, ref);
    }
}

static inline void trace_qed_find_l2_cache_entry(void * l2_cache, void * entry, uint64_t offset, int ref)
{
    QEMU_QED_FIND_L2_CACHE_ENTRY(l2_cache, entry, offset, ref);
    if (trace_event_get_state(TRACE_QED_FIND_L2_CACHE_ENTRY)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qed_find_l2_cache_entry " "l2_cache %p entry %p offset %"PRIu64" ref %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , l2_cache, entry, offset, ref);
    }
}

static inline void trace_qed_read_table(void * s, uint64_t offset, void * table)
{
    QEMU_QED_READ_TABLE(s, offset, table);
    if (trace_event_get_state(TRACE_QED_READ_TABLE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qed_read_table " "s %p offset %"PRIu64" table %p" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , s, offset, table);
    }
}

static inline void trace_qed_read_table_cb(void * s, void * table, int ret)
{
    QEMU_QED_READ_TABLE_CB(s, table, ret);
    if (trace_event_get_state(TRACE_QED_READ_TABLE_CB)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qed_read_table_cb " "s %p table %p ret %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , s, table, ret);
    }
}

static inline void trace_qed_write_table(void * s, uint64_t offset, void * table, unsigned int index, unsigned int n)
{
    QEMU_QED_WRITE_TABLE(s, offset, table, index, n);
    if (trace_event_get_state(TRACE_QED_WRITE_TABLE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qed_write_table " "s %p offset %"PRIu64" table %p index %u n %u" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , s, offset, table, index, n);
    }
}

static inline void trace_qed_write_table_cb(void * s, void * table, int flush, int ret)
{
    QEMU_QED_WRITE_TABLE_CB(s, table, flush, ret);
    if (trace_event_get_state(TRACE_QED_WRITE_TABLE_CB)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qed_write_table_cb " "s %p table %p flush %d ret %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , s, table, flush, ret);
    }
}

static inline void trace_qed_need_check_timer_cb(void * s)
{
    QEMU_QED_NEED_CHECK_TIMER_CB(s);
    if (trace_event_get_state(TRACE_QED_NEED_CHECK_TIMER_CB)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qed_need_check_timer_cb " "s %p" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , s);
    }
}

static inline void trace_qed_start_need_check_timer(void * s)
{
    QEMU_QED_START_NEED_CHECK_TIMER(s);
    if (trace_event_get_state(TRACE_QED_START_NEED_CHECK_TIMER)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qed_start_need_check_timer " "s %p" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , s);
    }
}

static inline void trace_qed_cancel_need_check_timer(void * s)
{
    QEMU_QED_CANCEL_NEED_CHECK_TIMER(s);
    if (trace_event_get_state(TRACE_QED_CANCEL_NEED_CHECK_TIMER)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qed_cancel_need_check_timer " "s %p" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , s);
    }
}

static inline void trace_qed_aio_complete(void * s, void * acb, int ret)
{
    QEMU_QED_AIO_COMPLETE(s, acb, ret);
    if (trace_event_get_state(TRACE_QED_AIO_COMPLETE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qed_aio_complete " "s %p acb %p ret %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , s, acb, ret);
    }
}

static inline void trace_qed_aio_setup(void * s, void * acb, int64_t sector_num, int nb_sectors, void * opaque, int flags)
{
    QEMU_QED_AIO_SETUP(s, acb, sector_num, nb_sectors, opaque, flags);
    if (trace_event_get_state(TRACE_QED_AIO_SETUP)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qed_aio_setup " "s %p acb %p sector_num %"PRId64" nb_sectors %d opaque %p flags %#x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , s, acb, sector_num, nb_sectors, opaque, flags);
    }
}

static inline void trace_qed_aio_next_io(void * s, void * acb, int ret, uint64_t cur_pos)
{
    QEMU_QED_AIO_NEXT_IO(s, acb, ret, cur_pos);
    if (trace_event_get_state(TRACE_QED_AIO_NEXT_IO)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qed_aio_next_io " "s %p acb %p ret %d cur_pos %"PRIu64 "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , s, acb, ret, cur_pos);
    }
}

static inline void trace_qed_aio_read_data(void * s, void * acb, int ret, uint64_t offset, size_t len)
{
    QEMU_QED_AIO_READ_DATA(s, acb, ret, offset, len);
    if (trace_event_get_state(TRACE_QED_AIO_READ_DATA)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qed_aio_read_data " "s %p acb %p ret %d offset %"PRIu64" len %zu" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , s, acb, ret, offset, len);
    }
}

static inline void trace_qed_aio_write_data(void * s, void * acb, int ret, uint64_t offset, size_t len)
{
    QEMU_QED_AIO_WRITE_DATA(s, acb, ret, offset, len);
    if (trace_event_get_state(TRACE_QED_AIO_WRITE_DATA)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qed_aio_write_data " "s %p acb %p ret %d offset %"PRIu64" len %zu" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , s, acb, ret, offset, len);
    }
}

static inline void trace_qed_aio_write_prefill(void * s, void * acb, uint64_t start, size_t len, uint64_t offset)
{
    QEMU_QED_AIO_WRITE_PREFILL(s, acb, start, len, offset);
    if (trace_event_get_state(TRACE_QED_AIO_WRITE_PREFILL)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qed_aio_write_prefill " "s %p acb %p start %"PRIu64" len %zu offset %"PRIu64 "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , s, acb, start, len, offset);
    }
}

static inline void trace_qed_aio_write_postfill(void * s, void * acb, uint64_t start, size_t len, uint64_t offset)
{
    QEMU_QED_AIO_WRITE_POSTFILL(s, acb, start, len, offset);
    if (trace_event_get_state(TRACE_QED_AIO_WRITE_POSTFILL)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qed_aio_write_postfill " "s %p acb %p start %"PRIu64" len %zu offset %"PRIu64 "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , s, acb, start, len, offset);
    }
}

static inline void trace_qed_aio_write_main(void * s, void * acb, int ret, uint64_t offset, size_t len)
{
    QEMU_QED_AIO_WRITE_MAIN(s, acb, ret, offset, len);
    if (trace_event_get_state(TRACE_QED_AIO_WRITE_MAIN)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qed_aio_write_main " "s %p acb %p ret %d offset %"PRIu64" len %zu" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , s, acb, ret, offset, len);
    }
}

static inline void trace_g364fb_read(uint64_t addr, uint32_t val)
{
    QEMU_G364FB_READ(addr, val);
    if (trace_event_get_state(TRACE_G364FB_READ)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:g364fb_read " "read addr=0x%"PRIx64": 0x%x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , addr, val);
    }
}

static inline void trace_g364fb_write(uint64_t addr, uint32_t new)
{
    QEMU_G364FB_WRITE(addr, new);
    if (trace_event_get_state(TRACE_G364FB_WRITE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:g364fb_write " "write addr=0x%"PRIx64": 0x%x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , addr, new);
    }
}

static inline void trace_grlib_gptimer_enable(int id, uint32_t count)
{
    QEMU_GRLIB_GPTIMER_ENABLE(id, count);
    if (trace_event_get_state(TRACE_GRLIB_GPTIMER_ENABLE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:grlib_gptimer_enable " "timer:%d set count 0x%x and run" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , id, count);
    }
}

static inline void trace_grlib_gptimer_disabled(int id, uint32_t config)
{
    QEMU_GRLIB_GPTIMER_DISABLED(id, config);
    if (trace_event_get_state(TRACE_GRLIB_GPTIMER_DISABLED)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:grlib_gptimer_disabled " "timer:%d Timer disable config 0x%x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , id, config);
    }
}

static inline void trace_grlib_gptimer_restart(int id, uint32_t reload)
{
    QEMU_GRLIB_GPTIMER_RESTART(id, reload);
    if (trace_event_get_state(TRACE_GRLIB_GPTIMER_RESTART)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:grlib_gptimer_restart " "timer:%d reload val: 0x%x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , id, reload);
    }
}

static inline void trace_grlib_gptimer_set_scaler(uint32_t scaler, uint32_t freq)
{
    QEMU_GRLIB_GPTIMER_SET_SCALER(scaler, freq);
    if (trace_event_get_state(TRACE_GRLIB_GPTIMER_SET_SCALER)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:grlib_gptimer_set_scaler " "scaler:0x%x freq: 0x%x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , scaler, freq);
    }
}

static inline void trace_grlib_gptimer_hit(int id)
{
    QEMU_GRLIB_GPTIMER_HIT(id);
    if (trace_event_get_state(TRACE_GRLIB_GPTIMER_HIT)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:grlib_gptimer_hit " "timer:%d HIT" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , id);
    }
}

static inline void trace_grlib_gptimer_readl(int id, uint64_t addr, uint32_t val)
{
    QEMU_GRLIB_GPTIMER_READL(id, addr, val);
    if (trace_event_get_state(TRACE_GRLIB_GPTIMER_READL)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:grlib_gptimer_readl " "timer:%d addr 0x%"PRIx64" 0x%x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , id, addr, val);
    }
}

static inline void trace_grlib_gptimer_writel(int id, uint64_t addr, uint32_t val)
{
    QEMU_GRLIB_GPTIMER_WRITEL(id, addr, val);
    if (trace_event_get_state(TRACE_GRLIB_GPTIMER_WRITEL)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:grlib_gptimer_writel " "timer:%d addr 0x%"PRIx64" 0x%x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , id, addr, val);
    }
}

static inline void trace_grlib_irqmp_check_irqs(uint32_t pend, uint32_t force, uint32_t mask, uint32_t lvl1, uint32_t lvl2)
{
    QEMU_GRLIB_IRQMP_CHECK_IRQS(pend, force, mask, lvl1, lvl2);
    if (trace_event_get_state(TRACE_GRLIB_IRQMP_CHECK_IRQS)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:grlib_irqmp_check_irqs " "pend:0x%04x force:0x%04x mask:0x%04x lvl1:0x%04x lvl0:0x%04x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , pend, force, mask, lvl1, lvl2);
    }
}

static inline void trace_grlib_irqmp_ack(int intno)
{
    QEMU_GRLIB_IRQMP_ACK(intno);
    if (trace_event_get_state(TRACE_GRLIB_IRQMP_ACK)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:grlib_irqmp_ack " "interrupt:%d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , intno);
    }
}

static inline void trace_grlib_irqmp_set_irq(int irq)
{
    QEMU_GRLIB_IRQMP_SET_IRQ(irq);
    if (trace_event_get_state(TRACE_GRLIB_IRQMP_SET_IRQ)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:grlib_irqmp_set_irq " "Raise CPU IRQ %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , irq);
    }
}

static inline void trace_grlib_irqmp_readl_unknown(uint64_t addr)
{
    QEMU_GRLIB_IRQMP_READL_UNKNOWN(addr);
    if (trace_event_get_state(TRACE_GRLIB_IRQMP_READL_UNKNOWN)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:grlib_irqmp_readl_unknown " "addr 0x%"PRIx64 "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , addr);
    }
}

static inline void trace_grlib_irqmp_writel_unknown(uint64_t addr, uint32_t value)
{
    QEMU_GRLIB_IRQMP_WRITEL_UNKNOWN(addr, value);
    if (trace_event_get_state(TRACE_GRLIB_IRQMP_WRITEL_UNKNOWN)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:grlib_irqmp_writel_unknown " "addr 0x%"PRIx64" value 0x%x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , addr, value);
    }
}

static inline void trace_grlib_apbuart_event(int event)
{
    QEMU_GRLIB_APBUART_EVENT(event);
    if (trace_event_get_state(TRACE_GRLIB_APBUART_EVENT)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:grlib_apbuart_event " "event:%d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , event);
    }
}

static inline void trace_grlib_apbuart_writel_unknown(uint64_t addr, uint32_t value)
{
    QEMU_GRLIB_APBUART_WRITEL_UNKNOWN(addr, value);
    if (trace_event_get_state(TRACE_GRLIB_APBUART_WRITEL_UNKNOWN)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:grlib_apbuart_writel_unknown " "addr 0x%"PRIx64" value 0x%x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , addr, value);
    }
}

static inline void trace_grlib_apbuart_readl_unknown(uint64_t addr)
{
    QEMU_GRLIB_APBUART_READL_UNKNOWN(addr);
    if (trace_event_get_state(TRACE_GRLIB_APBUART_READL_UNKNOWN)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:grlib_apbuart_readl_unknown " "addr 0x%"PRIx64"" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , addr);
    }
}

static inline void trace_leon3_set_irq(int intno)
{
    QEMU_LEON3_SET_IRQ(intno);
    if (trace_event_get_state(TRACE_LEON3_SET_IRQ)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:leon3_set_irq " "Set CPU IRQ %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , intno);
    }
}

static inline void trace_leon3_reset_irq(int intno)
{
    QEMU_LEON3_RESET_IRQ(intno);
    if (trace_event_get_state(TRACE_LEON3_RESET_IRQ)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:leon3_reset_irq " "Reset CPU IRQ %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , intno);
    }
}

static inline void trace_spice_vmc_write(ssize_t out, int len)
{
    QEMU_SPICE_VMC_WRITE(out, len);
    if (trace_event_get_state(TRACE_SPICE_VMC_WRITE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:spice_vmc_write " "spice wrottn %zd of requested %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , out, len);
    }
}

static inline void trace_spice_vmc_read(int bytes, int len)
{
    QEMU_SPICE_VMC_READ(bytes, len);
    if (trace_event_get_state(TRACE_SPICE_VMC_READ)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:spice_vmc_read " "spice read %d of requested %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , bytes, len);
    }
}

static inline void trace_spice_vmc_register_interface(void * scd)
{
    QEMU_SPICE_VMC_REGISTER_INTERFACE(scd);
    if (trace_event_get_state(TRACE_SPICE_VMC_REGISTER_INTERFACE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:spice_vmc_register_interface " "spice vmc registered interface %p" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , scd);
    }
}

static inline void trace_spice_vmc_unregister_interface(void * scd)
{
    QEMU_SPICE_VMC_UNREGISTER_INTERFACE(scd);
    if (trace_event_get_state(TRACE_SPICE_VMC_UNREGISTER_INTERFACE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:spice_vmc_unregister_interface " "spice vmc unregistered interface %p" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , scd);
    }
}

static inline void trace_spice_vmc_event(int event)
{
    QEMU_SPICE_VMC_EVENT(event);
    if (trace_event_get_state(TRACE_SPICE_VMC_EVENT)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:spice_vmc_event " "spice vmc event %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , event);
    }
}

static inline void trace_lm32_pic_raise_irq(void)
{
    QEMU_LM32_PIC_RAISE_IRQ();
    if (trace_event_get_state(TRACE_LM32_PIC_RAISE_IRQ)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:lm32_pic_raise_irq " "Raise CPU interrupt" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      );
    }
}

static inline void trace_lm32_pic_lower_irq(void)
{
    QEMU_LM32_PIC_LOWER_IRQ();
    if (trace_event_get_state(TRACE_LM32_PIC_LOWER_IRQ)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:lm32_pic_lower_irq " "Lower CPU interrupt" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      );
    }
}

static inline void trace_lm32_pic_interrupt(int irq, int level)
{
    QEMU_LM32_PIC_INTERRUPT(irq, level);
    if (trace_event_get_state(TRACE_LM32_PIC_INTERRUPT)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:lm32_pic_interrupt " "Set IRQ%d %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , irq, level);
    }
}

static inline void trace_lm32_pic_set_im(uint32_t im)
{
    QEMU_LM32_PIC_SET_IM(im);
    if (trace_event_get_state(TRACE_LM32_PIC_SET_IM)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:lm32_pic_set_im " "im 0x%08x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , im);
    }
}

static inline void trace_lm32_pic_set_ip(uint32_t ip)
{
    QEMU_LM32_PIC_SET_IP(ip);
    if (trace_event_get_state(TRACE_LM32_PIC_SET_IP)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:lm32_pic_set_ip " "ip 0x%08x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , ip);
    }
}

static inline void trace_lm32_pic_get_im(uint32_t im)
{
    QEMU_LM32_PIC_GET_IM(im);
    if (trace_event_get_state(TRACE_LM32_PIC_GET_IM)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:lm32_pic_get_im " "im 0x%08x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , im);
    }
}

static inline void trace_lm32_pic_get_ip(uint32_t ip)
{
    QEMU_LM32_PIC_GET_IP(ip);
    if (trace_event_get_state(TRACE_LM32_PIC_GET_IP)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:lm32_pic_get_ip " "ip 0x%08x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , ip);
    }
}

static inline void trace_lm32_juart_get_jtx(uint32_t value)
{
    QEMU_LM32_JUART_GET_JTX(value);
    if (trace_event_get_state(TRACE_LM32_JUART_GET_JTX)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:lm32_juart_get_jtx " "jtx 0x%08x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , value);
    }
}

static inline void trace_lm32_juart_set_jtx(uint32_t value)
{
    QEMU_LM32_JUART_SET_JTX(value);
    if (trace_event_get_state(TRACE_LM32_JUART_SET_JTX)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:lm32_juart_set_jtx " "jtx 0x%08x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , value);
    }
}

static inline void trace_lm32_juart_get_jrx(uint32_t value)
{
    QEMU_LM32_JUART_GET_JRX(value);
    if (trace_event_get_state(TRACE_LM32_JUART_GET_JRX)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:lm32_juart_get_jrx " "jrx 0x%08x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , value);
    }
}

static inline void trace_lm32_juart_set_jrx(uint32_t value)
{
    QEMU_LM32_JUART_SET_JRX(value);
    if (trace_event_get_state(TRACE_LM32_JUART_SET_JRX)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:lm32_juart_set_jrx " "jrx 0x%08x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , value);
    }
}

static inline void trace_lm32_timer_memory_write(uint32_t addr, uint32_t value)
{
    QEMU_LM32_TIMER_MEMORY_WRITE(addr, value);
    if (trace_event_get_state(TRACE_LM32_TIMER_MEMORY_WRITE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:lm32_timer_memory_write " "addr 0x%08x value 0x%08x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , addr, value);
    }
}

static inline void trace_lm32_timer_memory_read(uint32_t addr, uint32_t value)
{
    QEMU_LM32_TIMER_MEMORY_READ(addr, value);
    if (trace_event_get_state(TRACE_LM32_TIMER_MEMORY_READ)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:lm32_timer_memory_read " "addr 0x%08x value 0x%08x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , addr, value);
    }
}

static inline void trace_lm32_timer_hit(void)
{
    QEMU_LM32_TIMER_HIT();
    if (trace_event_get_state(TRACE_LM32_TIMER_HIT)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:lm32_timer_hit " "timer hit" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      );
    }
}

static inline void trace_lm32_timer_irq_state(int level)
{
    QEMU_LM32_TIMER_IRQ_STATE(level);
    if (trace_event_get_state(TRACE_LM32_TIMER_IRQ_STATE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:lm32_timer_irq_state " "irq state %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , level);
    }
}

static inline void trace_lm32_uart_memory_write(uint32_t addr, uint32_t value)
{
    QEMU_LM32_UART_MEMORY_WRITE(addr, value);
    if (trace_event_get_state(TRACE_LM32_UART_MEMORY_WRITE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:lm32_uart_memory_write " "addr 0x%08x value 0x%08x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , addr, value);
    }
}

static inline void trace_lm32_uart_memory_read(uint32_t addr, uint32_t value)
{
    QEMU_LM32_UART_MEMORY_READ(addr, value);
    if (trace_event_get_state(TRACE_LM32_UART_MEMORY_READ)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:lm32_uart_memory_read " "addr 0x%08x value 0x%08x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , addr, value);
    }
}

static inline void trace_lm32_uart_irq_state(int level)
{
    QEMU_LM32_UART_IRQ_STATE(level);
    if (trace_event_get_state(TRACE_LM32_UART_IRQ_STATE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:lm32_uart_irq_state " "irq state %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , level);
    }
}

static inline void trace_megasas_init_firmware(uint64_t pa)
{
    QEMU_MEGASAS_INIT_FIRMWARE(pa);
    if (trace_event_get_state(TRACE_MEGASAS_INIT_FIRMWARE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:megasas_init_firmware " "pa %" PRIx64 " " "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , pa);
    }
}

static inline void trace_megasas_init_queue(uint64_t queue_pa, int queue_len, uint64_t head, uint64_t tail, uint32_t flags)
{
    QEMU_MEGASAS_INIT_QUEUE(queue_pa, queue_len, head, tail, flags);
    if (trace_event_get_state(TRACE_MEGASAS_INIT_QUEUE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:megasas_init_queue " "queue at %" PRIx64 " len %d head %" PRIx64 " tail %" PRIx64 " flags %x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , queue_pa, queue_len, head, tail, flags);
    }
}

static inline void trace_megasas_initq_map_failed(int frame)
{
    QEMU_MEGASAS_INITQ_MAP_FAILED(frame);
    if (trace_event_get_state(TRACE_MEGASAS_INITQ_MAP_FAILED)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:megasas_initq_map_failed " "scmd %d: failed to map queue" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , frame);
    }
}

static inline void trace_megasas_initq_mapped(uint64_t pa)
{
    QEMU_MEGASAS_INITQ_MAPPED(pa);
    if (trace_event_get_state(TRACE_MEGASAS_INITQ_MAPPED)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:megasas_initq_mapped " "queue already mapped at %" PRIx64 "" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , pa);
    }
}

static inline void trace_megasas_initq_mismatch(int queue_len, int fw_cmds)
{
    QEMU_MEGASAS_INITQ_MISMATCH(queue_len, fw_cmds);
    if (trace_event_get_state(TRACE_MEGASAS_INITQ_MISMATCH)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:megasas_initq_mismatch " "queue size %d max fw cmds %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , queue_len, fw_cmds);
    }
}

static inline void trace_megasas_qf_mapped(unsigned int index)
{
    QEMU_MEGASAS_QF_MAPPED(index);
    if (trace_event_get_state(TRACE_MEGASAS_QF_MAPPED)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:megasas_qf_mapped " "skip mapped frame %x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , index);
    }
}

static inline void trace_megasas_qf_new(unsigned int index, uint64_t frame)
{
    QEMU_MEGASAS_QF_NEW(index, frame);
    if (trace_event_get_state(TRACE_MEGASAS_QF_NEW)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:megasas_qf_new " "frame %x addr %" PRIx64 "" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , index, frame);
    }
}

static inline void trace_megasas_qf_busy(unsigned long pa)
{
    QEMU_MEGASAS_QF_BUSY(pa);
    if (trace_event_get_state(TRACE_MEGASAS_QF_BUSY)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:megasas_qf_busy " "all frames busy for frame %lx" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , pa);
    }
}

static inline void trace_megasas_qf_enqueue(unsigned int index, unsigned int count, uint64_t context, unsigned int head, unsigned int tail, int busy)
{
    QEMU_MEGASAS_QF_ENQUEUE(index, count, context, head, tail, busy);
    if (trace_event_get_state(TRACE_MEGASAS_QF_ENQUEUE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:megasas_qf_enqueue " "frame %x count %d context %" PRIx64 " head %x tail %x busy %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , index, count, context, head, tail, busy);
    }
}

static inline void trace_megasas_qf_update(unsigned int head, unsigned int tail, unsigned int busy)
{
    QEMU_MEGASAS_QF_UPDATE(head, tail, busy);
    if (trace_event_get_state(TRACE_MEGASAS_QF_UPDATE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:megasas_qf_update " "head %x tail %x busy %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , head, tail, busy);
    }
}

static inline void trace_megasas_qf_map_failed(int cmd, unsigned long frame)
{
    QEMU_MEGASAS_QF_MAP_FAILED(cmd, frame);
    if (trace_event_get_state(TRACE_MEGASAS_QF_MAP_FAILED)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:megasas_qf_map_failed " "scmd %d: frame %lu" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , cmd, frame);
    }
}

static inline void trace_megasas_qf_complete_noirq(uint64_t context)
{
    QEMU_MEGASAS_QF_COMPLETE_NOIRQ(context);
    if (trace_event_get_state(TRACE_MEGASAS_QF_COMPLETE_NOIRQ)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:megasas_qf_complete_noirq " "context %" PRIx64 " " "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , context);
    }
}

static inline void trace_megasas_qf_complete(uint64_t context, unsigned int head, unsigned int tail, int busy)
{
    QEMU_MEGASAS_QF_COMPLETE(context, head, tail, busy);
    if (trace_event_get_state(TRACE_MEGASAS_QF_COMPLETE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:megasas_qf_complete " "context %" PRIx64 " head %x tail %x busy %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , context, head, tail, busy);
    }
}

static inline void trace_megasas_frame_busy(uint64_t addr)
{
    QEMU_MEGASAS_FRAME_BUSY(addr);
    if (trace_event_get_state(TRACE_MEGASAS_FRAME_BUSY)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:megasas_frame_busy " "frame %" PRIx64 " busy" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , addr);
    }
}

static inline void trace_megasas_unhandled_frame_cmd(int cmd, uint8_t frame_cmd)
{
    QEMU_MEGASAS_UNHANDLED_FRAME_CMD(cmd, frame_cmd);
    if (trace_event_get_state(TRACE_MEGASAS_UNHANDLED_FRAME_CMD)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:megasas_unhandled_frame_cmd " "scmd %d: MFI cmd %x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , cmd, frame_cmd);
    }
}

static inline void trace_megasas_handle_scsi(const char * frame, int bus, int dev, int lun, void * sdev, unsigned long size)
{
    QEMU_MEGASAS_HANDLE_SCSI(frame, bus, dev, lun, sdev, size);
    if (trace_event_get_state(TRACE_MEGASAS_HANDLE_SCSI)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:megasas_handle_scsi " "%s dev %x/%x/%x sdev %p xfer %lu" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , frame, bus, dev, lun, sdev, size);
    }
}

static inline void trace_megasas_scsi_target_not_present(const char * frame, int bus, int dev, int lun)
{
    QEMU_MEGASAS_SCSI_TARGET_NOT_PRESENT(frame, bus, dev, lun);
    if (trace_event_get_state(TRACE_MEGASAS_SCSI_TARGET_NOT_PRESENT)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:megasas_scsi_target_not_present " "%s dev %x/%x/%x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , frame, bus, dev, lun);
    }
}

static inline void trace_megasas_scsi_invalid_cdb_len(const char * frame, int bus, int dev, int lun, int len)
{
    QEMU_MEGASAS_SCSI_INVALID_CDB_LEN(frame, bus, dev, lun, len);
    if (trace_event_get_state(TRACE_MEGASAS_SCSI_INVALID_CDB_LEN)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:megasas_scsi_invalid_cdb_len " "%s dev %x/%x/%x invalid cdb len %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , frame, bus, dev, lun, len);
    }
}

static inline void trace_megasas_iov_read_overflow(int cmd, int bytes, int len)
{
    QEMU_MEGASAS_IOV_READ_OVERFLOW(cmd, bytes, len);
    if (trace_event_get_state(TRACE_MEGASAS_IOV_READ_OVERFLOW)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:megasas_iov_read_overflow " "scmd %d: %d/%d bytes" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , cmd, bytes, len);
    }
}

static inline void trace_megasas_iov_write_overflow(int cmd, int bytes, int len)
{
    QEMU_MEGASAS_IOV_WRITE_OVERFLOW(cmd, bytes, len);
    if (trace_event_get_state(TRACE_MEGASAS_IOV_WRITE_OVERFLOW)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:megasas_iov_write_overflow " "scmd %d: %d/%d bytes" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , cmd, bytes, len);
    }
}

static inline void trace_megasas_iov_read_underflow(int cmd, int bytes, int len)
{
    QEMU_MEGASAS_IOV_READ_UNDERFLOW(cmd, bytes, len);
    if (trace_event_get_state(TRACE_MEGASAS_IOV_READ_UNDERFLOW)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:megasas_iov_read_underflow " "scmd %d: %d/%d bytes" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , cmd, bytes, len);
    }
}

static inline void trace_megasas_iov_write_underflow(int cmd, int bytes, int len)
{
    QEMU_MEGASAS_IOV_WRITE_UNDERFLOW(cmd, bytes, len);
    if (trace_event_get_state(TRACE_MEGASAS_IOV_WRITE_UNDERFLOW)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:megasas_iov_write_underflow " "scmd %d: %d/%d bytes" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , cmd, bytes, len);
    }
}

static inline void trace_megasas_scsi_req_alloc_failed(const char * frame, int dev, int lun)
{
    QEMU_MEGASAS_SCSI_REQ_ALLOC_FAILED(frame, dev, lun);
    if (trace_event_get_state(TRACE_MEGASAS_SCSI_REQ_ALLOC_FAILED)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:megasas_scsi_req_alloc_failed " "%s dev %x/%x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , frame, dev, lun);
    }
}

static inline void trace_megasas_scsi_read_start(int cmd, int len)
{
    QEMU_MEGASAS_SCSI_READ_START(cmd, len);
    if (trace_event_get_state(TRACE_MEGASAS_SCSI_READ_START)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:megasas_scsi_read_start " "scmd %d: transfer %d bytes of data" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , cmd, len);
    }
}

static inline void trace_megasas_scsi_write_start(int cmd, int len)
{
    QEMU_MEGASAS_SCSI_WRITE_START(cmd, len);
    if (trace_event_get_state(TRACE_MEGASAS_SCSI_WRITE_START)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:megasas_scsi_write_start " "scmd %d: transfer %d bytes of data" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , cmd, len);
    }
}

static inline void trace_megasas_scsi_nodata(int cmd)
{
    QEMU_MEGASAS_SCSI_NODATA(cmd);
    if (trace_event_get_state(TRACE_MEGASAS_SCSI_NODATA)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:megasas_scsi_nodata " "scmd %d: no data to be transferred" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , cmd);
    }
}

static inline void trace_megasas_scsi_complete(int cmd, uint32_t status, int len, int xfer)
{
    QEMU_MEGASAS_SCSI_COMPLETE(cmd, status, len, xfer);
    if (trace_event_get_state(TRACE_MEGASAS_SCSI_COMPLETE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:megasas_scsi_complete " "scmd %d: status %x, len %u/%u" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , cmd, status, len, xfer);
    }
}

static inline void trace_megasas_command_complete(int cmd, uint32_t status, uint32_t resid)
{
    QEMU_MEGASAS_COMMAND_COMPLETE(cmd, status, resid);
    if (trace_event_get_state(TRACE_MEGASAS_COMMAND_COMPLETE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:megasas_command_complete " "scmd %d: status %x, residual %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , cmd, status, resid);
    }
}

static inline void trace_megasas_handle_io(int cmd, const char * frame, int dev, int lun, unsigned long lba, unsigned long count)
{
    QEMU_MEGASAS_HANDLE_IO(cmd, frame, dev, lun, lba, count);
    if (trace_event_get_state(TRACE_MEGASAS_HANDLE_IO)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:megasas_handle_io " "scmd %d: %s dev %x/%x lba %lx count %lu" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , cmd, frame, dev, lun, lba, count);
    }
}

static inline void trace_megasas_io_target_not_present(int cmd, const char * frame, int dev, int lun)
{
    QEMU_MEGASAS_IO_TARGET_NOT_PRESENT(cmd, frame, dev, lun);
    if (trace_event_get_state(TRACE_MEGASAS_IO_TARGET_NOT_PRESENT)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:megasas_io_target_not_present " "scmd %d: %s dev 1/%x/%x LUN not present" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , cmd, frame, dev, lun);
    }
}

static inline void trace_megasas_io_read_start(int cmd, unsigned long lba, unsigned long count, unsigned long len)
{
    QEMU_MEGASAS_IO_READ_START(cmd, lba, count, len);
    if (trace_event_get_state(TRACE_MEGASAS_IO_READ_START)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:megasas_io_read_start " "scmd %d: start LBA %lx %lu blocks (%lu bytes)" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , cmd, lba, count, len);
    }
}

static inline void trace_megasas_io_write_start(int cmd, unsigned long lba, unsigned long count, unsigned long len)
{
    QEMU_MEGASAS_IO_WRITE_START(cmd, lba, count, len);
    if (trace_event_get_state(TRACE_MEGASAS_IO_WRITE_START)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:megasas_io_write_start " "scmd %d: start LBA %lx %lu blocks (%lu bytes)" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , cmd, lba, count, len);
    }
}

static inline void trace_megasas_io_complete(int cmd, uint32_t len)
{
    QEMU_MEGASAS_IO_COMPLETE(cmd, len);
    if (trace_event_get_state(TRACE_MEGASAS_IO_COMPLETE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:megasas_io_complete " "scmd %d: %d bytes" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , cmd, len);
    }
}

static inline void trace_megasas_iovec_sgl_overflow(int cmd, int index, int limit)
{
    QEMU_MEGASAS_IOVEC_SGL_OVERFLOW(cmd, index, limit);
    if (trace_event_get_state(TRACE_MEGASAS_IOVEC_SGL_OVERFLOW)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:megasas_iovec_sgl_overflow " "scmd %d: iovec count %d limit %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , cmd, index, limit);
    }
}

static inline void trace_megasas_iovec_sgl_underflow(int cmd, int index)
{
    QEMU_MEGASAS_IOVEC_SGL_UNDERFLOW(cmd, index);
    if (trace_event_get_state(TRACE_MEGASAS_IOVEC_SGL_UNDERFLOW)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:megasas_iovec_sgl_underflow " "scmd %d: iovec count %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , cmd, index);
    }
}

static inline void trace_megasas_iovec_sgl_invalid(int cmd, int index, uint64_t pa, uint32_t len)
{
    QEMU_MEGASAS_IOVEC_SGL_INVALID(cmd, index, pa, len);
    if (trace_event_get_state(TRACE_MEGASAS_IOVEC_SGL_INVALID)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:megasas_iovec_sgl_invalid " "scmd %d: element %d pa %" PRIx64 " len %u" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , cmd, index, pa, len);
    }
}

static inline void trace_megasas_iovec_overflow(int cmd, int len, int limit)
{
    QEMU_MEGASAS_IOVEC_OVERFLOW(cmd, len, limit);
    if (trace_event_get_state(TRACE_MEGASAS_IOVEC_OVERFLOW)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:megasas_iovec_overflow " "scmd %d: len %d limit %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , cmd, len, limit);
    }
}

static inline void trace_megasas_iovec_underflow(int cmd, int len, int limit)
{
    QEMU_MEGASAS_IOVEC_UNDERFLOW(cmd, len, limit);
    if (trace_event_get_state(TRACE_MEGASAS_IOVEC_UNDERFLOW)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:megasas_iovec_underflow " "scmd %d: len %d limit %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , cmd, len, limit);
    }
}

static inline void trace_megasas_handle_dcmd(int cmd, int opcode)
{
    QEMU_MEGASAS_HANDLE_DCMD(cmd, opcode);
    if (trace_event_get_state(TRACE_MEGASAS_HANDLE_DCMD)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:megasas_handle_dcmd " "scmd %d: MFI DCMD opcode %x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , cmd, opcode);
    }
}

static inline void trace_megasas_finish_dcmd(int cmd, int size)
{
    QEMU_MEGASAS_FINISH_DCMD(cmd, size);
    if (trace_event_get_state(TRACE_MEGASAS_FINISH_DCMD)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:megasas_finish_dcmd " "scmd %d: MFI DCMD wrote %d bytes" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , cmd, size);
    }
}

static inline void trace_megasas_dcmd_req_alloc_failed(int cmd, const char * desc)
{
    QEMU_MEGASAS_DCMD_REQ_ALLOC_FAILED(cmd, desc);
    if (trace_event_get_state(TRACE_MEGASAS_DCMD_REQ_ALLOC_FAILED)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:megasas_dcmd_req_alloc_failed " "scmd %d: %s" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , cmd, desc);
    }
}

static inline void trace_megasas_dcmd_internal_submit(int cmd, const char * desc, int dev)
{
    QEMU_MEGASAS_DCMD_INTERNAL_SUBMIT(cmd, desc, dev);
    if (trace_event_get_state(TRACE_MEGASAS_DCMD_INTERNAL_SUBMIT)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:megasas_dcmd_internal_submit " "scmd %d: %s to dev %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , cmd, desc, dev);
    }
}

static inline void trace_megasas_dcmd_internal_finish(int cmd, int opcode, int lun)
{
    QEMU_MEGASAS_DCMD_INTERNAL_FINISH(cmd, opcode, lun);
    if (trace_event_get_state(TRACE_MEGASAS_DCMD_INTERNAL_FINISH)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:megasas_dcmd_internal_finish " "scmd %d: cmd %x lun %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , cmd, opcode, lun);
    }
}

static inline void trace_megasas_dcmd_internal_invalid(int cmd, int opcode)
{
    QEMU_MEGASAS_DCMD_INTERNAL_INVALID(cmd, opcode);
    if (trace_event_get_state(TRACE_MEGASAS_DCMD_INTERNAL_INVALID)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:megasas_dcmd_internal_invalid " "scmd %d: DCMD %x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , cmd, opcode);
    }
}

static inline void trace_megasas_dcmd_unhandled(int cmd, int opcode, int len)
{
    QEMU_MEGASAS_DCMD_UNHANDLED(cmd, opcode, len);
    if (trace_event_get_state(TRACE_MEGASAS_DCMD_UNHANDLED)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:megasas_dcmd_unhandled " "scmd %d: opcode %x, len %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , cmd, opcode, len);
    }
}

static inline void trace_megasas_dcmd_zero_sge(int cmd)
{
    QEMU_MEGASAS_DCMD_ZERO_SGE(cmd);
    if (trace_event_get_state(TRACE_MEGASAS_DCMD_ZERO_SGE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:megasas_dcmd_zero_sge " "scmd %d: zero DCMD sge count" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , cmd);
    }
}

static inline void trace_megasas_dcmd_invalid_sge(int cmd, int count)
{
    QEMU_MEGASAS_DCMD_INVALID_SGE(cmd, count);
    if (trace_event_get_state(TRACE_MEGASAS_DCMD_INVALID_SGE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:megasas_dcmd_invalid_sge " "scmd %d: DCMD sge count %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , cmd, count);
    }
}

static inline void trace_megasas_dcmd_invalid_xfer_len(int cmd, unsigned long size, unsigned long max)
{
    QEMU_MEGASAS_DCMD_INVALID_XFER_LEN(cmd, size, max);
    if (trace_event_get_state(TRACE_MEGASAS_DCMD_INVALID_XFER_LEN)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:megasas_dcmd_invalid_xfer_len " "scmd %d: xfer len %ld, max %ld" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , cmd, size, max);
    }
}

static inline void trace_megasas_dcmd_enter(int cmd, const char * dcmd, int len)
{
    QEMU_MEGASAS_DCMD_ENTER(cmd, dcmd, len);
    if (trace_event_get_state(TRACE_MEGASAS_DCMD_ENTER)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:megasas_dcmd_enter " "scmd %d: DCMD %s len %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , cmd, dcmd, len);
    }
}

static inline void trace_megasas_dcmd_dummy(int cmd, unsigned long size)
{
    QEMU_MEGASAS_DCMD_DUMMY(cmd, size);
    if (trace_event_get_state(TRACE_MEGASAS_DCMD_DUMMY)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:megasas_dcmd_dummy " "scmd %d: xfer len %ld" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , cmd, size);
    }
}

static inline void trace_megasas_dcmd_set_fw_time(int cmd, unsigned long time)
{
    QEMU_MEGASAS_DCMD_SET_FW_TIME(cmd, time);
    if (trace_event_get_state(TRACE_MEGASAS_DCMD_SET_FW_TIME)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:megasas_dcmd_set_fw_time " "scmd %d: Set FW time %lx" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , cmd, time);
    }
}

static inline void trace_megasas_dcmd_pd_get_list(int cmd, int num, int max, int offset)
{
    QEMU_MEGASAS_DCMD_PD_GET_LIST(cmd, num, max, offset);
    if (trace_event_get_state(TRACE_MEGASAS_DCMD_PD_GET_LIST)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:megasas_dcmd_pd_get_list " "scmd %d: DCMD PD get list: %d / %d PDs, size %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , cmd, num, max, offset);
    }
}

static inline void trace_megasas_dcmd_ld_get_list(int cmd, int num, int max)
{
    QEMU_MEGASAS_DCMD_LD_GET_LIST(cmd, num, max);
    if (trace_event_get_state(TRACE_MEGASAS_DCMD_LD_GET_LIST)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:megasas_dcmd_ld_get_list " "scmd %d: DCMD LD get list: found %d / %d LDs" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , cmd, num, max);
    }
}

static inline void trace_megasas_dcmd_ld_get_info(int cmd, int ld_id)
{
    QEMU_MEGASAS_DCMD_LD_GET_INFO(cmd, ld_id);
    if (trace_event_get_state(TRACE_MEGASAS_DCMD_LD_GET_INFO)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:megasas_dcmd_ld_get_info " "scmd %d: dev %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , cmd, ld_id);
    }
}

static inline void trace_megasas_dcmd_ld_list_query(int cmd, int flags)
{
    QEMU_MEGASAS_DCMD_LD_LIST_QUERY(cmd, flags);
    if (trace_event_get_state(TRACE_MEGASAS_DCMD_LD_LIST_QUERY)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:megasas_dcmd_ld_list_query " "scmd %d: query flags %x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , cmd, flags);
    }
}

static inline void trace_megasas_dcmd_pd_get_info(int cmd, int pd_id)
{
    QEMU_MEGASAS_DCMD_PD_GET_INFO(cmd, pd_id);
    if (trace_event_get_state(TRACE_MEGASAS_DCMD_PD_GET_INFO)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:megasas_dcmd_pd_get_info " "scmd %d: dev %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , cmd, pd_id);
    }
}

static inline void trace_megasas_dcmd_pd_list_query(int cmd, int flags)
{
    QEMU_MEGASAS_DCMD_PD_LIST_QUERY(cmd, flags);
    if (trace_event_get_state(TRACE_MEGASAS_DCMD_PD_LIST_QUERY)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:megasas_dcmd_pd_list_query " "scmd %d: query flags %x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , cmd, flags);
    }
}

static inline void trace_megasas_dcmd_reset_ld(int cmd, int target_id)
{
    QEMU_MEGASAS_DCMD_RESET_LD(cmd, target_id);
    if (trace_event_get_state(TRACE_MEGASAS_DCMD_RESET_LD)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:megasas_dcmd_reset_ld " "scmd %d: dev %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , cmd, target_id);
    }
}

static inline void trace_megasas_dcmd_unsupported(int cmd, unsigned long size)
{
    QEMU_MEGASAS_DCMD_UNSUPPORTED(cmd, size);
    if (trace_event_get_state(TRACE_MEGASAS_DCMD_UNSUPPORTED)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:megasas_dcmd_unsupported " "scmd %d: set properties len %ld" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , cmd, size);
    }
}

static inline void trace_megasas_abort_frame(int cmd, int abort_cmd)
{
    QEMU_MEGASAS_ABORT_FRAME(cmd, abort_cmd);
    if (trace_event_get_state(TRACE_MEGASAS_ABORT_FRAME)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:megasas_abort_frame " "scmd %d: frame %x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , cmd, abort_cmd);
    }
}

static inline void trace_megasas_abort_no_cmd(int cmd, uint64_t context)
{
    QEMU_MEGASAS_ABORT_NO_CMD(cmd, context);
    if (trace_event_get_state(TRACE_MEGASAS_ABORT_NO_CMD)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:megasas_abort_no_cmd " "scmd %d: no active command for frame context %" PRIx64 "" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , cmd, context);
    }
}

static inline void trace_megasas_abort_invalid_context(int cmd, uint64_t context, int abort_cmd)
{
    QEMU_MEGASAS_ABORT_INVALID_CONTEXT(cmd, context, abort_cmd);
    if (trace_event_get_state(TRACE_MEGASAS_ABORT_INVALID_CONTEXT)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:megasas_abort_invalid_context " "scmd %d: invalid frame context %" PRIx64 " for abort frame %x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , cmd, context, abort_cmd);
    }
}

static inline void trace_megasas_reset(int fw_state)
{
    QEMU_MEGASAS_RESET(fw_state);
    if (trace_event_get_state(TRACE_MEGASAS_RESET)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:megasas_reset " "firmware state %x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , fw_state);
    }
}

static inline void trace_megasas_init(int sges, int cmds, const char * mode)
{
    QEMU_MEGASAS_INIT(sges, cmds, mode);
    if (trace_event_get_state(TRACE_MEGASAS_INIT)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:megasas_init " "Using %d sges, %d cmds, %s mode" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , sges, cmds, mode);
    }
}

static inline void trace_megasas_msix_raise(int vector)
{
    QEMU_MEGASAS_MSIX_RAISE(vector);
    if (trace_event_get_state(TRACE_MEGASAS_MSIX_RAISE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:megasas_msix_raise " "vector %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , vector);
    }
}

static inline void trace_megasas_msi_raise(int vector)
{
    QEMU_MEGASAS_MSI_RAISE(vector);
    if (trace_event_get_state(TRACE_MEGASAS_MSI_RAISE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:megasas_msi_raise " "vector %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , vector);
    }
}

static inline void trace_megasas_irq_lower(void)
{
    QEMU_MEGASAS_IRQ_LOWER();
    if (trace_event_get_state(TRACE_MEGASAS_IRQ_LOWER)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:megasas_irq_lower " "INTx" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      );
    }
}

static inline void trace_megasas_irq_raise(void)
{
    QEMU_MEGASAS_IRQ_RAISE();
    if (trace_event_get_state(TRACE_MEGASAS_IRQ_RAISE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:megasas_irq_raise " "INTx" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      );
    }
}

static inline void trace_megasas_intr_enabled(void)
{
    QEMU_MEGASAS_INTR_ENABLED();
    if (trace_event_get_state(TRACE_MEGASAS_INTR_ENABLED)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:megasas_intr_enabled " "Interrupts enabled" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      );
    }
}

static inline void trace_megasas_intr_disabled(void)
{
    QEMU_MEGASAS_INTR_DISABLED();
    if (trace_event_get_state(TRACE_MEGASAS_INTR_DISABLED)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:megasas_intr_disabled " "Interrupts disabled" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      );
    }
}

static inline void trace_megasas_msix_enabled(int vector)
{
    QEMU_MEGASAS_MSIX_ENABLED(vector);
    if (trace_event_get_state(TRACE_MEGASAS_MSIX_ENABLED)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:megasas_msix_enabled " "vector %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , vector);
    }
}

static inline void trace_megasas_msi_enabled(int vector)
{
    QEMU_MEGASAS_MSI_ENABLED(vector);
    if (trace_event_get_state(TRACE_MEGASAS_MSI_ENABLED)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:megasas_msi_enabled " "vector %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , vector);
    }
}

static inline void trace_megasas_mmio_readl(const char * reg, uint32_t val)
{
    QEMU_MEGASAS_MMIO_READL(reg, val);
    if (trace_event_get_state(TRACE_MEGASAS_MMIO_READL)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:megasas_mmio_readl " "reg %s: 0x%x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , reg, val);
    }
}

static inline void trace_megasas_mmio_invalid_readl(unsigned long addr)
{
    QEMU_MEGASAS_MMIO_INVALID_READL(addr);
    if (trace_event_get_state(TRACE_MEGASAS_MMIO_INVALID_READL)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:megasas_mmio_invalid_readl " "addr 0x%lx" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , addr);
    }
}

static inline void trace_megasas_mmio_writel(const char * reg, uint32_t val)
{
    QEMU_MEGASAS_MMIO_WRITEL(reg, val);
    if (trace_event_get_state(TRACE_MEGASAS_MMIO_WRITEL)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:megasas_mmio_writel " "reg %s: 0x%x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , reg, val);
    }
}

static inline void trace_megasas_mmio_invalid_writel(uint32_t addr, uint32_t val)
{
    QEMU_MEGASAS_MMIO_INVALID_WRITEL(addr, val);
    if (trace_event_get_state(TRACE_MEGASAS_MMIO_INVALID_WRITEL)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:megasas_mmio_invalid_writel " "addr 0x%x: 0x%x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , addr, val);
    }
}

static inline void trace_milkymist_ac97_memory_read(uint32_t addr, uint32_t value)
{
    QEMU_MILKYMIST_AC97_MEMORY_READ(addr, value);
    if (trace_event_get_state(TRACE_MILKYMIST_AC97_MEMORY_READ)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:milkymist_ac97_memory_read " "addr %08x value %08x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , addr, value);
    }
}

static inline void trace_milkymist_ac97_memory_write(uint32_t addr, uint32_t value)
{
    QEMU_MILKYMIST_AC97_MEMORY_WRITE(addr, value);
    if (trace_event_get_state(TRACE_MILKYMIST_AC97_MEMORY_WRITE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:milkymist_ac97_memory_write " "addr %08x value %08x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , addr, value);
    }
}

static inline void trace_milkymist_ac97_pulse_irq_crrequest(void)
{
    QEMU_MILKYMIST_AC97_PULSE_IRQ_CRREQUEST();
    if (trace_event_get_state(TRACE_MILKYMIST_AC97_PULSE_IRQ_CRREQUEST)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:milkymist_ac97_pulse_irq_crrequest " "Pulse IRQ CR request" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      );
    }
}

static inline void trace_milkymist_ac97_pulse_irq_crreply(void)
{
    QEMU_MILKYMIST_AC97_PULSE_IRQ_CRREPLY();
    if (trace_event_get_state(TRACE_MILKYMIST_AC97_PULSE_IRQ_CRREPLY)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:milkymist_ac97_pulse_irq_crreply " "Pulse IRQ CR reply" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      );
    }
}

static inline void trace_milkymist_ac97_pulse_irq_dmaw(void)
{
    QEMU_MILKYMIST_AC97_PULSE_IRQ_DMAW();
    if (trace_event_get_state(TRACE_MILKYMIST_AC97_PULSE_IRQ_DMAW)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:milkymist_ac97_pulse_irq_dmaw " "Pulse IRQ DMA write" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      );
    }
}

static inline void trace_milkymist_ac97_pulse_irq_dmar(void)
{
    QEMU_MILKYMIST_AC97_PULSE_IRQ_DMAR();
    if (trace_event_get_state(TRACE_MILKYMIST_AC97_PULSE_IRQ_DMAR)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:milkymist_ac97_pulse_irq_dmar " "Pulse IRQ DMA read" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      );
    }
}

static inline void trace_milkymist_ac97_in_cb(int avail, uint32_t remaining)
{
    QEMU_MILKYMIST_AC97_IN_CB(avail, remaining);
    if (trace_event_get_state(TRACE_MILKYMIST_AC97_IN_CB)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:milkymist_ac97_in_cb " "avail %d remaining %u" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , avail, remaining);
    }
}

static inline void trace_milkymist_ac97_in_cb_transferred(int transferred)
{
    QEMU_MILKYMIST_AC97_IN_CB_TRANSFERRED(transferred);
    if (trace_event_get_state(TRACE_MILKYMIST_AC97_IN_CB_TRANSFERRED)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:milkymist_ac97_in_cb_transferred " "transferred %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , transferred);
    }
}

static inline void trace_milkymist_ac97_out_cb(int free, uint32_t remaining)
{
    QEMU_MILKYMIST_AC97_OUT_CB(free, remaining);
    if (trace_event_get_state(TRACE_MILKYMIST_AC97_OUT_CB)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:milkymist_ac97_out_cb " "free %d remaining %u" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , free, remaining);
    }
}

static inline void trace_milkymist_ac97_out_cb_transferred(int transferred)
{
    QEMU_MILKYMIST_AC97_OUT_CB_TRANSFERRED(transferred);
    if (trace_event_get_state(TRACE_MILKYMIST_AC97_OUT_CB_TRANSFERRED)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:milkymist_ac97_out_cb_transferred " "transferred %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , transferred);
    }
}

static inline void trace_milkymist_hpdmc_memory_read(uint32_t addr, uint32_t value)
{
    QEMU_MILKYMIST_HPDMC_MEMORY_READ(addr, value);
    if (trace_event_get_state(TRACE_MILKYMIST_HPDMC_MEMORY_READ)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:milkymist_hpdmc_memory_read " "addr=%08x value=%08x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , addr, value);
    }
}

static inline void trace_milkymist_hpdmc_memory_write(uint32_t addr, uint32_t value)
{
    QEMU_MILKYMIST_HPDMC_MEMORY_WRITE(addr, value);
    if (trace_event_get_state(TRACE_MILKYMIST_HPDMC_MEMORY_WRITE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:milkymist_hpdmc_memory_write " "addr=%08x value=%08x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , addr, value);
    }
}

static inline void trace_milkymist_memcard_memory_read(uint32_t addr, uint32_t value)
{
    QEMU_MILKYMIST_MEMCARD_MEMORY_READ(addr, value);
    if (trace_event_get_state(TRACE_MILKYMIST_MEMCARD_MEMORY_READ)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:milkymist_memcard_memory_read " "addr %08x value %08x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , addr, value);
    }
}

static inline void trace_milkymist_memcard_memory_write(uint32_t addr, uint32_t value)
{
    QEMU_MILKYMIST_MEMCARD_MEMORY_WRITE(addr, value);
    if (trace_event_get_state(TRACE_MILKYMIST_MEMCARD_MEMORY_WRITE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:milkymist_memcard_memory_write " "addr %08x value %08x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , addr, value);
    }
}

static inline void trace_milkymist_minimac2_memory_read(uint32_t addr, uint32_t value)
{
    QEMU_MILKYMIST_MINIMAC2_MEMORY_READ(addr, value);
    if (trace_event_get_state(TRACE_MILKYMIST_MINIMAC2_MEMORY_READ)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:milkymist_minimac2_memory_read " "addr %08x value %08x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , addr, value);
    }
}

static inline void trace_milkymist_minimac2_memory_write(uint32_t addr, uint32_t value)
{
    QEMU_MILKYMIST_MINIMAC2_MEMORY_WRITE(addr, value);
    if (trace_event_get_state(TRACE_MILKYMIST_MINIMAC2_MEMORY_WRITE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:milkymist_minimac2_memory_write " "addr %08x value %08x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , addr, value);
    }
}

static inline void trace_milkymist_minimac2_mdio_write(uint8_t phy_addr, uint8_t addr, uint16_t value)
{
    QEMU_MILKYMIST_MINIMAC2_MDIO_WRITE(phy_addr, addr, value);
    if (trace_event_get_state(TRACE_MILKYMIST_MINIMAC2_MDIO_WRITE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:milkymist_minimac2_mdio_write " "phy_addr %02x addr %02x value %04x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , phy_addr, addr, value);
    }
}

static inline void trace_milkymist_minimac2_mdio_read(uint8_t phy_addr, uint8_t addr, uint16_t value)
{
    QEMU_MILKYMIST_MINIMAC2_MDIO_READ(phy_addr, addr, value);
    if (trace_event_get_state(TRACE_MILKYMIST_MINIMAC2_MDIO_READ)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:milkymist_minimac2_mdio_read " "phy_addr %02x addr %02x value %04x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , phy_addr, addr, value);
    }
}

static inline void trace_milkymist_minimac2_tx_frame(uint32_t length)
{
    QEMU_MILKYMIST_MINIMAC2_TX_FRAME(length);
    if (trace_event_get_state(TRACE_MILKYMIST_MINIMAC2_TX_FRAME)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:milkymist_minimac2_tx_frame " "length %u" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , length);
    }
}

static inline void trace_milkymist_minimac2_rx_frame(const void * buf, uint32_t length)
{
    QEMU_MILKYMIST_MINIMAC2_RX_FRAME(buf, length);
    if (trace_event_get_state(TRACE_MILKYMIST_MINIMAC2_RX_FRAME)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:milkymist_minimac2_rx_frame " "buf %p length %u" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , buf, length);
    }
}

static inline void trace_milkymist_minimac2_drop_rx_frame(const void * buf)
{
    QEMU_MILKYMIST_MINIMAC2_DROP_RX_FRAME(buf);
    if (trace_event_get_state(TRACE_MILKYMIST_MINIMAC2_DROP_RX_FRAME)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:milkymist_minimac2_drop_rx_frame " "buf %p" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , buf);
    }
}

static inline void trace_milkymist_minimac2_rx_transfer(const void * buf, uint32_t length)
{
    QEMU_MILKYMIST_MINIMAC2_RX_TRANSFER(buf, length);
    if (trace_event_get_state(TRACE_MILKYMIST_MINIMAC2_RX_TRANSFER)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:milkymist_minimac2_rx_transfer " "buf %p length %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , buf, length);
    }
}

static inline void trace_milkymist_minimac2_raise_irq_rx(void)
{
    QEMU_MILKYMIST_MINIMAC2_RAISE_IRQ_RX();
    if (trace_event_get_state(TRACE_MILKYMIST_MINIMAC2_RAISE_IRQ_RX)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:milkymist_minimac2_raise_irq_rx " "Raise IRQ RX" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      );
    }
}

static inline void trace_milkymist_minimac2_lower_irq_rx(void)
{
    QEMU_MILKYMIST_MINIMAC2_LOWER_IRQ_RX();
    if (trace_event_get_state(TRACE_MILKYMIST_MINIMAC2_LOWER_IRQ_RX)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:milkymist_minimac2_lower_irq_rx " "Lower IRQ RX" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      );
    }
}

static inline void trace_milkymist_minimac2_pulse_irq_tx(void)
{
    QEMU_MILKYMIST_MINIMAC2_PULSE_IRQ_TX();
    if (trace_event_get_state(TRACE_MILKYMIST_MINIMAC2_PULSE_IRQ_TX)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:milkymist_minimac2_pulse_irq_tx " "Pulse IRQ TX" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      );
    }
}

static inline void trace_milkymist_pfpu_memory_read(uint32_t addr, uint32_t value)
{
    QEMU_MILKYMIST_PFPU_MEMORY_READ(addr, value);
    if (trace_event_get_state(TRACE_MILKYMIST_PFPU_MEMORY_READ)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:milkymist_pfpu_memory_read " "addr %08x value %08x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , addr, value);
    }
}

static inline void trace_milkymist_pfpu_memory_write(uint32_t addr, uint32_t value)
{
    QEMU_MILKYMIST_PFPU_MEMORY_WRITE(addr, value);
    if (trace_event_get_state(TRACE_MILKYMIST_PFPU_MEMORY_WRITE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:milkymist_pfpu_memory_write " "addr %08x value %08x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , addr, value);
    }
}

static inline void trace_milkymist_pfpu_vectout(uint32_t a, uint32_t b, uint32_t dma_ptr)
{
    QEMU_MILKYMIST_PFPU_VECTOUT(a, b, dma_ptr);
    if (trace_event_get_state(TRACE_MILKYMIST_PFPU_VECTOUT)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:milkymist_pfpu_vectout " "a %08x b %08x dma_ptr %08x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , a, b, dma_ptr);
    }
}

static inline void trace_milkymist_pfpu_pulse_irq(void)
{
    QEMU_MILKYMIST_PFPU_PULSE_IRQ();
    if (trace_event_get_state(TRACE_MILKYMIST_PFPU_PULSE_IRQ)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:milkymist_pfpu_pulse_irq " "Pulse IRQ" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      );
    }
}

static inline void trace_milkymist_softusb_memory_read(uint32_t addr, uint32_t value)
{
    QEMU_MILKYMIST_SOFTUSB_MEMORY_READ(addr, value);
    if (trace_event_get_state(TRACE_MILKYMIST_SOFTUSB_MEMORY_READ)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:milkymist_softusb_memory_read " "addr %08x value %08x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , addr, value);
    }
}

static inline void trace_milkymist_softusb_memory_write(uint32_t addr, uint32_t value)
{
    QEMU_MILKYMIST_SOFTUSB_MEMORY_WRITE(addr, value);
    if (trace_event_get_state(TRACE_MILKYMIST_SOFTUSB_MEMORY_WRITE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:milkymist_softusb_memory_write " "addr %08x value %08x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , addr, value);
    }
}

static inline void trace_milkymist_softusb_mevt(uint8_t m)
{
    QEMU_MILKYMIST_SOFTUSB_MEVT(m);
    if (trace_event_get_state(TRACE_MILKYMIST_SOFTUSB_MEVT)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:milkymist_softusb_mevt " "m %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , m);
    }
}

static inline void trace_milkymist_softusb_kevt(uint8_t m)
{
    QEMU_MILKYMIST_SOFTUSB_KEVT(m);
    if (trace_event_get_state(TRACE_MILKYMIST_SOFTUSB_KEVT)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:milkymist_softusb_kevt " "m %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , m);
    }
}

static inline void trace_milkymist_softusb_pulse_irq(void)
{
    QEMU_MILKYMIST_SOFTUSB_PULSE_IRQ();
    if (trace_event_get_state(TRACE_MILKYMIST_SOFTUSB_PULSE_IRQ)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:milkymist_softusb_pulse_irq " "Pulse IRQ" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      );
    }
}

static inline void trace_milkymist_sysctl_memory_read(uint32_t addr, uint32_t value)
{
    QEMU_MILKYMIST_SYSCTL_MEMORY_READ(addr, value);
    if (trace_event_get_state(TRACE_MILKYMIST_SYSCTL_MEMORY_READ)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:milkymist_sysctl_memory_read " "addr %08x value %08x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , addr, value);
    }
}

static inline void trace_milkymist_sysctl_memory_write(uint32_t addr, uint32_t value)
{
    QEMU_MILKYMIST_SYSCTL_MEMORY_WRITE(addr, value);
    if (trace_event_get_state(TRACE_MILKYMIST_SYSCTL_MEMORY_WRITE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:milkymist_sysctl_memory_write " "addr %08x value %08x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , addr, value);
    }
}

static inline void trace_milkymist_sysctl_icap_write(uint32_t value)
{
    QEMU_MILKYMIST_SYSCTL_ICAP_WRITE(value);
    if (trace_event_get_state(TRACE_MILKYMIST_SYSCTL_ICAP_WRITE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:milkymist_sysctl_icap_write " "value %08x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , value);
    }
}

static inline void trace_milkymist_sysctl_start_timer0(void)
{
    QEMU_MILKYMIST_SYSCTL_START_TIMER0();
    if (trace_event_get_state(TRACE_MILKYMIST_SYSCTL_START_TIMER0)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:milkymist_sysctl_start_timer0 " "Start timer0" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      );
    }
}

static inline void trace_milkymist_sysctl_stop_timer0(void)
{
    QEMU_MILKYMIST_SYSCTL_STOP_TIMER0();
    if (trace_event_get_state(TRACE_MILKYMIST_SYSCTL_STOP_TIMER0)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:milkymist_sysctl_stop_timer0 " "Stop timer0" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      );
    }
}

static inline void trace_milkymist_sysctl_start_timer1(void)
{
    QEMU_MILKYMIST_SYSCTL_START_TIMER1();
    if (trace_event_get_state(TRACE_MILKYMIST_SYSCTL_START_TIMER1)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:milkymist_sysctl_start_timer1 " "Start timer1" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      );
    }
}

static inline void trace_milkymist_sysctl_stop_timer1(void)
{
    QEMU_MILKYMIST_SYSCTL_STOP_TIMER1();
    if (trace_event_get_state(TRACE_MILKYMIST_SYSCTL_STOP_TIMER1)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:milkymist_sysctl_stop_timer1 " "Stop timer1" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      );
    }
}

static inline void trace_milkymist_sysctl_pulse_irq_timer0(void)
{
    QEMU_MILKYMIST_SYSCTL_PULSE_IRQ_TIMER0();
    if (trace_event_get_state(TRACE_MILKYMIST_SYSCTL_PULSE_IRQ_TIMER0)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:milkymist_sysctl_pulse_irq_timer0 " "Pulse IRQ Timer0" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      );
    }
}

static inline void trace_milkymist_sysctl_pulse_irq_timer1(void)
{
    QEMU_MILKYMIST_SYSCTL_PULSE_IRQ_TIMER1();
    if (trace_event_get_state(TRACE_MILKYMIST_SYSCTL_PULSE_IRQ_TIMER1)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:milkymist_sysctl_pulse_irq_timer1 " "Pulse IRQ Timer1" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      );
    }
}

static inline void trace_milkymist_tmu2_memory_read(uint32_t addr, uint32_t value)
{
    QEMU_MILKYMIST_TMU2_MEMORY_READ(addr, value);
    if (trace_event_get_state(TRACE_MILKYMIST_TMU2_MEMORY_READ)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:milkymist_tmu2_memory_read " "addr %08x value %08x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , addr, value);
    }
}

static inline void trace_milkymist_tmu2_memory_write(uint32_t addr, uint32_t value)
{
    QEMU_MILKYMIST_TMU2_MEMORY_WRITE(addr, value);
    if (trace_event_get_state(TRACE_MILKYMIST_TMU2_MEMORY_WRITE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:milkymist_tmu2_memory_write " "addr %08x value %08x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , addr, value);
    }
}

static inline void trace_milkymist_tmu2_start(void)
{
    QEMU_MILKYMIST_TMU2_START();
    if (trace_event_get_state(TRACE_MILKYMIST_TMU2_START)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:milkymist_tmu2_start " "Start TMU" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      );
    }
}

static inline void trace_milkymist_tmu2_pulse_irq(void)
{
    QEMU_MILKYMIST_TMU2_PULSE_IRQ();
    if (trace_event_get_state(TRACE_MILKYMIST_TMU2_PULSE_IRQ)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:milkymist_tmu2_pulse_irq " "Pulse IRQ" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      );
    }
}

static inline void trace_milkymist_uart_memory_read(uint32_t addr, uint32_t value)
{
    QEMU_MILKYMIST_UART_MEMORY_READ(addr, value);
    if (trace_event_get_state(TRACE_MILKYMIST_UART_MEMORY_READ)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:milkymist_uart_memory_read " "addr %08x value %08x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , addr, value);
    }
}

static inline void trace_milkymist_uart_memory_write(uint32_t addr, uint32_t value)
{
    QEMU_MILKYMIST_UART_MEMORY_WRITE(addr, value);
    if (trace_event_get_state(TRACE_MILKYMIST_UART_MEMORY_WRITE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:milkymist_uart_memory_write " "addr %08x value %08x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , addr, value);
    }
}

static inline void trace_milkymist_uart_raise_irq(void)
{
    QEMU_MILKYMIST_UART_RAISE_IRQ();
    if (trace_event_get_state(TRACE_MILKYMIST_UART_RAISE_IRQ)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:milkymist_uart_raise_irq " "Raise IRQ" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      );
    }
}

static inline void trace_milkymist_uart_lower_irq(void)
{
    QEMU_MILKYMIST_UART_LOWER_IRQ();
    if (trace_event_get_state(TRACE_MILKYMIST_UART_LOWER_IRQ)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:milkymist_uart_lower_irq " "Lower IRQ" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      );
    }
}

static inline void trace_milkymist_vgafb_memory_read(uint32_t addr, uint32_t value)
{
    QEMU_MILKYMIST_VGAFB_MEMORY_READ(addr, value);
    if (trace_event_get_state(TRACE_MILKYMIST_VGAFB_MEMORY_READ)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:milkymist_vgafb_memory_read " "addr %08x value %08x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , addr, value);
    }
}

static inline void trace_milkymist_vgafb_memory_write(uint32_t addr, uint32_t value)
{
    QEMU_MILKYMIST_VGAFB_MEMORY_WRITE(addr, value);
    if (trace_event_get_state(TRACE_MILKYMIST_VGAFB_MEMORY_WRITE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:milkymist_vgafb_memory_write " "addr %08x value %08x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , addr, value);
    }
}

static inline void trace_mipsnet_send(uint32_t size)
{
    QEMU_MIPSNET_SEND(size);
    if (trace_event_get_state(TRACE_MIPSNET_SEND)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:mipsnet_send " "sending len=%u" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , size);
    }
}

static inline void trace_mipsnet_receive(uint32_t size)
{
    QEMU_MIPSNET_RECEIVE(size);
    if (trace_event_get_state(TRACE_MIPSNET_RECEIVE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:mipsnet_receive " "receiving len=%u" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , size);
    }
}

static inline void trace_mipsnet_read(uint64_t addr, uint32_t val)
{
    QEMU_MIPSNET_READ(addr, val);
    if (trace_event_get_state(TRACE_MIPSNET_READ)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:mipsnet_read " "read addr=0x%" PRIx64 " val=0x%x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , addr, val);
    }
}

static inline void trace_mipsnet_write(uint64_t addr, uint64_t val)
{
    QEMU_MIPSNET_WRITE(addr, val);
    if (trace_event_get_state(TRACE_MIPSNET_WRITE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:mipsnet_write " "write addr=0x%" PRIx64 " val=0x%" PRIx64 "" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , addr, val);
    }
}

static inline void trace_mipsnet_irq(uint32_t isr, uint32_t intctl)
{
    QEMU_MIPSNET_IRQ(isr, intctl);
    if (trace_event_get_state(TRACE_MIPSNET_IRQ)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:mipsnet_irq " "set irq to %d (%02x)" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , isr, intctl);
    }
}

static inline void trace_pc87312_io_read(uint32_t addr, uint32_t val)
{
    QEMU_PC87312_IO_READ(addr, val);
    if (trace_event_get_state(TRACE_PC87312_IO_READ)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:pc87312_io_read " "read addr=%x val=%x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , addr, val);
    }
}

static inline void trace_pc87312_io_write(uint32_t addr, uint32_t val)
{
    QEMU_PC87312_IO_WRITE(addr, val);
    if (trace_event_get_state(TRACE_PC87312_IO_WRITE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:pc87312_io_write " "write addr=%x val=%x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , addr, val);
    }
}

static inline void trace_pc87312_info_floppy(uint32_t base)
{
    QEMU_PC87312_INFO_FLOPPY(base);
    if (trace_event_get_state(TRACE_PC87312_INFO_FLOPPY)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:pc87312_info_floppy " "base 0x%x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , base);
    }
}

static inline void trace_pc87312_info_ide(uint32_t base)
{
    QEMU_PC87312_INFO_IDE(base);
    if (trace_event_get_state(TRACE_PC87312_INFO_IDE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:pc87312_info_ide " "base 0x%x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , base);
    }
}

static inline void trace_pc87312_info_parallel(uint32_t base, uint32_t irq)
{
    QEMU_PC87312_INFO_PARALLEL(base, irq);
    if (trace_event_get_state(TRACE_PC87312_INFO_PARALLEL)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:pc87312_info_parallel " "base 0x%x, irq %u" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , base, irq);
    }
}

static inline void trace_pc87312_info_serial(int n, uint32_t base, uint32_t irq)
{
    QEMU_PC87312_INFO_SERIAL(n, base, irq);
    if (trace_event_get_state(TRACE_PC87312_INFO_SERIAL)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:pc87312_info_serial " "id=%d, base 0x%x, irq %u" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , n, base, irq);
    }
}

static inline void trace_pvscsi_ring_init_data(uint32_t txr_len_log2, uint32_t rxr_len_log2)
{
    QEMU_PVSCSI_RING_INIT_DATA(txr_len_log2, rxr_len_log2);
    if (trace_event_get_state(TRACE_PVSCSI_RING_INIT_DATA)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:pvscsi_ring_init_data " "TX/RX rings logarithms set to %d/%d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , txr_len_log2, rxr_len_log2);
    }
}

static inline void trace_pvscsi_ring_init_msg(uint32_t len_log2)
{
    QEMU_PVSCSI_RING_INIT_MSG(len_log2);
    if (trace_event_get_state(TRACE_PVSCSI_RING_INIT_MSG)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:pvscsi_ring_init_msg " "MSG ring logarithm set to %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , len_log2);
    }
}

static inline void trace_pvscsi_ring_flush_cmp(uint64_t filled_cmp_ptr)
{
    QEMU_PVSCSI_RING_FLUSH_CMP(filled_cmp_ptr);
    if (trace_event_get_state(TRACE_PVSCSI_RING_FLUSH_CMP)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:pvscsi_ring_flush_cmp " "new production counter of completion ring is 0x%"PRIx64"" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , filled_cmp_ptr);
    }
}

static inline void trace_pvscsi_ring_flush_msg(uint64_t filled_cmp_ptr)
{
    QEMU_PVSCSI_RING_FLUSH_MSG(filled_cmp_ptr);
    if (trace_event_get_state(TRACE_PVSCSI_RING_FLUSH_MSG)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:pvscsi_ring_flush_msg " "new production counter of message ring is 0x%"PRIx64"" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , filled_cmp_ptr);
    }
}

static inline void trace_pvscsi_update_irq_level(bool raise, uint64_t mask, uint64_t status)
{
    QEMU_PVSCSI_UPDATE_IRQ_LEVEL(raise, mask, status);
    if (trace_event_get_state(TRACE_PVSCSI_UPDATE_IRQ_LEVEL)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:pvscsi_update_irq_level " "interrupt level set to %d (MASK: 0x%"PRIx64", STATUS: 0x%"PRIx64")" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , raise, mask, status);
    }
}

static inline void trace_pvscsi_update_irq_msi(void)
{
    QEMU_PVSCSI_UPDATE_IRQ_MSI();
    if (trace_event_get_state(TRACE_PVSCSI_UPDATE_IRQ_MSI)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:pvscsi_update_irq_msi " "sending MSI notification" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      );
    }
}

static inline void trace_pvscsi_cmp_ring_put(unsigned long addr)
{
    QEMU_PVSCSI_CMP_RING_PUT(addr);
    if (trace_event_get_state(TRACE_PVSCSI_CMP_RING_PUT)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:pvscsi_cmp_ring_put " "got completion descriptor 0x%lx" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , addr);
    }
}

static inline void trace_pvscsi_msg_ring_put(unsigned long addr)
{
    QEMU_PVSCSI_MSG_RING_PUT(addr);
    if (trace_event_get_state(TRACE_PVSCSI_MSG_RING_PUT)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:pvscsi_msg_ring_put " "got message descriptor 0x%lx" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , addr);
    }
}

static inline void trace_pvscsi_complete_request(uint64_t context, uint64_t len, uint8_t sense_key)
{
    QEMU_PVSCSI_COMPLETE_REQUEST(context, len, sense_key);
    if (trace_event_get_state(TRACE_PVSCSI_COMPLETE_REQUEST)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:pvscsi_complete_request " "completion: ctx: 0x%"PRIx64", len: 0x%"PRIx64", sense key: %u" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , context, len, sense_key);
    }
}

static inline void trace_pvscsi_get_sg_list(int nsg, size_t size)
{
    QEMU_PVSCSI_GET_SG_LIST(nsg, size);
    if (trace_event_get_state(TRACE_PVSCSI_GET_SG_LIST)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:pvscsi_get_sg_list " "get SG list: depth: %u, size: %zu" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , nsg, size);
    }
}

static inline void trace_pvscsi_get_next_sg_elem(uint32_t flags)
{
    QEMU_PVSCSI_GET_NEXT_SG_ELEM(flags);
    if (trace_event_get_state(TRACE_PVSCSI_GET_NEXT_SG_ELEM)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:pvscsi_get_next_sg_elem " "unknown flags in SG element (val: 0x%x)" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , flags);
    }
}

static inline void trace_pvscsi_command_complete_not_found(uint32_t tag)
{
    QEMU_PVSCSI_COMMAND_COMPLETE_NOT_FOUND(tag);
    if (trace_event_get_state(TRACE_PVSCSI_COMMAND_COMPLETE_NOT_FOUND)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:pvscsi_command_complete_not_found " "can't find request for tag 0x%x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , tag);
    }
}

static inline void trace_pvscsi_command_complete_data_run(void)
{
    QEMU_PVSCSI_COMMAND_COMPLETE_DATA_RUN();
    if (trace_event_get_state(TRACE_PVSCSI_COMMAND_COMPLETE_DATA_RUN)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:pvscsi_command_complete_data_run " "not all data required for command transferred" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      );
    }
}

static inline void trace_pvscsi_command_complete_sense_len(int len)
{
    QEMU_PVSCSI_COMMAND_COMPLETE_SENSE_LEN(len);
    if (trace_event_get_state(TRACE_PVSCSI_COMMAND_COMPLETE_SENSE_LEN)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:pvscsi_command_complete_sense_len " "sense information length is %d bytes" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , len);
    }
}

static inline void trace_pvscsi_convert_sglist(uint64_t context, unsigned long addr, uint32_t resid)
{
    QEMU_PVSCSI_CONVERT_SGLIST(context, addr, resid);
    if (trace_event_get_state(TRACE_PVSCSI_CONVERT_SGLIST)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:pvscsi_convert_sglist " "element: ctx: 0x%"PRIx64" addr: 0x%lx, len: %ul" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , context, addr, resid);
    }
}

static inline void trace_pvscsi_process_req_descr(uint8_t cmd, uint64_t ctx)
{
    QEMU_PVSCSI_PROCESS_REQ_DESCR(cmd, ctx);
    if (trace_event_get_state(TRACE_PVSCSI_PROCESS_REQ_DESCR)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:pvscsi_process_req_descr " "SCSI cmd 0x%x, ctx: 0x%"PRIx64"" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , cmd, ctx);
    }
}

static inline void trace_pvscsi_process_req_descr_unknown_device(void)
{
    QEMU_PVSCSI_PROCESS_REQ_DESCR_UNKNOWN_DEVICE();
    if (trace_event_get_state(TRACE_PVSCSI_PROCESS_REQ_DESCR_UNKNOWN_DEVICE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:pvscsi_process_req_descr_unknown_device " "command directed to unknown device rejected" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      );
    }
}

static inline void trace_pvscsi_process_req_descr_invalid_dir(void)
{
    QEMU_PVSCSI_PROCESS_REQ_DESCR_INVALID_DIR();
    if (trace_event_get_state(TRACE_PVSCSI_PROCESS_REQ_DESCR_INVALID_DIR)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:pvscsi_process_req_descr_invalid_dir " "command with invalid transfer direction rejected" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      );
    }
}

static inline void trace_pvscsi_process_io(unsigned long addr)
{
    QEMU_PVSCSI_PROCESS_IO(addr);
    if (trace_event_get_state(TRACE_PVSCSI_PROCESS_IO)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:pvscsi_process_io " "got descriptor 0x%lx" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , addr);
    }
}

static inline void trace_pvscsi_on_cmd_noimpl(const char* cmd)
{
    QEMU_PVSCSI_ON_CMD_NOIMPL(cmd);
    if (trace_event_get_state(TRACE_PVSCSI_ON_CMD_NOIMPL)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:pvscsi_on_cmd_noimpl " "unimplemented command %s ignored" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , cmd);
    }
}

static inline void trace_pvscsi_on_cmd_reset_dev(uint32_t tgt, int lun, void* dev)
{
    QEMU_PVSCSI_ON_CMD_RESET_DEV(tgt, lun, dev);
    if (trace_event_get_state(TRACE_PVSCSI_ON_CMD_RESET_DEV)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:pvscsi_on_cmd_reset_dev " "PVSCSI_CMD_RESET_DEVICE[target %u lun %d (dev 0x%p)]" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , tgt, lun, dev);
    }
}

static inline void trace_pvscsi_on_cmd_arrived(const char* cmd)
{
    QEMU_PVSCSI_ON_CMD_ARRIVED(cmd);
    if (trace_event_get_state(TRACE_PVSCSI_ON_CMD_ARRIVED)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:pvscsi_on_cmd_arrived " "command %s arrived" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , cmd);
    }
}

static inline void trace_pvscsi_on_cmd_abort(uint64_t ctx, uint32_t tgt)
{
    QEMU_PVSCSI_ON_CMD_ABORT(ctx, tgt);
    if (trace_event_get_state(TRACE_PVSCSI_ON_CMD_ABORT)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:pvscsi_on_cmd_abort " "command PVSCSI_CMD_ABORT_CMD for ctx 0x%"PRIx64", target %u" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , ctx, tgt);
    }
}

static inline void trace_pvscsi_on_cmd_unknown(uint64_t cmd_id)
{
    QEMU_PVSCSI_ON_CMD_UNKNOWN(cmd_id);
    if (trace_event_get_state(TRACE_PVSCSI_ON_CMD_UNKNOWN)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:pvscsi_on_cmd_unknown " "unknown command %"PRIx64"" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , cmd_id);
    }
}

static inline void trace_pvscsi_on_cmd_unknown_data(uint32_t data)
{
    QEMU_PVSCSI_ON_CMD_UNKNOWN_DATA(data);
    if (trace_event_get_state(TRACE_PVSCSI_ON_CMD_UNKNOWN_DATA)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:pvscsi_on_cmd_unknown_data " "data for unknown command 0x:%x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , data);
    }
}

static inline void trace_pvscsi_io_write(const char* cmd, uint64_t val)
{
    QEMU_PVSCSI_IO_WRITE(cmd, val);
    if (trace_event_get_state(TRACE_PVSCSI_IO_WRITE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:pvscsi_io_write " "%s write: %"PRIx64"" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , cmd, val);
    }
}

static inline void trace_pvscsi_io_write_unknown(unsigned long addr, unsigned sz, uint64_t val)
{
    QEMU_PVSCSI_IO_WRITE_UNKNOWN(addr, sz, val);
    if (trace_event_get_state(TRACE_PVSCSI_IO_WRITE_UNKNOWN)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:pvscsi_io_write_unknown " "unknown write address: 0x%lx size: %u bytes value: 0x%"PRIx64"" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , addr, sz, val);
    }
}

static inline void trace_pvscsi_io_read(const char* cmd, uint64_t status)
{
    QEMU_PVSCSI_IO_READ(cmd, status);
    if (trace_event_get_state(TRACE_PVSCSI_IO_READ)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:pvscsi_io_read " "%s read: 0x%"PRIx64"" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , cmd, status);
    }
}

static inline void trace_pvscsi_io_read_unknown(unsigned long addr, unsigned sz)
{
    QEMU_PVSCSI_IO_READ_UNKNOWN(addr, sz);
    if (trace_event_get_state(TRACE_PVSCSI_IO_READ_UNKNOWN)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:pvscsi_io_read_unknown " "unknown read address: 0x%lx size: %u bytes" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , addr, sz);
    }
}

static inline void trace_pvscsi_init_msi_fail(int res)
{
    QEMU_PVSCSI_INIT_MSI_FAIL(res);
    if (trace_event_get_state(TRACE_PVSCSI_INIT_MSI_FAIL)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:pvscsi_init_msi_fail " "failed to initialize MSI, error %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , res);
    }
}

static inline void trace_pvscsi_state(const char* state)
{
    QEMU_PVSCSI_STATE(state);
    if (trace_event_get_state(TRACE_PVSCSI_STATE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:pvscsi_state " "starting %s ..." "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , state);
    }
}

static inline void trace_pvscsi_tx_rings_ppn(const char* label, uint64_t ppn)
{
    QEMU_PVSCSI_TX_RINGS_PPN(label, ppn);
    if (trace_event_get_state(TRACE_PVSCSI_TX_RINGS_PPN)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:pvscsi_tx_rings_ppn " "%s page: %"PRIx64"" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , label, ppn);
    }
}

static inline void trace_pvscsi_tx_rings_num_pages(const char* label, uint32_t num)
{
    QEMU_PVSCSI_TX_RINGS_NUM_PAGES(label, num);
    if (trace_event_get_state(TRACE_PVSCSI_TX_RINGS_NUM_PAGES)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:pvscsi_tx_rings_num_pages " "Number of %s pages: %u" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , label, num);
    }
}

static inline void trace_xen_ram_alloc(unsigned long ram_addr, unsigned long size)
{
    QEMU_XEN_RAM_ALLOC(ram_addr, size);
    if (trace_event_get_state(TRACE_XEN_RAM_ALLOC)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:xen_ram_alloc " "requested: %#lx, size %#lx" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , ram_addr, size);
    }
}

static inline void trace_xen_client_set_memory(uint64_t start_addr, unsigned long size, bool log_dirty)
{
    QEMU_XEN_CLIENT_SET_MEMORY(start_addr, size, log_dirty);
    if (trace_event_get_state(TRACE_XEN_CLIENT_SET_MEMORY)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:xen_client_set_memory " "%#"PRIx64" size %#lx, log_dirty %i" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , start_addr, size, log_dirty);
    }
}

static inline void trace_xen_ioreq_server_create(uint32_t id)
{
    QEMU_XEN_IOREQ_SERVER_CREATE(id);
    if (trace_event_get_state(TRACE_XEN_IOREQ_SERVER_CREATE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:xen_ioreq_server_create " "id: %u" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , id);
    }
}

static inline void trace_xen_ioreq_server_destroy(uint32_t id)
{
    QEMU_XEN_IOREQ_SERVER_DESTROY(id);
    if (trace_event_get_state(TRACE_XEN_IOREQ_SERVER_DESTROY)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:xen_ioreq_server_destroy " "id: %u" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , id);
    }
}

static inline void trace_xen_ioreq_server_state(uint32_t id, bool enable)
{
    QEMU_XEN_IOREQ_SERVER_STATE(id, enable);
    if (trace_event_get_state(TRACE_XEN_IOREQ_SERVER_STATE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:xen_ioreq_server_state " "id: %u: enable: %i" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , id, enable);
    }
}

static inline void trace_xen_map_mmio_range(uint32_t id, uint64_t start_addr, uint64_t end_addr)
{
    QEMU_XEN_MAP_MMIO_RANGE(id, start_addr, end_addr);
    if (trace_event_get_state(TRACE_XEN_MAP_MMIO_RANGE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:xen_map_mmio_range " "id: %u start: %#"PRIx64" end: %#"PRIx64 "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , id, start_addr, end_addr);
    }
}

static inline void trace_xen_unmap_mmio_range(uint32_t id, uint64_t start_addr, uint64_t end_addr)
{
    QEMU_XEN_UNMAP_MMIO_RANGE(id, start_addr, end_addr);
    if (trace_event_get_state(TRACE_XEN_UNMAP_MMIO_RANGE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:xen_unmap_mmio_range " "id: %u start: %#"PRIx64" end: %#"PRIx64 "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , id, start_addr, end_addr);
    }
}

static inline void trace_xen_map_portio_range(uint32_t id, uint64_t start_addr, uint64_t end_addr)
{
    QEMU_XEN_MAP_PORTIO_RANGE(id, start_addr, end_addr);
    if (trace_event_get_state(TRACE_XEN_MAP_PORTIO_RANGE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:xen_map_portio_range " "id: %u start: %#"PRIx64" end: %#"PRIx64 "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , id, start_addr, end_addr);
    }
}

static inline void trace_xen_unmap_portio_range(uint32_t id, uint64_t start_addr, uint64_t end_addr)
{
    QEMU_XEN_UNMAP_PORTIO_RANGE(id, start_addr, end_addr);
    if (trace_event_get_state(TRACE_XEN_UNMAP_PORTIO_RANGE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:xen_unmap_portio_range " "id: %u start: %#"PRIx64" end: %#"PRIx64 "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , id, start_addr, end_addr);
    }
}

static inline void trace_xen_map_pcidev(uint32_t id, uint8_t bus, uint8_t dev, uint8_t func)
{
    QEMU_XEN_MAP_PCIDEV(id, bus, dev, func);
    if (trace_event_get_state(TRACE_XEN_MAP_PCIDEV)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:xen_map_pcidev " "id: %u bdf: %02x.%02x.%02x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , id, bus, dev, func);
    }
}

static inline void trace_xen_unmap_pcidev(uint32_t id, uint8_t bus, uint8_t dev, uint8_t func)
{
    QEMU_XEN_UNMAP_PCIDEV(id, bus, dev, func);
    if (trace_event_get_state(TRACE_XEN_UNMAP_PCIDEV)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:xen_unmap_pcidev " "id: %u bdf: %02x.%02x.%02x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , id, bus, dev, func);
    }
}

static inline void trace_xen_map_cache(uint64_t phys_addr)
{
    QEMU_XEN_MAP_CACHE(phys_addr);
    if (trace_event_get_state(TRACE_XEN_MAP_CACHE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:xen_map_cache " "want %#"PRIx64 "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , phys_addr);
    }
}

static inline void trace_xen_remap_bucket(uint64_t index)
{
    QEMU_XEN_REMAP_BUCKET(index);
    if (trace_event_get_state(TRACE_XEN_REMAP_BUCKET)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:xen_remap_bucket " "index %#"PRIx64 "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , index);
    }
}

static inline void trace_xen_map_cache_return(void* ptr)
{
    QEMU_XEN_MAP_CACHE_RETURN(ptr);
    if (trace_event_get_state(TRACE_XEN_MAP_CACHE_RETURN)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:xen_map_cache_return " "%p" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , ptr);
    }
}

static inline void trace_xen_platform_log(char * s)
{
    QEMU_XEN_PLATFORM_LOG(s);
    if (trace_event_get_state(TRACE_XEN_PLATFORM_LOG)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:xen_platform_log " "xen platform: %s" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , s);
    }
}

static inline void trace_qemu_coroutine_enter(void * from, void * to, void * opaque)
{
    QEMU_QEMU_COROUTINE_ENTER(from, to, opaque);
    if (trace_event_get_state(TRACE_QEMU_COROUTINE_ENTER)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qemu_coroutine_enter " "from %p to %p opaque %p" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , from, to, opaque);
    }
}

static inline void trace_qemu_coroutine_yield(void * from, void * to)
{
    QEMU_QEMU_COROUTINE_YIELD(from, to);
    if (trace_event_get_state(TRACE_QEMU_COROUTINE_YIELD)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qemu_coroutine_yield " "from %p to %p" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , from, to);
    }
}

static inline void trace_qemu_coroutine_terminate(void * co)
{
    QEMU_QEMU_COROUTINE_TERMINATE(co);
    if (trace_event_get_state(TRACE_QEMU_COROUTINE_TERMINATE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qemu_coroutine_terminate " "self %p" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , co);
    }
}

static inline void trace_qemu_co_queue_run_restart(void * co)
{
    QEMU_QEMU_CO_QUEUE_RUN_RESTART(co);
    if (trace_event_get_state(TRACE_QEMU_CO_QUEUE_RUN_RESTART)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qemu_co_queue_run_restart " "co %p" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , co);
    }
}

static inline void trace_qemu_co_queue_next(void * nxt)
{
    QEMU_QEMU_CO_QUEUE_NEXT(nxt);
    if (trace_event_get_state(TRACE_QEMU_CO_QUEUE_NEXT)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qemu_co_queue_next " "next %p" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , nxt);
    }
}

static inline void trace_qemu_co_mutex_lock_entry(void * mutex, void * self)
{
    QEMU_QEMU_CO_MUTEX_LOCK_ENTRY(mutex, self);
    if (trace_event_get_state(TRACE_QEMU_CO_MUTEX_LOCK_ENTRY)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qemu_co_mutex_lock_entry " "mutex %p self %p" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , mutex, self);
    }
}

static inline void trace_qemu_co_mutex_lock_return(void * mutex, void * self)
{
    QEMU_QEMU_CO_MUTEX_LOCK_RETURN(mutex, self);
    if (trace_event_get_state(TRACE_QEMU_CO_MUTEX_LOCK_RETURN)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qemu_co_mutex_lock_return " "mutex %p self %p" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , mutex, self);
    }
}

static inline void trace_qemu_co_mutex_unlock_entry(void * mutex, void * self)
{
    QEMU_QEMU_CO_MUTEX_UNLOCK_ENTRY(mutex, self);
    if (trace_event_get_state(TRACE_QEMU_CO_MUTEX_UNLOCK_ENTRY)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qemu_co_mutex_unlock_entry " "mutex %p self %p" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , mutex, self);
    }
}

static inline void trace_qemu_co_mutex_unlock_return(void * mutex, void * self)
{
    QEMU_QEMU_CO_MUTEX_UNLOCK_RETURN(mutex, self);
    if (trace_event_get_state(TRACE_QEMU_CO_MUTEX_UNLOCK_RETURN)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qemu_co_mutex_unlock_return " "mutex %p self %p" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , mutex, self);
    }
}

static inline void trace_escc_put_queue(char channel, int b)
{
    QEMU_ESCC_PUT_QUEUE(channel, b);
    if (trace_event_get_state(TRACE_ESCC_PUT_QUEUE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:escc_put_queue " "channel %c put: 0x%02x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , channel, b);
    }
}

static inline void trace_escc_get_queue(char channel, int val)
{
    QEMU_ESCC_GET_QUEUE(channel, val);
    if (trace_event_get_state(TRACE_ESCC_GET_QUEUE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:escc_get_queue " "channel %c get 0x%02x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , channel, val);
    }
}

static inline void trace_escc_update_irq(int irq)
{
    QEMU_ESCC_UPDATE_IRQ(irq);
    if (trace_event_get_state(TRACE_ESCC_UPDATE_IRQ)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:escc_update_irq " "IRQ = %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , irq);
    }
}

static inline void trace_escc_update_parameters(char channel, int speed, int parity, int data_bits, int stop_bits)
{
    QEMU_ESCC_UPDATE_PARAMETERS(channel, speed, parity, data_bits, stop_bits);
    if (trace_event_get_state(TRACE_ESCC_UPDATE_PARAMETERS)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:escc_update_parameters " "channel %c: speed=%d parity=%c data=%d stop=%d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , channel, speed, parity, data_bits, stop_bits);
    }
}

static inline void trace_escc_mem_writeb_ctrl(char channel, uint32_t reg, uint32_t val)
{
    QEMU_ESCC_MEM_WRITEB_CTRL(channel, reg, val);
    if (trace_event_get_state(TRACE_ESCC_MEM_WRITEB_CTRL)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:escc_mem_writeb_ctrl " "Write channel %c, reg[%d] = %2.2x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , channel, reg, val);
    }
}

static inline void trace_escc_mem_writeb_data(char channel, uint32_t val)
{
    QEMU_ESCC_MEM_WRITEB_DATA(channel, val);
    if (trace_event_get_state(TRACE_ESCC_MEM_WRITEB_DATA)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:escc_mem_writeb_data " "Write channel %c, ch %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , channel, val);
    }
}

static inline void trace_escc_mem_readb_ctrl(char channel, uint32_t reg, uint8_t val)
{
    QEMU_ESCC_MEM_READB_CTRL(channel, reg, val);
    if (trace_event_get_state(TRACE_ESCC_MEM_READB_CTRL)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:escc_mem_readb_ctrl " "Read channel %c, reg[%d] = %2.2x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , channel, reg, val);
    }
}

static inline void trace_escc_mem_readb_data(char channel, uint32_t ret)
{
    QEMU_ESCC_MEM_READB_DATA(channel, ret);
    if (trace_event_get_state(TRACE_ESCC_MEM_READB_DATA)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:escc_mem_readb_data " "Read channel %c, ch %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , channel, ret);
    }
}

static inline void trace_escc_serial_receive_byte(char channel, int ch)
{
    QEMU_ESCC_SERIAL_RECEIVE_BYTE(channel, ch);
    if (trace_event_get_state(TRACE_ESCC_SERIAL_RECEIVE_BYTE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:escc_serial_receive_byte " "channel %c put ch %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , channel, ch);
    }
}

static inline void trace_escc_sunkbd_event_in(int ch, const char * name, int down)
{
    QEMU_ESCC_SUNKBD_EVENT_IN(ch, name, down);
    if (trace_event_get_state(TRACE_ESCC_SUNKBD_EVENT_IN)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:escc_sunkbd_event_in " "QKeyCode 0x%2.2x [%s], down %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , ch, name, down);
    }
}

static inline void trace_escc_sunkbd_event_out(int ch)
{
    QEMU_ESCC_SUNKBD_EVENT_OUT(ch);
    if (trace_event_get_state(TRACE_ESCC_SUNKBD_EVENT_OUT)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:escc_sunkbd_event_out " "Translated keycode 0x%2.2x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , ch);
    }
}

static inline void trace_escc_kbd_command(int val)
{
    QEMU_ESCC_KBD_COMMAND(val);
    if (trace_event_get_state(TRACE_ESCC_KBD_COMMAND)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:escc_kbd_command " "Command %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , val);
    }
}

static inline void trace_escc_sunmouse_event(int dx, int dy, int buttons_state)
{
    QEMU_ESCC_SUNMOUSE_EVENT(dx, dy, buttons_state);
    if (trace_event_get_state(TRACE_ESCC_SUNMOUSE_EVENT)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:escc_sunmouse_event " "dx=%d dy=%d buttons=%01x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , dx, dy, buttons_state);
    }
}

static inline void trace_esp_error_fifo_overrun(void)
{
    QEMU_ESP_ERROR_FIFO_OVERRUN();
    if (trace_event_get_state(TRACE_ESP_ERROR_FIFO_OVERRUN)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:esp_error_fifo_overrun " "FIFO overrun" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      );
    }
}

static inline void trace_esp_error_unhandled_command(uint32_t val)
{
    QEMU_ESP_ERROR_UNHANDLED_COMMAND(val);
    if (trace_event_get_state(TRACE_ESP_ERROR_UNHANDLED_COMMAND)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:esp_error_unhandled_command " "unhandled command (%2.2x)" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , val);
    }
}

static inline void trace_esp_error_invalid_write(uint32_t val, uint32_t addr)
{
    QEMU_ESP_ERROR_INVALID_WRITE(val, addr);
    if (trace_event_get_state(TRACE_ESP_ERROR_INVALID_WRITE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:esp_error_invalid_write " "invalid write of 0x%02x at [0x%x]" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , val, addr);
    }
}

static inline void trace_esp_raise_irq(void)
{
    QEMU_ESP_RAISE_IRQ();
    if (trace_event_get_state(TRACE_ESP_RAISE_IRQ)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:esp_raise_irq " "Raise IRQ" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      );
    }
}

static inline void trace_esp_lower_irq(void)
{
    QEMU_ESP_LOWER_IRQ();
    if (trace_event_get_state(TRACE_ESP_LOWER_IRQ)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:esp_lower_irq " "Lower IRQ" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      );
    }
}

static inline void trace_esp_dma_enable(void)
{
    QEMU_ESP_DMA_ENABLE();
    if (trace_event_get_state(TRACE_ESP_DMA_ENABLE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:esp_dma_enable " "Raise enable" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      );
    }
}

static inline void trace_esp_dma_disable(void)
{
    QEMU_ESP_DMA_DISABLE();
    if (trace_event_get_state(TRACE_ESP_DMA_DISABLE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:esp_dma_disable " "Lower enable" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      );
    }
}

static inline void trace_esp_get_cmd(uint32_t dmalen, int target)
{
    QEMU_ESP_GET_CMD(dmalen, target);
    if (trace_event_get_state(TRACE_ESP_GET_CMD)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:esp_get_cmd " "len %d target %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , dmalen, target);
    }
}

static inline void trace_esp_do_busid_cmd(uint8_t busid)
{
    QEMU_ESP_DO_BUSID_CMD(busid);
    if (trace_event_get_state(TRACE_ESP_DO_BUSID_CMD)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:esp_do_busid_cmd " "busid 0x%x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , busid);
    }
}

static inline void trace_esp_handle_satn_stop(uint32_t cmdlen)
{
    QEMU_ESP_HANDLE_SATN_STOP(cmdlen);
    if (trace_event_get_state(TRACE_ESP_HANDLE_SATN_STOP)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:esp_handle_satn_stop " "cmdlen %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , cmdlen);
    }
}

static inline void trace_esp_write_response(uint32_t status)
{
    QEMU_ESP_WRITE_RESPONSE(status);
    if (trace_event_get_state(TRACE_ESP_WRITE_RESPONSE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:esp_write_response " "Transfer status (status=%d)" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , status);
    }
}

static inline void trace_esp_do_dma(uint32_t cmdlen, uint32_t len)
{
    QEMU_ESP_DO_DMA(cmdlen, len);
    if (trace_event_get_state(TRACE_ESP_DO_DMA)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:esp_do_dma " "command len %d + %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , cmdlen, len);
    }
}

static inline void trace_esp_command_complete(void)
{
    QEMU_ESP_COMMAND_COMPLETE();
    if (trace_event_get_state(TRACE_ESP_COMMAND_COMPLETE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:esp_command_complete " "SCSI Command complete" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      );
    }
}

static inline void trace_esp_command_complete_unexpected(void)
{
    QEMU_ESP_COMMAND_COMPLETE_UNEXPECTED();
    if (trace_event_get_state(TRACE_ESP_COMMAND_COMPLETE_UNEXPECTED)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:esp_command_complete_unexpected " "SCSI command completed unexpectedly" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      );
    }
}

static inline void trace_esp_command_complete_fail(void)
{
    QEMU_ESP_COMMAND_COMPLETE_FAIL();
    if (trace_event_get_state(TRACE_ESP_COMMAND_COMPLETE_FAIL)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:esp_command_complete_fail " "Command failed" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      );
    }
}

static inline void trace_esp_transfer_data(uint32_t dma_left, int32_t ti_size)
{
    QEMU_ESP_TRANSFER_DATA(dma_left, ti_size);
    if (trace_event_get_state(TRACE_ESP_TRANSFER_DATA)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:esp_transfer_data " "transfer %d/%d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , dma_left, ti_size);
    }
}

static inline void trace_esp_handle_ti(uint32_t minlen)
{
    QEMU_ESP_HANDLE_TI(minlen);
    if (trace_event_get_state(TRACE_ESP_HANDLE_TI)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:esp_handle_ti " "Transfer Information len %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , minlen);
    }
}

static inline void trace_esp_handle_ti_cmd(uint32_t cmdlen)
{
    QEMU_ESP_HANDLE_TI_CMD(cmdlen);
    if (trace_event_get_state(TRACE_ESP_HANDLE_TI_CMD)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:esp_handle_ti_cmd " "command len %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , cmdlen);
    }
}

static inline void trace_esp_mem_readb(uint32_t saddr, uint8_t reg)
{
    QEMU_ESP_MEM_READB(saddr, reg);
    if (trace_event_get_state(TRACE_ESP_MEM_READB)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:esp_mem_readb " "reg[%d]: 0x%2.2x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , saddr, reg);
    }
}

static inline void trace_esp_mem_writeb(uint32_t saddr, uint8_t reg, uint32_t val)
{
    QEMU_ESP_MEM_WRITEB(saddr, reg, val);
    if (trace_event_get_state(TRACE_ESP_MEM_WRITEB)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:esp_mem_writeb " "reg[%d]: 0x%2.2x -> 0x%2.2x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , saddr, reg, val);
    }
}

static inline void trace_esp_mem_writeb_cmd_nop(uint32_t val)
{
    QEMU_ESP_MEM_WRITEB_CMD_NOP(val);
    if (trace_event_get_state(TRACE_ESP_MEM_WRITEB_CMD_NOP)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:esp_mem_writeb_cmd_nop " "NOP (%2.2x)" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , val);
    }
}

static inline void trace_esp_mem_writeb_cmd_flush(uint32_t val)
{
    QEMU_ESP_MEM_WRITEB_CMD_FLUSH(val);
    if (trace_event_get_state(TRACE_ESP_MEM_WRITEB_CMD_FLUSH)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:esp_mem_writeb_cmd_flush " "Flush FIFO (%2.2x)" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , val);
    }
}

static inline void trace_esp_mem_writeb_cmd_reset(uint32_t val)
{
    QEMU_ESP_MEM_WRITEB_CMD_RESET(val);
    if (trace_event_get_state(TRACE_ESP_MEM_WRITEB_CMD_RESET)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:esp_mem_writeb_cmd_reset " "Chip reset (%2.2x)" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , val);
    }
}

static inline void trace_esp_mem_writeb_cmd_bus_reset(uint32_t val)
{
    QEMU_ESP_MEM_WRITEB_CMD_BUS_RESET(val);
    if (trace_event_get_state(TRACE_ESP_MEM_WRITEB_CMD_BUS_RESET)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:esp_mem_writeb_cmd_bus_reset " "Bus reset (%2.2x)" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , val);
    }
}

static inline void trace_esp_mem_writeb_cmd_iccs(uint32_t val)
{
    QEMU_ESP_MEM_WRITEB_CMD_ICCS(val);
    if (trace_event_get_state(TRACE_ESP_MEM_WRITEB_CMD_ICCS)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:esp_mem_writeb_cmd_iccs " "Initiator Command Complete Sequence (%2.2x)" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , val);
    }
}

static inline void trace_esp_mem_writeb_cmd_msgacc(uint32_t val)
{
    QEMU_ESP_MEM_WRITEB_CMD_MSGACC(val);
    if (trace_event_get_state(TRACE_ESP_MEM_WRITEB_CMD_MSGACC)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:esp_mem_writeb_cmd_msgacc " "Message Accepted (%2.2x)" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , val);
    }
}

static inline void trace_esp_mem_writeb_cmd_pad(uint32_t val)
{
    QEMU_ESP_MEM_WRITEB_CMD_PAD(val);
    if (trace_event_get_state(TRACE_ESP_MEM_WRITEB_CMD_PAD)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:esp_mem_writeb_cmd_pad " "Transfer padding (%2.2x)" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , val);
    }
}

static inline void trace_esp_mem_writeb_cmd_satn(uint32_t val)
{
    QEMU_ESP_MEM_WRITEB_CMD_SATN(val);
    if (trace_event_get_state(TRACE_ESP_MEM_WRITEB_CMD_SATN)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:esp_mem_writeb_cmd_satn " "Set ATN (%2.2x)" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , val);
    }
}

static inline void trace_esp_mem_writeb_cmd_rstatn(uint32_t val)
{
    QEMU_ESP_MEM_WRITEB_CMD_RSTATN(val);
    if (trace_event_get_state(TRACE_ESP_MEM_WRITEB_CMD_RSTATN)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:esp_mem_writeb_cmd_rstatn " "Reset ATN (%2.2x)" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , val);
    }
}

static inline void trace_esp_mem_writeb_cmd_sel(uint32_t val)
{
    QEMU_ESP_MEM_WRITEB_CMD_SEL(val);
    if (trace_event_get_state(TRACE_ESP_MEM_WRITEB_CMD_SEL)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:esp_mem_writeb_cmd_sel " "Select without ATN (%2.2x)" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , val);
    }
}

static inline void trace_esp_mem_writeb_cmd_selatn(uint32_t val)
{
    QEMU_ESP_MEM_WRITEB_CMD_SELATN(val);
    if (trace_event_get_state(TRACE_ESP_MEM_WRITEB_CMD_SELATN)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:esp_mem_writeb_cmd_selatn " "Select with ATN (%2.2x)" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , val);
    }
}

static inline void trace_esp_mem_writeb_cmd_selatns(uint32_t val)
{
    QEMU_ESP_MEM_WRITEB_CMD_SELATNS(val);
    if (trace_event_get_state(TRACE_ESP_MEM_WRITEB_CMD_SELATNS)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:esp_mem_writeb_cmd_selatns " "Select with ATN & stop (%2.2x)" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , val);
    }
}

static inline void trace_esp_mem_writeb_cmd_ensel(uint32_t val)
{
    QEMU_ESP_MEM_WRITEB_CMD_ENSEL(val);
    if (trace_event_get_state(TRACE_ESP_MEM_WRITEB_CMD_ENSEL)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:esp_mem_writeb_cmd_ensel " "Enable selection (%2.2x)" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , val);
    }
}

static inline void trace_esp_mem_writeb_cmd_dissel(uint32_t val)
{
    QEMU_ESP_MEM_WRITEB_CMD_DISSEL(val);
    if (trace_event_get_state(TRACE_ESP_MEM_WRITEB_CMD_DISSEL)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:esp_mem_writeb_cmd_dissel " "Disable selection (%2.2x)" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , val);
    }
}

static inline void trace_esp_pci_error_invalid_dma_direction(void)
{
    QEMU_ESP_PCI_ERROR_INVALID_DMA_DIRECTION();
    if (trace_event_get_state(TRACE_ESP_PCI_ERROR_INVALID_DMA_DIRECTION)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:esp_pci_error_invalid_dma_direction " "invalid DMA transfer direction" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      );
    }
}

static inline void trace_esp_pci_error_invalid_read(uint32_t reg)
{
    QEMU_ESP_PCI_ERROR_INVALID_READ(reg);
    if (trace_event_get_state(TRACE_ESP_PCI_ERROR_INVALID_READ)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:esp_pci_error_invalid_read " "read access outside bounds (reg 0x%x)" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , reg);
    }
}

static inline void trace_esp_pci_error_invalid_write(uint32_t reg)
{
    QEMU_ESP_PCI_ERROR_INVALID_WRITE(reg);
    if (trace_event_get_state(TRACE_ESP_PCI_ERROR_INVALID_WRITE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:esp_pci_error_invalid_write " "write access outside bounds (reg 0x%x)" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , reg);
    }
}

static inline void trace_esp_pci_error_invalid_write_dma(uint32_t val, uint32_t addr)
{
    QEMU_ESP_PCI_ERROR_INVALID_WRITE_DMA(val, addr);
    if (trace_event_get_state(TRACE_ESP_PCI_ERROR_INVALID_WRITE_DMA)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:esp_pci_error_invalid_write_dma " "invalid write of 0x%02x at [0x%x]" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , val, addr);
    }
}

static inline void trace_esp_pci_dma_read(uint32_t saddr, uint32_t reg)
{
    QEMU_ESP_PCI_DMA_READ(saddr, reg);
    if (trace_event_get_state(TRACE_ESP_PCI_DMA_READ)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:esp_pci_dma_read " "reg[%d]: 0x%8.8x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , saddr, reg);
    }
}

static inline void trace_esp_pci_dma_write(uint32_t saddr, uint32_t reg, uint32_t val)
{
    QEMU_ESP_PCI_DMA_WRITE(saddr, reg, val);
    if (trace_event_get_state(TRACE_ESP_PCI_DMA_WRITE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:esp_pci_dma_write " "reg[%d]: 0x%8.8x -> 0x%8.8x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , saddr, reg, val);
    }
}

static inline void trace_esp_pci_dma_idle(uint32_t val)
{
    QEMU_ESP_PCI_DMA_IDLE(val);
    if (trace_event_get_state(TRACE_ESP_PCI_DMA_IDLE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:esp_pci_dma_idle " "IDLE (%.8x)" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , val);
    }
}

static inline void trace_esp_pci_dma_blast(uint32_t val)
{
    QEMU_ESP_PCI_DMA_BLAST(val);
    if (trace_event_get_state(TRACE_ESP_PCI_DMA_BLAST)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:esp_pci_dma_blast " "BLAST (%.8x)" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , val);
    }
}

static inline void trace_esp_pci_dma_abort(uint32_t val)
{
    QEMU_ESP_PCI_DMA_ABORT(val);
    if (trace_event_get_state(TRACE_ESP_PCI_DMA_ABORT)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:esp_pci_dma_abort " "ABORT (%.8x)" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , val);
    }
}

static inline void trace_esp_pci_dma_start(uint32_t val)
{
    QEMU_ESP_PCI_DMA_START(val);
    if (trace_event_get_state(TRACE_ESP_PCI_DMA_START)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:esp_pci_dma_start " "START (%.8x)" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , val);
    }
}

static inline void trace_esp_pci_sbac_read(uint32_t reg)
{
    QEMU_ESP_PCI_SBAC_READ(reg);
    if (trace_event_get_state(TRACE_ESP_PCI_SBAC_READ)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:esp_pci_sbac_read " "sbac: 0x%8.8x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , reg);
    }
}

static inline void trace_esp_pci_sbac_write(uint32_t reg, uint32_t val)
{
    QEMU_ESP_PCI_SBAC_WRITE(reg, val);
    if (trace_event_get_state(TRACE_ESP_PCI_SBAC_WRITE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:esp_pci_sbac_write " "sbac: 0x%8.8x -> 0x%8.8x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , reg, val);
    }
}

static inline void trace_handle_qmp_command(void * mon, const char * cmd_name)
{
    QEMU_HANDLE_QMP_COMMAND(mon, cmd_name);
    if (trace_event_get_state(TRACE_HANDLE_QMP_COMMAND)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:handle_qmp_command " "mon %p cmd_name \"%s\"" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , mon, cmd_name);
    }
}

static inline void trace_monitor_protocol_emitter(void * mon)
{
    QEMU_MONITOR_PROTOCOL_EMITTER(mon);
    if (trace_event_get_state(TRACE_MONITOR_PROTOCOL_EMITTER)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:monitor_protocol_emitter " "mon %p" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , mon);
    }
}

static inline void trace_monitor_protocol_event_handler(uint32_t event, void * data, uint64_t last, uint64_t now)
{
    QEMU_MONITOR_PROTOCOL_EVENT_HANDLER(event, data, last, now);
    if (trace_event_get_state(TRACE_MONITOR_PROTOCOL_EVENT_HANDLER)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:monitor_protocol_event_handler " "event=%d data=%p last=%" PRId64 " now=%" PRId64 "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , event, data, last, now);
    }
}

static inline void trace_monitor_protocol_event_emit(uint32_t event, void * data)
{
    QEMU_MONITOR_PROTOCOL_EVENT_EMIT(event, data);
    if (trace_event_get_state(TRACE_MONITOR_PROTOCOL_EVENT_EMIT)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:monitor_protocol_event_emit " "event=%d data=%p" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , event, data);
    }
}

static inline void trace_monitor_protocol_event_queue(uint32_t event, void * data, uint64_t rate, uint64_t last, uint64_t now)
{
    QEMU_MONITOR_PROTOCOL_EVENT_QUEUE(event, data, rate, last, now);
    if (trace_event_get_state(TRACE_MONITOR_PROTOCOL_EVENT_QUEUE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:monitor_protocol_event_queue " "event=%d data=%p rate=%" PRId64 " last=%" PRId64 " now=%" PRId64 "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , event, data, rate, last, now);
    }
}

static inline void trace_monitor_protocol_event_throttle(uint32_t event, uint64_t rate)
{
    QEMU_MONITOR_PROTOCOL_EVENT_THROTTLE(event, rate);
    if (trace_event_get_state(TRACE_MONITOR_PROTOCOL_EVENT_THROTTLE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:monitor_protocol_event_throttle " "event=%d rate=%" PRId64 "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , event, rate);
    }
}

static inline void trace_open_eth_mii_write(unsigned idx, uint16_t v)
{
    QEMU_OPEN_ETH_MII_WRITE(idx, v);
    if (trace_event_get_state(TRACE_OPEN_ETH_MII_WRITE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:open_eth_mii_write " "MII[%02x] <- %04x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , idx, v);
    }
}

static inline void trace_open_eth_mii_read(unsigned idx, uint16_t v)
{
    QEMU_OPEN_ETH_MII_READ(idx, v);
    if (trace_event_get_state(TRACE_OPEN_ETH_MII_READ)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:open_eth_mii_read " "MII[%02x] -> %04x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , idx, v);
    }
}

static inline void trace_open_eth_update_irq(uint32_t v)
{
    QEMU_OPEN_ETH_UPDATE_IRQ(v);
    if (trace_event_get_state(TRACE_OPEN_ETH_UPDATE_IRQ)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:open_eth_update_irq " "IRQ <- %x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , v);
    }
}

static inline void trace_open_eth_receive(unsigned len)
{
    QEMU_OPEN_ETH_RECEIVE(len);
    if (trace_event_get_state(TRACE_OPEN_ETH_RECEIVE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:open_eth_receive " "RX: len: %u" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , len);
    }
}

static inline void trace_open_eth_receive_mcast(unsigned idx, uint32_t h0, uint32_t h1)
{
    QEMU_OPEN_ETH_RECEIVE_MCAST(idx, h0, h1);
    if (trace_event_get_state(TRACE_OPEN_ETH_RECEIVE_MCAST)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:open_eth_receive_mcast " "MCAST: idx = %u, hash: %08x:%08x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , idx, h0, h1);
    }
}

static inline void trace_open_eth_receive_reject(void)
{
    QEMU_OPEN_ETH_RECEIVE_REJECT();
    if (trace_event_get_state(TRACE_OPEN_ETH_RECEIVE_REJECT)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:open_eth_receive_reject " "RX: rejected" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      );
    }
}

static inline void trace_open_eth_receive_desc(uint32_t addr, uint32_t len_flags)
{
    QEMU_OPEN_ETH_RECEIVE_DESC(addr, len_flags);
    if (trace_event_get_state(TRACE_OPEN_ETH_RECEIVE_DESC)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:open_eth_receive_desc " "RX: %08x, len_flags: %08x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , addr, len_flags);
    }
}

static inline void trace_open_eth_start_xmit(uint32_t addr, unsigned len, unsigned tx_len)
{
    QEMU_OPEN_ETH_START_XMIT(addr, len, tx_len);
    if (trace_event_get_state(TRACE_OPEN_ETH_START_XMIT)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:open_eth_start_xmit " "TX: %08x, len: %u, tx_len: %u" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , addr, len, tx_len);
    }
}

static inline void trace_open_eth_reg_read(uint32_t addr, uint32_t v)
{
    QEMU_OPEN_ETH_REG_READ(addr, v);
    if (trace_event_get_state(TRACE_OPEN_ETH_REG_READ)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:open_eth_reg_read " "MAC[%02x] -> %08x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , addr, v);
    }
}

static inline void trace_open_eth_reg_write(uint32_t addr, uint32_t v)
{
    QEMU_OPEN_ETH_REG_WRITE(addr, v);
    if (trace_event_get_state(TRACE_OPEN_ETH_REG_WRITE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:open_eth_reg_write " "MAC[%02x] <- %08x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , addr, v);
    }
}

static inline void trace_open_eth_desc_read(uint32_t addr, uint32_t v)
{
    QEMU_OPEN_ETH_DESC_READ(addr, v);
    if (trace_event_get_state(TRACE_OPEN_ETH_DESC_READ)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:open_eth_desc_read " "DESC[%04x] -> %08x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , addr, v);
    }
}

static inline void trace_open_eth_desc_write(uint32_t addr, uint32_t v)
{
    QEMU_OPEN_ETH_DESC_WRITE(addr, v);
    if (trace_event_get_state(TRACE_OPEN_ETH_DESC_WRITE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:open_eth_desc_write " "DESC[%04x] <- %08x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , addr, v);
    }
}

static inline void trace_v9fs_rerror(uint16_t tag, uint8_t id, int err)
{
    QEMU_V9FS_RERROR(tag, id, err);
    if (trace_event_get_state(TRACE_V9FS_RERROR)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:v9fs_rerror " "tag %d id %d err %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , tag, id, err);
    }
}

static inline void trace_v9fs_version(uint16_t tag, uint8_t id, int32_t msize, char* version)
{
    QEMU_V9FS_VERSION(tag, id, msize, version);
    if (trace_event_get_state(TRACE_V9FS_VERSION)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:v9fs_version " "tag %d id %d msize %d version %s" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , tag, id, msize, version);
    }
}

static inline void trace_v9fs_version_return(uint16_t tag, uint8_t id, int32_t msize, char* version)
{
    QEMU_V9FS_VERSION_RETURN(tag, id, msize, version);
    if (trace_event_get_state(TRACE_V9FS_VERSION_RETURN)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:v9fs_version_return " "tag %d id %d msize %d version %s" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , tag, id, msize, version);
    }
}

static inline void trace_v9fs_attach(uint16_t tag, uint8_t id, int32_t fid, int32_t afid, char* uname, char* aname)
{
    QEMU_V9FS_ATTACH(tag, id, fid, afid, uname, aname);
    if (trace_event_get_state(TRACE_V9FS_ATTACH)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:v9fs_attach " "tag %u id %u fid %d afid %d uname %s aname %s" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , tag, id, fid, afid, uname, aname);
    }
}

static inline void trace_v9fs_attach_return(uint16_t tag, uint8_t id, int8_t type, int32_t version, int64_t path)
{
    QEMU_V9FS_ATTACH_RETURN(tag, id, type, version, path);
    if (trace_event_get_state(TRACE_V9FS_ATTACH_RETURN)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:v9fs_attach_return " "tag %d id %d type %d version %d path %"PRId64"" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , tag, id, type, version, path);
    }
}

static inline void trace_v9fs_stat(uint16_t tag, uint8_t id, int32_t fid)
{
    QEMU_V9FS_STAT(tag, id, fid);
    if (trace_event_get_state(TRACE_V9FS_STAT)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:v9fs_stat " "tag %d id %d fid %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , tag, id, fid);
    }
}

static inline void trace_v9fs_stat_return(uint16_t tag, uint8_t id, int32_t mode, int32_t atime, int32_t mtime, int64_t length)
{
    QEMU_V9FS_STAT_RETURN(tag, id, mode, atime, mtime, length);
    if (trace_event_get_state(TRACE_V9FS_STAT_RETURN)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:v9fs_stat_return " "tag %d id %d stat={mode %d atime %d mtime %d length %"PRId64"}" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , tag, id, mode, atime, mtime, length);
    }
}

static inline void trace_v9fs_getattr(uint16_t tag, uint8_t id, int32_t fid, uint64_t request_mask)
{
    QEMU_V9FS_GETATTR(tag, id, fid, request_mask);
    if (trace_event_get_state(TRACE_V9FS_GETATTR)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:v9fs_getattr " "tag %d id %d fid %d request_mask %"PRIu64"" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , tag, id, fid, request_mask);
    }
}

static inline void trace_v9fs_getattr_return(uint16_t tag, uint8_t id, uint64_t result_mask, uint32_t mode, uint32_t uid, uint32_t gid)
{
    QEMU_V9FS_GETATTR_RETURN(tag, id, result_mask, mode, uid, gid);
    if (trace_event_get_state(TRACE_V9FS_GETATTR_RETURN)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:v9fs_getattr_return " "tag %d id %d getattr={result_mask %"PRId64" mode %u uid %u gid %u}" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , tag, id, result_mask, mode, uid, gid);
    }
}

static inline void trace_v9fs_walk(uint16_t tag, uint8_t id, int32_t fid, int32_t newfid, uint16_t nwnames)
{
    QEMU_V9FS_WALK(tag, id, fid, newfid, nwnames);
    if (trace_event_get_state(TRACE_V9FS_WALK)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:v9fs_walk " "tag %d id %d fid %d newfid %d nwnames %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , tag, id, fid, newfid, nwnames);
    }
}

static inline void trace_v9fs_walk_return(uint16_t tag, uint8_t id, uint16_t nwnames, void* qids)
{
    QEMU_V9FS_WALK_RETURN(tag, id, nwnames, qids);
    if (trace_event_get_state(TRACE_V9FS_WALK_RETURN)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:v9fs_walk_return " "tag %d id %d nwnames %d qids %p" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , tag, id, nwnames, qids);
    }
}

static inline void trace_v9fs_open(uint16_t tag, uint8_t id, int32_t fid, int32_t mode)
{
    QEMU_V9FS_OPEN(tag, id, fid, mode);
    if (trace_event_get_state(TRACE_V9FS_OPEN)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:v9fs_open " "tag %d id %d fid %d mode %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , tag, id, fid, mode);
    }
}

static inline void trace_v9fs_open_return(uint16_t tag, uint8_t id, int8_t type, int32_t version, int64_t path, int iounit)
{
    QEMU_V9FS_OPEN_RETURN(tag, id, type, version, path, iounit);
    if (trace_event_get_state(TRACE_V9FS_OPEN_RETURN)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:v9fs_open_return " "tag %d id %d qid={type %d version %d path %"PRId64"} iounit %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , tag, id, type, version, path, iounit);
    }
}

static inline void trace_v9fs_lcreate(uint16_t tag, uint8_t id, int32_t dfid, int32_t flags, int32_t mode, uint32_t gid)
{
    QEMU_V9FS_LCREATE(tag, id, dfid, flags, mode, gid);
    if (trace_event_get_state(TRACE_V9FS_LCREATE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:v9fs_lcreate " "tag %d id %d dfid %d flags %d mode %d gid %u" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , tag, id, dfid, flags, mode, gid);
    }
}

static inline void trace_v9fs_lcreate_return(uint16_t tag, uint8_t id, int8_t type, int32_t version, int64_t path, int32_t iounit)
{
    QEMU_V9FS_LCREATE_RETURN(tag, id, type, version, path, iounit);
    if (trace_event_get_state(TRACE_V9FS_LCREATE_RETURN)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:v9fs_lcreate_return " "tag %d id %d qid={type %d version %d path %"PRId64"} iounit %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , tag, id, type, version, path, iounit);
    }
}

static inline void trace_v9fs_fsync(uint16_t tag, uint8_t id, int32_t fid, int datasync)
{
    QEMU_V9FS_FSYNC(tag, id, fid, datasync);
    if (trace_event_get_state(TRACE_V9FS_FSYNC)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:v9fs_fsync " "tag %d id %d fid %d datasync %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , tag, id, fid, datasync);
    }
}

static inline void trace_v9fs_clunk(uint16_t tag, uint8_t id, int32_t fid)
{
    QEMU_V9FS_CLUNK(tag, id, fid);
    if (trace_event_get_state(TRACE_V9FS_CLUNK)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:v9fs_clunk " "tag %d id %d fid %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , tag, id, fid);
    }
}

static inline void trace_v9fs_read(uint16_t tag, uint8_t id, int32_t fid, uint64_t off, uint32_t max_count)
{
    QEMU_V9FS_READ(tag, id, fid, off, max_count);
    if (trace_event_get_state(TRACE_V9FS_READ)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:v9fs_read " "tag %d id %d fid %d off %"PRIu64" max_count %u" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , tag, id, fid, off, max_count);
    }
}

static inline void trace_v9fs_read_return(uint16_t tag, uint8_t id, int32_t count, ssize_t err)
{
    QEMU_V9FS_READ_RETURN(tag, id, count, err);
    if (trace_event_get_state(TRACE_V9FS_READ_RETURN)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:v9fs_read_return " "tag %d id %d count %d err %zd" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , tag, id, count, err);
    }
}

static inline void trace_v9fs_readdir(uint16_t tag, uint8_t id, int32_t fid, uint64_t offset, uint32_t max_count)
{
    QEMU_V9FS_READDIR(tag, id, fid, offset, max_count);
    if (trace_event_get_state(TRACE_V9FS_READDIR)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:v9fs_readdir " "tag %d id %d fid %d offset %"PRIu64" max_count %u" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , tag, id, fid, offset, max_count);
    }
}

static inline void trace_v9fs_readdir_return(uint16_t tag, uint8_t id, uint32_t count, ssize_t retval)
{
    QEMU_V9FS_READDIR_RETURN(tag, id, count, retval);
    if (trace_event_get_state(TRACE_V9FS_READDIR_RETURN)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:v9fs_readdir_return " "tag %d id %d count %u retval %zd" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , tag, id, count, retval);
    }
}

static inline void trace_v9fs_write(uint16_t tag, uint8_t id, int32_t fid, uint64_t off, uint32_t count, int cnt)
{
    QEMU_V9FS_WRITE(tag, id, fid, off, count, cnt);
    if (trace_event_get_state(TRACE_V9FS_WRITE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:v9fs_write " "tag %d id %d fid %d off %"PRIu64" count %u cnt %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , tag, id, fid, off, count, cnt);
    }
}

static inline void trace_v9fs_write_return(uint16_t tag, uint8_t id, int32_t total, ssize_t err)
{
    QEMU_V9FS_WRITE_RETURN(tag, id, total, err);
    if (trace_event_get_state(TRACE_V9FS_WRITE_RETURN)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:v9fs_write_return " "tag %d id %d total %d err %zd" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , tag, id, total, err);
    }
}

static inline void trace_v9fs_create(uint16_t tag, uint8_t id, int32_t fid, char* name, int32_t perm, int8_t mode)
{
    QEMU_V9FS_CREATE(tag, id, fid, name, perm, mode);
    if (trace_event_get_state(TRACE_V9FS_CREATE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:v9fs_create " "tag %d id %d fid %d name %s perm %d mode %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , tag, id, fid, name, perm, mode);
    }
}

static inline void trace_v9fs_create_return(uint16_t tag, uint8_t id, int8_t type, int32_t version, int64_t path, int iounit)
{
    QEMU_V9FS_CREATE_RETURN(tag, id, type, version, path, iounit);
    if (trace_event_get_state(TRACE_V9FS_CREATE_RETURN)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:v9fs_create_return " "tag %d id %d qid={type %d version %d path %"PRId64"} iounit %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , tag, id, type, version, path, iounit);
    }
}

static inline void trace_v9fs_symlink(uint16_t tag, uint8_t id, int32_t fid, char* name, char* symname, uint32_t gid)
{
    QEMU_V9FS_SYMLINK(tag, id, fid, name, symname, gid);
    if (trace_event_get_state(TRACE_V9FS_SYMLINK)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:v9fs_symlink " "tag %d id %d fid %d name %s symname %s gid %u" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , tag, id, fid, name, symname, gid);
    }
}

static inline void trace_v9fs_symlink_return(uint16_t tag, uint8_t id, int8_t type, int32_t version, int64_t path)
{
    QEMU_V9FS_SYMLINK_RETURN(tag, id, type, version, path);
    if (trace_event_get_state(TRACE_V9FS_SYMLINK_RETURN)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:v9fs_symlink_return " "tag %d id %d qid={type %d version %d path %"PRId64"}" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , tag, id, type, version, path);
    }
}

static inline void trace_v9fs_flush(uint16_t tag, uint8_t id, int16_t flush_tag)
{
    QEMU_V9FS_FLUSH(tag, id, flush_tag);
    if (trace_event_get_state(TRACE_V9FS_FLUSH)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:v9fs_flush " "tag %d id %d flush_tag %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , tag, id, flush_tag);
    }
}

static inline void trace_v9fs_link(uint16_t tag, uint8_t id, int32_t dfid, int32_t oldfid, char* name)
{
    QEMU_V9FS_LINK(tag, id, dfid, oldfid, name);
    if (trace_event_get_state(TRACE_V9FS_LINK)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:v9fs_link " "tag %d id %d dfid %d oldfid %d name %s" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , tag, id, dfid, oldfid, name);
    }
}

static inline void trace_v9fs_remove(uint16_t tag, uint8_t id, int32_t fid)
{
    QEMU_V9FS_REMOVE(tag, id, fid);
    if (trace_event_get_state(TRACE_V9FS_REMOVE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:v9fs_remove " "tag %d id %d fid %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , tag, id, fid);
    }
}

static inline void trace_v9fs_wstat(uint16_t tag, uint8_t id, int32_t fid, int32_t mode, int32_t atime, int32_t mtime)
{
    QEMU_V9FS_WSTAT(tag, id, fid, mode, atime, mtime);
    if (trace_event_get_state(TRACE_V9FS_WSTAT)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:v9fs_wstat " "tag %u id %u fid %d stat={mode %d atime %d mtime %d}" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , tag, id, fid, mode, atime, mtime);
    }
}

static inline void trace_v9fs_mknod(uint16_t tag, uint8_t id, int32_t fid, int mode, int major, int minor)
{
    QEMU_V9FS_MKNOD(tag, id, fid, mode, major, minor);
    if (trace_event_get_state(TRACE_V9FS_MKNOD)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:v9fs_mknod " "tag %d id %d fid %d mode %d major %d minor %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , tag, id, fid, mode, major, minor);
    }
}

static inline void trace_v9fs_mknod_return(uint16_t tag, uint8_t id, int8_t type, int32_t version, int64_t path)
{
    QEMU_V9FS_MKNOD_RETURN(tag, id, type, version, path);
    if (trace_event_get_state(TRACE_V9FS_MKNOD_RETURN)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:v9fs_mknod_return " "tag %d id %d qid={type %d version %d path %"PRId64"}" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , tag, id, type, version, path);
    }
}

static inline void trace_v9fs_lock(uint16_t tag, uint8_t id, int32_t fid, uint8_t type, uint64_t start, uint64_t length)
{
    QEMU_V9FS_LOCK(tag, id, fid, type, start, length);
    if (trace_event_get_state(TRACE_V9FS_LOCK)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:v9fs_lock " "tag %d id %d fid %d type %d start %"PRIu64" length %"PRIu64"" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , tag, id, fid, type, start, length);
    }
}

static inline void trace_v9fs_lock_return(uint16_t tag, uint8_t id, int8_t status)
{
    QEMU_V9FS_LOCK_RETURN(tag, id, status);
    if (trace_event_get_state(TRACE_V9FS_LOCK_RETURN)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:v9fs_lock_return " "tag %d id %d status %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , tag, id, status);
    }
}

static inline void trace_v9fs_getlock(uint16_t tag, uint8_t id, int32_t fid, uint8_t type, uint64_t start, uint64_t length)
{
    QEMU_V9FS_GETLOCK(tag, id, fid, type, start, length);
    if (trace_event_get_state(TRACE_V9FS_GETLOCK)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:v9fs_getlock " "tag %d id %d fid %d type %d start %"PRIu64" length %"PRIu64"" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , tag, id, fid, type, start, length);
    }
}

static inline void trace_v9fs_getlock_return(uint16_t tag, uint8_t id, uint8_t type, uint64_t start, uint64_t length, uint32_t proc_id)
{
    QEMU_V9FS_GETLOCK_RETURN(tag, id, type, start, length, proc_id);
    if (trace_event_get_state(TRACE_V9FS_GETLOCK_RETURN)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:v9fs_getlock_return " "tag %d id %d type %d start %"PRIu64" length %"PRIu64" proc_id %u" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , tag, id, type, start, length, proc_id);
    }
}

static inline void trace_v9fs_mkdir(uint16_t tag, uint8_t id, int32_t fid, char* name, int mode, uint32_t gid)
{
    QEMU_V9FS_MKDIR(tag, id, fid, name, mode, gid);
    if (trace_event_get_state(TRACE_V9FS_MKDIR)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:v9fs_mkdir " "tag %u id %u fid %d name %s mode %d gid %u" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , tag, id, fid, name, mode, gid);
    }
}

static inline void trace_v9fs_mkdir_return(uint16_t tag, uint8_t id, int8_t type, int32_t version, int64_t path, int err)
{
    QEMU_V9FS_MKDIR_RETURN(tag, id, type, version, path, err);
    if (trace_event_get_state(TRACE_V9FS_MKDIR_RETURN)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:v9fs_mkdir_return " "tag %u id %u qid={type %d version %d path %"PRId64"} err %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , tag, id, type, version, path, err);
    }
}

static inline void trace_v9fs_xattrwalk(uint16_t tag, uint8_t id, int32_t fid, int32_t newfid, char* name)
{
    QEMU_V9FS_XATTRWALK(tag, id, fid, newfid, name);
    if (trace_event_get_state(TRACE_V9FS_XATTRWALK)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:v9fs_xattrwalk " "tag %d id %d fid %d newfid %d name %s" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , tag, id, fid, newfid, name);
    }
}

static inline void trace_v9fs_xattrwalk_return(uint16_t tag, uint8_t id, int64_t size)
{
    QEMU_V9FS_XATTRWALK_RETURN(tag, id, size);
    if (trace_event_get_state(TRACE_V9FS_XATTRWALK_RETURN)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:v9fs_xattrwalk_return " "tag %d id %d size %"PRId64"" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , tag, id, size);
    }
}

static inline void trace_v9fs_xattrcreate(uint16_t tag, uint8_t id, int32_t fid, char* name, int64_t size, int flags)
{
    QEMU_V9FS_XATTRCREATE(tag, id, fid, name, size, flags);
    if (trace_event_get_state(TRACE_V9FS_XATTRCREATE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:v9fs_xattrcreate " "tag %d id %d fid %d name %s size %"PRId64" flags %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , tag, id, fid, name, size, flags);
    }
}

static inline void trace_v9fs_readlink(uint16_t tag, uint8_t id, int32_t fid)
{
    QEMU_V9FS_READLINK(tag, id, fid);
    if (trace_event_get_state(TRACE_V9FS_READLINK)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:v9fs_readlink " "tag %d id %d fid %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , tag, id, fid);
    }
}

static inline void trace_v9fs_readlink_return(uint16_t tag, uint8_t id, char* target)
{
    QEMU_V9FS_READLINK_RETURN(tag, id, target);
    if (trace_event_get_state(TRACE_V9FS_READLINK_RETURN)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:v9fs_readlink_return " "tag %d id %d name %s" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , tag, id, target);
    }
}

static inline void trace_mmu_helper_dfault(uint64_t address, uint64_t context, int mmu_idx, uint32_t tl)
{
    QEMU_MMU_HELPER_DFAULT(address, context, mmu_idx, tl);
    if (trace_event_get_state(TRACE_MMU_HELPER_DFAULT)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:mmu_helper_dfault " "DFAULT at %"PRIx64" context %"PRIx64" mmu_idx=%d tl=%d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , address, context, mmu_idx, tl);
    }
}

static inline void trace_mmu_helper_dprot(uint64_t address, uint64_t context, int mmu_idx, uint32_t tl)
{
    QEMU_MMU_HELPER_DPROT(address, context, mmu_idx, tl);
    if (trace_event_get_state(TRACE_MMU_HELPER_DPROT)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:mmu_helper_dprot " "DPROT at %"PRIx64" context %"PRIx64" mmu_idx=%d tl=%d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , address, context, mmu_idx, tl);
    }
}

static inline void trace_mmu_helper_dmiss(uint64_t address, uint64_t context)
{
    QEMU_MMU_HELPER_DMISS(address, context);
    if (trace_event_get_state(TRACE_MMU_HELPER_DMISS)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:mmu_helper_dmiss " "DMISS at %"PRIx64" context %"PRIx64"" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , address, context);
    }
}

static inline void trace_mmu_helper_tfault(uint64_t address, uint64_t context)
{
    QEMU_MMU_HELPER_TFAULT(address, context);
    if (trace_event_get_state(TRACE_MMU_HELPER_TFAULT)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:mmu_helper_tfault " "TFAULT at %"PRIx64" context %"PRIx64"" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , address, context);
    }
}

static inline void trace_mmu_helper_tmiss(uint64_t address, uint64_t context)
{
    QEMU_MMU_HELPER_TMISS(address, context);
    if (trace_event_get_state(TRACE_MMU_HELPER_TMISS)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:mmu_helper_tmiss " "TMISS at %"PRIx64" context %"PRIx64"" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , address, context);
    }
}

static inline void trace_mmu_helper_get_phys_addr_code(uint32_t tl, int mmu_idx, uint64_t prim_context, uint64_t sec_context, uint64_t address)
{
    QEMU_MMU_HELPER_GET_PHYS_ADDR_CODE(tl, mmu_idx, prim_context, sec_context, address);
    if (trace_event_get_state(TRACE_MMU_HELPER_GET_PHYS_ADDR_CODE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:mmu_helper_get_phys_addr_code " "tl=%d mmu_idx=%d primary context=%"PRIx64" secondary context=%"PRIx64" address=%"PRIx64"" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , tl, mmu_idx, prim_context, sec_context, address);
    }
}

static inline void trace_mmu_helper_get_phys_addr_data(uint32_t tl, int mmu_idx, uint64_t prim_context, uint64_t sec_context, uint64_t address)
{
    QEMU_MMU_HELPER_GET_PHYS_ADDR_DATA(tl, mmu_idx, prim_context, sec_context, address);
    if (trace_event_get_state(TRACE_MMU_HELPER_GET_PHYS_ADDR_DATA)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:mmu_helper_get_phys_addr_data " "tl=%d mmu_idx=%d primary context=%"PRIx64" secondary context=%"PRIx64" address=%"PRIx64"" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , tl, mmu_idx, prim_context, sec_context, address);
    }
}

static inline void trace_mmu_helper_mmu_fault(uint64_t address, uint64_t paddr, int mmu_idx, uint32_t tl, uint64_t prim_context, uint64_t sec_context)
{
    QEMU_MMU_HELPER_MMU_FAULT(address, paddr, mmu_idx, tl, prim_context, sec_context);
    if (trace_event_get_state(TRACE_MMU_HELPER_MMU_FAULT)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:mmu_helper_mmu_fault " "Translate at %"PRIx64" -> %"PRIx64", mmu_idx=%d tl=%d primary context=%"PRIx64" secondary context=%"PRIx64"" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , address, paddr, mmu_idx, tl, prim_context, sec_context);
    }
}

static inline void trace_int_helper_set_softint(uint32_t softint)
{
    QEMU_INT_HELPER_SET_SOFTINT(softint);
    if (trace_event_get_state(TRACE_INT_HELPER_SET_SOFTINT)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:int_helper_set_softint " "new %08x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , softint);
    }
}

static inline void trace_int_helper_clear_softint(uint32_t softint)
{
    QEMU_INT_HELPER_CLEAR_SOFTINT(softint);
    if (trace_event_get_state(TRACE_INT_HELPER_CLEAR_SOFTINT)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:int_helper_clear_softint " "new %08x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , softint);
    }
}

static inline void trace_int_helper_write_softint(uint32_t softint)
{
    QEMU_INT_HELPER_WRITE_SOFTINT(softint);
    if (trace_event_get_state(TRACE_INT_HELPER_WRITE_SOFTINT)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:int_helper_write_softint " "new %08x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , softint);
    }
}

static inline void trace_int_helper_icache_freeze(void)
{
    QEMU_INT_HELPER_ICACHE_FREEZE();
    if (trace_event_get_state(TRACE_INT_HELPER_ICACHE_FREEZE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:int_helper_icache_freeze " "Instruction cache: freeze" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      );
    }
}

static inline void trace_int_helper_dcache_freeze(void)
{
    QEMU_INT_HELPER_DCACHE_FREEZE();
    if (trace_event_get_state(TRACE_INT_HELPER_DCACHE_FREEZE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:int_helper_dcache_freeze " "Data cache: freeze" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      );
    }
}

static inline void trace_win_helper_gregset_error(uint32_t pstate)
{
    QEMU_WIN_HELPER_GREGSET_ERROR(pstate);
    if (trace_event_get_state(TRACE_WIN_HELPER_GREGSET_ERROR)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:win_helper_gregset_error " "ERROR in get_gregset: active pstate bits=%x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , pstate);
    }
}

static inline void trace_win_helper_switch_pstate(uint32_t pstate_regs, uint32_t new_pstate_regs)
{
    QEMU_WIN_HELPER_SWITCH_PSTATE(pstate_regs, new_pstate_regs);
    if (trace_event_get_state(TRACE_WIN_HELPER_SWITCH_PSTATE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:win_helper_switch_pstate " "change_pstate: switching regs old=%x new=%x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , pstate_regs, new_pstate_regs);
    }
}

static inline void trace_win_helper_no_switch_pstate(uint32_t new_pstate_regs)
{
    QEMU_WIN_HELPER_NO_SWITCH_PSTATE(new_pstate_regs);
    if (trace_event_get_state(TRACE_WIN_HELPER_NO_SWITCH_PSTATE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:win_helper_no_switch_pstate " "change_pstate: regs new=%x (unchanged)" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , new_pstate_regs);
    }
}

static inline void trace_win_helper_wrpil(uint32_t psrpil, uint32_t new_pil)
{
    QEMU_WIN_HELPER_WRPIL(psrpil, new_pil);
    if (trace_event_get_state(TRACE_WIN_HELPER_WRPIL)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:win_helper_wrpil " "old=%x new=%x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , psrpil, new_pil);
    }
}

static inline void trace_win_helper_done(uint32_t tl)
{
    QEMU_WIN_HELPER_DONE(tl);
    if (trace_event_get_state(TRACE_WIN_HELPER_DONE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:win_helper_done " "tl=%d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , tl);
    }
}

static inline void trace_win_helper_retry(uint32_t tl)
{
    QEMU_WIN_HELPER_RETRY(tl);
    if (trace_event_get_state(TRACE_WIN_HELPER_RETRY)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:win_helper_retry " "tl=%d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , tl);
    }
}

static inline void trace_dma_blk_io(void * dbs, void * bs, int64_t sector_num, bool to_dev)
{
    QEMU_DMA_BLK_IO(dbs, bs, sector_num, to_dev);
    if (trace_event_get_state(TRACE_DMA_BLK_IO)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:dma_blk_io " "dbs=%p bs=%p sector_num=%" PRId64 " to_dev=%d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , dbs, bs, sector_num, to_dev);
    }
}

static inline void trace_dma_aio_cancel(void * dbs)
{
    QEMU_DMA_AIO_CANCEL(dbs);
    if (trace_event_get_state(TRACE_DMA_AIO_CANCEL)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:dma_aio_cancel " "dbs=%p" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , dbs);
    }
}

static inline void trace_dma_complete(void * dbs, int ret, void * cb)
{
    QEMU_DMA_COMPLETE(dbs, ret, cb);
    if (trace_event_get_state(TRACE_DMA_COMPLETE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:dma_complete " "dbs=%p ret=%d cb=%p" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , dbs, ret, cb);
    }
}

static inline void trace_dma_blk_cb(void * dbs, int ret)
{
    QEMU_DMA_BLK_CB(dbs, ret);
    if (trace_event_get_state(TRACE_DMA_BLK_CB)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:dma_blk_cb " "dbs=%p ret=%d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , dbs, ret);
    }
}

static inline void trace_dma_map_wait(void * dbs)
{
    QEMU_DMA_MAP_WAIT(dbs);
    if (trace_event_get_state(TRACE_DMA_MAP_WAIT)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:dma_map_wait " "dbs=%p" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , dbs);
    }
}

static inline void trace_console_gfx_new(void)
{
    QEMU_CONSOLE_GFX_NEW();
    if (trace_event_get_state(TRACE_CONSOLE_GFX_NEW)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:console_gfx_new " "" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      );
    }
}

static inline void trace_console_putchar_csi(int esc_param0, int esc_param1, int ch, int nb_esc_params)
{
    QEMU_CONSOLE_PUTCHAR_CSI(esc_param0, esc_param1, ch, nb_esc_params);
    if (trace_event_get_state(TRACE_CONSOLE_PUTCHAR_CSI)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:console_putchar_csi " "escape sequence CSI%d;%d%c, %d parameters" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , esc_param0, esc_param1, ch, nb_esc_params);
    }
}

static inline void trace_console_putchar_unhandled(int ch)
{
    QEMU_CONSOLE_PUTCHAR_UNHANDLED(ch);
    if (trace_event_get_state(TRACE_CONSOLE_PUTCHAR_UNHANDLED)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:console_putchar_unhandled " "unhandled escape character '%c'" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , ch);
    }
}

static inline void trace_console_txt_new(int w, int h)
{
    QEMU_CONSOLE_TXT_NEW(w, h);
    if (trace_event_get_state(TRACE_CONSOLE_TXT_NEW)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:console_txt_new " "%dx%d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , w, h);
    }
}

static inline void trace_console_select(int nr)
{
    QEMU_CONSOLE_SELECT(nr);
    if (trace_event_get_state(TRACE_CONSOLE_SELECT)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:console_select " "%d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , nr);
    }
}

static inline void trace_console_refresh(int interval)
{
    QEMU_CONSOLE_REFRESH(interval);
    if (trace_event_get_state(TRACE_CONSOLE_REFRESH)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:console_refresh " "interval %d ms" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , interval);
    }
}

static inline void trace_displaysurface_create(void * display_surface, int w, int h)
{
    QEMU_DISPLAYSURFACE_CREATE(display_surface, w, h);
    if (trace_event_get_state(TRACE_DISPLAYSURFACE_CREATE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:displaysurface_create " "surface=%p, %dx%d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , display_surface, w, h);
    }
}

static inline void trace_displaysurface_create_from(void * display_surface, int w, int h, uint32_t format)
{
    QEMU_DISPLAYSURFACE_CREATE_FROM(display_surface, w, h, format);
    if (trace_event_get_state(TRACE_DISPLAYSURFACE_CREATE_FROM)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:displaysurface_create_from " "surface=%p, %dx%d, format 0x%x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , display_surface, w, h, format);
    }
}

static inline void trace_displaysurface_free(void * display_surface)
{
    QEMU_DISPLAYSURFACE_FREE(display_surface);
    if (trace_event_get_state(TRACE_DISPLAYSURFACE_FREE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:displaysurface_free " "surface=%p" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , display_surface);
    }
}

static inline void trace_displaychangelistener_register(void * dcl, const char * name)
{
    QEMU_DISPLAYCHANGELISTENER_REGISTER(dcl, name);
    if (trace_event_get_state(TRACE_DISPLAYCHANGELISTENER_REGISTER)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:displaychangelistener_register " "%p [ %s ]" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , dcl, name);
    }
}

static inline void trace_displaychangelistener_unregister(void * dcl, const char * name)
{
    QEMU_DISPLAYCHANGELISTENER_UNREGISTER(dcl, name);
    if (trace_event_get_state(TRACE_DISPLAYCHANGELISTENER_UNREGISTER)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:displaychangelistener_unregister " "%p [ %s ]" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , dcl, name);
    }
}

static inline void trace_ppm_save(const char * filename, void * display_surface)
{
    QEMU_PPM_SAVE(filename, display_surface);
    if (trace_event_get_state(TRACE_PPM_SAVE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:ppm_save " "%s surface=%p" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , filename, display_surface);
    }
}

static inline void trace_gd_switch(const char * tab, int width, int height)
{
    QEMU_GD_SWITCH(tab, width, height);
    if (trace_event_get_state(TRACE_GD_SWITCH)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:gd_switch " "tab=%s, width=%d, height=%d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , tab, width, height);
    }
}

static inline void trace_gd_update(const char * tab, int x, int y, int w, int h)
{
    QEMU_GD_UPDATE(tab, x, y, w, h);
    if (trace_event_get_state(TRACE_GD_UPDATE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:gd_update " "tab=%s, x=%d, y=%d, w=%d, h=%d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , tab, x, y, w, h);
    }
}

static inline void trace_gd_key_event(const char * tab, int gdk_keycode, int qemu_keycode, const char * action)
{
    QEMU_GD_KEY_EVENT(tab, gdk_keycode, qemu_keycode, action);
    if (trace_event_get_state(TRACE_GD_KEY_EVENT)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:gd_key_event " "tab=%s, translated GDK keycode %d to QEMU keycode %d (%s)" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , tab, gdk_keycode, qemu_keycode, action);
    }
}

static inline void trace_gd_grab(const char * tab, const char * device, bool on)
{
    QEMU_GD_GRAB(tab, device, on);
    if (trace_event_get_state(TRACE_GD_GRAB)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:gd_grab " "tab=%s, %s %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , tab, device, on);
    }
}

static inline void trace_vnc_key_guest_leds(bool caps, bool num, bool scroll)
{
    QEMU_VNC_KEY_GUEST_LEDS(caps, num, scroll);
    if (trace_event_get_state(TRACE_VNC_KEY_GUEST_LEDS)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:vnc_key_guest_leds " "caps %d, num %d, scroll %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , caps, num, scroll);
    }
}

static inline void trace_vnc_key_map_init(const char * layout)
{
    QEMU_VNC_KEY_MAP_INIT(layout);
    if (trace_event_get_state(TRACE_VNC_KEY_MAP_INIT)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:vnc_key_map_init " "%s" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , layout);
    }
}

static inline void trace_vnc_key_event_ext(bool down, int sym, int keycode, const char * name)
{
    QEMU_VNC_KEY_EVENT_EXT(down, sym, keycode, name);
    if (trace_event_get_state(TRACE_VNC_KEY_EVENT_EXT)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:vnc_key_event_ext " "down %d, sym 0x%x, keycode 0x%x [%s]" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , down, sym, keycode, name);
    }
}

static inline void trace_vnc_key_event_map(bool down, int sym, int keycode, const char * name)
{
    QEMU_VNC_KEY_EVENT_MAP(down, sym, keycode, name);
    if (trace_event_get_state(TRACE_VNC_KEY_EVENT_MAP)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:vnc_key_event_map " "down %d, sym 0x%x -> keycode 0x%x [%s]" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , down, sym, keycode, name);
    }
}

static inline void trace_vnc_key_sync_numlock(bool on)
{
    QEMU_VNC_KEY_SYNC_NUMLOCK(on);
    if (trace_event_get_state(TRACE_VNC_KEY_SYNC_NUMLOCK)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:vnc_key_sync_numlock " "%d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , on);
    }
}

static inline void trace_vnc_key_sync_capslock(bool on)
{
    QEMU_VNC_KEY_SYNC_CAPSLOCK(on);
    if (trace_event_get_state(TRACE_VNC_KEY_SYNC_CAPSLOCK)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:vnc_key_sync_capslock " "%d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , on);
    }
}

static inline void trace_input_event_key_number(int conidx, int number, const char * qcode, bool down)
{
    QEMU_INPUT_EVENT_KEY_NUMBER(conidx, number, qcode, down);
    if (trace_event_get_state(TRACE_INPUT_EVENT_KEY_NUMBER)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:input_event_key_number " "con %d, key number 0x%x [%s], down %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , conidx, number, qcode, down);
    }
}

static inline void trace_input_event_key_qcode(int conidx, const char * qcode, bool down)
{
    QEMU_INPUT_EVENT_KEY_QCODE(conidx, qcode, down);
    if (trace_event_get_state(TRACE_INPUT_EVENT_KEY_QCODE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:input_event_key_qcode " "con %d, key qcode %s, down %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , conidx, qcode, down);
    }
}

static inline void trace_input_event_btn(int conidx, const char * btn, bool down)
{
    QEMU_INPUT_EVENT_BTN(conidx, btn, down);
    if (trace_event_get_state(TRACE_INPUT_EVENT_BTN)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:input_event_btn " "con %d, button %s, down %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , conidx, btn, down);
    }
}

static inline void trace_input_event_rel(int conidx, const char * axis, int value)
{
    QEMU_INPUT_EVENT_REL(conidx, axis, value);
    if (trace_event_get_state(TRACE_INPUT_EVENT_REL)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:input_event_rel " "con %d, axis %s, value %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , conidx, axis, value);
    }
}

static inline void trace_input_event_abs(int conidx, const char * axis, int value)
{
    QEMU_INPUT_EVENT_ABS(conidx, axis, value);
    if (trace_event_get_state(TRACE_INPUT_EVENT_ABS)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:input_event_abs " "con %d, axis %s, value 0x%x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , conidx, axis, value);
    }
}

static inline void trace_input_event_sync(void)
{
    QEMU_INPUT_EVENT_SYNC();
    if (trace_event_get_state(TRACE_INPUT_EVENT_SYNC)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:input_event_sync " "" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      );
    }
}

static inline void trace_input_mouse_mode(int absolute)
{
    QEMU_INPUT_MOUSE_MODE(absolute);
    if (trace_event_get_state(TRACE_INPUT_MOUSE_MODE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:input_mouse_mode " "absolute %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , absolute);
    }
}

static inline void trace_vmware_value_read(uint32_t index, uint32_t value)
{
    QEMU_VMWARE_VALUE_READ(index, value);
    if (trace_event_get_state(TRACE_VMWARE_VALUE_READ)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:vmware_value_read " "index %d, value 0x%x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , index, value);
    }
}

static inline void trace_vmware_value_write(uint32_t index, uint32_t value)
{
    QEMU_VMWARE_VALUE_WRITE(index, value);
    if (trace_event_get_state(TRACE_VMWARE_VALUE_WRITE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:vmware_value_write " "index %d, value 0x%x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , index, value);
    }
}

static inline void trace_vmware_palette_read(uint32_t index, uint32_t value)
{
    QEMU_VMWARE_PALETTE_READ(index, value);
    if (trace_event_get_state(TRACE_VMWARE_PALETTE_READ)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:vmware_palette_read " "index %d, value 0x%x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , index, value);
    }
}

static inline void trace_vmware_palette_write(uint32_t index, uint32_t value)
{
    QEMU_VMWARE_PALETTE_WRITE(index, value);
    if (trace_event_get_state(TRACE_VMWARE_PALETTE_WRITE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:vmware_palette_write " "index %d, value 0x%x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , index, value);
    }
}

static inline void trace_vmware_scratch_read(uint32_t index, uint32_t value)
{
    QEMU_VMWARE_SCRATCH_READ(index, value);
    if (trace_event_get_state(TRACE_VMWARE_SCRATCH_READ)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:vmware_scratch_read " "index %d, value 0x%x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , index, value);
    }
}

static inline void trace_vmware_scratch_write(uint32_t index, uint32_t value)
{
    QEMU_VMWARE_SCRATCH_WRITE(index, value);
    if (trace_event_get_state(TRACE_VMWARE_SCRATCH_WRITE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:vmware_scratch_write " "index %d, value 0x%x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , index, value);
    }
}

static inline void trace_vmware_setmode(uint32_t w, uint32_t h, uint32_t bpp)
{
    QEMU_VMWARE_SETMODE(w, h, bpp);
    if (trace_event_get_state(TRACE_VMWARE_SETMODE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:vmware_setmode " "%dx%d @ %d bpp" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , w, h, bpp);
    }
}

static inline void trace_qemu_loadvm_state_section(unsigned int section_type)
{
    QEMU_QEMU_LOADVM_STATE_SECTION(section_type);
    if (trace_event_get_state(TRACE_QEMU_LOADVM_STATE_SECTION)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qemu_loadvm_state_section " "%d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , section_type);
    }
}

static inline void trace_qemu_loadvm_state_section_command(int ret)
{
    QEMU_QEMU_LOADVM_STATE_SECTION_COMMAND(ret);
    if (trace_event_get_state(TRACE_QEMU_LOADVM_STATE_SECTION_COMMAND)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qemu_loadvm_state_section_command " "%d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , ret);
    }
}

static inline void trace_qemu_loadvm_state_section_partend(uint32_t section_id)
{
    QEMU_QEMU_LOADVM_STATE_SECTION_PARTEND(section_id);
    if (trace_event_get_state(TRACE_QEMU_LOADVM_STATE_SECTION_PARTEND)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qemu_loadvm_state_section_partend " "%u" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , section_id);
    }
}

static inline void trace_qemu_loadvm_state_main(void)
{
    QEMU_QEMU_LOADVM_STATE_MAIN();
    if (trace_event_get_state(TRACE_QEMU_LOADVM_STATE_MAIN)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qemu_loadvm_state_main " "" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      );
    }
}

static inline void trace_qemu_loadvm_state_main_quit_parent(void)
{
    QEMU_QEMU_LOADVM_STATE_MAIN_QUIT_PARENT();
    if (trace_event_get_state(TRACE_QEMU_LOADVM_STATE_MAIN_QUIT_PARENT)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qemu_loadvm_state_main_quit_parent " "" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      );
    }
}

static inline void trace_qemu_loadvm_state_post_main(int ret)
{
    QEMU_QEMU_LOADVM_STATE_POST_MAIN(ret);
    if (trace_event_get_state(TRACE_QEMU_LOADVM_STATE_POST_MAIN)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qemu_loadvm_state_post_main " "%d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , ret);
    }
}

static inline void trace_qemu_loadvm_state_section_startfull(uint32_t section_id, const char * idstr, uint32_t instance_id, uint32_t version_id)
{
    QEMU_QEMU_LOADVM_STATE_SECTION_STARTFULL(section_id, idstr, instance_id, version_id);
    if (trace_event_get_state(TRACE_QEMU_LOADVM_STATE_SECTION_STARTFULL)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qemu_loadvm_state_section_startfull " "%u(%s) %u %u" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , section_id, idstr, instance_id, version_id);
    }
}

static inline void trace_qemu_savevm_send_packaged(void)
{
    QEMU_QEMU_SAVEVM_SEND_PACKAGED();
    if (trace_event_get_state(TRACE_QEMU_SAVEVM_SEND_PACKAGED)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qemu_savevm_send_packaged " "" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      );
    }
}

static inline void trace_loadvm_handle_cmd_packaged(unsigned int length)
{
    QEMU_LOADVM_HANDLE_CMD_PACKAGED(length);
    if (trace_event_get_state(TRACE_LOADVM_HANDLE_CMD_PACKAGED)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:loadvm_handle_cmd_packaged " "%u" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , length);
    }
}

static inline void trace_loadvm_handle_cmd_packaged_main(int ret)
{
    QEMU_LOADVM_HANDLE_CMD_PACKAGED_MAIN(ret);
    if (trace_event_get_state(TRACE_LOADVM_HANDLE_CMD_PACKAGED_MAIN)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:loadvm_handle_cmd_packaged_main " "%d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , ret);
    }
}

static inline void trace_loadvm_handle_cmd_packaged_received(int ret)
{
    QEMU_LOADVM_HANDLE_CMD_PACKAGED_RECEIVED(ret);
    if (trace_event_get_state(TRACE_LOADVM_HANDLE_CMD_PACKAGED_RECEIVED)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:loadvm_handle_cmd_packaged_received " "%d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , ret);
    }
}

static inline void trace_loadvm_postcopy_handle_advise(void)
{
    QEMU_LOADVM_POSTCOPY_HANDLE_ADVISE();
    if (trace_event_get_state(TRACE_LOADVM_POSTCOPY_HANDLE_ADVISE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:loadvm_postcopy_handle_advise " "" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      );
    }
}

static inline void trace_loadvm_postcopy_handle_listen(void)
{
    QEMU_LOADVM_POSTCOPY_HANDLE_LISTEN();
    if (trace_event_get_state(TRACE_LOADVM_POSTCOPY_HANDLE_LISTEN)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:loadvm_postcopy_handle_listen " "" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      );
    }
}

static inline void trace_loadvm_postcopy_handle_run(void)
{
    QEMU_LOADVM_POSTCOPY_HANDLE_RUN();
    if (trace_event_get_state(TRACE_LOADVM_POSTCOPY_HANDLE_RUN)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:loadvm_postcopy_handle_run " "" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      );
    }
}

static inline void trace_loadvm_postcopy_handle_run_cpu_sync(void)
{
    QEMU_LOADVM_POSTCOPY_HANDLE_RUN_CPU_SYNC();
    if (trace_event_get_state(TRACE_LOADVM_POSTCOPY_HANDLE_RUN_CPU_SYNC)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:loadvm_postcopy_handle_run_cpu_sync " "" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      );
    }
}

static inline void trace_loadvm_postcopy_handle_run_vmstart(void)
{
    QEMU_LOADVM_POSTCOPY_HANDLE_RUN_VMSTART();
    if (trace_event_get_state(TRACE_LOADVM_POSTCOPY_HANDLE_RUN_VMSTART)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:loadvm_postcopy_handle_run_vmstart " "" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      );
    }
}

static inline void trace_loadvm_process_command(uint16_t com, uint16_t len)
{
    QEMU_LOADVM_PROCESS_COMMAND(com, len);
    if (trace_event_get_state(TRACE_LOADVM_PROCESS_COMMAND)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:loadvm_process_command " "com=0x%x len=%d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , com, len);
    }
}

static inline void trace_postcopy_ram_listen_thread_exit(void)
{
    QEMU_POSTCOPY_RAM_LISTEN_THREAD_EXIT();
    if (trace_event_get_state(TRACE_POSTCOPY_RAM_LISTEN_THREAD_EXIT)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:postcopy_ram_listen_thread_exit " "" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      );
    }
}

static inline void trace_postcopy_ram_listen_thread_start(void)
{
    QEMU_POSTCOPY_RAM_LISTEN_THREAD_START();
    if (trace_event_get_state(TRACE_POSTCOPY_RAM_LISTEN_THREAD_START)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:postcopy_ram_listen_thread_start " "" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      );
    }
}

static inline void trace_qemu_savevm_send_postcopy_advise(void)
{
    QEMU_QEMU_SAVEVM_SEND_POSTCOPY_ADVISE();
    if (trace_event_get_state(TRACE_QEMU_SAVEVM_SEND_POSTCOPY_ADVISE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qemu_savevm_send_postcopy_advise " "" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      );
    }
}

static inline void trace_savevm_command_send(uint16_t command, uint16_t len)
{
    QEMU_SAVEVM_COMMAND_SEND(command, len);
    if (trace_event_get_state(TRACE_SAVEVM_COMMAND_SEND)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:savevm_command_send " "com=0x%x len=%d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , command, len);
    }
}

static inline void trace_savevm_section_start(const char * id, unsigned int section_id)
{
    QEMU_SAVEVM_SECTION_START(id, section_id);
    if (trace_event_get_state(TRACE_SAVEVM_SECTION_START)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:savevm_section_start " "%s, section_id %u" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , id, section_id);
    }
}

static inline void trace_savevm_section_end(const char * id, unsigned int section_id, int ret)
{
    QEMU_SAVEVM_SECTION_END(id, section_id, ret);
    if (trace_event_get_state(TRACE_SAVEVM_SECTION_END)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:savevm_section_end " "%s, section_id %u -> %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , id, section_id, ret);
    }
}

static inline void trace_savevm_section_skip(const char * id, unsigned int section_id)
{
    QEMU_SAVEVM_SECTION_SKIP(id, section_id);
    if (trace_event_get_state(TRACE_SAVEVM_SECTION_SKIP)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:savevm_section_skip " "%s, section_id %u" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , id, section_id);
    }
}

static inline void trace_savevm_send_postcopy_listen(void)
{
    QEMU_SAVEVM_SEND_POSTCOPY_LISTEN();
    if (trace_event_get_state(TRACE_SAVEVM_SEND_POSTCOPY_LISTEN)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:savevm_send_postcopy_listen " "" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      );
    }
}

static inline void trace_savevm_send_postcopy_run(void)
{
    QEMU_SAVEVM_SEND_POSTCOPY_RUN();
    if (trace_event_get_state(TRACE_SAVEVM_SEND_POSTCOPY_RUN)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:savevm_send_postcopy_run " "" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      );
    }
}

static inline void trace_savevm_state_begin(void)
{
    QEMU_SAVEVM_STATE_BEGIN();
    if (trace_event_get_state(TRACE_SAVEVM_STATE_BEGIN)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:savevm_state_begin " "" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      );
    }
}

static inline void trace_savevm_state_header(void)
{
    QEMU_SAVEVM_STATE_HEADER();
    if (trace_event_get_state(TRACE_SAVEVM_STATE_HEADER)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:savevm_state_header " "" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      );
    }
}

static inline void trace_savevm_state_iterate(void)
{
    QEMU_SAVEVM_STATE_ITERATE();
    if (trace_event_get_state(TRACE_SAVEVM_STATE_ITERATE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:savevm_state_iterate " "" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      );
    }
}

static inline void trace_savevm_state_cleanup(void)
{
    QEMU_SAVEVM_STATE_CLEANUP();
    if (trace_event_get_state(TRACE_SAVEVM_STATE_CLEANUP)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:savevm_state_cleanup " "" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      );
    }
}

static inline void trace_savevm_state_complete_precopy(void)
{
    QEMU_SAVEVM_STATE_COMPLETE_PRECOPY();
    if (trace_event_get_state(TRACE_SAVEVM_STATE_COMPLETE_PRECOPY)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:savevm_state_complete_precopy " "" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      );
    }
}

static inline void trace_vmstate_save(const char * idstr, const char * vmsd_name)
{
    QEMU_VMSTATE_SAVE(idstr, vmsd_name);
    if (trace_event_get_state(TRACE_VMSTATE_SAVE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:vmstate_save " "%s, %s" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , idstr, vmsd_name);
    }
}

static inline void trace_vmstate_load(const char * idstr, const char * vmsd_name)
{
    QEMU_VMSTATE_LOAD(idstr, vmsd_name);
    if (trace_event_get_state(TRACE_VMSTATE_LOAD)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:vmstate_load " "%s, %s" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , idstr, vmsd_name);
    }
}

static inline void trace_qemu_announce_self_iter(const char * mac)
{
    QEMU_QEMU_ANNOUNCE_SELF_ITER(mac);
    if (trace_event_get_state(TRACE_QEMU_ANNOUNCE_SELF_ITER)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qemu_announce_self_iter " "%s" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , mac);
    }
}

static inline void trace_vmstate_load_field_error(const char * field, int ret)
{
    QEMU_VMSTATE_LOAD_FIELD_ERROR(field, ret);
    if (trace_event_get_state(TRACE_VMSTATE_LOAD_FIELD_ERROR)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:vmstate_load_field_error " "field \"%s\" load failed, ret = %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , field, ret);
    }
}

static inline void trace_vmstate_load_state(const char * name, int version_id)
{
    QEMU_VMSTATE_LOAD_STATE(name, version_id);
    if (trace_event_get_state(TRACE_VMSTATE_LOAD_STATE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:vmstate_load_state " "%s v%d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , name, version_id);
    }
}

static inline void trace_vmstate_load_state_end(const char * name, const char * reason, int val)
{
    QEMU_VMSTATE_LOAD_STATE_END(name, reason, val);
    if (trace_event_get_state(TRACE_VMSTATE_LOAD_STATE_END)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:vmstate_load_state_end " "%s %s/%d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , name, reason, val);
    }
}

static inline void trace_vmstate_load_state_field(const char * name, const char * field)
{
    QEMU_VMSTATE_LOAD_STATE_FIELD(name, field);
    if (trace_event_get_state(TRACE_VMSTATE_LOAD_STATE_FIELD)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:vmstate_load_state_field " "%s:%s" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , name, field);
    }
}

static inline void trace_vmstate_subsection_load(const char * parent)
{
    QEMU_VMSTATE_SUBSECTION_LOAD(parent);
    if (trace_event_get_state(TRACE_VMSTATE_SUBSECTION_LOAD)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:vmstate_subsection_load " "%s" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , parent);
    }
}

static inline void trace_vmstate_subsection_load_bad(const char * parent, const char * sub)
{
    QEMU_VMSTATE_SUBSECTION_LOAD_BAD(parent, sub);
    if (trace_event_get_state(TRACE_VMSTATE_SUBSECTION_LOAD_BAD)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:vmstate_subsection_load_bad " "%s: %s" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , parent, sub);
    }
}

static inline void trace_vmstate_subsection_load_good(const char * parent)
{
    QEMU_VMSTATE_SUBSECTION_LOAD_GOOD(parent);
    if (trace_event_get_state(TRACE_VMSTATE_SUBSECTION_LOAD_GOOD)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:vmstate_subsection_load_good " "%s" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , parent);
    }
}

static inline void trace_qemu_file_fclose(void)
{
    QEMU_QEMU_FILE_FCLOSE();
    if (trace_event_get_state(TRACE_QEMU_FILE_FCLOSE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qemu_file_fclose " "" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      );
    }
}

static inline void trace_migration_bitmap_sync_start(void)
{
    QEMU_MIGRATION_BITMAP_SYNC_START();
    if (trace_event_get_state(TRACE_MIGRATION_BITMAP_SYNC_START)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:migration_bitmap_sync_start " "" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      );
    }
}

static inline void trace_migration_bitmap_sync_end(uint64_t dirty_pages)
{
    QEMU_MIGRATION_BITMAP_SYNC_END(dirty_pages);
    if (trace_event_get_state(TRACE_MIGRATION_BITMAP_SYNC_END)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:migration_bitmap_sync_end " "dirty_pages %" PRIu64"" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , dirty_pages);
    }
}

static inline void trace_migration_throttle(void)
{
    QEMU_MIGRATION_THROTTLE();
    if (trace_event_get_state(TRACE_MIGRATION_THROTTLE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:migration_throttle " "" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      );
    }
}

static inline void trace_qxl_interface_set_mm_time(int qid, uint32_t mm_time)
{
}

static inline void trace_qxl_io_write_vga(int qid, const char * mode, uint32_t addr, uint32_t val)
{
}

static inline void trace_qxl_create_guest_primary(int qid, uint32_t width, uint32_t height, uint64_t mem, uint32_t format, uint32_t position)
{
    QEMU_QXL_CREATE_GUEST_PRIMARY(qid, width, height, mem, format, position);
    if (trace_event_get_state(TRACE_QXL_CREATE_GUEST_PRIMARY)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qxl_create_guest_primary " "%d %ux%u mem=%" PRIx64 " %u,%u" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , qid, width, height, mem, format, position);
    }
}

static inline void trace_qxl_create_guest_primary_rest(int qid, int32_t stride, uint32_t type, uint32_t flags)
{
    QEMU_QXL_CREATE_GUEST_PRIMARY_REST(qid, stride, type, flags);
    if (trace_event_get_state(TRACE_QXL_CREATE_GUEST_PRIMARY_REST)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qxl_create_guest_primary_rest " "%d %d,%d,%d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , qid, stride, type, flags);
    }
}

static inline void trace_qxl_destroy_primary(int qid)
{
    QEMU_QXL_DESTROY_PRIMARY(qid);
    if (trace_event_get_state(TRACE_QXL_DESTROY_PRIMARY)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qxl_destroy_primary " "%d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , qid);
    }
}

static inline void trace_qxl_enter_vga_mode(int qid)
{
    QEMU_QXL_ENTER_VGA_MODE(qid);
    if (trace_event_get_state(TRACE_QXL_ENTER_VGA_MODE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qxl_enter_vga_mode " "%d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , qid);
    }
}

static inline void trace_qxl_exit_vga_mode(int qid)
{
    QEMU_QXL_EXIT_VGA_MODE(qid);
    if (trace_event_get_state(TRACE_QXL_EXIT_VGA_MODE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qxl_exit_vga_mode " "%d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , qid);
    }
}

static inline void trace_qxl_hard_reset(int qid, int64_t loadvm)
{
    QEMU_QXL_HARD_RESET(qid, loadvm);
    if (trace_event_get_state(TRACE_QXL_HARD_RESET)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qxl_hard_reset " "%d loadvm=%"PRId64"" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , qid, loadvm);
    }
}

static inline void trace_qxl_interface_async_complete_io(int qid, uint32_t current_async, void * cookie)
{
    QEMU_QXL_INTERFACE_ASYNC_COMPLETE_IO(qid, current_async, cookie);
    if (trace_event_get_state(TRACE_QXL_INTERFACE_ASYNC_COMPLETE_IO)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qxl_interface_async_complete_io " "%d current=%d cookie=%p" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , qid, current_async, cookie);
    }
}

static inline void trace_qxl_interface_attach_worker(int qid)
{
    QEMU_QXL_INTERFACE_ATTACH_WORKER(qid);
    if (trace_event_get_state(TRACE_QXL_INTERFACE_ATTACH_WORKER)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qxl_interface_attach_worker " "%d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , qid);
    }
}

static inline void trace_qxl_interface_get_init_info(int qid)
{
    QEMU_QXL_INTERFACE_GET_INIT_INFO(qid);
    if (trace_event_get_state(TRACE_QXL_INTERFACE_GET_INIT_INFO)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qxl_interface_get_init_info " "%d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , qid);
    }
}

static inline void trace_qxl_interface_set_compression_level(int qid, int64_t level)
{
    QEMU_QXL_INTERFACE_SET_COMPRESSION_LEVEL(qid, level);
    if (trace_event_get_state(TRACE_QXL_INTERFACE_SET_COMPRESSION_LEVEL)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qxl_interface_set_compression_level " "%d %"PRId64 "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , qid, level);
    }
}

static inline void trace_qxl_interface_update_area_complete(int qid, uint32_t surface_id, uint32_t dirty_left, uint32_t dirty_right, uint32_t dirty_top, uint32_t dirty_bottom)
{
    QEMU_QXL_INTERFACE_UPDATE_AREA_COMPLETE(qid, surface_id, dirty_left, dirty_right, dirty_top, dirty_bottom);
    if (trace_event_get_state(TRACE_QXL_INTERFACE_UPDATE_AREA_COMPLETE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qxl_interface_update_area_complete " "%d surface=%d [%d,%d,%d,%d]" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , qid, surface_id, dirty_left, dirty_right, dirty_top, dirty_bottom);
    }
}

static inline void trace_qxl_interface_update_area_complete_rest(int qid, uint32_t num_updated_rects)
{
    QEMU_QXL_INTERFACE_UPDATE_AREA_COMPLETE_REST(qid, num_updated_rects);
    if (trace_event_get_state(TRACE_QXL_INTERFACE_UPDATE_AREA_COMPLETE_REST)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qxl_interface_update_area_complete_rest " "%d #=%d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , qid, num_updated_rects);
    }
}

static inline void trace_qxl_interface_update_area_complete_overflow(int qid, int max)
{
    QEMU_QXL_INTERFACE_UPDATE_AREA_COMPLETE_OVERFLOW(qid, max);
    if (trace_event_get_state(TRACE_QXL_INTERFACE_UPDATE_AREA_COMPLETE_OVERFLOW)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qxl_interface_update_area_complete_overflow " "%d max=%d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , qid, max);
    }
}

static inline void trace_qxl_interface_update_area_complete_schedule_bh(int qid, uint32_t num_dirty)
{
    QEMU_QXL_INTERFACE_UPDATE_AREA_COMPLETE_SCHEDULE_BH(qid, num_dirty);
    if (trace_event_get_state(TRACE_QXL_INTERFACE_UPDATE_AREA_COMPLETE_SCHEDULE_BH)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qxl_interface_update_area_complete_schedule_bh " "%d #dirty=%d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , qid, num_dirty);
    }
}

static inline void trace_qxl_io_destroy_primary_ignored(int qid, const char * mode)
{
    QEMU_QXL_IO_DESTROY_PRIMARY_IGNORED(qid, mode);
    if (trace_event_get_state(TRACE_QXL_IO_DESTROY_PRIMARY_IGNORED)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qxl_io_destroy_primary_ignored " "%d %s" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , qid, mode);
    }
}

static inline void trace_qxl_io_log(int qid, const uint8_t * log_buf)
{
    QEMU_QXL_IO_LOG(qid, log_buf);
    if (trace_event_get_state(TRACE_QXL_IO_LOG)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qxl_io_log " "%d %s" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , qid, log_buf);
    }
}

static inline void trace_qxl_io_read_unexpected(int qid)
{
    QEMU_QXL_IO_READ_UNEXPECTED(qid);
    if (trace_event_get_state(TRACE_QXL_IO_READ_UNEXPECTED)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qxl_io_read_unexpected " "%d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , qid);
    }
}

static inline void trace_qxl_io_unexpected_vga_mode(int qid, uint64_t addr, uint64_t val, const char * desc)
{
    QEMU_QXL_IO_UNEXPECTED_VGA_MODE(qid, addr, val, desc);
    if (trace_event_get_state(TRACE_QXL_IO_UNEXPECTED_VGA_MODE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qxl_io_unexpected_vga_mode " "%d 0x%"PRIx64"=%"PRIu64" (%s)" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , qid, addr, val, desc);
    }
}

static inline void trace_qxl_io_write(int qid, const char * mode, uint64_t addr, const char * aname, uint64_t val, unsigned size, int async)
{
    QEMU_QXL_IO_WRITE(qid, mode, addr, aname, val, size, async);
    if (trace_event_get_state(TRACE_QXL_IO_WRITE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qxl_io_write " "%d %s addr=%"PRIu64 " (%s) val=%"PRIu64" size=%u async=%d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , qid, mode, addr, aname, val, size, async);
    }
}

static inline void trace_qxl_memslot_add_guest(int qid, uint32_t slot_id, uint64_t guest_start, uint64_t guest_end)
{
    QEMU_QXL_MEMSLOT_ADD_GUEST(qid, slot_id, guest_start, guest_end);
    if (trace_event_get_state(TRACE_QXL_MEMSLOT_ADD_GUEST)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qxl_memslot_add_guest " "%d %u: guest phys 0x%"PRIx64 " - 0x%" PRIx64 "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , qid, slot_id, guest_start, guest_end);
    }
}

static inline void trace_qxl_post_load(int qid, const char * mode)
{
    QEMU_QXL_POST_LOAD(qid, mode);
    if (trace_event_get_state(TRACE_QXL_POST_LOAD)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qxl_post_load " "%d %s" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , qid, mode);
    }
}

static inline void trace_qxl_pre_load(int qid)
{
    QEMU_QXL_PRE_LOAD(qid);
    if (trace_event_get_state(TRACE_QXL_PRE_LOAD)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qxl_pre_load " "%d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , qid);
    }
}

static inline void trace_qxl_pre_save(int qid)
{
    QEMU_QXL_PRE_SAVE(qid);
    if (trace_event_get_state(TRACE_QXL_PRE_SAVE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qxl_pre_save " "%d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , qid);
    }
}

static inline void trace_qxl_reset_surfaces(int qid)
{
    QEMU_QXL_RESET_SURFACES(qid);
    if (trace_event_get_state(TRACE_QXL_RESET_SURFACES)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qxl_reset_surfaces " "%d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , qid);
    }
}

static inline void trace_qxl_ring_command_check(int qid, const char * mode)
{
    QEMU_QXL_RING_COMMAND_CHECK(qid, mode);
    if (trace_event_get_state(TRACE_QXL_RING_COMMAND_CHECK)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qxl_ring_command_check " "%d %s" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , qid, mode);
    }
}

static inline void trace_qxl_ring_command_get(int qid, const char * mode)
{
    QEMU_QXL_RING_COMMAND_GET(qid, mode);
    if (trace_event_get_state(TRACE_QXL_RING_COMMAND_GET)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qxl_ring_command_get " "%d %s" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , qid, mode);
    }
}

static inline void trace_qxl_ring_command_req_notification(int qid)
{
    QEMU_QXL_RING_COMMAND_REQ_NOTIFICATION(qid);
    if (trace_event_get_state(TRACE_QXL_RING_COMMAND_REQ_NOTIFICATION)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qxl_ring_command_req_notification " "%d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , qid);
    }
}

static inline void trace_qxl_ring_cursor_check(int qid, const char * mode)
{
    QEMU_QXL_RING_CURSOR_CHECK(qid, mode);
    if (trace_event_get_state(TRACE_QXL_RING_CURSOR_CHECK)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qxl_ring_cursor_check " "%d %s" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , qid, mode);
    }
}

static inline void trace_qxl_ring_cursor_get(int qid, const char * mode)
{
    QEMU_QXL_RING_CURSOR_GET(qid, mode);
    if (trace_event_get_state(TRACE_QXL_RING_CURSOR_GET)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qxl_ring_cursor_get " "%d %s" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , qid, mode);
    }
}

static inline void trace_qxl_ring_cursor_req_notification(int qid)
{
    QEMU_QXL_RING_CURSOR_REQ_NOTIFICATION(qid);
    if (trace_event_get_state(TRACE_QXL_RING_CURSOR_REQ_NOTIFICATION)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qxl_ring_cursor_req_notification " "%d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , qid);
    }
}

static inline void trace_qxl_ring_res_push(int qid, const char * mode, uint32_t surface_count, uint32_t free_res, void * last_release, const char * notify)
{
    QEMU_QXL_RING_RES_PUSH(qid, mode, surface_count, free_res, last_release, notify);
    if (trace_event_get_state(TRACE_QXL_RING_RES_PUSH)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qxl_ring_res_push " "%d %s s#=%d res#=%d last=%p notify=%s" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , qid, mode, surface_count, free_res, last_release, notify);
    }
}

static inline void trace_qxl_ring_res_push_rest(int qid, uint32_t ring_has, uint32_t ring_size, uint32_t prod, uint32_t cons)
{
    QEMU_QXL_RING_RES_PUSH_REST(qid, ring_has, ring_size, prod, cons);
    if (trace_event_get_state(TRACE_QXL_RING_RES_PUSH_REST)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qxl_ring_res_push_rest " "%d ring %d/%d [%d,%d]" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , qid, ring_has, ring_size, prod, cons);
    }
}

static inline void trace_qxl_ring_res_put(int qid, uint32_t free_res)
{
    QEMU_QXL_RING_RES_PUT(qid, free_res);
    if (trace_event_get_state(TRACE_QXL_RING_RES_PUT)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qxl_ring_res_put " "%d #res=%d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , qid, free_res);
    }
}

static inline void trace_qxl_set_mode(int qid, int modenr, uint32_t x_res, uint32_t y_res, uint32_t bits, uint64_t devmem)
{
    QEMU_QXL_SET_MODE(qid, modenr, x_res, y_res, bits, devmem);
    if (trace_event_get_state(TRACE_QXL_SET_MODE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qxl_set_mode " "%d mode=%d [ x=%d y=%d @ bpp=%d devmem=0x%" PRIx64 " ]" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , qid, modenr, x_res, y_res, bits, devmem);
    }
}

static inline void trace_qxl_soft_reset(int qid)
{
    QEMU_QXL_SOFT_RESET(qid);
    if (trace_event_get_state(TRACE_QXL_SOFT_RESET)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qxl_soft_reset " "%d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , qid);
    }
}

static inline void trace_qxl_spice_destroy_surfaces_complete(int qid)
{
    QEMU_QXL_SPICE_DESTROY_SURFACES_COMPLETE(qid);
    if (trace_event_get_state(TRACE_QXL_SPICE_DESTROY_SURFACES_COMPLETE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qxl_spice_destroy_surfaces_complete " "%d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , qid);
    }
}

static inline void trace_qxl_spice_destroy_surfaces(int qid, int async)
{
    QEMU_QXL_SPICE_DESTROY_SURFACES(qid, async);
    if (trace_event_get_state(TRACE_QXL_SPICE_DESTROY_SURFACES)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qxl_spice_destroy_surfaces " "%d async=%d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , qid, async);
    }
}

static inline void trace_qxl_spice_destroy_surface_wait_complete(int qid, uint32_t id)
{
    QEMU_QXL_SPICE_DESTROY_SURFACE_WAIT_COMPLETE(qid, id);
    if (trace_event_get_state(TRACE_QXL_SPICE_DESTROY_SURFACE_WAIT_COMPLETE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qxl_spice_destroy_surface_wait_complete " "%d sid=%d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , qid, id);
    }
}

static inline void trace_qxl_spice_destroy_surface_wait(int qid, uint32_t id, int async)
{
    QEMU_QXL_SPICE_DESTROY_SURFACE_WAIT(qid, id, async);
    if (trace_event_get_state(TRACE_QXL_SPICE_DESTROY_SURFACE_WAIT)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qxl_spice_destroy_surface_wait " "%d sid=%d async=%d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , qid, id, async);
    }
}

static inline void trace_qxl_spice_flush_surfaces_async(int qid, uint32_t surface_count, uint32_t num_free_res)
{
    QEMU_QXL_SPICE_FLUSH_SURFACES_ASYNC(qid, surface_count, num_free_res);
    if (trace_event_get_state(TRACE_QXL_SPICE_FLUSH_SURFACES_ASYNC)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qxl_spice_flush_surfaces_async " "%d s#=%d, res#=%d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , qid, surface_count, num_free_res);
    }
}

static inline void trace_qxl_spice_monitors_config(int qid)
{
    QEMU_QXL_SPICE_MONITORS_CONFIG(qid);
    if (trace_event_get_state(TRACE_QXL_SPICE_MONITORS_CONFIG)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qxl_spice_monitors_config " "%d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , qid);
    }
}

static inline void trace_qxl_spice_loadvm_commands(int qid, void * ext, uint32_t count)
{
    QEMU_QXL_SPICE_LOADVM_COMMANDS(qid, ext, count);
    if (trace_event_get_state(TRACE_QXL_SPICE_LOADVM_COMMANDS)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qxl_spice_loadvm_commands " "%d ext=%p count=%d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , qid, ext, count);
    }
}

static inline void trace_qxl_spice_oom(int qid)
{
    QEMU_QXL_SPICE_OOM(qid);
    if (trace_event_get_state(TRACE_QXL_SPICE_OOM)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qxl_spice_oom " "%d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , qid);
    }
}

static inline void trace_qxl_spice_reset_cursor(int qid)
{
    QEMU_QXL_SPICE_RESET_CURSOR(qid);
    if (trace_event_get_state(TRACE_QXL_SPICE_RESET_CURSOR)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qxl_spice_reset_cursor " "%d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , qid);
    }
}

static inline void trace_qxl_spice_reset_image_cache(int qid)
{
    QEMU_QXL_SPICE_RESET_IMAGE_CACHE(qid);
    if (trace_event_get_state(TRACE_QXL_SPICE_RESET_IMAGE_CACHE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qxl_spice_reset_image_cache " "%d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , qid);
    }
}

static inline void trace_qxl_spice_reset_memslots(int qid)
{
    QEMU_QXL_SPICE_RESET_MEMSLOTS(qid);
    if (trace_event_get_state(TRACE_QXL_SPICE_RESET_MEMSLOTS)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qxl_spice_reset_memslots " "%d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , qid);
    }
}

static inline void trace_qxl_spice_update_area(int qid, uint32_t surface_id, uint32_t left, uint32_t right, uint32_t top, uint32_t bottom)
{
    QEMU_QXL_SPICE_UPDATE_AREA(qid, surface_id, left, right, top, bottom);
    if (trace_event_get_state(TRACE_QXL_SPICE_UPDATE_AREA)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qxl_spice_update_area " "%d sid=%d [%d,%d,%d,%d]" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , qid, surface_id, left, right, top, bottom);
    }
}

static inline void trace_qxl_spice_update_area_rest(int qid, uint32_t num_dirty_rects, uint32_t clear_dirty_region)
{
    QEMU_QXL_SPICE_UPDATE_AREA_REST(qid, num_dirty_rects, clear_dirty_region);
    if (trace_event_get_state(TRACE_QXL_SPICE_UPDATE_AREA_REST)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qxl_spice_update_area_rest " "%d #d=%d clear=%d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , qid, num_dirty_rects, clear_dirty_region);
    }
}

static inline void trace_qxl_surfaces_dirty(int qid, int surface, int offset, int size)
{
    QEMU_QXL_SURFACES_DIRTY(qid, surface, offset, size);
    if (trace_event_get_state(TRACE_QXL_SURFACES_DIRTY)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qxl_surfaces_dirty " "%d surface=%d offset=%d size=%d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , qid, surface, offset, size);
    }
}

static inline void trace_qxl_send_events(int qid, uint32_t events)
{
    QEMU_QXL_SEND_EVENTS(qid, events);
    if (trace_event_get_state(TRACE_QXL_SEND_EVENTS)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qxl_send_events " "%d %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , qid, events);
    }
}

static inline void trace_qxl_send_events_vm_stopped(int qid, uint32_t events)
{
    QEMU_QXL_SEND_EVENTS_VM_STOPPED(qid, events);
    if (trace_event_get_state(TRACE_QXL_SEND_EVENTS_VM_STOPPED)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qxl_send_events_vm_stopped " "%d %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , qid, events);
    }
}

static inline void trace_qxl_set_guest_bug(int qid)
{
    QEMU_QXL_SET_GUEST_BUG(qid);
    if (trace_event_get_state(TRACE_QXL_SET_GUEST_BUG)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qxl_set_guest_bug " "%d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , qid);
    }
}

static inline void trace_qxl_interrupt_client_monitors_config(int qid, int num_heads, void * heads)
{
    QEMU_QXL_INTERRUPT_CLIENT_MONITORS_CONFIG(qid, num_heads, heads);
    if (trace_event_get_state(TRACE_QXL_INTERRUPT_CLIENT_MONITORS_CONFIG)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qxl_interrupt_client_monitors_config " "%d %d %p" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , qid, num_heads, heads);
    }
}

static inline void trace_qxl_client_monitors_config_unsupported_by_guest(int qid, uint32_t int_mask, void * client_monitors_config)
{
    QEMU_QXL_CLIENT_MONITORS_CONFIG_UNSUPPORTED_BY_GUEST(qid, int_mask, client_monitors_config);
    if (trace_event_get_state(TRACE_QXL_CLIENT_MONITORS_CONFIG_UNSUPPORTED_BY_GUEST)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qxl_client_monitors_config_unsupported_by_guest " "%d %X %p" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , qid, int_mask, client_monitors_config);
    }
}

static inline void trace_qxl_client_monitors_config_unsupported_by_device(int qid, int revision)
{
    QEMU_QXL_CLIENT_MONITORS_CONFIG_UNSUPPORTED_BY_DEVICE(qid, revision);
    if (trace_event_get_state(TRACE_QXL_CLIENT_MONITORS_CONFIG_UNSUPPORTED_BY_DEVICE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qxl_client_monitors_config_unsupported_by_device " "%d revision=%d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , qid, revision);
    }
}

static inline void trace_qxl_client_monitors_config_capped(int qid, int requested, int limit)
{
    QEMU_QXL_CLIENT_MONITORS_CONFIG_CAPPED(qid, requested, limit);
    if (trace_event_get_state(TRACE_QXL_CLIENT_MONITORS_CONFIG_CAPPED)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qxl_client_monitors_config_capped " "%d %d %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , qid, requested, limit);
    }
}

static inline void trace_qxl_client_monitors_config_crc(int qid, unsigned size, uint32_t crc32)
{
    QEMU_QXL_CLIENT_MONITORS_CONFIG_CRC(qid, size, crc32);
    if (trace_event_get_state(TRACE_QXL_CLIENT_MONITORS_CONFIG_CRC)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qxl_client_monitors_config_crc " "%d %u %u" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , qid, size, crc32);
    }
}

static inline void trace_qxl_set_client_capabilities_unsupported_by_revision(int qid, int revision)
{
    QEMU_QXL_SET_CLIENT_CAPABILITIES_UNSUPPORTED_BY_REVISION(qid, revision);
    if (trace_event_get_state(TRACE_QXL_SET_CLIENT_CAPABILITIES_UNSUPPORTED_BY_REVISION)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qxl_set_client_capabilities_unsupported_by_revision " "%d revision=%d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , qid, revision);
    }
}

static inline void trace_qemu_spice_add_memslot(int qid, uint32_t slot_id, unsigned long virt_start, unsigned long virt_end, int async)
{
    QEMU_QEMU_SPICE_ADD_MEMSLOT(qid, slot_id, virt_start, virt_end, async);
    if (trace_event_get_state(TRACE_QEMU_SPICE_ADD_MEMSLOT)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qemu_spice_add_memslot " "%d %u: host virt 0x%lx - 0x%lx async=%d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , qid, slot_id, virt_start, virt_end, async);
    }
}

static inline void trace_qemu_spice_del_memslot(int qid, uint32_t gid, uint32_t slot_id)
{
    QEMU_QEMU_SPICE_DEL_MEMSLOT(qid, gid, slot_id);
    if (trace_event_get_state(TRACE_QEMU_SPICE_DEL_MEMSLOT)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qemu_spice_del_memslot " "%d gid=%u sid=%u" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , qid, gid, slot_id);
    }
}

static inline void trace_qemu_spice_create_primary_surface(int qid, uint32_t sid, void * surface, int async)
{
    QEMU_QEMU_SPICE_CREATE_PRIMARY_SURFACE(qid, sid, surface, async);
    if (trace_event_get_state(TRACE_QEMU_SPICE_CREATE_PRIMARY_SURFACE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qemu_spice_create_primary_surface " "%d sid=%u surface=%p async=%d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , qid, sid, surface, async);
    }
}

static inline void trace_qemu_spice_destroy_primary_surface(int qid, uint32_t sid, int async)
{
    QEMU_QEMU_SPICE_DESTROY_PRIMARY_SURFACE(qid, sid, async);
    if (trace_event_get_state(TRACE_QEMU_SPICE_DESTROY_PRIMARY_SURFACE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qemu_spice_destroy_primary_surface " "%d sid=%u async=%d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , qid, sid, async);
    }
}

static inline void trace_qemu_spice_wakeup(uint32_t qid)
{
    QEMU_QEMU_SPICE_WAKEUP(qid);
    if (trace_event_get_state(TRACE_QEMU_SPICE_WAKEUP)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qemu_spice_wakeup " "%d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , qid);
    }
}

static inline void trace_qemu_spice_create_update(uint32_t left, uint32_t right, uint32_t top, uint32_t bottom)
{
    QEMU_QEMU_SPICE_CREATE_UPDATE(left, right, top, bottom);
    if (trace_event_get_state(TRACE_QEMU_SPICE_CREATE_UPDATE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qemu_spice_create_update " "lr %d -> %d,  tb -> %d -> %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , left, right, top, bottom);
    }
}

static inline void trace_qxl_render_blit(int32_t stride, int32_t left, int32_t right, int32_t top, int32_t bottom)
{
    QEMU_QXL_RENDER_BLIT(stride, left, right, top, bottom);
    if (trace_event_get_state(TRACE_QXL_RENDER_BLIT)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qxl_render_blit " "stride=%d [%d, %d, %d, %d]" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , stride, left, right, top, bottom);
    }
}

static inline void trace_qxl_render_guest_primary_resized(int32_t width, int32_t height, int32_t stride, int32_t bytes_pp, int32_t bits_pp)
{
    QEMU_QXL_RENDER_GUEST_PRIMARY_RESIZED(width, height, stride, bytes_pp, bits_pp);
    if (trace_event_get_state(TRACE_QXL_RENDER_GUEST_PRIMARY_RESIZED)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qxl_render_guest_primary_resized " "%dx%d, stride %d, bpp %d, depth %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , width, height, stride, bytes_pp, bits_pp);
    }
}

static inline void trace_qxl_render_update_area_done(void * cookie)
{
    QEMU_QXL_RENDER_UPDATE_AREA_DONE(cookie);
    if (trace_event_get_state(TRACE_QXL_RENDER_UPDATE_AREA_DONE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qxl_render_update_area_done " "%p" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , cookie);
    }
}

static inline void trace_spapr_pci_msi(const char * msg, uint32_t ca)
{
    QEMU_SPAPR_PCI_MSI(msg, ca);
    if (trace_event_get_state(TRACE_SPAPR_PCI_MSI)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:spapr_pci_msi " "%s (cfg=%x)" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , msg, ca);
    }
}

static inline void trace_spapr_pci_msi_setup(const char * name, unsigned vector, uint64_t addr)
{
    QEMU_SPAPR_PCI_MSI_SETUP(name, vector, addr);
    if (trace_event_get_state(TRACE_SPAPR_PCI_MSI_SETUP)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:spapr_pci_msi_setup " "dev\"%s\" vector %u, addr=%"PRIx64 "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , name, vector, addr);
    }
}

static inline void trace_spapr_pci_rtas_ibm_change_msi(unsigned cfg, unsigned func, unsigned req, unsigned first)
{
    QEMU_SPAPR_PCI_RTAS_IBM_CHANGE_MSI(cfg, func, req, first);
    if (trace_event_get_state(TRACE_SPAPR_PCI_RTAS_IBM_CHANGE_MSI)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:spapr_pci_rtas_ibm_change_msi " "cfgaddr %x func %u, requested %u, first irq %u" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , cfg, func, req, first);
    }
}

static inline void trace_spapr_pci_rtas_ibm_query_interrupt_source_number(unsigned ioa, unsigned intr)
{
    QEMU_SPAPR_PCI_RTAS_IBM_QUERY_INTERRUPT_SOURCE_NUMBER(ioa, intr);
    if (trace_event_get_state(TRACE_SPAPR_PCI_RTAS_IBM_QUERY_INTERRUPT_SOURCE_NUMBER)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:spapr_pci_rtas_ibm_query_interrupt_source_number " "queries for #%u, IRQ%u" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , ioa, intr);
    }
}

static inline void trace_spapr_pci_msi_write(uint64_t addr, uint64_t data, uint32_t dt_irq)
{
    QEMU_SPAPR_PCI_MSI_WRITE(addr, data, dt_irq);
    if (trace_event_get_state(TRACE_SPAPR_PCI_MSI_WRITE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:spapr_pci_msi_write " "@%"PRIx64"<=%"PRIx64" IRQ %u" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , addr, data, dt_irq);
    }
}

static inline void trace_spapr_pci_lsi_set(const char * busname, int pin, uint32_t irq)
{
    QEMU_SPAPR_PCI_LSI_SET(busname, pin, irq);
    if (trace_event_get_state(TRACE_SPAPR_PCI_LSI_SET)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:spapr_pci_lsi_set " "%s PIN%d IRQ %u" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , busname, pin, irq);
    }
}

static inline void trace_spapr_pci_msi_retry(unsigned config_addr, unsigned req_num, unsigned max_irqs)
{
    QEMU_SPAPR_PCI_MSI_RETRY(config_addr, req_num, max_irqs);
    if (trace_event_get_state(TRACE_SPAPR_PCI_MSI_RETRY)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:spapr_pci_msi_retry " "Guest device at %x asked %u, have only %u" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , config_addr, req_num, max_irqs);
    }
}

static inline void trace_pci_update_mappings_del(void * d, uint32_t bus, uint32_t func, uint32_t slot, int bar, uint64_t addr, uint64_t size)
{
    QEMU_PCI_UPDATE_MAPPINGS_DEL(d, bus, func, slot, bar, addr, size);
    if (trace_event_get_state(TRACE_PCI_UPDATE_MAPPINGS_DEL)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:pci_update_mappings_del " "d=%p %02x:%02x.%x %d,%#"PRIx64"+%#"PRIx64 "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , d, bus, func, slot, bar, addr, size);
    }
}

static inline void trace_pci_update_mappings_add(void * d, uint32_t bus, uint32_t func, uint32_t slot, int bar, uint64_t addr, uint64_t size)
{
    QEMU_PCI_UPDATE_MAPPINGS_ADD(d, bus, func, slot, bar, addr, size);
    if (trace_event_get_state(TRACE_PCI_UPDATE_MAPPINGS_ADD)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:pci_update_mappings_add " "d=%p %02x:%02x.%x %d,%#"PRIx64"+%#"PRIx64 "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , d, bus, func, slot, bar, addr, size);
    }
}

static inline void trace_pcnet_s_reset(void * s)
{
    QEMU_PCNET_S_RESET(s);
    if (trace_event_get_state(TRACE_PCNET_S_RESET)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:pcnet_s_reset " "s=%p" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , s);
    }
}

static inline void trace_pcnet_user_int(void * s)
{
    QEMU_PCNET_USER_INT(s);
    if (trace_event_get_state(TRACE_PCNET_USER_INT)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:pcnet_user_int " "s=%p" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , s);
    }
}

static inline void trace_pcnet_isr_change(void * s, uint32_t isr, uint32_t isr_old)
{
    QEMU_PCNET_ISR_CHANGE(s, isr, isr_old);
    if (trace_event_get_state(TRACE_PCNET_ISR_CHANGE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:pcnet_isr_change " "s=%p INTA=%d<=%d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , s, isr, isr_old);
    }
}

static inline void trace_pcnet_init(void * s, uint64_t init_addr)
{
    QEMU_PCNET_INIT(s, init_addr);
    if (trace_event_get_state(TRACE_PCNET_INIT)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:pcnet_init " "s=%p init_addr=%#"PRIx64 "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , s, init_addr);
    }
}

static inline void trace_pcnet_rlen_tlen(void * s, uint32_t rlen, uint32_t tlen)
{
    QEMU_PCNET_RLEN_TLEN(s, rlen, tlen);
    if (trace_event_get_state(TRACE_PCNET_RLEN_TLEN)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:pcnet_rlen_tlen " "s=%p rlen=%d tlen=%d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , s, rlen, tlen);
    }
}

static inline void trace_pcnet_ss32_rdra_tdra(void * s, uint32_t ss32, uint32_t rdra, uint32_t rcvrl, uint32_t tdra, uint32_t xmtrl)
{
    QEMU_PCNET_SS32_RDRA_TDRA(s, ss32, rdra, rcvrl, tdra, xmtrl);
    if (trace_event_get_state(TRACE_PCNET_SS32_RDRA_TDRA)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:pcnet_ss32_rdra_tdra " "s=%p ss32=%d rdra=0x%08x[%d] tdra=0x%08x[%d]" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , s, ss32, rdra, rcvrl, tdra, xmtrl);
    }
}

static inline void trace_pcnet_aprom_writeb(void * opaque, uint32_t addr, uint32_t val)
{
    QEMU_PCNET_APROM_WRITEB(opaque, addr, val);
    if (trace_event_get_state(TRACE_PCNET_APROM_WRITEB)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:pcnet_aprom_writeb " "opaque=%p addr=0x%08x val=0x%02x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , opaque, addr, val);
    }
}

static inline void trace_pcnet_aprom_readb(void * opaque, uint32_t addr, uint32_t val)
{
    QEMU_PCNET_APROM_READB(opaque, addr, val);
    if (trace_event_get_state(TRACE_PCNET_APROM_READB)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:pcnet_aprom_readb " "opaque=%p addr=0x%08x val=0x%02x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , opaque, addr, val);
    }
}

static inline void trace_pcnet_ioport_read(void * opaque, uint64_t addr, unsigned size)
{
    QEMU_PCNET_IOPORT_READ(opaque, addr, size);
    if (trace_event_get_state(TRACE_PCNET_IOPORT_READ)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:pcnet_ioport_read " "opaque=%p addr=%#"PRIx64" size=%d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , opaque, addr, size);
    }
}

static inline void trace_pcnet_ioport_write(void * opaque, uint64_t addr, uint64_t data, unsigned size)
{
    QEMU_PCNET_IOPORT_WRITE(opaque, addr, data, size);
    if (trace_event_get_state(TRACE_PCNET_IOPORT_WRITE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:pcnet_ioport_write " "opaque=%p addr=%#"PRIx64" data=%#"PRIx64" size=%d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , opaque, addr, data, size);
    }
}

static inline void trace_pcnet_mmio_writeb(void * opaque, uint64_t addr, uint32_t val)
{
    QEMU_PCNET_MMIO_WRITEB(opaque, addr, val);
    if (trace_event_get_state(TRACE_PCNET_MMIO_WRITEB)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:pcnet_mmio_writeb " "opaque=%p addr=%#"PRIx64" val=0x%x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , opaque, addr, val);
    }
}

static inline void trace_pcnet_mmio_writew(void * opaque, uint64_t addr, uint32_t val)
{
    QEMU_PCNET_MMIO_WRITEW(opaque, addr, val);
    if (trace_event_get_state(TRACE_PCNET_MMIO_WRITEW)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:pcnet_mmio_writew " "opaque=%p addr=%#"PRIx64" val=0x%x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , opaque, addr, val);
    }
}

static inline void trace_pcnet_mmio_writel(void * opaque, uint64_t addr, uint32_t val)
{
    QEMU_PCNET_MMIO_WRITEL(opaque, addr, val);
    if (trace_event_get_state(TRACE_PCNET_MMIO_WRITEL)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:pcnet_mmio_writel " "opaque=%p addr=%#"PRIx64" val=0x%x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , opaque, addr, val);
    }
}

static inline void trace_pcnet_mmio_readb(void * opaque, uint64_t addr, uint32_t val)
{
    QEMU_PCNET_MMIO_READB(opaque, addr, val);
    if (trace_event_get_state(TRACE_PCNET_MMIO_READB)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:pcnet_mmio_readb " "opaque=%p addr=%#"PRIx64" val=0x%x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , opaque, addr, val);
    }
}

static inline void trace_pcnet_mmio_readw(void * opaque, uint64_t addr, uint32_t val)
{
    QEMU_PCNET_MMIO_READW(opaque, addr, val);
    if (trace_event_get_state(TRACE_PCNET_MMIO_READW)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:pcnet_mmio_readw " "opaque=%p addr=%#"PRIx64" val=0x%x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , opaque, addr, val);
    }
}

static inline void trace_pcnet_mmio_readl(void * opaque, uint64_t addr, uint32_t val)
{
    QEMU_PCNET_MMIO_READL(opaque, addr, val);
    if (trace_event_get_state(TRACE_PCNET_MMIO_READL)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:pcnet_mmio_readl " "opaque=%p addr=%#"PRIx64" val=0x%x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , opaque, addr, val);
    }
}

static inline void trace_xics_icp_check_ipi(int server, uint8_t mfrr)
{
    QEMU_XICS_ICP_CHECK_IPI(server, mfrr);
    if (trace_event_get_state(TRACE_XICS_ICP_CHECK_IPI)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:xics_icp_check_ipi " "CPU %d can take IPI mfrr=%#x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , server, mfrr);
    }
}

static inline void trace_xics_icp_accept(uint32_t old_xirr, uint32_t new_xirr)
{
    QEMU_XICS_ICP_ACCEPT(old_xirr, new_xirr);
    if (trace_event_get_state(TRACE_XICS_ICP_ACCEPT)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:xics_icp_accept " "icp_accept: XIRR %#"PRIx32"->%#"PRIx32 "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , old_xirr, new_xirr);
    }
}

static inline void trace_xics_icp_eoi(int server, uint32_t xirr, uint32_t new_xirr)
{
    QEMU_XICS_ICP_EOI(server, xirr, new_xirr);
    if (trace_event_get_state(TRACE_XICS_ICP_EOI)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:xics_icp_eoi " "icp_eoi: server %d given XIRR %#"PRIx32" new XIRR %#"PRIx32 "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , server, xirr, new_xirr);
    }
}

static inline void trace_xics_icp_irq(int server, int nr, uint8_t priority)
{
    QEMU_XICS_ICP_IRQ(server, nr, priority);
    if (trace_event_get_state(TRACE_XICS_ICP_IRQ)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:xics_icp_irq " "cpu %d trying to deliver irq %#"PRIx32" priority %#x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , server, nr, priority);
    }
}

static inline void trace_xics_icp_raise(uint32_t xirr, uint8_t pending_priority)
{
    QEMU_XICS_ICP_RAISE(xirr, pending_priority);
    if (trace_event_get_state(TRACE_XICS_ICP_RAISE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:xics_icp_raise " "raising IRQ new XIRR=%#x new pending priority=%#x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , xirr, pending_priority);
    }
}

static inline void trace_xics_set_irq_msi(int srcno, int nr)
{
    QEMU_XICS_SET_IRQ_MSI(srcno, nr);
    if (trace_event_get_state(TRACE_XICS_SET_IRQ_MSI)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:xics_set_irq_msi " "set_irq_msi: srcno %d [irq %#x]" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , srcno, nr);
    }
}

static inline void trace_xics_masked_pending(void)
{
    QEMU_XICS_MASKED_PENDING();
    if (trace_event_get_state(TRACE_XICS_MASKED_PENDING)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:xics_masked_pending " "set_irq_msi: masked pending" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      );
    }
}

static inline void trace_xics_set_irq_lsi(int srcno, int nr)
{
    QEMU_XICS_SET_IRQ_LSI(srcno, nr);
    if (trace_event_get_state(TRACE_XICS_SET_IRQ_LSI)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:xics_set_irq_lsi " "set_irq_lsi: srcno %d [irq %#x]" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , srcno, nr);
    }
}

static inline void trace_xics_ics_write_xive(int nr, int srcno, int server, uint8_t priority)
{
    QEMU_XICS_ICS_WRITE_XIVE(nr, srcno, server, priority);
    if (trace_event_get_state(TRACE_XICS_ICS_WRITE_XIVE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:xics_ics_write_xive " "ics_write_xive: irq %#x [src %d] server %#x prio %#x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , nr, srcno, server, priority);
    }
}

static inline void trace_xics_ics_reject(int nr, int srcno)
{
    QEMU_XICS_ICS_REJECT(nr, srcno);
    if (trace_event_get_state(TRACE_XICS_ICS_REJECT)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:xics_ics_reject " "reject irq %#x [src %d]" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , nr, srcno);
    }
}

static inline void trace_xics_ics_eoi(int nr)
{
    QEMU_XICS_ICS_EOI(nr);
    if (trace_event_get_state(TRACE_XICS_ICS_EOI)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:xics_ics_eoi " "ics_eoi: irq %#x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , nr);
    }
}

static inline void trace_xics_alloc(int src, int irq)
{
    QEMU_XICS_ALLOC(src, irq);
    if (trace_event_get_state(TRACE_XICS_ALLOC)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:xics_alloc " "source#%d, irq %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , src, irq);
    }
}

static inline void trace_xics_alloc_failed_hint(int src, int irq)
{
    QEMU_XICS_ALLOC_FAILED_HINT(src, irq);
    if (trace_event_get_state(TRACE_XICS_ALLOC_FAILED_HINT)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:xics_alloc_failed_hint " "source#%d, irq %d is already in use" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , src, irq);
    }
}

static inline void trace_xics_alloc_failed_no_left(int src)
{
    QEMU_XICS_ALLOC_FAILED_NO_LEFT(src);
    if (trace_event_get_state(TRACE_XICS_ALLOC_FAILED_NO_LEFT)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:xics_alloc_failed_no_left " "source#%d, no irq left" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , src);
    }
}

static inline void trace_xics_alloc_block(int src, int first, int num, bool lsi, int align)
{
    QEMU_XICS_ALLOC_BLOCK(src, first, num, lsi, align);
    if (trace_event_get_state(TRACE_XICS_ALLOC_BLOCK)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:xics_alloc_block " "source#%d, first irq %d, %d irqs, lsi=%d, alignnum %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , src, first, num, lsi, align);
    }
}

static inline void trace_xics_ics_free(int src, int irq, int num)
{
    QEMU_XICS_ICS_FREE(src, irq, num);
    if (trace_event_get_state(TRACE_XICS_ICS_FREE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:xics_ics_free " "Source#%d, first irq %d, %d irqs" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , src, irq, num);
    }
}

static inline void trace_xics_ics_free_warn(int src, int irq)
{
    QEMU_XICS_ICS_FREE_WARN(src, irq);
    if (trace_event_get_state(TRACE_XICS_ICS_FREE_WARN)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:xics_ics_free_warn " "Source#%d, irq %d is already free" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , src, irq);
    }
}

static inline void trace_spapr_cas_failed(unsigned long n)
{
    QEMU_SPAPR_CAS_FAILED(n);
    if (trace_event_get_state(TRACE_SPAPR_CAS_FAILED)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:spapr_cas_failed " "DT diff buffer is too small: %ld bytes" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , n);
    }
}

static inline void trace_spapr_cas_continue(unsigned long n)
{
    QEMU_SPAPR_CAS_CONTINUE(n);
    if (trace_event_get_state(TRACE_SPAPR_CAS_CONTINUE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:spapr_cas_continue " "Copy changes to the guest: %ld bytes" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , n);
    }
}

static inline void trace_spapr_cas_pvr_try(uint32_t pvr)
{
    QEMU_SPAPR_CAS_PVR_TRY(pvr);
    if (trace_event_get_state(TRACE_SPAPR_CAS_PVR_TRY)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:spapr_cas_pvr_try " "%x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , pvr);
    }
}

static inline void trace_spapr_cas_pvr(uint32_t cur_pvr, bool cpu_match, uint32_t new_pvr, uint64_t pcr)
{
    QEMU_SPAPR_CAS_PVR(cur_pvr, cpu_match, new_pvr, pcr);
    if (trace_event_get_state(TRACE_SPAPR_CAS_PVR)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:spapr_cas_pvr " "current=%x, cpu_match=%u, new=%x, compat flags=%"PRIx64 "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , cur_pvr, cpu_match, new_pvr, pcr);
    }
}

static inline void trace_spapr_iommu_put(uint64_t liobn, uint64_t ioba, uint64_t tce, uint64_t ret)
{
    QEMU_SPAPR_IOMMU_PUT(liobn, ioba, tce, ret);
    if (trace_event_get_state(TRACE_SPAPR_IOMMU_PUT)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:spapr_iommu_put " "liobn=%"PRIx64" ioba=0x%"PRIx64" tce=0x%"PRIx64" ret=%"PRId64 "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , liobn, ioba, tce, ret);
    }
}

static inline void trace_spapr_iommu_get(uint64_t liobn, uint64_t ioba, uint64_t ret, uint64_t tce)
{
    QEMU_SPAPR_IOMMU_GET(liobn, ioba, ret, tce);
    if (trace_event_get_state(TRACE_SPAPR_IOMMU_GET)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:spapr_iommu_get " "liobn=%"PRIx64" ioba=0x%"PRIx64" ret=%"PRId64" tce=0x%"PRIx64 "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , liobn, ioba, ret, tce);
    }
}

static inline void trace_spapr_iommu_indirect(uint64_t liobn, uint64_t ioba, uint64_t tce, uint64_t iobaN, uint64_t tceN, uint64_t ret)
{
    QEMU_SPAPR_IOMMU_INDIRECT(liobn, ioba, tce, iobaN, tceN, ret);
    if (trace_event_get_state(TRACE_SPAPR_IOMMU_INDIRECT)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:spapr_iommu_indirect " "liobn=%"PRIx64" ioba=0x%"PRIx64" tcelist=0x%"PRIx64" iobaN=0x%"PRIx64" tceN=0x%"PRIx64" ret=%"PRId64 "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , liobn, ioba, tce, iobaN, tceN, ret);
    }
}

static inline void trace_spapr_iommu_stuff(uint64_t liobn, uint64_t ioba, uint64_t tce_value, uint64_t npages, uint64_t ret)
{
    QEMU_SPAPR_IOMMU_STUFF(liobn, ioba, tce_value, npages, ret);
    if (trace_event_get_state(TRACE_SPAPR_IOMMU_STUFF)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:spapr_iommu_stuff " "liobn=%"PRIx64" ioba=0x%"PRIx64" tcevalue=0x%"PRIx64" npages=%"PRId64" ret=%"PRId64 "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , liobn, ioba, tce_value, npages, ret);
    }
}

static inline void trace_spapr_iommu_xlate(uint64_t liobn, uint64_t ioba, uint64_t tce, unsigned perm, unsigned pgsize)
{
    QEMU_SPAPR_IOMMU_XLATE(liobn, ioba, tce, perm, pgsize);
    if (trace_event_get_state(TRACE_SPAPR_IOMMU_XLATE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:spapr_iommu_xlate " "liobn=%"PRIx64" 0x%"PRIx64" -> 0x%"PRIx64" perm=%u mask=%x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , liobn, ioba, tce, perm, pgsize);
    }
}

static inline void trace_spapr_iommu_new_table(uint64_t liobn, void * tcet, void * table, int fd)
{
    QEMU_SPAPR_IOMMU_NEW_TABLE(liobn, tcet, table, fd);
    if (trace_event_get_state(TRACE_SPAPR_IOMMU_NEW_TABLE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:spapr_iommu_new_table " "liobn=%"PRIx64" tcet=%p table=%p fd=%d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , liobn, tcet, table, fd);
    }
}

static inline void trace_ppc_tb_adjust(uint64_t offs1, uint64_t offs2, int64_t diff, int64_t seconds)
{
    QEMU_PPC_TB_ADJUST(offs1, offs2, diff, seconds);
    if (trace_event_get_state(TRACE_PPC_TB_ADJUST)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:ppc_tb_adjust " "adjusted from 0x%"PRIx64" to 0x%"PRIx64", diff %"PRId64" (%"PRId64"s)" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , offs1, offs2, diff, seconds);
    }
}

static inline void trace_hbitmap_iter_skip_words(const void * hb, void * hbi, uint64_t pos, unsigned long cur)
{
    QEMU_HBITMAP_ITER_SKIP_WORDS(hb, hbi, pos, cur);
    if (trace_event_get_state(TRACE_HBITMAP_ITER_SKIP_WORDS)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:hbitmap_iter_skip_words " "hb %p hbi %p pos %"PRId64" cur 0x%lx" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , hb, hbi, pos, cur);
    }
}

static inline void trace_hbitmap_reset(void * hb, uint64_t start, uint64_t count, uint64_t sbit, uint64_t ebit)
{
    QEMU_HBITMAP_RESET(hb, start, count, sbit, ebit);
    if (trace_event_get_state(TRACE_HBITMAP_RESET)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:hbitmap_reset " "hb %p items %"PRIu64",%"PRIu64" bits %"PRIu64"..%"PRIu64 "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , hb, start, count, sbit, ebit);
    }
}

static inline void trace_hbitmap_set(void * hb, uint64_t start, uint64_t count, uint64_t sbit, uint64_t ebit)
{
    QEMU_HBITMAP_SET(hb, start, count, sbit, ebit);
    if (trace_event_get_state(TRACE_HBITMAP_SET)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:hbitmap_set " "hb %p items %"PRIu64",%"PRIu64" bits %"PRIu64"..%"PRIu64 "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , hb, start, count, sbit, ebit);
    }
}

static inline void trace_ioinst(const char * insn)
{
    QEMU_IOINST(insn);
    if (trace_event_get_state(TRACE_IOINST)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:ioinst " "IOINST: %s" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , insn);
    }
}

static inline void trace_ioinst_sch_id(const char * insn, int cssid, int ssid, int schid)
{
    QEMU_IOINST_SCH_ID(insn, cssid, ssid, schid);
    if (trace_event_get_state(TRACE_IOINST_SCH_ID)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:ioinst_sch_id " "IOINST: %s (%x.%x.%04x)" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , insn, cssid, ssid, schid);
    }
}

static inline void trace_ioinst_chp_id(const char * insn, int cssid, int chpid)
{
    QEMU_IOINST_CHP_ID(insn, cssid, chpid);
    if (trace_event_get_state(TRACE_IOINST_CHP_ID)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:ioinst_chp_id " "IOINST: %s (%x.%02x)" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , insn, cssid, chpid);
    }
}

static inline void trace_ioinst_chsc_cmd(uint16_t cmd, uint16_t len)
{
    QEMU_IOINST_CHSC_CMD(cmd, len);
    if (trace_event_get_state(TRACE_IOINST_CHSC_CMD)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:ioinst_chsc_cmd " "IOINST: chsc command %04x, len %04x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , cmd, len);
    }
}

static inline void trace_css_enable_facility(const char * facility)
{
    QEMU_CSS_ENABLE_FACILITY(facility);
    if (trace_event_get_state(TRACE_CSS_ENABLE_FACILITY)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:css_enable_facility " "CSS: enable %s" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , facility);
    }
}

static inline void trace_css_crw(uint8_t rsc, uint8_t erc, uint16_t rsid, const char * chained)
{
    QEMU_CSS_CRW(rsc, erc, rsid, chained);
    if (trace_event_get_state(TRACE_CSS_CRW)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:css_crw " "CSS: queueing crw: rsc=%x, erc=%x, rsid=%x %s" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , rsc, erc, rsid, chained);
    }
}

static inline void trace_css_chpid_add(uint8_t cssid, uint8_t chpid, uint8_t type)
{
    QEMU_CSS_CHPID_ADD(cssid, chpid, type);
    if (trace_event_get_state(TRACE_CSS_CHPID_ADD)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:css_chpid_add " "CSS: add chpid %x.%02x (type %02x)" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , cssid, chpid, type);
    }
}

static inline void trace_css_new_image(uint8_t cssid, const char * default_cssid)
{
    QEMU_CSS_NEW_IMAGE(cssid, default_cssid);
    if (trace_event_get_state(TRACE_CSS_NEW_IMAGE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:css_new_image " "CSS: add css image %02x %s" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , cssid, default_cssid);
    }
}

static inline void trace_css_assign_subch(const char * do_assign, uint8_t cssid, uint8_t ssid, uint16_t schid, uint16_t devno)
{
    QEMU_CSS_ASSIGN_SUBCH(do_assign, cssid, ssid, schid, devno);
    if (trace_event_get_state(TRACE_CSS_ASSIGN_SUBCH)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:css_assign_subch " "CSS: %s %x.%x.%04x (devno %04x)" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , do_assign, cssid, ssid, schid, devno);
    }
}

static inline void trace_css_io_interrupt(int cssid, int ssid, int schid, uint32_t intparm, uint8_t isc, const char * conditional)
{
    QEMU_CSS_IO_INTERRUPT(cssid, ssid, schid, intparm, isc, conditional);
    if (trace_event_get_state(TRACE_CSS_IO_INTERRUPT)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:css_io_interrupt " "CSS: I/O interrupt on sch %x.%x.%04x (intparm %08x, isc %x) %s" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , cssid, ssid, schid, intparm, isc, conditional);
    }
}

static inline void trace_css_adapter_interrupt(uint8_t isc)
{
    QEMU_CSS_ADAPTER_INTERRUPT(isc);
    if (trace_event_get_state(TRACE_CSS_ADAPTER_INTERRUPT)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:css_adapter_interrupt " "CSS: adapter I/O interrupt (isc %x)" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , isc);
    }
}

static inline void trace_virtio_ccw_interpret_ccw(int cssid, int ssid, int schid, int cmd_code)
{
    QEMU_VIRTIO_CCW_INTERPRET_CCW(cssid, ssid, schid, cmd_code);
    if (trace_event_get_state(TRACE_VIRTIO_CCW_INTERPRET_CCW)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:virtio_ccw_interpret_ccw " "VIRTIO-CCW: %x.%x.%04x: interpret command %x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , cssid, ssid, schid, cmd_code);
    }
}

static inline void trace_virtio_ccw_new_device(int cssid, int ssid, int schid, int devno, const char * devno_mode)
{
    QEMU_VIRTIO_CCW_NEW_DEVICE(cssid, ssid, schid, devno, devno_mode);
    if (trace_event_get_state(TRACE_VIRTIO_CCW_NEW_DEVICE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:virtio_ccw_new_device " "VIRTIO-CCW: add subchannel %x.%x.%04x, devno %04x (%s)" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , cssid, ssid, schid, devno, devno_mode);
    }
}

static inline void trace_flic_create_device(int err)
{
    QEMU_FLIC_CREATE_DEVICE(err);
    if (trace_event_get_state(TRACE_FLIC_CREATE_DEVICE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:flic_create_device " "flic: create device failed %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , err);
    }
}

static inline void trace_flic_no_device_api(int err)
{
    QEMU_FLIC_NO_DEVICE_API(err);
    if (trace_event_get_state(TRACE_FLIC_NO_DEVICE_API)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:flic_no_device_api " "flic: no Device Contral API support %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , err);
    }
}

static inline void trace_flic_reset_failed(int err)
{
    QEMU_FLIC_RESET_FAILED(err);
    if (trace_event_get_state(TRACE_FLIC_RESET_FAILED)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:flic_reset_failed " "flic: reset failed %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , err);
    }
}

static inline void trace_migrate_set_state(int new_state)
{
    QEMU_MIGRATE_SET_STATE(new_state);
    if (trace_event_get_state(TRACE_MIGRATE_SET_STATE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:migrate_set_state " "new state %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , new_state);
    }
}

static inline void trace_migrate_fd_cleanup(void)
{
    QEMU_MIGRATE_FD_CLEANUP();
    if (trace_event_get_state(TRACE_MIGRATE_FD_CLEANUP)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:migrate_fd_cleanup " "" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      );
    }
}

static inline void trace_migrate_fd_error(void)
{
    QEMU_MIGRATE_FD_ERROR();
    if (trace_event_get_state(TRACE_MIGRATE_FD_ERROR)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:migrate_fd_error " "" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      );
    }
}

static inline void trace_migrate_fd_cancel(void)
{
    QEMU_MIGRATE_FD_CANCEL();
    if (trace_event_get_state(TRACE_MIGRATE_FD_CANCEL)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:migrate_fd_cancel " "" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      );
    }
}

static inline void trace_migrate_pending(uint64_t size, uint64_t max, uint64_t pre, uint64_t compat, uint64_t post)
{
    QEMU_MIGRATE_PENDING(size, max, pre, compat, post);
    if (trace_event_get_state(TRACE_MIGRATE_PENDING)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:migrate_pending " "pending size %" PRIu64 " max %" PRIu64 " (pre = %" PRIu64 " compat=%" PRIu64 " post=%" PRIu64 ")" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , size, max, pre, compat, post);
    }
}

static inline void trace_migration_completion_file_err(void)
{
    QEMU_MIGRATION_COMPLETION_FILE_ERR();
    if (trace_event_get_state(TRACE_MIGRATION_COMPLETION_FILE_ERR)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:migration_completion_file_err " "" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      );
    }
}

static inline void trace_migration_completion_postcopy_end(void)
{
    QEMU_MIGRATION_COMPLETION_POSTCOPY_END();
    if (trace_event_get_state(TRACE_MIGRATION_COMPLETION_POSTCOPY_END)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:migration_completion_postcopy_end " "" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      );
    }
}

static inline void trace_migration_completion_postcopy_end_after_complete(void)
{
    QEMU_MIGRATION_COMPLETION_POSTCOPY_END_AFTER_COMPLETE();
    if (trace_event_get_state(TRACE_MIGRATION_COMPLETION_POSTCOPY_END_AFTER_COMPLETE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:migration_completion_postcopy_end_after_complete " "" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      );
    }
}

static inline void trace_migration_thread_after_loop(void)
{
    QEMU_MIGRATION_THREAD_AFTER_LOOP();
    if (trace_event_get_state(TRACE_MIGRATION_THREAD_AFTER_LOOP)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:migration_thread_after_loop " "" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      );
    }
}

static inline void trace_migration_thread_file_err(void)
{
    QEMU_MIGRATION_THREAD_FILE_ERR();
    if (trace_event_get_state(TRACE_MIGRATION_THREAD_FILE_ERR)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:migration_thread_file_err " "" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      );
    }
}

static inline void trace_migration_thread_setup_complete(void)
{
    QEMU_MIGRATION_THREAD_SETUP_COMPLETE();
    if (trace_event_get_state(TRACE_MIGRATION_THREAD_SETUP_COMPLETE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:migration_thread_setup_complete " "" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      );
    }
}

static inline void trace_postcopy_start(void)
{
    QEMU_POSTCOPY_START();
    if (trace_event_get_state(TRACE_POSTCOPY_START)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:postcopy_start " "" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      );
    }
}

static inline void trace_postcopy_start_set_run(void)
{
    QEMU_POSTCOPY_START_SET_RUN();
    if (trace_event_get_state(TRACE_POSTCOPY_START_SET_RUN)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:postcopy_start_set_run " "" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      );
    }
}

static inline void trace_migrate_global_state_post_load(const char * state)
{
    QEMU_MIGRATE_GLOBAL_STATE_POST_LOAD(state);
    if (trace_event_get_state(TRACE_MIGRATE_GLOBAL_STATE_POST_LOAD)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:migrate_global_state_post_load " "loaded state: %s" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , state);
    }
}

static inline void trace_migrate_global_state_pre_save(const char * state)
{
    QEMU_MIGRATE_GLOBAL_STATE_PRE_SAVE(state);
    if (trace_event_get_state(TRACE_MIGRATE_GLOBAL_STATE_PRE_SAVE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:migrate_global_state_pre_save " "saved state: %s" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , state);
    }
}

static inline void trace_migration_thread_low_pending(uint64_t pending)
{
    QEMU_MIGRATION_THREAD_LOW_PENDING(pending);
    if (trace_event_get_state(TRACE_MIGRATION_THREAD_LOW_PENDING)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:migration_thread_low_pending " "%" PRIu64 "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , pending);
    }
}

static inline void trace_migrate_state_too_big(void)
{
    QEMU_MIGRATE_STATE_TOO_BIG();
    if (trace_event_get_state(TRACE_MIGRATE_STATE_TOO_BIG)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:migrate_state_too_big " "" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      );
    }
}

static inline void trace_migrate_transferred(uint64_t tranferred, uint64_t time_spent, double bandwidth, uint64_t size)
{
    QEMU_MIGRATE_TRANSFERRED(tranferred, time_spent, bandwidth, size);
    if (trace_event_get_state(TRACE_MIGRATE_TRANSFERRED)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:migrate_transferred " "transferred %" PRIu64 " time_spent %" PRIu64 " bandwidth %g max_size %" PRId64 "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , tranferred, time_spent, bandwidth, size);
    }
}

static inline void trace_process_incoming_migration_co_end(int ret, int ps)
{
    QEMU_PROCESS_INCOMING_MIGRATION_CO_END(ret, ps);
    if (trace_event_get_state(TRACE_PROCESS_INCOMING_MIGRATION_CO_END)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:process_incoming_migration_co_end " "ret=%d postcopy-state=%d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , ret, ps);
    }
}

static inline void trace_process_incoming_migration_co_postcopy_end_main(void)
{
    QEMU_PROCESS_INCOMING_MIGRATION_CO_POSTCOPY_END_MAIN();
    if (trace_event_get_state(TRACE_PROCESS_INCOMING_MIGRATION_CO_POSTCOPY_END_MAIN)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:process_incoming_migration_co_postcopy_end_main " "" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      );
    }
}

static inline void trace_qemu_rdma_accept_incoming_migration(void)
{
    QEMU_QEMU_RDMA_ACCEPT_INCOMING_MIGRATION();
    if (trace_event_get_state(TRACE_QEMU_RDMA_ACCEPT_INCOMING_MIGRATION)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qemu_rdma_accept_incoming_migration " "" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      );
    }
}

static inline void trace_qemu_rdma_accept_incoming_migration_accepted(void)
{
    QEMU_QEMU_RDMA_ACCEPT_INCOMING_MIGRATION_ACCEPTED();
    if (trace_event_get_state(TRACE_QEMU_RDMA_ACCEPT_INCOMING_MIGRATION_ACCEPTED)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qemu_rdma_accept_incoming_migration_accepted " "" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      );
    }
}

static inline void trace_qemu_rdma_accept_pin_state(bool pin)
{
    QEMU_QEMU_RDMA_ACCEPT_PIN_STATE(pin);
    if (trace_event_get_state(TRACE_QEMU_RDMA_ACCEPT_PIN_STATE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qemu_rdma_accept_pin_state " "%d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , pin);
    }
}

static inline void trace_qemu_rdma_accept_pin_verbsc(void * verbs)
{
    QEMU_QEMU_RDMA_ACCEPT_PIN_VERBSC(verbs);
    if (trace_event_get_state(TRACE_QEMU_RDMA_ACCEPT_PIN_VERBSC)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qemu_rdma_accept_pin_verbsc " "Verbs context after listen: %p" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , verbs);
    }
}

static inline void trace_qemu_rdma_block_for_wrid_miss(const char * wcompstr, int wcomp, const char * gcompstr, uint64_t req)
{
    QEMU_QEMU_RDMA_BLOCK_FOR_WRID_MISS(wcompstr, wcomp, gcompstr, req);
    if (trace_event_get_state(TRACE_QEMU_RDMA_BLOCK_FOR_WRID_MISS)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qemu_rdma_block_for_wrid_miss " "A Wanted wrid %s (%d) but got %s (%" PRIu64 ")" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , wcompstr, wcomp, gcompstr, req);
    }
}

static inline void trace_qemu_rdma_block_for_wrid_miss_b(const char * wcompstr, int wcomp, const char * gcompstr, uint64_t req)
{
    QEMU_QEMU_RDMA_BLOCK_FOR_WRID_MISS_B(wcompstr, wcomp, gcompstr, req);
    if (trace_event_get_state(TRACE_QEMU_RDMA_BLOCK_FOR_WRID_MISS_B)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qemu_rdma_block_for_wrid_miss_b " "B Wanted wrid %s (%d) but got %s (%" PRIu64 ")" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , wcompstr, wcomp, gcompstr, req);
    }
}

static inline void trace_qemu_rdma_cleanup_disconnect(void)
{
    QEMU_QEMU_RDMA_CLEANUP_DISCONNECT();
    if (trace_event_get_state(TRACE_QEMU_RDMA_CLEANUP_DISCONNECT)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qemu_rdma_cleanup_disconnect " "" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      );
    }
}

static inline void trace_qemu_rdma_cleanup_waiting_for_disconnect(void)
{
    QEMU_QEMU_RDMA_CLEANUP_WAITING_FOR_DISCONNECT();
    if (trace_event_get_state(TRACE_QEMU_RDMA_CLEANUP_WAITING_FOR_DISCONNECT)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qemu_rdma_cleanup_waiting_for_disconnect " "" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      );
    }
}

static inline void trace_qemu_rdma_close(void)
{
    QEMU_QEMU_RDMA_CLOSE();
    if (trace_event_get_state(TRACE_QEMU_RDMA_CLOSE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qemu_rdma_close " "" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      );
    }
}

static inline void trace_qemu_rdma_connect_pin_all_requested(void)
{
    QEMU_QEMU_RDMA_CONNECT_PIN_ALL_REQUESTED();
    if (trace_event_get_state(TRACE_QEMU_RDMA_CONNECT_PIN_ALL_REQUESTED)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qemu_rdma_connect_pin_all_requested " "" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      );
    }
}

static inline void trace_qemu_rdma_connect_pin_all_outcome(bool pin)
{
    QEMU_QEMU_RDMA_CONNECT_PIN_ALL_OUTCOME(pin);
    if (trace_event_get_state(TRACE_QEMU_RDMA_CONNECT_PIN_ALL_OUTCOME)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qemu_rdma_connect_pin_all_outcome " "%d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , pin);
    }
}

static inline void trace_qemu_rdma_dest_init_trying(const char * host, const char * ip)
{
    QEMU_QEMU_RDMA_DEST_INIT_TRYING(host, ip);
    if (trace_event_get_state(TRACE_QEMU_RDMA_DEST_INIT_TRYING)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qemu_rdma_dest_init_trying " "%s => %s" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , host, ip);
    }
}

static inline void trace_qemu_rdma_dump_gid(const char * who, const char * src, const char * dst)
{
    QEMU_QEMU_RDMA_DUMP_GID(who, src, dst);
    if (trace_event_get_state(TRACE_QEMU_RDMA_DUMP_GID)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qemu_rdma_dump_gid " "%s Source GID: %s, Dest GID: %s" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , who, src, dst);
    }
}

static inline void trace_qemu_rdma_exchange_get_response_start(const char * desc)
{
    QEMU_QEMU_RDMA_EXCHANGE_GET_RESPONSE_START(desc);
    if (trace_event_get_state(TRACE_QEMU_RDMA_EXCHANGE_GET_RESPONSE_START)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qemu_rdma_exchange_get_response_start " "CONTROL: %s receiving..." "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , desc);
    }
}

static inline void trace_qemu_rdma_exchange_get_response_none(const char * desc, int type)
{
    QEMU_QEMU_RDMA_EXCHANGE_GET_RESPONSE_NONE(desc, type);
    if (trace_event_get_state(TRACE_QEMU_RDMA_EXCHANGE_GET_RESPONSE_NONE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qemu_rdma_exchange_get_response_none " "Surprise: got %s (%d)" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , desc, type);
    }
}

static inline void trace_qemu_rdma_exchange_send_issue_callback(void)
{
    QEMU_QEMU_RDMA_EXCHANGE_SEND_ISSUE_CALLBACK();
    if (trace_event_get_state(TRACE_QEMU_RDMA_EXCHANGE_SEND_ISSUE_CALLBACK)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qemu_rdma_exchange_send_issue_callback " "" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      );
    }
}

static inline void trace_qemu_rdma_exchange_send_waiting(const char * desc)
{
    QEMU_QEMU_RDMA_EXCHANGE_SEND_WAITING(desc);
    if (trace_event_get_state(TRACE_QEMU_RDMA_EXCHANGE_SEND_WAITING)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qemu_rdma_exchange_send_waiting " "Waiting for response %s" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , desc);
    }
}

static inline void trace_qemu_rdma_exchange_send_received(const char * desc)
{
    QEMU_QEMU_RDMA_EXCHANGE_SEND_RECEIVED(desc);
    if (trace_event_get_state(TRACE_QEMU_RDMA_EXCHANGE_SEND_RECEIVED)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qemu_rdma_exchange_send_received " "Response %s received." "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , desc);
    }
}

static inline void trace_qemu_rdma_fill(int64_t control_len, int size)
{
    QEMU_QEMU_RDMA_FILL(control_len, size);
    if (trace_event_get_state(TRACE_QEMU_RDMA_FILL)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qemu_rdma_fill " "RDMA %" PRId64 " of %d bytes already in buffer" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , control_len, size);
    }
}

static inline void trace_qemu_rdma_init_ram_blocks(int blocks)
{
    QEMU_QEMU_RDMA_INIT_RAM_BLOCKS(blocks);
    if (trace_event_get_state(TRACE_QEMU_RDMA_INIT_RAM_BLOCKS)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qemu_rdma_init_ram_blocks " "Allocated %d local ram block structures" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , blocks);
    }
}

static inline void trace_qemu_rdma_poll_recv(const char * compstr, int64_t comp, int64_t id, int sent)
{
    QEMU_QEMU_RDMA_POLL_RECV(compstr, comp, id, sent);
    if (trace_event_get_state(TRACE_QEMU_RDMA_POLL_RECV)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qemu_rdma_poll_recv " "completion %s #%" PRId64 " received (%" PRId64 ") left %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , compstr, comp, id, sent);
    }
}

static inline void trace_qemu_rdma_poll_write(const char * compstr, int64_t comp, int left, uint64_t block, uint64_t chunk, void * local, void * remote)
{
    QEMU_QEMU_RDMA_POLL_WRITE(compstr, comp, left, block, chunk, local, remote);
    if (trace_event_get_state(TRACE_QEMU_RDMA_POLL_WRITE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qemu_rdma_poll_write " "completions %s (%" PRId64 ") left %d, block %" PRIu64 ", chunk: %" PRIu64 " %p %p" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , compstr, comp, left, block, chunk, local, remote);
    }
}

static inline void trace_qemu_rdma_poll_other(const char * compstr, int64_t comp, int left)
{
    QEMU_QEMU_RDMA_POLL_OTHER(compstr, comp, left);
    if (trace_event_get_state(TRACE_QEMU_RDMA_POLL_OTHER)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qemu_rdma_poll_other " "other completion %s (%" PRId64 ") received left %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , compstr, comp, left);
    }
}

static inline void trace_qemu_rdma_post_send_control(const char * desc)
{
    QEMU_QEMU_RDMA_POST_SEND_CONTROL(desc);
    if (trace_event_get_state(TRACE_QEMU_RDMA_POST_SEND_CONTROL)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qemu_rdma_post_send_control " "CONTROL: sending %s.." "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , desc);
    }
}

static inline void trace_qemu_rdma_register_and_get_keys(uint64_t len, void * start)
{
    QEMU_QEMU_RDMA_REGISTER_AND_GET_KEYS(len, start);
    if (trace_event_get_state(TRACE_QEMU_RDMA_REGISTER_AND_GET_KEYS)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qemu_rdma_register_and_get_keys " "Registering %" PRIu64 " bytes @ %p" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , len, start);
    }
}

static inline void trace_qemu_rdma_registration_handle_compress(int64_t length, int index, int64_t offset)
{
    QEMU_QEMU_RDMA_REGISTRATION_HANDLE_COMPRESS(length, index, offset);
    if (trace_event_get_state(TRACE_QEMU_RDMA_REGISTRATION_HANDLE_COMPRESS)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qemu_rdma_registration_handle_compress " "Zapping zero chunk: %" PRId64 " bytes, index %d, offset %" PRId64 "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , length, index, offset);
    }
}

static inline void trace_qemu_rdma_registration_handle_finished(void)
{
    QEMU_QEMU_RDMA_REGISTRATION_HANDLE_FINISHED();
    if (trace_event_get_state(TRACE_QEMU_RDMA_REGISTRATION_HANDLE_FINISHED)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qemu_rdma_registration_handle_finished " "" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      );
    }
}

static inline void trace_qemu_rdma_registration_handle_ram_blocks(void)
{
    QEMU_QEMU_RDMA_REGISTRATION_HANDLE_RAM_BLOCKS();
    if (trace_event_get_state(TRACE_QEMU_RDMA_REGISTRATION_HANDLE_RAM_BLOCKS)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qemu_rdma_registration_handle_ram_blocks " "" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      );
    }
}

static inline void trace_qemu_rdma_registration_handle_ram_blocks_loop(const char * name, uint64_t offset, uint64_t length, void * local_host_addr, unsigned int src_index)
{
    QEMU_QEMU_RDMA_REGISTRATION_HANDLE_RAM_BLOCKS_LOOP(name, offset, length, local_host_addr, src_index);
    if (trace_event_get_state(TRACE_QEMU_RDMA_REGISTRATION_HANDLE_RAM_BLOCKS_LOOP)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qemu_rdma_registration_handle_ram_blocks_loop " "%s: @%" PRIx64 "/%" PRIu64 " host:@%p src_index: %u" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , name, offset, length, local_host_addr, src_index);
    }
}

static inline void trace_qemu_rdma_registration_handle_register(int requests)
{
    QEMU_QEMU_RDMA_REGISTRATION_HANDLE_REGISTER(requests);
    if (trace_event_get_state(TRACE_QEMU_RDMA_REGISTRATION_HANDLE_REGISTER)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qemu_rdma_registration_handle_register " "%d requests" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , requests);
    }
}

static inline void trace_qemu_rdma_registration_handle_register_loop(int req, int index, uint64_t addr, uint64_t chunks)
{
    QEMU_QEMU_RDMA_REGISTRATION_HANDLE_REGISTER_LOOP(req, index, addr, chunks);
    if (trace_event_get_state(TRACE_QEMU_RDMA_REGISTRATION_HANDLE_REGISTER_LOOP)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qemu_rdma_registration_handle_register_loop " "Registration request (%d): index %d, current_addr %" PRIu64 " chunks: %" PRIu64 "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , req, index, addr, chunks);
    }
}

static inline void trace_qemu_rdma_registration_handle_register_rkey(int rkey)
{
    QEMU_QEMU_RDMA_REGISTRATION_HANDLE_REGISTER_RKEY(rkey);
    if (trace_event_get_state(TRACE_QEMU_RDMA_REGISTRATION_HANDLE_REGISTER_RKEY)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qemu_rdma_registration_handle_register_rkey " "%x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , rkey);
    }
}

static inline void trace_qemu_rdma_registration_handle_unregister(int requests)
{
    QEMU_QEMU_RDMA_REGISTRATION_HANDLE_UNREGISTER(requests);
    if (trace_event_get_state(TRACE_QEMU_RDMA_REGISTRATION_HANDLE_UNREGISTER)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qemu_rdma_registration_handle_unregister " "%d requests" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , requests);
    }
}

static inline void trace_qemu_rdma_registration_handle_unregister_loop(int count, int index, uint64_t chunk)
{
    QEMU_QEMU_RDMA_REGISTRATION_HANDLE_UNREGISTER_LOOP(count, index, chunk);
    if (trace_event_get_state(TRACE_QEMU_RDMA_REGISTRATION_HANDLE_UNREGISTER_LOOP)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qemu_rdma_registration_handle_unregister_loop " "Unregistration request (%d): index %d, chunk %" PRIu64 "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , count, index, chunk);
    }
}

static inline void trace_qemu_rdma_registration_handle_unregister_success(uint64_t chunk)
{
    QEMU_QEMU_RDMA_REGISTRATION_HANDLE_UNREGISTER_SUCCESS(chunk);
    if (trace_event_get_state(TRACE_QEMU_RDMA_REGISTRATION_HANDLE_UNREGISTER_SUCCESS)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qemu_rdma_registration_handle_unregister_success " "%" PRIu64 "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , chunk);
    }
}

static inline void trace_qemu_rdma_registration_handle_wait(void)
{
    QEMU_QEMU_RDMA_REGISTRATION_HANDLE_WAIT();
    if (trace_event_get_state(TRACE_QEMU_RDMA_REGISTRATION_HANDLE_WAIT)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qemu_rdma_registration_handle_wait " "" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      );
    }
}

static inline void trace_qemu_rdma_registration_start(uint64_t flags)
{
    QEMU_QEMU_RDMA_REGISTRATION_START(flags);
    if (trace_event_get_state(TRACE_QEMU_RDMA_REGISTRATION_START)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qemu_rdma_registration_start " "%" PRIu64 "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , flags);
    }
}

static inline void trace_qemu_rdma_registration_stop(uint64_t flags)
{
    QEMU_QEMU_RDMA_REGISTRATION_STOP(flags);
    if (trace_event_get_state(TRACE_QEMU_RDMA_REGISTRATION_STOP)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qemu_rdma_registration_stop " "%" PRIu64 "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , flags);
    }
}

static inline void trace_qemu_rdma_registration_stop_ram(void)
{
    QEMU_QEMU_RDMA_REGISTRATION_STOP_RAM();
    if (trace_event_get_state(TRACE_QEMU_RDMA_REGISTRATION_STOP_RAM)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qemu_rdma_registration_stop_ram " "" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      );
    }
}

static inline void trace_qemu_rdma_resolve_host_trying(const char * host, const char * ip)
{
    QEMU_QEMU_RDMA_RESOLVE_HOST_TRYING(host, ip);
    if (trace_event_get_state(TRACE_QEMU_RDMA_RESOLVE_HOST_TRYING)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qemu_rdma_resolve_host_trying " "Trying %s => %s" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , host, ip);
    }
}

static inline void trace_qemu_rdma_signal_unregister_append(uint64_t chunk, int pos)
{
    QEMU_QEMU_RDMA_SIGNAL_UNREGISTER_APPEND(chunk, pos);
    if (trace_event_get_state(TRACE_QEMU_RDMA_SIGNAL_UNREGISTER_APPEND)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qemu_rdma_signal_unregister_append " "Appending unregister chunk %" PRIu64 " at position %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , chunk, pos);
    }
}

static inline void trace_qemu_rdma_signal_unregister_already(uint64_t chunk)
{
    QEMU_QEMU_RDMA_SIGNAL_UNREGISTER_ALREADY(chunk);
    if (trace_event_get_state(TRACE_QEMU_RDMA_SIGNAL_UNREGISTER_ALREADY)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qemu_rdma_signal_unregister_already " "Unregister chunk %" PRIu64 " already in queue" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , chunk);
    }
}

static inline void trace_qemu_rdma_unregister_waiting_inflight(uint64_t chunk)
{
    QEMU_QEMU_RDMA_UNREGISTER_WAITING_INFLIGHT(chunk);
    if (trace_event_get_state(TRACE_QEMU_RDMA_UNREGISTER_WAITING_INFLIGHT)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qemu_rdma_unregister_waiting_inflight " "Cannot unregister inflight chunk: %" PRIu64 "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , chunk);
    }
}

static inline void trace_qemu_rdma_unregister_waiting_proc(uint64_t chunk, int pos)
{
    QEMU_QEMU_RDMA_UNREGISTER_WAITING_PROC(chunk, pos);
    if (trace_event_get_state(TRACE_QEMU_RDMA_UNREGISTER_WAITING_PROC)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qemu_rdma_unregister_waiting_proc " "Processing unregister for chunk: %" PRIu64 " at position %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , chunk, pos);
    }
}

static inline void trace_qemu_rdma_unregister_waiting_send(uint64_t chunk)
{
    QEMU_QEMU_RDMA_UNREGISTER_WAITING_SEND(chunk);
    if (trace_event_get_state(TRACE_QEMU_RDMA_UNREGISTER_WAITING_SEND)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qemu_rdma_unregister_waiting_send " "Sending unregister for chunk: %" PRIu64 "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , chunk);
    }
}

static inline void trace_qemu_rdma_unregister_waiting_complete(uint64_t chunk)
{
    QEMU_QEMU_RDMA_UNREGISTER_WAITING_COMPLETE(chunk);
    if (trace_event_get_state(TRACE_QEMU_RDMA_UNREGISTER_WAITING_COMPLETE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qemu_rdma_unregister_waiting_complete " "Unregister for chunk: %" PRIu64 " complete." "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , chunk);
    }
}

static inline void trace_qemu_rdma_write_flush(int sent)
{
    QEMU_QEMU_RDMA_WRITE_FLUSH(sent);
    if (trace_event_get_state(TRACE_QEMU_RDMA_WRITE_FLUSH)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qemu_rdma_write_flush " "sent total: %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , sent);
    }
}

static inline void trace_qemu_rdma_write_one_block(int count, int block, uint64_t chunk, uint64_t current, uint64_t len, int nb_sent, int nb_chunks)
{
    QEMU_QEMU_RDMA_WRITE_ONE_BLOCK(count, block, chunk, current, len, nb_sent, nb_chunks);
    if (trace_event_get_state(TRACE_QEMU_RDMA_WRITE_ONE_BLOCK)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qemu_rdma_write_one_block " "(%d) Not clobbering: block: %d chunk %" PRIu64 " current %" PRIu64 " len %" PRIu64 " %d %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , count, block, chunk, current, len, nb_sent, nb_chunks);
    }
}

static inline void trace_qemu_rdma_write_one_post(uint64_t chunk, long addr, long remote, uint32_t len)
{
    QEMU_QEMU_RDMA_WRITE_ONE_POST(chunk, addr, remote, len);
    if (trace_event_get_state(TRACE_QEMU_RDMA_WRITE_ONE_POST)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qemu_rdma_write_one_post " "Posting chunk: %" PRIu64 ", addr: %lx remote: %lx, bytes %" PRIu32 "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , chunk, addr, remote, len);
    }
}

static inline void trace_qemu_rdma_write_one_queue_full(void)
{
    QEMU_QEMU_RDMA_WRITE_ONE_QUEUE_FULL();
    if (trace_event_get_state(TRACE_QEMU_RDMA_WRITE_ONE_QUEUE_FULL)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qemu_rdma_write_one_queue_full " "" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      );
    }
}

static inline void trace_qemu_rdma_write_one_recvregres(int mykey, int theirkey, uint64_t chunk)
{
    QEMU_QEMU_RDMA_WRITE_ONE_RECVREGRES(mykey, theirkey, chunk);
    if (trace_event_get_state(TRACE_QEMU_RDMA_WRITE_ONE_RECVREGRES)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qemu_rdma_write_one_recvregres " "Received registration result: my key: %x their key %x, chunk %" PRIu64 "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , mykey, theirkey, chunk);
    }
}

static inline void trace_qemu_rdma_write_one_sendreg(uint64_t chunk, int len, int index, int64_t offset)
{
    QEMU_QEMU_RDMA_WRITE_ONE_SENDREG(chunk, len, index, offset);
    if (trace_event_get_state(TRACE_QEMU_RDMA_WRITE_ONE_SENDREG)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qemu_rdma_write_one_sendreg " "Sending registration request chunk %" PRIu64 " for %d bytes, index: %d, offset: %" PRId64 "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , chunk, len, index, offset);
    }
}

static inline void trace_qemu_rdma_write_one_top(uint64_t chunks, uint64_t size)
{
    QEMU_QEMU_RDMA_WRITE_ONE_TOP(chunks, size);
    if (trace_event_get_state(TRACE_QEMU_RDMA_WRITE_ONE_TOP)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qemu_rdma_write_one_top " "Writing %" PRIu64 " chunks, (%" PRIu64 " MB)" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , chunks, size);
    }
}

static inline void trace_qemu_rdma_write_one_zero(uint64_t chunk, int len, int index, int64_t offset)
{
    QEMU_QEMU_RDMA_WRITE_ONE_ZERO(chunk, len, index, offset);
    if (trace_event_get_state(TRACE_QEMU_RDMA_WRITE_ONE_ZERO)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:qemu_rdma_write_one_zero " "Entire chunk is zero, sending compress: %" PRIu64 " for %d bytes, index: %d, offset: %" PRId64 "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , chunk, len, index, offset);
    }
}

static inline void trace_rdma_add_block(const char * block_name, int block, uint64_t addr, uint64_t offset, uint64_t len, uint64_t end, uint64_t bits, int chunks)
{
    QEMU_RDMA_ADD_BLOCK(block_name, block, addr, offset, len, end, bits, chunks);
    if (trace_event_get_state(TRACE_RDMA_ADD_BLOCK)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:rdma_add_block " "Added Block: '%s':%d, addr: %" PRIu64 ", offset: %" PRIu64 " length: %" PRIu64 " end: %" PRIu64 " bits %" PRIu64 " chunks %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , block_name, block, addr, offset, len, end, bits, chunks);
    }
}

static inline void trace_rdma_block_notification_handle(const char * name, int index)
{
    QEMU_RDMA_BLOCK_NOTIFICATION_HANDLE(name, index);
    if (trace_event_get_state(TRACE_RDMA_BLOCK_NOTIFICATION_HANDLE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:rdma_block_notification_handle " "%s at %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , name, index);
    }
}

static inline void trace_rdma_delete_block(void * block, uint64_t addr, uint64_t offset, uint64_t len, uint64_t end, uint64_t bits, int chunks)
{
    QEMU_RDMA_DELETE_BLOCK(block, addr, offset, len, end, bits, chunks);
    if (trace_event_get_state(TRACE_RDMA_DELETE_BLOCK)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:rdma_delete_block " "Deleted Block: %p, addr: %" PRIu64 ", offset: %" PRIu64 " length: %" PRIu64 " end: %" PRIu64 " bits %" PRIu64 " chunks %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , block, addr, offset, len, end, bits, chunks);
    }
}

static inline void trace_rdma_start_incoming_migration(void)
{
    QEMU_RDMA_START_INCOMING_MIGRATION();
    if (trace_event_get_state(TRACE_RDMA_START_INCOMING_MIGRATION)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:rdma_start_incoming_migration " "" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      );
    }
}

static inline void trace_rdma_start_incoming_migration_after_dest_init(void)
{
    QEMU_RDMA_START_INCOMING_MIGRATION_AFTER_DEST_INIT();
    if (trace_event_get_state(TRACE_RDMA_START_INCOMING_MIGRATION_AFTER_DEST_INIT)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:rdma_start_incoming_migration_after_dest_init " "" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      );
    }
}

static inline void trace_rdma_start_incoming_migration_after_rdma_listen(void)
{
    QEMU_RDMA_START_INCOMING_MIGRATION_AFTER_RDMA_LISTEN();
    if (trace_event_get_state(TRACE_RDMA_START_INCOMING_MIGRATION_AFTER_RDMA_LISTEN)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:rdma_start_incoming_migration_after_rdma_listen " "" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      );
    }
}

static inline void trace_rdma_start_outgoing_migration_after_rdma_connect(void)
{
    QEMU_RDMA_START_OUTGOING_MIGRATION_AFTER_RDMA_CONNECT();
    if (trace_event_get_state(TRACE_RDMA_START_OUTGOING_MIGRATION_AFTER_RDMA_CONNECT)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:rdma_start_outgoing_migration_after_rdma_connect " "" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      );
    }
}

static inline void trace_rdma_start_outgoing_migration_after_rdma_source_init(void)
{
    QEMU_RDMA_START_OUTGOING_MIGRATION_AFTER_RDMA_SOURCE_INIT();
    if (trace_event_get_state(TRACE_RDMA_START_OUTGOING_MIGRATION_AFTER_RDMA_SOURCE_INIT)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:rdma_start_outgoing_migration_after_rdma_source_init " "" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      );
    }
}

static inline void trace_kvm_ioctl(int type, void * arg)
{
    QEMU_KVM_IOCTL(type, arg);
    if (trace_event_get_state(TRACE_KVM_IOCTL)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:kvm_ioctl " "type 0x%x, arg %p" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , type, arg);
    }
}

static inline void trace_kvm_vm_ioctl(int type, void * arg)
{
    QEMU_KVM_VM_IOCTL(type, arg);
    if (trace_event_get_state(TRACE_KVM_VM_IOCTL)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:kvm_vm_ioctl " "type 0x%x, arg %p" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , type, arg);
    }
}

static inline void trace_kvm_vcpu_ioctl(int cpu_index, int type, void * arg)
{
    QEMU_KVM_VCPU_IOCTL(cpu_index, type, arg);
    if (trace_event_get_state(TRACE_KVM_VCPU_IOCTL)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:kvm_vcpu_ioctl " "cpu_index %d, type 0x%x, arg %p" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , cpu_index, type, arg);
    }
}

static inline void trace_kvm_run_exit(int cpu_index, uint32_t reason)
{
    QEMU_KVM_RUN_EXIT(cpu_index, reason);
    if (trace_event_get_state(TRACE_KVM_RUN_EXIT)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:kvm_run_exit " "cpu_index %d, reason %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , cpu_index, reason);
    }
}

static inline void trace_kvm_device_ioctl(int fd, int type, void * arg)
{
    QEMU_KVM_DEVICE_IOCTL(fd, type, arg);
    if (trace_event_get_state(TRACE_KVM_DEVICE_IOCTL)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:kvm_device_ioctl " "dev fd %d, type 0x%x, arg %p" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , fd, type, arg);
    }
}

static inline void trace_kvm_failed_reg_get(uint64_t id, const char * msg)
{
    QEMU_KVM_FAILED_REG_GET(id, msg);
    if (trace_event_get_state(TRACE_KVM_FAILED_REG_GET)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:kvm_failed_reg_get " "Warning: Unable to retrieve ONEREG %" PRIu64 " from KVM: %s" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , id, msg);
    }
}

static inline void trace_kvm_failed_reg_set(uint64_t id, const char * msg)
{
    QEMU_KVM_FAILED_REG_SET(id, msg);
    if (trace_event_get_state(TRACE_KVM_FAILED_REG_SET)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:kvm_failed_reg_set " "Warning: Unable to set ONEREG %" PRIu64 " to KVM: %s" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , id, msg);
    }
}

static inline void trace_kvm_failed_spr_set(int str, const char * msg)
{
    QEMU_KVM_FAILED_SPR_SET(str, msg);
    if (trace_event_get_state(TRACE_KVM_FAILED_SPR_SET)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:kvm_failed_spr_set " "Warning: Unable to set SPR %d to KVM: %s" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , str, msg);
    }
}

static inline void trace_kvm_failed_spr_get(int str, const char * msg)
{
    QEMU_KVM_FAILED_SPR_GET(str, msg);
    if (trace_event_get_state(TRACE_KVM_FAILED_SPR_GET)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:kvm_failed_spr_get " "Warning: Unable to retrieve SPR %d from KVM: %s" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , str, msg);
    }
}

static inline void trace_exec_tb(void * tb, uintptr_t pc)
{
}

static inline void trace_exec_tb_nocache(void * tb, uintptr_t pc)
{
}

static inline void trace_exec_tb_exit(void * next_tb, unsigned int flags)
{
}

static inline void trace_translate_block(void * tb, uintptr_t pc, uint8_t * tb_code)
{
    QEMU_TRANSLATE_BLOCK(tb, pc, tb_code);
    if (trace_event_get_state(TRACE_TRANSLATE_BLOCK)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:translate_block " "tb:%p, pc:0x%"PRIxPTR", tb_code:%p" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , tb, pc, tb_code);
    }
}

static inline void trace_memory_region_ops_read(void * mr, uint64_t addr, uint64_t value, unsigned size)
{
    QEMU_MEMORY_REGION_OPS_READ(mr, addr, value, size);
    if (trace_event_get_state(TRACE_MEMORY_REGION_OPS_READ)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:memory_region_ops_read " "mr %p addr %#"PRIx64" value %#"PRIx64" size %u" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , mr, addr, value, size);
    }
}

static inline void trace_memory_region_ops_write(void * mr, uint64_t addr, uint64_t value, unsigned size)
{
    QEMU_MEMORY_REGION_OPS_WRITE(mr, addr, value, size);
    if (trace_event_get_state(TRACE_MEMORY_REGION_OPS_WRITE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:memory_region_ops_write " "mr %p addr %#"PRIx64" value %#"PRIx64" size %u" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , mr, addr, value, size);
    }
}

static inline void trace_object_dynamic_cast_assert(const char * type, const char * target, const char * file, int line, const char * func)
{
    QEMU_OBJECT_DYNAMIC_CAST_ASSERT(type, target, file, line, func);
    if (trace_event_get_state(TRACE_OBJECT_DYNAMIC_CAST_ASSERT)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:object_dynamic_cast_assert " "%s->%s (%s:%d:%s)" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , type, target, file, line, func);
    }
}

static inline void trace_object_class_dynamic_cast_assert(const char * type, const char * target, const char * file, int line, const char * func)
{
    QEMU_OBJECT_CLASS_DYNAMIC_CAST_ASSERT(type, target, file, line, func);
    if (trace_event_get_state(TRACE_OBJECT_CLASS_DYNAMIC_CAST_ASSERT)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:object_class_dynamic_cast_assert " "%s->%s (%s:%d:%s)" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , type, target, file, line, func);
    }
}

static inline void trace_xen_pv_mmio_read(uint64_t addr)
{
    QEMU_XEN_PV_MMIO_READ(addr);
    if (trace_event_get_state(TRACE_XEN_PV_MMIO_READ)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:xen_pv_mmio_read " "WARNING: read from Xen PV Device MMIO space (address %"PRIx64")" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , addr);
    }
}

static inline void trace_xen_pv_mmio_write(uint64_t addr)
{
    QEMU_XEN_PV_MMIO_WRITE(addr);
    if (trace_event_get_state(TRACE_XEN_PV_MMIO_WRITE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:xen_pv_mmio_write " "WARNING: write to Xen PV Device MMIO space (address %"PRIx64")" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , addr);
    }
}

static inline void trace_pci_cfg_read(const char * dev, unsigned devid, unsigned fnid, unsigned offs, unsigned val)
{
    QEMU_PCI_CFG_READ(dev, devid, fnid, offs, val);
    if (trace_event_get_state(TRACE_PCI_CFG_READ)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:pci_cfg_read " "%s %02u:%u @0x%x -> 0x%x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , dev, devid, fnid, offs, val);
    }
}

static inline void trace_pci_cfg_write(const char * dev, unsigned devid, unsigned fnid, unsigned offs, unsigned val)
{
    QEMU_PCI_CFG_WRITE(dev, devid, fnid, offs, val);
    if (trace_event_get_state(TRACE_PCI_CFG_WRITE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:pci_cfg_write " "%s %02u:%u @0x%x <- 0x%x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , dev, devid, fnid, offs, val);
    }
}

static inline void trace_vfio_intx_interrupt(const char * name, char line)
{
    QEMU_VFIO_INTX_INTERRUPT(name, line);
    if (trace_event_get_state(TRACE_VFIO_INTX_INTERRUPT)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:vfio_intx_interrupt " " (%s) Pin %c" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , name, line);
    }
}

static inline void trace_vfio_eoi(const char * name)
{
    QEMU_VFIO_EOI(name);
    if (trace_event_get_state(TRACE_VFIO_EOI)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:vfio_eoi " " (%s) EOI" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , name);
    }
}

static inline void trace_vfio_enable_intx_kvm(const char * name)
{
    QEMU_VFIO_ENABLE_INTX_KVM(name);
    if (trace_event_get_state(TRACE_VFIO_ENABLE_INTX_KVM)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:vfio_enable_intx_kvm " " (%s) KVM INTx accel enabled" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , name);
    }
}

static inline void trace_vfio_disable_intx_kvm(const char * name)
{
    QEMU_VFIO_DISABLE_INTX_KVM(name);
    if (trace_event_get_state(TRACE_VFIO_DISABLE_INTX_KVM)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:vfio_disable_intx_kvm " " (%s) KVM INTx accel disabled" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , name);
    }
}

static inline void trace_vfio_update_irq(const char * name, int new_irq, int target_irq)
{
    QEMU_VFIO_UPDATE_IRQ(name, new_irq, target_irq);
    if (trace_event_get_state(TRACE_VFIO_UPDATE_IRQ)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:vfio_update_irq " " (%s) IRQ moved %d -> %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , name, new_irq, target_irq);
    }
}

static inline void trace_vfio_enable_intx(const char * name)
{
    QEMU_VFIO_ENABLE_INTX(name);
    if (trace_event_get_state(TRACE_VFIO_ENABLE_INTX)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:vfio_enable_intx " " (%s)" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , name);
    }
}

static inline void trace_vfio_disable_intx(const char * name)
{
    QEMU_VFIO_DISABLE_INTX(name);
    if (trace_event_get_state(TRACE_VFIO_DISABLE_INTX)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:vfio_disable_intx " " (%s)" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , name);
    }
}

static inline void trace_vfio_msi_interrupt(const char * name, int index, uint64_t addr, int data)
{
    QEMU_VFIO_MSI_INTERRUPT(name, index, addr, data);
    if (trace_event_get_state(TRACE_VFIO_MSI_INTERRUPT)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:vfio_msi_interrupt " " (%s) vector %d 0x%"PRIx64"/0x%x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , name, index, addr, data);
    }
}

static inline void trace_vfio_msix_vector_do_use(const char * name, int index)
{
    QEMU_VFIO_MSIX_VECTOR_DO_USE(name, index);
    if (trace_event_get_state(TRACE_VFIO_MSIX_VECTOR_DO_USE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:vfio_msix_vector_do_use " " (%s) vector %d used" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , name, index);
    }
}

static inline void trace_vfio_msix_vector_release(const char * name, int index)
{
    QEMU_VFIO_MSIX_VECTOR_RELEASE(name, index);
    if (trace_event_get_state(TRACE_VFIO_MSIX_VECTOR_RELEASE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:vfio_msix_vector_release " " (%s) vector %d released" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , name, index);
    }
}

static inline void trace_vfio_enable_msix(const char * name)
{
    QEMU_VFIO_ENABLE_MSIX(name);
    if (trace_event_get_state(TRACE_VFIO_ENABLE_MSIX)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:vfio_enable_msix " " (%s)" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , name);
    }
}

static inline void trace_vfio_enable_msi(const char * name, int nr_vectors)
{
    QEMU_VFIO_ENABLE_MSI(name, nr_vectors);
    if (trace_event_get_state(TRACE_VFIO_ENABLE_MSI)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:vfio_enable_msi " " (%s) Enabled %d MSI vectors" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , name, nr_vectors);
    }
}

static inline void trace_vfio_disable_msix(const char * name)
{
    QEMU_VFIO_DISABLE_MSIX(name);
    if (trace_event_get_state(TRACE_VFIO_DISABLE_MSIX)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:vfio_disable_msix " " (%s)" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , name);
    }
}

static inline void trace_vfio_disable_msi(const char * name)
{
    QEMU_VFIO_DISABLE_MSI(name);
    if (trace_event_get_state(TRACE_VFIO_DISABLE_MSI)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:vfio_disable_msi " " (%s)" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , name);
    }
}

static inline void trace_vfio_pci_load_rom(const char * name, unsigned long size, unsigned long offset, unsigned long flags)
{
    QEMU_VFIO_PCI_LOAD_ROM(name, size, offset, flags);
    if (trace_event_get_state(TRACE_VFIO_PCI_LOAD_ROM)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:vfio_pci_load_rom " "Device %s ROM:\n  size: 0x%lx, offset: 0x%lx, flags: 0x%lx" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , name, size, offset, flags);
    }
}

static inline void trace_vfio_rom_read(const char * name, uint64_t addr, int size, uint64_t data)
{
    QEMU_VFIO_ROM_READ(name, addr, size, data);
    if (trace_event_get_state(TRACE_VFIO_ROM_READ)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:vfio_rom_read " " (%s, 0x%"PRIx64", 0x%x) = 0x%"PRIx64 "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , name, addr, size, data);
    }
}

static inline void trace_vfio_pci_size_rom(const char * name, int size)
{
    QEMU_VFIO_PCI_SIZE_ROM(name, size);
    if (trace_event_get_state(TRACE_VFIO_PCI_SIZE_ROM)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:vfio_pci_size_rom " "%s ROM size 0x%x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , name, size);
    }
}

static inline void trace_vfio_vga_write(uint64_t addr, uint64_t data, int size)
{
    QEMU_VFIO_VGA_WRITE(addr, data, size);
    if (trace_event_get_state(TRACE_VFIO_VGA_WRITE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:vfio_vga_write " " (0x%"PRIx64", 0x%"PRIx64", %d)" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , addr, data, size);
    }
}

static inline void trace_vfio_vga_read(uint64_t addr, int size, uint64_t data)
{
    QEMU_VFIO_VGA_READ(addr, size, data);
    if (trace_event_get_state(TRACE_VFIO_VGA_READ)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:vfio_vga_read " " (0x%"PRIx64", %d) = 0x%"PRIx64 "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , addr, size, data);
    }
}

static inline void trace_vfio_generic_window_quirk_read(const char * region_name, const char * name, int index, uint64_t addr, int size, uint64_t data)
{
    QEMU_VFIO_GENERIC_WINDOW_QUIRK_READ(region_name, name, index, addr, size, data);
    if (trace_event_get_state(TRACE_VFIO_GENERIC_WINDOW_QUIRK_READ)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:vfio_generic_window_quirk_read " "%s read(%s:BAR%d+0x%"PRIx64", %d = 0x%"PRIx64 "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , region_name, name, index, addr, size, data);
    }
}

static inline void trace_vfio_generic_window_quirk_write(const char * region_name, const char * name, int index, uint64_t addr, uint64_t data, int size)
{
    QEMU_VFIO_GENERIC_WINDOW_QUIRK_WRITE(region_name, name, index, addr, data, size);
    if (trace_event_get_state(TRACE_VFIO_GENERIC_WINDOW_QUIRK_WRITE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:vfio_generic_window_quirk_write " "%s write(%s:BAR%d+0x%"PRIx64", 0x%"PRIx64", %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , region_name, name, index, addr, data, size);
    }
}

static inline void trace_vfio_generic_quirk_read(const char * region_name, const char * name, int index, uint64_t addr, int size, uint64_t data)
{
    QEMU_VFIO_GENERIC_QUIRK_READ(region_name, name, index, addr, size, data);
    if (trace_event_get_state(TRACE_VFIO_GENERIC_QUIRK_READ)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:vfio_generic_quirk_read " "%s read(%s:BAR%d+0x%"PRIx64", %d = 0x%"PRIx64 "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , region_name, name, index, addr, size, data);
    }
}

static inline void trace_vfio_generic_quirk_write(const char * region_name, const char * name, int index, uint64_t addr, uint64_t data, int size)
{
    QEMU_VFIO_GENERIC_QUIRK_WRITE(region_name, name, index, addr, data, size);
    if (trace_event_get_state(TRACE_VFIO_GENERIC_QUIRK_WRITE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:vfio_generic_quirk_write " "%s write(%s:BAR%d+0x%"PRIx64", 0x%"PRIx64", %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , region_name, name, index, addr, data, size);
    }
}

static inline void trace_vfio_ati_3c3_quirk_read(uint64_t data)
{
    QEMU_VFIO_ATI_3C3_QUIRK_READ(data);
    if (trace_event_get_state(TRACE_VFIO_ATI_3C3_QUIRK_READ)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:vfio_ati_3c3_quirk_read " " (0x3c3, 1) = 0x%"PRIx64 "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , data);
    }
}

static inline void trace_vfio_vga_probe_ati_3c3_quirk(const char * name)
{
    QEMU_VFIO_VGA_PROBE_ATI_3C3_QUIRK(name);
    if (trace_event_get_state(TRACE_VFIO_VGA_PROBE_ATI_3C3_QUIRK)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:vfio_vga_probe_ati_3c3_quirk " "Enabled ATI/AMD quirk 0x3c3 BAR4for device %s" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , name);
    }
}

static inline void trace_vfio_probe_ati_bar4_window_quirk(const char * name)
{
    QEMU_VFIO_PROBE_ATI_BAR4_WINDOW_QUIRK(name);
    if (trace_event_get_state(TRACE_VFIO_PROBE_ATI_BAR4_WINDOW_QUIRK)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:vfio_probe_ati_bar4_window_quirk " "Enabled ATI/AMD BAR4 window quirk for device %s" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , name);
    }
}

static inline void trace_vfio_rtl8168_window_quirk_read_fake(const char * region_name, const char * name)
{
    QEMU_VFIO_RTL8168_WINDOW_QUIRK_READ_FAKE(region_name, name);
    if (trace_event_get_state(TRACE_VFIO_RTL8168_WINDOW_QUIRK_READ_FAKE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:vfio_rtl8168_window_quirk_read_fake " "%s fake read(%s" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , region_name, name);
    }
}

static inline void trace_vfio_rtl8168_window_quirk_read_table(const char * region_name, const char * name)
{
    QEMU_VFIO_RTL8168_WINDOW_QUIRK_READ_TABLE(region_name, name);
    if (trace_event_get_state(TRACE_VFIO_RTL8168_WINDOW_QUIRK_READ_TABLE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:vfio_rtl8168_window_quirk_read_table " "%s MSI-X table read(%s" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , region_name, name);
    }
}

static inline void trace_vfio_rtl8168_window_quirk_read_direct(const char * region_name, const char * name)
{
    QEMU_VFIO_RTL8168_WINDOW_QUIRK_READ_DIRECT(region_name, name);
    if (trace_event_get_state(TRACE_VFIO_RTL8168_WINDOW_QUIRK_READ_DIRECT)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:vfio_rtl8168_window_quirk_read_direct " "%s direct read(%s" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , region_name, name);
    }
}

static inline void trace_vfio_rtl8168_window_quirk_write_table(const char * region_name, const char * name)
{
    QEMU_VFIO_RTL8168_WINDOW_QUIRK_WRITE_TABLE(region_name, name);
    if (trace_event_get_state(TRACE_VFIO_RTL8168_WINDOW_QUIRK_WRITE_TABLE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:vfio_rtl8168_window_quirk_write_table " "%s MSI-X table write(%s" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , region_name, name);
    }
}

static inline void trace_vfio_rtl8168_window_quirk_write_direct(const char * region_name, const char * name)
{
    QEMU_VFIO_RTL8168_WINDOW_QUIRK_WRITE_DIRECT(region_name, name);
    if (trace_event_get_state(TRACE_VFIO_RTL8168_WINDOW_QUIRK_WRITE_DIRECT)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:vfio_rtl8168_window_quirk_write_direct " "%s direct write(%s" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , region_name, name);
    }
}

static inline void trace_vfio_probe_rtl8168_bar2_window_quirk(const char * name)
{
    QEMU_VFIO_PROBE_RTL8168_BAR2_WINDOW_QUIRK(name);
    if (trace_event_get_state(TRACE_VFIO_PROBE_RTL8168_BAR2_WINDOW_QUIRK)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:vfio_probe_rtl8168_bar2_window_quirk " "Enabled RTL8168 BAR2 window quirk for device %s" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , name);
    }
}

static inline void trace_vfio_probe_ati_bar2_4000_quirk(const char * name)
{
    QEMU_VFIO_PROBE_ATI_BAR2_4000_QUIRK(name);
    if (trace_event_get_state(TRACE_VFIO_PROBE_ATI_BAR2_4000_QUIRK)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:vfio_probe_ati_bar2_4000_quirk " "Enabled ATI/AMD BAR2 0x4000 quirk for device %s" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , name);
    }
}

static inline void trace_vfio_nvidia_3d0_quirk_read(int size, uint64_t data)
{
    QEMU_VFIO_NVIDIA_3D0_QUIRK_READ(size, data);
    if (trace_event_get_state(TRACE_VFIO_NVIDIA_3D0_QUIRK_READ)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:vfio_nvidia_3d0_quirk_read " " (0x3d0, %d) = 0x%"PRIx64 "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , size, data);
    }
}

static inline void trace_vfio_nvidia_3d0_quirk_write(uint64_t data, int size)
{
    QEMU_VFIO_NVIDIA_3D0_QUIRK_WRITE(data, size);
    if (trace_event_get_state(TRACE_VFIO_NVIDIA_3D0_QUIRK_WRITE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:vfio_nvidia_3d0_quirk_write " " (0x3d0, 0x%"PRIx64", %d)" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , data, size);
    }
}

static inline void trace_vfio_vga_probe_nvidia_3d0_quirk(const char * name)
{
    QEMU_VFIO_VGA_PROBE_NVIDIA_3D0_QUIRK(name);
    if (trace_event_get_state(TRACE_VFIO_VGA_PROBE_NVIDIA_3D0_QUIRK)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:vfio_vga_probe_nvidia_3d0_quirk " "Enabled NVIDIA VGA 0x3d0 quirk for device %s" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , name);
    }
}

static inline void trace_vfio_probe_nvidia_bar5_window_quirk(const char * name)
{
    QEMU_VFIO_PROBE_NVIDIA_BAR5_WINDOW_QUIRK(name);
    if (trace_event_get_state(TRACE_VFIO_PROBE_NVIDIA_BAR5_WINDOW_QUIRK)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:vfio_probe_nvidia_bar5_window_quirk " "Enabled NVIDIA BAR5 window quirk for device %s" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , name);
    }
}

static inline void trace_vfio_probe_nvidia_bar0_88000_quirk(const char * name)
{
    QEMU_VFIO_PROBE_NVIDIA_BAR0_88000_QUIRK(name);
    if (trace_event_get_state(TRACE_VFIO_PROBE_NVIDIA_BAR0_88000_QUIRK)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:vfio_probe_nvidia_bar0_88000_quirk " "Enabled NVIDIA BAR0 0x88000 quirk for device %s" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , name);
    }
}

static inline void trace_vfio_probe_nvidia_bar0_1800_quirk_id(int id)
{
    QEMU_VFIO_PROBE_NVIDIA_BAR0_1800_QUIRK_ID(id);
    if (trace_event_get_state(TRACE_VFIO_PROBE_NVIDIA_BAR0_1800_QUIRK_ID)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:vfio_probe_nvidia_bar0_1800_quirk_id " "Nvidia NV%02x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , id);
    }
}

static inline void trace_vfio_probe_nvidia_bar0_1800_quirk(const char * name)
{
    QEMU_VFIO_PROBE_NVIDIA_BAR0_1800_QUIRK(name);
    if (trace_event_get_state(TRACE_VFIO_PROBE_NVIDIA_BAR0_1800_QUIRK)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:vfio_probe_nvidia_bar0_1800_quirk " "Enabled NVIDIA BAR0 0x1800 quirk for device %s" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , name);
    }
}

static inline void trace_vfio_pci_read_config(const char * name, int addr, int len, int val)
{
    QEMU_VFIO_PCI_READ_CONFIG(name, addr, len, val);
    if (trace_event_get_state(TRACE_VFIO_PCI_READ_CONFIG)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:vfio_pci_read_config " " (%s, @0x%x, len=0x%x) %x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , name, addr, len, val);
    }
}

static inline void trace_vfio_pci_write_config(const char * name, int addr, int val, int len)
{
    QEMU_VFIO_PCI_WRITE_CONFIG(name, addr, val, len);
    if (trace_event_get_state(TRACE_VFIO_PCI_WRITE_CONFIG)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:vfio_pci_write_config " " (%s, @0x%x, 0x%x, len=0x%x)" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , name, addr, val, len);
    }
}

static inline void trace_vfio_setup_msi(const char * name, int pos)
{
    QEMU_VFIO_SETUP_MSI(name, pos);
    if (trace_event_get_state(TRACE_VFIO_SETUP_MSI)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:vfio_setup_msi " "%s PCI MSI CAP @0x%x" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , name, pos);
    }
}

static inline void trace_vfio_early_setup_msix(const char * name, int pos, int table_bar, int offset, int entries)
{
    QEMU_VFIO_EARLY_SETUP_MSIX(name, pos, table_bar, offset, entries);
    if (trace_event_get_state(TRACE_VFIO_EARLY_SETUP_MSIX)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:vfio_early_setup_msix " "%s PCI MSI-X CAP @0x%x, BAR %d, offset 0x%x, entries %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , name, pos, table_bar, offset, entries);
    }
}

static inline void trace_vfio_check_pcie_flr(const char * name)
{
    QEMU_VFIO_CHECK_PCIE_FLR(name);
    if (trace_event_get_state(TRACE_VFIO_CHECK_PCIE_FLR)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:vfio_check_pcie_flr " "%s Supports FLR via PCIe cap" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , name);
    }
}

static inline void trace_vfio_check_pm_reset(const char * name)
{
    QEMU_VFIO_CHECK_PM_RESET(name);
    if (trace_event_get_state(TRACE_VFIO_CHECK_PM_RESET)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:vfio_check_pm_reset " "%s Supports PM reset" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , name);
    }
}

static inline void trace_vfio_check_af_flr(const char * name)
{
    QEMU_VFIO_CHECK_AF_FLR(name);
    if (trace_event_get_state(TRACE_VFIO_CHECK_AF_FLR)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:vfio_check_af_flr " "%s Supports FLR via AF cap" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , name);
    }
}

static inline void trace_vfio_pci_hot_reset(const char * name, const char * type)
{
    QEMU_VFIO_PCI_HOT_RESET(name, type);
    if (trace_event_get_state(TRACE_VFIO_PCI_HOT_RESET)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:vfio_pci_hot_reset " " (%s) %s" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , name, type);
    }
}

static inline void trace_vfio_pci_hot_reset_has_dep_devices(const char * name)
{
    QEMU_VFIO_PCI_HOT_RESET_HAS_DEP_DEVICES(name);
    if (trace_event_get_state(TRACE_VFIO_PCI_HOT_RESET_HAS_DEP_DEVICES)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:vfio_pci_hot_reset_has_dep_devices " "%s: hot reset dependent devices:" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , name);
    }
}

static inline void trace_vfio_pci_hot_reset_dep_devices(int domain, int bus, int slot, int function, int group_id)
{
    QEMU_VFIO_PCI_HOT_RESET_DEP_DEVICES(domain, bus, slot, function, group_id);
    if (trace_event_get_state(TRACE_VFIO_PCI_HOT_RESET_DEP_DEVICES)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:vfio_pci_hot_reset_dep_devices " "\t%04x:%02x:%02x.%x group %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , domain, bus, slot, function, group_id);
    }
}

static inline void trace_vfio_pci_hot_reset_result(const char * name, const char * result)
{
    QEMU_VFIO_PCI_HOT_RESET_RESULT(name, result);
    if (trace_event_get_state(TRACE_VFIO_PCI_HOT_RESET_RESULT)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:vfio_pci_hot_reset_result " "%s hot reset: %s" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , name, result);
    }
}

static inline void trace_vfio_populate_device_region(const char * region_name, int index, unsigned long size, unsigned long offset, unsigned long flags)
{
    QEMU_VFIO_POPULATE_DEVICE_REGION(region_name, index, size, offset, flags);
    if (trace_event_get_state(TRACE_VFIO_POPULATE_DEVICE_REGION)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:vfio_populate_device_region " "Device %s region %d:\n  size: 0x%lx, offset: 0x%lx, flags: 0x%lx" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , region_name, index, size, offset, flags);
    }
}

static inline void trace_vfio_populate_device_config(const char * name, unsigned long size, unsigned long offset, unsigned long flags)
{
    QEMU_VFIO_POPULATE_DEVICE_CONFIG(name, size, offset, flags);
    if (trace_event_get_state(TRACE_VFIO_POPULATE_DEVICE_CONFIG)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:vfio_populate_device_config " "Device %s config:\n  size: 0x%lx, offset: 0x%lx, flags: 0x%lx" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , name, size, offset, flags);
    }
}

static inline void trace_vfio_populate_device_get_irq_info_failure(void)
{
    QEMU_VFIO_POPULATE_DEVICE_GET_IRQ_INFO_FAILURE();
    if (trace_event_get_state(TRACE_VFIO_POPULATE_DEVICE_GET_IRQ_INFO_FAILURE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:vfio_populate_device_get_irq_info_failure " "VFIO_DEVICE_GET_IRQ_INFO failure: %m" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      );
    }
}

static inline void trace_vfio_initfn(const char * name, int group_id)
{
    QEMU_VFIO_INITFN(name, group_id);
    if (trace_event_get_state(TRACE_VFIO_INITFN)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:vfio_initfn " " (%s) group %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , name, group_id);
    }
}

static inline void trace_vfio_pci_reset(const char * name)
{
    QEMU_VFIO_PCI_RESET(name);
    if (trace_event_get_state(TRACE_VFIO_PCI_RESET)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:vfio_pci_reset " " (%s)" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , name);
    }
}

static inline void trace_vfio_pci_reset_flr(const char * name)
{
    QEMU_VFIO_PCI_RESET_FLR(name);
    if (trace_event_get_state(TRACE_VFIO_PCI_RESET_FLR)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:vfio_pci_reset_flr " "%s FLR/VFIO_DEVICE_RESET" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , name);
    }
}

static inline void trace_vfio_pci_reset_pm(const char * name)
{
    QEMU_VFIO_PCI_RESET_PM(name);
    if (trace_event_get_state(TRACE_VFIO_PCI_RESET_PM)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:vfio_pci_reset_pm " "%s PCI PM Reset" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , name);
    }
}

static inline void trace_vfio_region_write(const char * name, int index, uint64_t addr, uint64_t data, unsigned size)
{
    QEMU_VFIO_REGION_WRITE(name, index, addr, data, size);
    if (trace_event_get_state(TRACE_VFIO_REGION_WRITE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:vfio_region_write " " (%s:region%d+0x%"PRIx64", 0x%"PRIx64 ", %d)" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , name, index, addr, data, size);
    }
}

static inline void trace_vfio_region_read(char * name, int index, uint64_t addr, unsigned size, uint64_t data)
{
    QEMU_VFIO_REGION_READ(name, index, addr, size, data);
    if (trace_event_get_state(TRACE_VFIO_REGION_READ)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:vfio_region_read " " (%s:region%d+0x%"PRIx64", %d) = 0x%"PRIx64 "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , name, index, addr, size, data);
    }
}

static inline void trace_vfio_iommu_map_notify(uint64_t iova_start, uint64_t iova_end)
{
    QEMU_VFIO_IOMMU_MAP_NOTIFY(iova_start, iova_end);
    if (trace_event_get_state(TRACE_VFIO_IOMMU_MAP_NOTIFY)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:vfio_iommu_map_notify " "iommu map @ %"PRIx64" - %"PRIx64 "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , iova_start, iova_end);
    }
}

static inline void trace_vfio_listener_region_add_skip(uint64_t start, uint64_t end)
{
    QEMU_VFIO_LISTENER_REGION_ADD_SKIP(start, end);
    if (trace_event_get_state(TRACE_VFIO_LISTENER_REGION_ADD_SKIP)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:vfio_listener_region_add_skip " "SKIPPING region_add %"PRIx64" - %"PRIx64 "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , start, end);
    }
}

static inline void trace_vfio_listener_region_add_iommu(uint64_t start, uint64_t end)
{
    QEMU_VFIO_LISTENER_REGION_ADD_IOMMU(start, end);
    if (trace_event_get_state(TRACE_VFIO_LISTENER_REGION_ADD_IOMMU)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:vfio_listener_region_add_iommu " "region_add [iommu] %"PRIx64" - %"PRIx64 "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , start, end);
    }
}

static inline void trace_vfio_listener_region_add_ram(uint64_t iova_start, uint64_t iova_end, void * vaddr)
{
    QEMU_VFIO_LISTENER_REGION_ADD_RAM(iova_start, iova_end, vaddr);
    if (trace_event_get_state(TRACE_VFIO_LISTENER_REGION_ADD_RAM)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:vfio_listener_region_add_ram " "region_add [ram] %"PRIx64" - %"PRIx64" [%p]" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , iova_start, iova_end, vaddr);
    }
}

static inline void trace_vfio_listener_region_del_skip(uint64_t start, uint64_t end)
{
    QEMU_VFIO_LISTENER_REGION_DEL_SKIP(start, end);
    if (trace_event_get_state(TRACE_VFIO_LISTENER_REGION_DEL_SKIP)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:vfio_listener_region_del_skip " "SKIPPING region_del %"PRIx64" - %"PRIx64 "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , start, end);
    }
}

static inline void trace_vfio_listener_region_del(uint64_t start, uint64_t end)
{
    QEMU_VFIO_LISTENER_REGION_DEL(start, end);
    if (trace_event_get_state(TRACE_VFIO_LISTENER_REGION_DEL)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:vfio_listener_region_del " "region_del %"PRIx64" - %"PRIx64 "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , start, end);
    }
}

static inline void trace_vfio_disconnect_container(int fd)
{
    QEMU_VFIO_DISCONNECT_CONTAINER(fd);
    if (trace_event_get_state(TRACE_VFIO_DISCONNECT_CONTAINER)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:vfio_disconnect_container " "close container->fd=%d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , fd);
    }
}

static inline void trace_vfio_put_group(int fd)
{
    QEMU_VFIO_PUT_GROUP(fd);
    if (trace_event_get_state(TRACE_VFIO_PUT_GROUP)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:vfio_put_group " "close group->fd=%d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , fd);
    }
}

static inline void trace_vfio_get_device(const char * name, unsigned int flags, unsigned int num_regions, unsigned int num_irqs)
{
    QEMU_VFIO_GET_DEVICE(name, flags, num_regions, num_irqs);
    if (trace_event_get_state(TRACE_VFIO_GET_DEVICE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:vfio_get_device " "Device %s flags: %u, regions: %u, irqs: %u" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , name, flags, num_regions, num_irqs);
    }
}

static inline void trace_vfio_put_base_device(int fd)
{
    QEMU_VFIO_PUT_BASE_DEVICE(fd);
    if (trace_event_get_state(TRACE_VFIO_PUT_BASE_DEVICE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:vfio_put_base_device " "close vdev->fd=%d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , fd);
    }
}

static inline void trace_mhp_acpi_invalid_slot_selected(uint32_t slot)
{
    QEMU_MHP_ACPI_INVALID_SLOT_SELECTED(slot);
    if (trace_event_get_state(TRACE_MHP_ACPI_INVALID_SLOT_SELECTED)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:mhp_acpi_invalid_slot_selected " "0x%"PRIx32 "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , slot);
    }
}

static inline void trace_mhp_acpi_ejecting_invalid_slot(uint32_t slot)
{
    QEMU_MHP_ACPI_EJECTING_INVALID_SLOT(slot);
    if (trace_event_get_state(TRACE_MHP_ACPI_EJECTING_INVALID_SLOT)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:mhp_acpi_ejecting_invalid_slot " "0x%"PRIx32 "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , slot);
    }
}

static inline void trace_mhp_acpi_read_addr_lo(uint32_t slot, uint32_t addr)
{
    QEMU_MHP_ACPI_READ_ADDR_LO(slot, addr);
    if (trace_event_get_state(TRACE_MHP_ACPI_READ_ADDR_LO)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:mhp_acpi_read_addr_lo " "slot[0x%"PRIx32"] addr lo: 0x%"PRIx32 "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , slot, addr);
    }
}

static inline void trace_mhp_acpi_read_addr_hi(uint32_t slot, uint32_t addr)
{
    QEMU_MHP_ACPI_READ_ADDR_HI(slot, addr);
    if (trace_event_get_state(TRACE_MHP_ACPI_READ_ADDR_HI)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:mhp_acpi_read_addr_hi " "slot[0x%"PRIx32"] addr hi: 0x%"PRIx32 "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , slot, addr);
    }
}

static inline void trace_mhp_acpi_read_size_lo(uint32_t slot, uint32_t size)
{
    QEMU_MHP_ACPI_READ_SIZE_LO(slot, size);
    if (trace_event_get_state(TRACE_MHP_ACPI_READ_SIZE_LO)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:mhp_acpi_read_size_lo " "slot[0x%"PRIx32"] size lo: 0x%"PRIx32 "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , slot, size);
    }
}

static inline void trace_mhp_acpi_read_size_hi(uint32_t slot, uint32_t size)
{
    QEMU_MHP_ACPI_READ_SIZE_HI(slot, size);
    if (trace_event_get_state(TRACE_MHP_ACPI_READ_SIZE_HI)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:mhp_acpi_read_size_hi " "slot[0x%"PRIx32"] size hi: 0x%"PRIx32 "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , slot, size);
    }
}

static inline void trace_mhp_acpi_read_pxm(uint32_t slot, uint32_t pxm)
{
    QEMU_MHP_ACPI_READ_PXM(slot, pxm);
    if (trace_event_get_state(TRACE_MHP_ACPI_READ_PXM)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:mhp_acpi_read_pxm " "slot[0x%"PRIx32"] proximity: 0x%"PRIx32 "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , slot, pxm);
    }
}

static inline void trace_mhp_acpi_read_flags(uint32_t slot, uint32_t flags)
{
    QEMU_MHP_ACPI_READ_FLAGS(slot, flags);
    if (trace_event_get_state(TRACE_MHP_ACPI_READ_FLAGS)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:mhp_acpi_read_flags " "slot[0x%"PRIx32"] flags: 0x%"PRIx32 "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , slot, flags);
    }
}

static inline void trace_mhp_acpi_write_slot(uint32_t slot)
{
    QEMU_MHP_ACPI_WRITE_SLOT(slot);
    if (trace_event_get_state(TRACE_MHP_ACPI_WRITE_SLOT)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:mhp_acpi_write_slot " "set active slot: 0x%"PRIx32 "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , slot);
    }
}

static inline void trace_mhp_acpi_write_ost_ev(uint32_t slot, uint32_t ev)
{
    QEMU_MHP_ACPI_WRITE_OST_EV(slot, ev);
    if (trace_event_get_state(TRACE_MHP_ACPI_WRITE_OST_EV)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:mhp_acpi_write_ost_ev " "slot[0x%"PRIx32"] OST EVENT: 0x%"PRIx32 "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , slot, ev);
    }
}

static inline void trace_mhp_acpi_write_ost_status(uint32_t slot, uint32_t st)
{
    QEMU_MHP_ACPI_WRITE_OST_STATUS(slot, st);
    if (trace_event_get_state(TRACE_MHP_ACPI_WRITE_OST_STATUS)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:mhp_acpi_write_ost_status " "slot[0x%"PRIx32"] OST STATUS: 0x%"PRIx32 "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , slot, st);
    }
}

static inline void trace_mhp_acpi_clear_insert_evt(uint32_t slot)
{
    QEMU_MHP_ACPI_CLEAR_INSERT_EVT(slot);
    if (trace_event_get_state(TRACE_MHP_ACPI_CLEAR_INSERT_EVT)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:mhp_acpi_clear_insert_evt " "slot[0x%"PRIx32"] clear insert event" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , slot);
    }
}

static inline void trace_mhp_acpi_clear_remove_evt(uint32_t slot)
{
    QEMU_MHP_ACPI_CLEAR_REMOVE_EVT(slot);
    if (trace_event_get_state(TRACE_MHP_ACPI_CLEAR_REMOVE_EVT)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:mhp_acpi_clear_remove_evt " "slot[0x%"PRIx32"] clear remove event" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , slot);
    }
}

static inline void trace_mhp_acpi_pc_dimm_deleted(uint32_t slot)
{
    QEMU_MHP_ACPI_PC_DIMM_DELETED(slot);
    if (trace_event_get_state(TRACE_MHP_ACPI_PC_DIMM_DELETED)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:mhp_acpi_pc_dimm_deleted " "slot[0x%"PRIx32"] pc-dimm deleted" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , slot);
    }
}

static inline void trace_mhp_acpi_pc_dimm_delete_failed(uint32_t slot)
{
    QEMU_MHP_ACPI_PC_DIMM_DELETE_FAILED(slot);
    if (trace_event_get_state(TRACE_MHP_ACPI_PC_DIMM_DELETE_FAILED)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:mhp_acpi_pc_dimm_delete_failed " "slot[0x%"PRIx32"] pc-dimm delete failed" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , slot);
    }
}

static inline void trace_mhp_pc_dimm_assigned_slot(int slot)
{
    QEMU_MHP_PC_DIMM_ASSIGNED_SLOT(slot);
    if (trace_event_get_state(TRACE_MHP_PC_DIMM_ASSIGNED_SLOT)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:mhp_pc_dimm_assigned_slot " "0x%d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , slot);
    }
}

static inline void trace_mhp_pc_dimm_assigned_address(uint64_t addr)
{
    QEMU_MHP_PC_DIMM_ASSIGNED_ADDRESS(addr);
    if (trace_event_get_state(TRACE_MHP_PC_DIMM_ASSIGNED_ADDRESS)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:mhp_pc_dimm_assigned_address " "0x%"PRIx64 "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , addr);
    }
}

static inline void trace_kvm_enable_cmma(int rc)
{
    QEMU_KVM_ENABLE_CMMA(rc);
    if (trace_event_get_state(TRACE_KVM_ENABLE_CMMA)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:kvm_enable_cmma " "CMMA: enabling with result code %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , rc);
    }
}

static inline void trace_kvm_clear_cmma(int rc)
{
    QEMU_KVM_CLEAR_CMMA(rc);
    if (trace_event_get_state(TRACE_KVM_CLEAR_CMMA)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:kvm_clear_cmma " "CMMA: clearing with result code %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , rc);
    }
}

static inline void trace_kvm_failed_cpu_state_set(int cpu_index, uint8_t state, const char * msg)
{
    QEMU_KVM_FAILED_CPU_STATE_SET(cpu_index, state, msg);
    if (trace_event_get_state(TRACE_KVM_FAILED_CPU_STATE_SET)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:kvm_failed_cpu_state_set " "Warning: Unable to set cpu %d state %" PRIu8 " to KVM: %s" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , cpu_index, state, msg);
    }
}

static inline void trace_kvm_sigp_finished(uint8_t order, int cpu_index, int dst_index, int cc)
{
    QEMU_KVM_SIGP_FINISHED(order, cpu_index, dst_index, cc);
    if (trace_event_get_state(TRACE_KVM_SIGP_FINISHED)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:kvm_sigp_finished " "SIGP: Finished order %u on cpu %d -> cpu %d with cc=%d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , order, cpu_index, dst_index, cc);
    }
}

static inline void trace_i8257_unregistered_dma(int nchan, int dma_pos, int dma_len)
{
    QEMU_I8257_UNREGISTERED_DMA(nchan, dma_pos, dma_len);
    if (trace_event_get_state(TRACE_I8257_UNREGISTERED_DMA)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:i8257_unregistered_dma " "unregistered DMA channel used nchan=%d dma_pos=%d dma_len=%d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , nchan, dma_pos, dma_len);
    }
}

static inline void trace_cpu_set_state(int cpu_index, uint8_t state)
{
    QEMU_CPU_SET_STATE(cpu_index, state);
    if (trace_event_get_state(TRACE_CPU_SET_STATE)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:cpu_set_state " "setting cpu %d state to %" PRIu8 "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , cpu_index, state);
    }
}

static inline void trace_cpu_halt(int cpu_index)
{
    QEMU_CPU_HALT(cpu_index);
    if (trace_event_get_state(TRACE_CPU_HALT)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:cpu_halt " "halting cpu %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , cpu_index);
    }
}

static inline void trace_cpu_unhalt(int cpu_index)
{
    QEMU_CPU_UNHALT(cpu_index);
    if (trace_event_get_state(TRACE_CPU_UNHALT)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:cpu_unhalt " "unhalting cpu %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , cpu_index);
    }
}

static inline void trace_virt_acpi_setup(void)
{
    QEMU_VIRT_ACPI_SETUP();
    if (trace_event_get_state(TRACE_VIRT_ACPI_SETUP)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:virt_acpi_setup " "No fw cfg or ACPI disabled. Bailing out." "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      );
    }
}

static inline void trace_vhost_user_event(const char * chr, int event)
{
    QEMU_VHOST_USER_EVENT(chr, event);
    if (trace_event_get_state(TRACE_VHOST_USER_EVENT)) {
        struct timeval _now;
        gettimeofday(&_now, NULL);
        qemu_log_mask(LOG_TRACE, "%d@%zd.%06zd:vhost_user_event " "chr: %s got event: %d" "\n",
                      getpid(),
                      (size_t)_now.tv_sec, (size_t)_now.tv_usec
                      , chr, event);
    }
}
#endif /* TRACE__GENERATED_TRACERS_H */
